/**
 * vis-timeline and vis-graph2d
 * https://visjs.github.io/vis-timeline/
 *
 * Create a fully customizable, interactive timeline with items and ranges.
 *
 * @version 0.0.0-no-version
 * @date    2024-03-03T07:13:05.328Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).vis=t.vis||{})}(this,(function(t){var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function n(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}function r(t){throw new Error('Could not dynamically require "'+t+'". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.')}var o,s,a={exports:{}};function l(){return o||(o=1,function(t,e){t.exports=function(){var e,i;function n(){return e.apply(null,arguments)}function o(t){e=t}function s(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function a(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function l(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function h(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(l(t,e))return!1;return!0}function u(t){return void 0===t}function d(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function c(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function p(t,e){var i,n=[],r=t.length;for(i=0;i<r;++i)n.push(e(t[i],i));return n}function f(t,e){for(var i in e)l(e,i)&&(t[i]=e[i]);return l(e,"toString")&&(t.toString=e.toString),l(e,"valueOf")&&(t.valueOf=e.valueOf),t}function m(t,e,i,n){return qi(t,e,i,n,!0).utc()}function v(){return{empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}}function g(t){return null==t._pf&&(t._pf=v()),t._pf}function y(t){var e=null,n=!1,r=t._d&&!isNaN(t._d.getTime());return r&&(e=g(t),n=i.call(e.parsedDateParts,(function(t){return null!=t})),r=e.overflow<0&&!e.empty&&!e.invalidEra&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&n),t._strict&&(r=r&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour)),null!=Object.isFrozen&&Object.isFrozen(t)?r:(t._isValid=r,t._isValid)}function b(t){var e=m(NaN);return null!=t?f(g(e),t):g(e).userInvalidated=!0,e}i=Array.prototype.some?Array.prototype.some:function(t){var e,i=Object(this),n=i.length>>>0;for(e=0;e<n;e++)if(e in i&&t.call(this,i[e],e,i))return!0;return!1};var _=n.momentProperties=[],w=!1;function k(t,e){var i,n,r,o=_.length;if(u(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),u(e._i)||(t._i=e._i),u(e._f)||(t._f=e._f),u(e._l)||(t._l=e._l),u(e._strict)||(t._strict=e._strict),u(e._tzm)||(t._tzm=e._tzm),u(e._isUTC)||(t._isUTC=e._isUTC),u(e._offset)||(t._offset=e._offset),u(e._pf)||(t._pf=g(e)),u(e._locale)||(t._locale=e._locale),o>0)for(i=0;i<o;i++)u(r=e[n=_[i]])||(t[n]=r);return t}function x(t){k(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===w&&(w=!0,n.updateOffset(this),w=!1)}function D(t){return t instanceof x||null!=t&&null!=t._isAMomentObject}function S(t){!1===n.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function C(t,e){var i=!0;return f((function(){if(null!=n.deprecationHandler&&n.deprecationHandler(null,t),i){var r,o,s,a=[],h=arguments.length;for(o=0;o<h;o++){if(r="","object"==typeof arguments[o]){for(s in r+="\n["+o+"] ",arguments[0])l(arguments[0],s)&&(r+=s+": "+arguments[0][s]+", ");r=r.slice(0,-2)}else r=arguments[o];a.push(r)}S(t+"\nArguments: "+Array.prototype.slice.call(a).join("")+"\n"+(new Error).stack),i=!1}return e.apply(this,arguments)}),e)}var T,M={};function O(t,e){null!=n.deprecationHandler&&n.deprecationHandler(t,e),M[t]||(S(e),M[t]=!0)}function E(t){return"undefined"!=typeof Function&&t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function P(t){var e,i;for(i in t)l(t,i)&&(E(e=t[i])?this[i]=e:this["_"+i]=e);this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)}function A(t,e){var i,n=f({},t);for(i in e)l(e,i)&&(a(t[i])&&a(e[i])?(n[i]={},f(n[i],t[i]),f(n[i],e[i])):null!=e[i]?n[i]=e[i]:delete n[i]);for(i in t)l(t,i)&&!l(e,i)&&a(t[i])&&(n[i]=f({},n[i]));return n}function I(t){null!=t&&this.set(t)}n.suppressDeprecationWarnings=!1,n.deprecationHandler=null,T=Object.keys?Object.keys:function(t){var e,i=[];for(e in t)l(t,e)&&i.push(e);return i};var L={sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"};function N(t,e,i){var n=this._calendar[t]||this._calendar.sameElse;return E(n)?n.call(e,i):n}function R(t,e,i){var n=""+Math.abs(t),r=e-n.length;return(t>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+n}var F=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,j=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,Y={},H={};function z(t,e,i,n){var r=n;"string"==typeof n&&(r=function(){return this[n]()}),t&&(H[t]=r),e&&(H[e[0]]=function(){return R(r.apply(this,arguments),e[1],e[2])}),i&&(H[i]=function(){return this.localeData().ordinal(r.apply(this,arguments),t)})}function B(t){return t.match(/\[[\s\S]/)?t.replace(/^\[|\]$/g,""):t.replace(/\\/g,"")}function G(t){var e,i,n=t.match(F);for(e=0,i=n.length;e<i;e++)H[n[e]]?n[e]=H[n[e]]:n[e]=B(n[e]);return function(e){var r,o="";for(r=0;r<i;r++)o+=E(n[r])?n[r].call(e,t):n[r];return o}}function W(t,e){return t.isValid()?(e=U(e,t.localeData()),Y[e]=Y[e]||G(e),Y[e](t)):t.localeData().invalidDate()}function U(t,e){var i=5;function n(t){return e.longDateFormat(t)||t}for(j.lastIndex=0;i>=0&&j.test(t);)t=t.replace(j,n),j.lastIndex=0,i-=1;return t}var V={LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"};function X(t){var e=this._longDateFormat[t],i=this._longDateFormat[t.toUpperCase()];return e||!i?e:(this._longDateFormat[t]=i.match(F).map((function(t){return"MMMM"===t||"MM"===t||"DD"===t||"dddd"===t?t.slice(1):t})).join(""),this._longDateFormat[t])}var q="Invalid date";function $(){return this._invalidDate}var Z="%d",K=/\d{1,2}/;function J(t){return this._ordinal.replace("%d",t)}var Q={future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"};function tt(t,e,i,n){var r=this._relativeTime[i];return E(r)?r(t,e,i,n):r.replace(/%d/i,t)}function et(t,e){var i=this._relativeTime[t>0?"future":"past"];return E(i)?i(e):i.replace(/%s/i,e)}var it={D:"date",dates:"date",date:"date",d:"day",days:"day",day:"day",e:"weekday",weekdays:"weekday",weekday:"weekday",E:"isoWeekday",isoweekdays:"isoWeekday",isoweekday:"isoWeekday",DDD:"dayOfYear",dayofyears:"dayOfYear",dayofyear:"dayOfYear",h:"hour",hours:"hour",hour:"hour",ms:"millisecond",milliseconds:"millisecond",millisecond:"millisecond",m:"minute",minutes:"minute",minute:"minute",M:"month",months:"month",month:"month",Q:"quarter",quarters:"quarter",quarter:"quarter",s:"second",seconds:"second",second:"second",gg:"weekYear",weekyears:"weekYear",weekyear:"weekYear",GG:"isoWeekYear",isoweekyears:"isoWeekYear",isoweekyear:"isoWeekYear",w:"week",weeks:"week",week:"week",W:"isoWeek",isoweeks:"isoWeek",isoweek:"isoWeek",y:"year",years:"year",year:"year"};function nt(t){return"string"==typeof t?it[t]||it[t.toLowerCase()]:void 0}function rt(t){var e,i,n={};for(i in t)l(t,i)&&(e=nt(i))&&(n[e]=t[i]);return n}var ot={date:9,day:11,weekday:11,isoWeekday:11,dayOfYear:4,hour:13,millisecond:16,minute:14,month:8,quarter:7,second:15,weekYear:1,isoWeekYear:1,week:5,isoWeek:5,year:1};function st(t){var e,i=[];for(e in t)l(t,e)&&i.push({unit:e,priority:ot[e]});return i.sort((function(t,e){return t.priority-e.priority})),i}var at,lt=/\d/,ht=/\d\d/,ut=/\d{3}/,dt=/\d{4}/,ct=/[+-]?\d{6}/,pt=/\d\d?/,ft=/\d\d\d\d?/,mt=/\d\d\d\d\d\d?/,vt=/\d{1,3}/,gt=/\d{1,4}/,yt=/[+-]?\d{1,6}/,bt=/\d+/,_t=/[+-]?\d+/,wt=/Z|[+-]\d\d:?\d\d/gi,kt=/Z|[+-]\d\d(?::?\d\d)?/gi,xt=/[+-]?\d+(\.\d{1,3})?/,Dt=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,St=/^[1-9]\d?/,Ct=/^([1-9]\d|\d)/;function Tt(t,e,i){at[t]=E(e)?e:function(t,n){return t&&i?i:e}}function Mt(t,e){return l(at,t)?at[t](e._strict,e._locale):new RegExp(Ot(t))}function Ot(t){return Et(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,i,n,r){return e||i||n||r})))}function Et(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}function Pt(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function At(t){var e=+t,i=0;return 0!==e&&isFinite(e)&&(i=Pt(e)),i}at={};var It={};function Lt(t,e){var i,n,r=e;for("string"==typeof t&&(t=[t]),d(e)&&(r=function(t,i){i[e]=At(t)}),n=t.length,i=0;i<n;i++)It[t[i]]=r}function Nt(t,e){Lt(t,(function(t,i,n,r){n._w=n._w||{},e(t,n._w,n,r)}))}function Rt(t,e,i){null!=e&&l(It,t)&&It[t](e,i._a,i,t)}function Ft(t){return t%4==0&&t%100!=0||t%400==0}var jt=0,Yt=1,Ht=2,zt=3,Bt=4,Gt=5,Wt=6,Ut=7,Vt=8;function Xt(t){return Ft(t)?366:365}z("Y",0,0,(function(){var t=this.year();return t<=9999?R(t,4):"+"+t})),z(0,["YY",2],0,(function(){return this.year()%100})),z(0,["YYYY",4],0,"year"),z(0,["YYYYY",5],0,"year"),z(0,["YYYYYY",6,!0],0,"year"),Tt("Y",_t),Tt("YY",pt,ht),Tt("YYYY",gt,dt),Tt("YYYYY",yt,ct),Tt("YYYYYY",yt,ct),Lt(["YYYYY","YYYYYY"],jt),Lt("YYYY",(function(t,e){e[jt]=2===t.length?n.parseTwoDigitYear(t):At(t)})),Lt("YY",(function(t,e){e[jt]=n.parseTwoDigitYear(t)})),Lt("Y",(function(t,e){e[jt]=parseInt(t,10)})),n.parseTwoDigitYear=function(t){return At(t)+(At(t)>68?1900:2e3)};var qt,$t=Kt("FullYear",!0);function Zt(){return Ft(this.year())}function Kt(t,e){return function(i){return null!=i?(Qt(this,t,i),n.updateOffset(this,e),this):Jt(this,t)}}function Jt(t,e){if(!t.isValid())return NaN;var i=t._d,n=t._isUTC;switch(e){case"Milliseconds":return n?i.getUTCMilliseconds():i.getMilliseconds();case"Seconds":return n?i.getUTCSeconds():i.getSeconds();case"Minutes":return n?i.getUTCMinutes():i.getMinutes();case"Hours":return n?i.getUTCHours():i.getHours();case"Date":return n?i.getUTCDate():i.getDate();case"Day":return n?i.getUTCDay():i.getDay();case"Month":return n?i.getUTCMonth():i.getMonth();case"FullYear":return n?i.getUTCFullYear():i.getFullYear();default:return NaN}}function Qt(t,e,i){var n,r,o,s,a;if(t.isValid()&&!isNaN(i)){switch(n=t._d,r=t._isUTC,e){case"Milliseconds":return void(r?n.setUTCMilliseconds(i):n.setMilliseconds(i));case"Seconds":return void(r?n.setUTCSeconds(i):n.setSeconds(i));case"Minutes":return void(r?n.setUTCMinutes(i):n.setMinutes(i));case"Hours":return void(r?n.setUTCHours(i):n.setHours(i));case"Date":return void(r?n.setUTCDate(i):n.setDate(i));case"FullYear":break;default:return}o=i,s=t.month(),a=29!==(a=t.date())||1!==s||Ft(o)?a:28,r?n.setUTCFullYear(o,s,a):n.setFullYear(o,s,a)}}function te(t){return E(this[t=nt(t)])?this[t]():this}function ee(t,e){if("object"==typeof t){var i,n=st(t=rt(t)),r=n.length;for(i=0;i<r;i++)this[n[i].unit](t[n[i].unit])}else if(E(this[t=nt(t)]))return this[t](e);return this}function ie(t,e){return(t%e+e)%e}function ne(t,e){if(isNaN(t)||isNaN(e))return NaN;var i=ie(e,12);return t+=(e-i)/12,1===i?Ft(t)?29:28:31-i%7%2}qt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},z("M",["MM",2],"Mo",(function(){return this.month()+1})),z("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),z("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),Tt("M",pt,St),Tt("MM",pt,ht),Tt("MMM",(function(t,e){return e.monthsShortRegex(t)})),Tt("MMMM",(function(t,e){return e.monthsRegex(t)})),Lt(["M","MM"],(function(t,e){e[Yt]=At(t)-1})),Lt(["MMM","MMMM"],(function(t,e,i,n){var r=i._locale.monthsParse(t,n,i._strict);null!=r?e[Yt]=r:g(i).invalidMonth=t}));var re="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),oe="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),se=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,ae=Dt,le=Dt;function he(t,e){return t?s(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||se).test(e)?"format":"standalone"][t.month()]:s(this._months)?this._months:this._months.standalone}function ue(t,e){return t?s(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[se.test(e)?"format":"standalone"][t.month()]:s(this._monthsShort)?this._monthsShort:this._monthsShort.standalone}function de(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)o=m([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(o,"").toLocaleLowerCase();return i?"MMM"===e?-1!==(r=qt.call(this._shortMonthsParse,s))?r:null:-1!==(r=qt.call(this._longMonthsParse,s))?r:null:"MMM"===e?-1!==(r=qt.call(this._shortMonthsParse,s))||-1!==(r=qt.call(this._longMonthsParse,s))?r:null:-1!==(r=qt.call(this._longMonthsParse,s))||-1!==(r=qt.call(this._shortMonthsParse,s))?r:null}function ce(t,e,i){var n,r,o;if(this._monthsParseExact)return de.call(this,t,e,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(r=m([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[n]=new RegExp(o.replace(".",""),"i")),i&&"MMMM"===e&&this._longMonthsParse[n].test(t))return n;if(i&&"MMM"===e&&this._shortMonthsParse[n].test(t))return n;if(!i&&this._monthsParse[n].test(t))return n}}function pe(t,e){if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=At(e);else if(!d(e=t.localeData().monthsParse(e)))return t;var i=e,n=t.date();return n=n<29?n:Math.min(n,ne(t.year(),i)),t._isUTC?t._d.setUTCMonth(i,n):t._d.setMonth(i,n),t}function fe(t){return null!=t?(pe(this,t),n.updateOffset(this,!0),this):Jt(this,"Month")}function me(){return ne(this.year(),this.month())}function ve(t){return this._monthsParseExact?(l(this,"_monthsRegex")||ye.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(l(this,"_monthsShortRegex")||(this._monthsShortRegex=ae),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)}function ge(t){return this._monthsParseExact?(l(this,"_monthsRegex")||ye.call(this),t?this._monthsStrictRegex:this._monthsRegex):(l(this,"_monthsRegex")||(this._monthsRegex=le),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)}function ye(){function t(t,e){return e.length-t.length}var e,i,n,r,o=[],s=[],a=[];for(e=0;e<12;e++)i=m([2e3,e]),n=Et(this.monthsShort(i,"")),r=Et(this.months(i,"")),o.push(n),s.push(r),a.push(r),a.push(n);o.sort(t),s.sort(t),a.sort(t),this._monthsRegex=new RegExp("^("+a.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+o.join("|")+")","i")}function be(t,e,i,n,r,o,s){var a;return t<100&&t>=0?(a=new Date(t+400,e,i,n,r,o,s),isFinite(a.getFullYear())&&a.setFullYear(t)):a=new Date(t,e,i,n,r,o,s),a}function _e(t){var e,i;return t<100&&t>=0?((i=Array.prototype.slice.call(arguments))[0]=t+400,e=new Date(Date.UTC.apply(null,i)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)):e=new Date(Date.UTC.apply(null,arguments)),e}function we(t,e,i){var n=7+e-i;return-(7+_e(t,0,n).getUTCDay()-e)%7+n-1}function ke(t,e,i,n,r){var o,s,a=1+7*(e-1)+(7+i-n)%7+we(t,n,r);return a<=0?s=Xt(o=t-1)+a:a>Xt(t)?(o=t+1,s=a-Xt(t)):(o=t,s=a),{year:o,dayOfYear:s}}function xe(t,e,i){var n,r,o=we(t.year(),e,i),s=Math.floor((t.dayOfYear()-o-1)/7)+1;return s<1?n=s+De(r=t.year()-1,e,i):s>De(t.year(),e,i)?(n=s-De(t.year(),e,i),r=t.year()+1):(r=t.year(),n=s),{week:n,year:r}}function De(t,e,i){var n=we(t,e,i),r=we(t+1,e,i);return(Xt(t)-n+r)/7}function Se(t){return xe(t,this._week.dow,this._week.doy).week}z("w",["ww",2],"wo","week"),z("W",["WW",2],"Wo","isoWeek"),Tt("w",pt,St),Tt("ww",pt,ht),Tt("W",pt,St),Tt("WW",pt,ht),Nt(["w","ww","W","WW"],(function(t,e,i,n){e[n.substr(0,1)]=At(t)}));var Ce={dow:0,doy:6};function Te(){return this._week.dow}function Me(){return this._week.doy}function Oe(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")}function Ee(t){var e=xe(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")}function Pe(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}function Ae(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}function Ie(t,e){return t.slice(e,7).concat(t.slice(0,e))}z("d",0,"do","day"),z("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),z("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),z("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),z("e",0,0,"weekday"),z("E",0,0,"isoWeekday"),Tt("d",pt),Tt("e",pt),Tt("E",pt),Tt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),Tt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),Tt("dddd",(function(t,e){return e.weekdaysRegex(t)})),Nt(["dd","ddd","dddd"],(function(t,e,i,n){var r=i._locale.weekdaysParse(t,n,i._strict);null!=r?e.d=r:g(i).invalidWeekday=t})),Nt(["d","e","E"],(function(t,e,i,n){e[n]=At(t)}));var Le="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Ne="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Re="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Fe=Dt,je=Dt,Ye=Dt;function He(t,e){var i=s(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Ie(i,this._week.dow):t?i[t.day()]:i}function ze(t){return!0===t?Ie(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort}function Be(t){return!0===t?Ie(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin}function Ge(t,e,i){var n,r,o,s=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)o=m([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(o,"").toLocaleLowerCase();return i?"dddd"===e?-1!==(r=qt.call(this._weekdaysParse,s))?r:null:"ddd"===e?-1!==(r=qt.call(this._shortWeekdaysParse,s))?r:null:-1!==(r=qt.call(this._minWeekdaysParse,s))?r:null:"dddd"===e?-1!==(r=qt.call(this._weekdaysParse,s))||-1!==(r=qt.call(this._shortWeekdaysParse,s))||-1!==(r=qt.call(this._minWeekdaysParse,s))?r:null:"ddd"===e?-1!==(r=qt.call(this._shortWeekdaysParse,s))||-1!==(r=qt.call(this._weekdaysParse,s))||-1!==(r=qt.call(this._minWeekdaysParse,s))?r:null:-1!==(r=qt.call(this._minWeekdaysParse,s))||-1!==(r=qt.call(this._weekdaysParse,s))||-1!==(r=qt.call(this._shortWeekdaysParse,s))?r:null}function We(t,e,i){var n,r,o;if(this._weekdaysParseExact)return Ge.call(this,t,e,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(r=m([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[n]=new RegExp(o.replace(".",""),"i")),i&&"dddd"===e&&this._fullWeekdaysParse[n].test(t))return n;if(i&&"ddd"===e&&this._shortWeekdaysParse[n].test(t))return n;if(i&&"dd"===e&&this._minWeekdaysParse[n].test(t))return n;if(!i&&this._weekdaysParse[n].test(t))return n}}function Ue(t){if(!this.isValid())return null!=t?this:NaN;var e=Jt(this,"Day");return null!=t?(t=Pe(t,this.localeData()),this.add(t-e,"d")):e}function Ve(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")}function Xe(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=Ae(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7}function qe(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(l(this,"_weekdaysRegex")||(this._weekdaysRegex=Fe),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)}function $e(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(l(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=je),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)}function Ze(t){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||Ke.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(l(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Ye),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)}function Ke(){function t(t,e){return e.length-t.length}var e,i,n,r,o,s=[],a=[],l=[],h=[];for(e=0;e<7;e++)i=m([2e3,1]).day(e),n=Et(this.weekdaysMin(i,"")),r=Et(this.weekdaysShort(i,"")),o=Et(this.weekdays(i,"")),s.push(n),a.push(r),l.push(o),h.push(n),h.push(r),h.push(o);s.sort(t),a.sort(t),l.sort(t),h.sort(t),this._weekdaysRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+s.join("|")+")","i")}function Je(){return this.hours()%12||12}function Qe(){return this.hours()||24}function ti(t,e){z(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function ei(t,e){return e._meridiemParse}function ii(t){return"p"===(t+"").toLowerCase().charAt(0)}z("H",["HH",2],0,"hour"),z("h",["hh",2],0,Je),z("k",["kk",2],0,Qe),z("hmm",0,0,(function(){return""+Je.apply(this)+R(this.minutes(),2)})),z("hmmss",0,0,(function(){return""+Je.apply(this)+R(this.minutes(),2)+R(this.seconds(),2)})),z("Hmm",0,0,(function(){return""+this.hours()+R(this.minutes(),2)})),z("Hmmss",0,0,(function(){return""+this.hours()+R(this.minutes(),2)+R(this.seconds(),2)})),ti("a",!0),ti("A",!1),Tt("a",ei),Tt("A",ei),Tt("H",pt,Ct),Tt("h",pt,St),Tt("k",pt,St),Tt("HH",pt,ht),Tt("hh",pt,ht),Tt("kk",pt,ht),Tt("hmm",ft),Tt("hmmss",mt),Tt("Hmm",ft),Tt("Hmmss",mt),Lt(["H","HH"],zt),Lt(["k","kk"],(function(t,e,i){var n=At(t);e[zt]=24===n?0:n})),Lt(["a","A"],(function(t,e,i){i._isPm=i._locale.isPM(t),i._meridiem=t})),Lt(["h","hh"],(function(t,e,i){e[zt]=At(t),g(i).bigHour=!0})),Lt("hmm",(function(t,e,i){var n=t.length-2;e[zt]=At(t.substr(0,n)),e[Bt]=At(t.substr(n)),g(i).bigHour=!0})),Lt("hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[zt]=At(t.substr(0,n)),e[Bt]=At(t.substr(n,2)),e[Gt]=At(t.substr(r)),g(i).bigHour=!0})),Lt("Hmm",(function(t,e,i){var n=t.length-2;e[zt]=At(t.substr(0,n)),e[Bt]=At(t.substr(n))})),Lt("Hmmss",(function(t,e,i){var n=t.length-4,r=t.length-2;e[zt]=At(t.substr(0,n)),e[Bt]=At(t.substr(n,2)),e[Gt]=At(t.substr(r))}));var ni=/[ap]\.?m?\.?/i,ri=Kt("Hours",!0);function oi(t,e,i){return t>11?i?"pm":"PM":i?"am":"AM"}var si,ai={calendar:L,longDateFormat:V,invalidDate:q,ordinal:Z,dayOfMonthOrdinalParse:K,relativeTime:Q,months:re,monthsShort:oe,week:Ce,weekdays:Le,weekdaysMin:Re,weekdaysShort:Ne,meridiemParse:ni},li={},hi={};function ui(t,e){var i,n=Math.min(t.length,e.length);for(i=0;i<n;i+=1)if(t[i]!==e[i])return i;return n}function di(t){return t?t.toLowerCase().replace("_","-"):t}function ci(t){for(var e,i,n,r,o=0;o<t.length;){for(e=(r=di(t[o]).split("-")).length,i=(i=di(t[o+1]))?i.split("-"):null;e>0;){if(n=fi(r.slice(0,e).join("-")))return n;if(i&&i.length>=e&&ui(r,i)>=e-1)break;e--}o++}return si}function pi(t){return!(!t||!t.match("^[^/\\\\]*$"))}function fi(e){var i=null;if(void 0===li[e]&&t&&t.exports&&pi(e))try{i=si._abbr,r("./locale/"+e),mi(i)}catch(t){li[e]=null}return li[e]}function mi(t,e){var i;return t&&((i=u(e)?yi(t):vi(t,e))?si=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),si._abbr}function vi(t,e){if(null!==e){var i,n=ai;if(e.abbr=t,null!=li[t])O("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=li[t]._config;else if(null!=e.parentLocale)if(null!=li[e.parentLocale])n=li[e.parentLocale]._config;else{if(null==(i=fi(e.parentLocale)))return hi[e.parentLocale]||(hi[e.parentLocale]=[]),hi[e.parentLocale].push({name:t,config:e}),null;n=i._config}return li[t]=new I(A(n,e)),hi[t]&&hi[t].forEach((function(t){vi(t.name,t.config)})),mi(t),li[t]}return delete li[t],null}function gi(t,e){if(null!=e){var i,n,r=ai;null!=li[t]&&null!=li[t].parentLocale?li[t].set(A(li[t]._config,e)):(null!=(n=fi(t))&&(r=n._config),e=A(r,e),null==n&&(e.abbr=t),(i=new I(e)).parentLocale=li[t],li[t]=i),mi(t)}else null!=li[t]&&(null!=li[t].parentLocale?(li[t]=li[t].parentLocale,t===mi()&&mi(t)):null!=li[t]&&delete li[t]);return li[t]}function yi(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return si;if(!s(t)){if(e=fi(t))return e;t=[t]}return ci(t)}function bi(){return T(li)}function _i(t){var e,i=t._a;return i&&-2===g(t).overflow&&(e=i[Yt]<0||i[Yt]>11?Yt:i[Ht]<1||i[Ht]>ne(i[jt],i[Yt])?Ht:i[zt]<0||i[zt]>24||24===i[zt]&&(0!==i[Bt]||0!==i[Gt]||0!==i[Wt])?zt:i[Bt]<0||i[Bt]>59?Bt:i[Gt]<0||i[Gt]>59?Gt:i[Wt]<0||i[Wt]>999?Wt:-1,g(t)._overflowDayOfYear&&(e<jt||e>Ht)&&(e=Ht),g(t)._overflowWeeks&&-1===e&&(e=Ut),g(t)._overflowWeekday&&-1===e&&(e=Vt),g(t).overflow=e),t}var wi=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ki=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,xi=/Z|[+-]\d\d(?::?\d\d)?/,Di=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],Si=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Ci=/^\/?Date\((-?\d+)/i,Ti=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,Mi={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Oi(t){var e,i,n,r,o,s,a=t._i,l=wi.exec(a)||ki.exec(a),h=Di.length,u=Si.length;if(l){for(g(t).iso=!0,e=0,i=h;e<i;e++)if(Di[e][1].exec(l[1])){r=Di[e][0],n=!1!==Di[e][2];break}if(null==r)return void(t._isValid=!1);if(l[3]){for(e=0,i=u;e<i;e++)if(Si[e][1].exec(l[3])){o=(l[2]||" ")+Si[e][0];break}if(null==o)return void(t._isValid=!1)}if(!n&&null!=o)return void(t._isValid=!1);if(l[4]){if(!xi.exec(l[4]))return void(t._isValid=!1);s="Z"}t._f=r+(o||"")+(s||""),zi(t)}else t._isValid=!1}function Ei(t,e,i,n,r,o){var s=[Pi(t),oe.indexOf(e),parseInt(i,10),parseInt(n,10),parseInt(r,10)];return o&&s.push(parseInt(o,10)),s}function Pi(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function Ai(t){return t.replace(/\([^()]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,"")}function Ii(t,e,i){return!t||Ne.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(g(i).weekdayMismatch=!0,i._isValid=!1,!1)}function Li(t,e,i){if(t)return Mi[t];if(e)return 0;var n=parseInt(i,10),r=n%100;return(n-r)/100*60+r}function Ni(t){var e,i=Ti.exec(Ai(t._i));if(i){if(e=Ei(i[4],i[3],i[2],i[5],i[6],i[7]),!Ii(i[1],e,t))return;t._a=e,t._tzm=Li(i[8],i[9],i[10]),t._d=_e.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),g(t).rfc2822=!0}else t._isValid=!1}function Ri(t){var e=Ci.exec(t._i);null===e?(Oi(t),!1===t._isValid&&(delete t._isValid,Ni(t),!1===t._isValid&&(delete t._isValid,t._strict?t._isValid=!1:n.createFromInputFallback(t)))):t._d=new Date(+e[1])}function Fi(t,e,i){return null!=t?t:null!=e?e:i}function ji(t){var e=new Date(n.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}function Yi(t){var e,i,n,r,o,s=[];if(!t._d){for(n=ji(t),t._w&&null==t._a[Ht]&&null==t._a[Yt]&&Hi(t),null!=t._dayOfYear&&(o=Fi(t._a[jt],n[jt]),(t._dayOfYear>Xt(o)||0===t._dayOfYear)&&(g(t)._overflowDayOfYear=!0),i=_e(o,0,t._dayOfYear),t._a[Yt]=i.getUTCMonth(),t._a[Ht]=i.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=s[e]=n[e];for(;e<7;e++)t._a[e]=s[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[zt]&&0===t._a[Bt]&&0===t._a[Gt]&&0===t._a[Wt]&&(t._nextDay=!0,t._a[zt]=0),t._d=(t._useUTC?_e:be).apply(null,s),r=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[zt]=24),t._w&&void 0!==t._w.d&&t._w.d!==r&&(g(t).weekdayMismatch=!0)}}function Hi(t){var e,i,n,r,o,s,a,l,h;null!=(e=t._w).GG||null!=e.W||null!=e.E?(o=1,s=4,i=Fi(e.GG,t._a[jt],xe($i(),1,4).year),n=Fi(e.W,1),((r=Fi(e.E,1))<1||r>7)&&(l=!0)):(o=t._locale._week.dow,s=t._locale._week.doy,h=xe($i(),o,s),i=Fi(e.gg,t._a[jt],h.year),n=Fi(e.w,h.week),null!=e.d?((r=e.d)<0||r>6)&&(l=!0):null!=e.e?(r=e.e+o,(e.e<0||e.e>6)&&(l=!0)):r=o),n<1||n>De(i,o,s)?g(t)._overflowWeeks=!0:null!=l?g(t)._overflowWeekday=!0:(a=ke(i,n,r,o,s),t._a[jt]=a.year,t._dayOfYear=a.dayOfYear)}function zi(t){if(t._f!==n.ISO_8601)if(t._f!==n.RFC_2822){t._a=[],g(t).empty=!0;var e,i,r,o,s,a,l,h=""+t._i,u=h.length,d=0;for(l=(r=U(t._f,t._locale).match(F)||[]).length,e=0;e<l;e++)o=r[e],(i=(h.match(Mt(o,t))||[])[0])&&((s=h.substr(0,h.indexOf(i))).length>0&&g(t).unusedInput.push(s),h=h.slice(h.indexOf(i)+i.length),d+=i.length),H[o]?(i?g(t).empty=!1:g(t).unusedTokens.push(o),Rt(o,i,t)):t._strict&&!i&&g(t).unusedTokens.push(o);g(t).charsLeftOver=u-d,h.length>0&&g(t).unusedInput.push(h),t._a[zt]<=12&&!0===g(t).bigHour&&t._a[zt]>0&&(g(t).bigHour=void 0),g(t).parsedDateParts=t._a.slice(0),g(t).meridiem=t._meridiem,t._a[zt]=Bi(t._locale,t._a[zt],t._meridiem),null!==(a=g(t).era)&&(t._a[jt]=t._locale.erasConvertYear(a,t._a[jt])),Yi(t),_i(t)}else Ni(t);else Oi(t)}function Bi(t,e,i){var n;return null==i?e:null!=t.meridiemHour?t.meridiemHour(e,i):null!=t.isPM?((n=t.isPM(i))&&e<12&&(e+=12),n||12!==e||(e=0),e):e}function Gi(t){var e,i,n,r,o,s,a=!1,l=t._f.length;if(0===l)return g(t).invalidFormat=!0,void(t._d=new Date(NaN));for(r=0;r<l;r++)o=0,s=!1,e=k({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[r],zi(e),y(e)&&(s=!0),o+=g(e).charsLeftOver,o+=10*g(e).unusedTokens.length,g(e).score=o,a?o<n&&(n=o,i=e):(null==n||o<n||s)&&(n=o,i=e,s&&(a=!0));f(t,i||e)}function Wi(t){if(!t._d){var e=rt(t._i),i=void 0===e.day?e.date:e.day;t._a=p([e.year,e.month,i,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),Yi(t)}}function Ui(t){var e=new x(_i(Vi(t)));return e._nextDay&&(e.add(1,"d"),e._nextDay=void 0),e}function Vi(t){var e=t._i,i=t._f;return t._locale=t._locale||yi(t._l),null===e||void 0===i&&""===e?b({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),D(e)?new x(_i(e)):(c(e)?t._d=e:s(i)?Gi(t):i?zi(t):Xi(t),y(t)||(t._d=null),t))}function Xi(t){var e=t._i;u(e)?t._d=new Date(n.now()):c(e)?t._d=new Date(e.valueOf()):"string"==typeof e?Ri(t):s(e)?(t._a=p(e.slice(0),(function(t){return parseInt(t,10)})),Yi(t)):a(e)?Wi(t):d(e)?t._d=new Date(e):n.createFromInputFallback(t)}function qi(t,e,i,n,r){var o={};return!0!==e&&!1!==e||(n=e,e=void 0),!0!==i&&!1!==i||(n=i,i=void 0),(a(t)&&h(t)||s(t)&&0===t.length)&&(t=void 0),o._isAMomentObject=!0,o._useUTC=o._isUTC=r,o._l=i,o._i=t,o._f=e,o._strict=n,Ui(o)}function $i(t,e,i,n){return qi(t,e,i,n,!1)}n.createFromInputFallback=C("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),n.ISO_8601=function(){},n.RFC_2822=function(){};var Zi=C("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=$i.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:b()})),Ki=C("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=$i.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:b()}));function Ji(t,e){var i,n;if(1===e.length&&s(e[0])&&(e=e[0]),!e.length)return $i();for(i=e[0],n=1;n<e.length;++n)e[n].isValid()&&!e[n][t](i)||(i=e[n]);return i}function Qi(){return Ji("isBefore",[].slice.call(arguments,0))}function tn(){return Ji("isAfter",[].slice.call(arguments,0))}var en=function(){return Date.now?Date.now():+new Date},nn=["year","quarter","month","week","day","hour","minute","second","millisecond"];function rn(t){var e,i,n=!1,r=nn.length;for(e in t)if(l(t,e)&&(-1===qt.call(nn,e)||null!=t[e]&&isNaN(t[e])))return!1;for(i=0;i<r;++i)if(t[nn[i]]){if(n)return!1;parseFloat(t[nn[i]])!==At(t[nn[i]])&&(n=!0)}return!0}function on(){return this._isValid}function sn(){return On(NaN)}function an(t){var e=rt(t),i=e.year||0,n=e.quarter||0,r=e.month||0,o=e.week||e.isoWeek||0,s=e.day||0,a=e.hour||0,l=e.minute||0,h=e.second||0,u=e.millisecond||0;this._isValid=rn(e),this._milliseconds=+u+1e3*h+6e4*l+1e3*a*60*60,this._days=+s+7*o,this._months=+r+3*n+12*i,this._data={},this._locale=yi(),this._bubble()}function ln(t){return t instanceof an}function hn(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function un(t,e,i){var n,r=Math.min(t.length,e.length),o=Math.abs(t.length-e.length),s=0;for(n=0;n<r;n++)(i&&t[n]!==e[n]||!i&&At(t[n])!==At(e[n]))&&s++;return s+o}function dn(t,e){z(t,0,0,(function(){var t=this.utcOffset(),i="+";return t<0&&(t=-t,i="-"),i+R(~~(t/60),2)+e+R(~~t%60,2)}))}dn("Z",":"),dn("ZZ",""),Tt("Z",kt),Tt("ZZ",kt),Lt(["Z","ZZ"],(function(t,e,i){i._useUTC=!0,i._tzm=pn(kt,t)}));var cn=/([\+\-]|\d\d)/gi;function pn(t,e){var i,n,r=(e||"").match(t);return null===r?null:0===(n=60*(i=((r[r.length-1]||[])+"").match(cn)||["-",0,0])[1]+At(i[2]))?0:"+"===i[0]?n:-n}function fn(t,e){var i,r;return e._isUTC?(i=e.clone(),r=(D(t)||c(t)?t.valueOf():$i(t).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+r),n.updateOffset(i,!1),i):$i(t).local()}function mn(t){return-Math.round(t._d.getTimezoneOffset())}function vn(t,e,i){var r,o=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=pn(kt,t)))return this}else Math.abs(t)<16&&!i&&(t*=60);return!this._isUTC&&e&&(r=mn(this)),this._offset=t,this._isUTC=!0,null!=r&&this.add(r,"m"),o!==t&&(!e||this._changeInProgress?Ln(this,On(t-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,n.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:mn(this)}function gn(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()}function yn(t){return this.utcOffset(0,t)}function bn(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(mn(this),"m")),this}function _n(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=pn(wt,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this}function wn(t){return!!this.isValid()&&(t=t?$i(t).utcOffset():0,(this.utcOffset()-t)%60==0)}function kn(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()}function xn(){if(!u(this._isDSTShifted))return this._isDSTShifted;var t,e={};return k(e,this),(e=Vi(e))._a?(t=e._isUTC?m(e._a):$i(e._a),this._isDSTShifted=this.isValid()&&un(e._a,t.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}function Dn(){return!!this.isValid()&&!this._isUTC}function Sn(){return!!this.isValid()&&this._isUTC}function Cn(){return!!this.isValid()&&this._isUTC&&0===this._offset}n.updateOffset=function(){};var Tn=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,Mn=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function On(t,e){var i,n,r,o=t,s=null;return ln(t)?o={ms:t._milliseconds,d:t._days,M:t._months}:d(t)||!isNaN(+t)?(o={},e?o[e]=+t:o.milliseconds=+t):(s=Tn.exec(t))?(i="-"===s[1]?-1:1,o={y:0,d:At(s[Ht])*i,h:At(s[zt])*i,m:At(s[Bt])*i,s:At(s[Gt])*i,ms:At(hn(1e3*s[Wt]))*i}):(s=Mn.exec(t))?(i="-"===s[1]?-1:1,o={y:En(s[2],i),M:En(s[3],i),w:En(s[4],i),d:En(s[5],i),h:En(s[6],i),m:En(s[7],i),s:En(s[8],i)}):null==o?o={}:"object"==typeof o&&("from"in o||"to"in o)&&(r=An($i(o.from),$i(o.to)),(o={}).ms=r.milliseconds,o.M=r.months),n=new an(o),ln(t)&&l(t,"_locale")&&(n._locale=t._locale),ln(t)&&l(t,"_isValid")&&(n._isValid=t._isValid),n}function En(t,e){var i=t&&parseFloat(t.replace(",","."));return(isNaN(i)?0:i)*e}function Pn(t,e){var i={};return i.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(i.months,"M").isAfter(e)&&--i.months,i.milliseconds=+e-+t.clone().add(i.months,"M"),i}function An(t,e){var i;return t.isValid()&&e.isValid()?(e=fn(e,t),t.isBefore(e)?i=Pn(t,e):((i=Pn(e,t)).milliseconds=-i.milliseconds,i.months=-i.months),i):{milliseconds:0,months:0}}function In(t,e){return function(i,n){var r;return null===n||isNaN(+n)||(O(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=i,i=n,n=r),Ln(this,On(i,n),t),this}}function Ln(t,e,i,r){var o=e._milliseconds,s=hn(e._days),a=hn(e._months);t.isValid()&&(r=null==r||r,a&&pe(t,Jt(t,"Month")+a*i),s&&Qt(t,"Date",Jt(t,"Date")+s*i),o&&t._d.setTime(t._d.valueOf()+o*i),r&&n.updateOffset(t,s||a))}On.fn=an.prototype,On.invalid=sn;var Nn=In(1,"add"),Rn=In(-1,"subtract");function Fn(t){return"string"==typeof t||t instanceof String}function jn(t){return D(t)||c(t)||Fn(t)||d(t)||Hn(t)||Yn(t)||null==t}function Yn(t){var e,i,n=a(t)&&!h(t),r=!1,o=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"],s=o.length;for(e=0;e<s;e+=1)i=o[e],r=r||l(t,i);return n&&r}function Hn(t){var e=s(t),i=!1;return e&&(i=0===t.filter((function(e){return!d(e)&&Fn(t)})).length),e&&i}function zn(t){var e,i,n=a(t)&&!h(t),r=!1,o=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(e=0;e<o.length;e+=1)i=o[e],r=r||l(t,i);return n&&r}function Bn(t,e){var i=t.diff(e,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"}function Gn(t,e){1===arguments.length&&(arguments[0]?jn(arguments[0])?(t=arguments[0],e=void 0):zn(arguments[0])&&(e=arguments[0],t=void 0):(t=void 0,e=void 0));var i=t||$i(),r=fn(i,this).startOf("day"),o=n.calendarFormat(this,r)||"sameElse",s=e&&(E(e[o])?e[o].call(this,i):e[o]);return this.format(s||this.localeData().calendar(o,this,$i(i)))}function Wn(){return new x(this)}function Un(t,e){var i=D(t)?t:$i(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=nt(e)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(e).valueOf())}function Vn(t,e){var i=D(t)?t:$i(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=nt(e)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(e).valueOf()<i.valueOf())}function Xn(t,e,i,n){var r=D(t)?t:$i(t),o=D(e)?e:$i(e);return!!(this.isValid()&&r.isValid()&&o.isValid())&&("("===(n=n||"()")[0]?this.isAfter(r,i):!this.isBefore(r,i))&&(")"===n[1]?this.isBefore(o,i):!this.isAfter(o,i))}function qn(t,e){var i,n=D(t)?t:$i(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=nt(e)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(e).valueOf()<=i&&i<=this.clone().endOf(e).valueOf()))}function $n(t,e){return this.isSame(t,e)||this.isAfter(t,e)}function Zn(t,e){return this.isSame(t,e)||this.isBefore(t,e)}function Kn(t,e,i){var n,r,o;if(!this.isValid())return NaN;if(!(n=fn(t,this)).isValid())return NaN;switch(r=6e4*(n.utcOffset()-this.utcOffset()),e=nt(e)){case"year":o=Jn(this,n)/12;break;case"month":o=Jn(this,n);break;case"quarter":o=Jn(this,n)/3;break;case"second":o=(this-n)/1e3;break;case"minute":o=(this-n)/6e4;break;case"hour":o=(this-n)/36e5;break;case"day":o=(this-n-r)/864e5;break;case"week":o=(this-n-r)/6048e5;break;default:o=this-n}return i?o:Pt(o)}function Jn(t,e){if(t.date()<e.date())return-Jn(e,t);var i=12*(e.year()-t.year())+(e.month()-t.month()),n=t.clone().add(i,"months");return-(i+(e-n<0?(e-n)/(n-t.clone().add(i-1,"months")):(e-n)/(t.clone().add(i+1,"months")-n)))||0}function Qn(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")}function tr(t){if(!this.isValid())return null;var e=!0!==t,i=e?this.clone().utc():this;return i.year()<0||i.year()>9999?W(i,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):E(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",W(i,"Z")):W(i,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")}function er(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t,e,i,n,r="moment",o="";return this.isLocal()||(r=0===this.utcOffset()?"moment.utc":"moment.parseZone",o="Z"),t="["+r+'("]',e=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",i="-MM-DD[T]HH:mm:ss.SSS",n=o+'[")]',this.format(t+e+i+n)}function ir(t){t||(t=this.isUtc()?n.defaultFormatUtc:n.defaultFormat);var e=W(this,t);return this.localeData().postformat(e)}function nr(t,e){return this.isValid()&&(D(t)&&t.isValid()||$i(t).isValid())?On({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()}function rr(t){return this.from($i(),t)}function or(t,e){return this.isValid()&&(D(t)&&t.isValid()||$i(t).isValid())?On({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()}function sr(t){return this.to($i(),t)}function ar(t){var e;return void 0===t?this._locale._abbr:(null!=(e=yi(t))&&(this._locale=e),this)}n.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",n.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var lr=C("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function hr(){return this._locale}var ur=1e3,dr=60*ur,cr=60*dr,pr=3506328*cr;function fr(t,e){return(t%e+e)%e}function mr(t,e,i){return t<100&&t>=0?new Date(t+400,e,i)-pr:new Date(t,e,i).valueOf()}function vr(t,e,i){return t<100&&t>=0?Date.UTC(t+400,e,i)-pr:Date.UTC(t,e,i)}function gr(t){var e,i;if(void 0===(t=nt(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?vr:mr,t){case"year":e=i(this.year(),0,1);break;case"quarter":e=i(this.year(),this.month()-this.month()%3,1);break;case"month":e=i(this.year(),this.month(),1);break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=i(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=fr(e+(this._isUTC?0:this.utcOffset()*dr),cr);break;case"minute":e=this._d.valueOf(),e-=fr(e,dr);break;case"second":e=this._d.valueOf(),e-=fr(e,ur)}return this._d.setTime(e),n.updateOffset(this,!0),this}function yr(t){var e,i;if(void 0===(t=nt(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?vr:mr,t){case"year":e=i(this.year()+1,0,1)-1;break;case"quarter":e=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=i(this.year(),this.month()+1,1)-1;break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=cr-fr(e+(this._isUTC?0:this.utcOffset()*dr),cr)-1;break;case"minute":e=this._d.valueOf(),e+=dr-fr(e,dr)-1;break;case"second":e=this._d.valueOf(),e+=ur-fr(e,ur)-1}return this._d.setTime(e),n.updateOffset(this,!0),this}function br(){return this._d.valueOf()-6e4*(this._offset||0)}function _r(){return Math.floor(this.valueOf()/1e3)}function wr(){return new Date(this.valueOf())}function kr(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]}function xr(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}}function Dr(){return this.isValid()?this.toISOString():null}function Sr(){return y(this)}function Cr(){return f({},g(this))}function Tr(){return g(this).overflow}function Mr(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}}function Or(t,e){var i,r,o,s=this._eras||yi("en")._eras;for(i=0,r=s.length;i<r;++i)switch("string"==typeof s[i].since&&(o=n(s[i].since).startOf("day"),s[i].since=o.valueOf()),typeof s[i].until){case"undefined":s[i].until=1/0;break;case"string":o=n(s[i].until).startOf("day").valueOf(),s[i].until=o.valueOf()}return s}function Er(t,e,i){var n,r,o,s,a,l=this.eras();for(t=t.toUpperCase(),n=0,r=l.length;n<r;++n)if(o=l[n].name.toUpperCase(),s=l[n].abbr.toUpperCase(),a=l[n].narrow.toUpperCase(),i)switch(e){case"N":case"NN":case"NNN":if(s===t)return l[n];break;case"NNNN":if(o===t)return l[n];break;case"NNNNN":if(a===t)return l[n]}else if([o,s,a].indexOf(t)>=0)return l[n]}function Pr(t,e){var i=t.since<=t.until?1:-1;return void 0===e?n(t.since).year():n(t.since).year()+(e-t.offset)*i}function Ar(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].name;if(n[t].until<=i&&i<=n[t].since)return n[t].name}return""}function Ir(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].narrow;if(n[t].until<=i&&i<=n[t].since)return n[t].narrow}return""}function Lr(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.clone().startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].abbr;if(n[t].until<=i&&i<=n[t].since)return n[t].abbr}return""}function Nr(){var t,e,i,r,o=this.localeData().eras();for(t=0,e=o.length;t<e;++t)if(i=o[t].since<=o[t].until?1:-1,r=this.clone().startOf("day").valueOf(),o[t].since<=r&&r<=o[t].until||o[t].until<=r&&r<=o[t].since)return(this.year()-n(o[t].since).year())*i+o[t].offset;return this.year()}function Rr(t){return l(this,"_erasNameRegex")||Gr.call(this),t?this._erasNameRegex:this._erasRegex}function Fr(t){return l(this,"_erasAbbrRegex")||Gr.call(this),t?this._erasAbbrRegex:this._erasRegex}function jr(t){return l(this,"_erasNarrowRegex")||Gr.call(this),t?this._erasNarrowRegex:this._erasRegex}function Yr(t,e){return e.erasAbbrRegex(t)}function Hr(t,e){return e.erasNameRegex(t)}function zr(t,e){return e.erasNarrowRegex(t)}function Br(t,e){return e._eraYearOrdinalRegex||bt}function Gr(){var t,e,i,n,r,o=[],s=[],a=[],l=[],h=this.eras();for(t=0,e=h.length;t<e;++t)i=Et(h[t].name),n=Et(h[t].abbr),r=Et(h[t].narrow),s.push(i),o.push(n),a.push(r),l.push(i),l.push(n),l.push(r);this._erasRegex=new RegExp("^("+l.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+s.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+o.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+a.join("|")+")","i")}function Wr(t,e){z(0,[t,t.length],0,e)}function Ur(t){return Kr.call(this,t,this.week(),this.weekday()+this.localeData()._week.dow,this.localeData()._week.dow,this.localeData()._week.doy)}function Vr(t){return Kr.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)}function Xr(){return De(this.year(),1,4)}function qr(){return De(this.isoWeekYear(),1,4)}function $r(){var t=this.localeData()._week;return De(this.year(),t.dow,t.doy)}function Zr(){var t=this.localeData()._week;return De(this.weekYear(),t.dow,t.doy)}function Kr(t,e,i,n,r){var o;return null==t?xe(this,n,r).year:(e>(o=De(t,n,r))&&(e=o),Jr.call(this,t,e,i,n,r))}function Jr(t,e,i,n,r){var o=ke(t,e,i,n,r),s=_e(o.year,0,o.dayOfYear);return this.year(s.getUTCFullYear()),this.month(s.getUTCMonth()),this.date(s.getUTCDate()),this}function Qr(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)}z("N",0,0,"eraAbbr"),z("NN",0,0,"eraAbbr"),z("NNN",0,0,"eraAbbr"),z("NNNN",0,0,"eraName"),z("NNNNN",0,0,"eraNarrow"),z("y",["y",1],"yo","eraYear"),z("y",["yy",2],0,"eraYear"),z("y",["yyy",3],0,"eraYear"),z("y",["yyyy",4],0,"eraYear"),Tt("N",Yr),Tt("NN",Yr),Tt("NNN",Yr),Tt("NNNN",Hr),Tt("NNNNN",zr),Lt(["N","NN","NNN","NNNN","NNNNN"],(function(t,e,i,n){var r=i._locale.erasParse(t,n,i._strict);r?g(i).era=r:g(i).invalidEra=t})),Tt("y",bt),Tt("yy",bt),Tt("yyy",bt),Tt("yyyy",bt),Tt("yo",Br),Lt(["y","yy","yyy","yyyy"],jt),Lt(["yo"],(function(t,e,i,n){var r;i._locale._eraYearOrdinalRegex&&(r=t.match(i._locale._eraYearOrdinalRegex)),i._locale.eraYearOrdinalParse?e[jt]=i._locale.eraYearOrdinalParse(t,r):e[jt]=parseInt(t,10)})),z(0,["gg",2],0,(function(){return this.weekYear()%100})),z(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),Wr("gggg","weekYear"),Wr("ggggg","weekYear"),Wr("GGGG","isoWeekYear"),Wr("GGGGG","isoWeekYear"),Tt("G",_t),Tt("g",_t),Tt("GG",pt,ht),Tt("gg",pt,ht),Tt("GGGG",gt,dt),Tt("gggg",gt,dt),Tt("GGGGG",yt,ct),Tt("ggggg",yt,ct),Nt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,i,n){e[n.substr(0,2)]=At(t)})),Nt(["gg","GG"],(function(t,e,i,r){e[r]=n.parseTwoDigitYear(t)})),z("Q",0,"Qo","quarter"),Tt("Q",lt),Lt("Q",(function(t,e){e[Yt]=3*(At(t)-1)})),z("D",["DD",2],"Do","date"),Tt("D",pt,St),Tt("DD",pt,ht),Tt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),Lt(["D","DD"],Ht),Lt("Do",(function(t,e){e[Ht]=At(t.match(pt)[0])}));var to=Kt("Date",!0);function eo(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")}z("DDD",["DDDD",3],"DDDo","dayOfYear"),Tt("DDD",vt),Tt("DDDD",ut),Lt(["DDD","DDDD"],(function(t,e,i){i._dayOfYear=At(t)})),z("m",["mm",2],0,"minute"),Tt("m",pt,Ct),Tt("mm",pt,ht),Lt(["m","mm"],Bt);var io=Kt("Minutes",!1);z("s",["ss",2],0,"second"),Tt("s",pt,Ct),Tt("ss",pt,ht),Lt(["s","ss"],Gt);var no,ro,oo=Kt("Seconds",!1);for(z("S",0,0,(function(){return~~(this.millisecond()/100)})),z(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),z(0,["SSS",3],0,"millisecond"),z(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),z(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),z(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),z(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),z(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),z(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),Tt("S",vt,lt),Tt("SS",vt,ht),Tt("SSS",vt,ut),no="SSSS";no.length<=9;no+="S")Tt(no,bt);function so(t,e){e[Wt]=At(1e3*("0."+t))}for(no="S";no.length<=9;no+="S")Lt(no,so);function ao(){return this._isUTC?"UTC":""}function lo(){return this._isUTC?"Coordinated Universal Time":""}ro=Kt("Milliseconds",!1),z("z",0,0,"zoneAbbr"),z("zz",0,0,"zoneName");var ho=x.prototype;function uo(t){return $i(1e3*t)}function co(){return $i.apply(null,arguments).parseZone()}function po(t){return t}ho.add=Nn,ho.calendar=Gn,ho.clone=Wn,ho.diff=Kn,ho.endOf=yr,ho.format=ir,ho.from=nr,ho.fromNow=rr,ho.to=or,ho.toNow=sr,ho.get=te,ho.invalidAt=Tr,ho.isAfter=Un,ho.isBefore=Vn,ho.isBetween=Xn,ho.isSame=qn,ho.isSameOrAfter=$n,ho.isSameOrBefore=Zn,ho.isValid=Sr,ho.lang=lr,ho.locale=ar,ho.localeData=hr,ho.max=Ki,ho.min=Zi,ho.parsingFlags=Cr,ho.set=ee,ho.startOf=gr,ho.subtract=Rn,ho.toArray=kr,ho.toObject=xr,ho.toDate=wr,ho.toISOString=tr,ho.inspect=er,"undefined"!=typeof Symbol&&null!=Symbol.for&&(ho[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),ho.toJSON=Dr,ho.toString=Qn,ho.unix=_r,ho.valueOf=br,ho.creationData=Mr,ho.eraName=Ar,ho.eraNarrow=Ir,ho.eraAbbr=Lr,ho.eraYear=Nr,ho.year=$t,ho.isLeapYear=Zt,ho.weekYear=Ur,ho.isoWeekYear=Vr,ho.quarter=ho.quarters=Qr,ho.month=fe,ho.daysInMonth=me,ho.week=ho.weeks=Oe,ho.isoWeek=ho.isoWeeks=Ee,ho.weeksInYear=$r,ho.weeksInWeekYear=Zr,ho.isoWeeksInYear=Xr,ho.isoWeeksInISOWeekYear=qr,ho.date=to,ho.day=ho.days=Ue,ho.weekday=Ve,ho.isoWeekday=Xe,ho.dayOfYear=eo,ho.hour=ho.hours=ri,ho.minute=ho.minutes=io,ho.second=ho.seconds=oo,ho.millisecond=ho.milliseconds=ro,ho.utcOffset=vn,ho.utc=yn,ho.local=bn,ho.parseZone=_n,ho.hasAlignedHourOffset=wn,ho.isDST=kn,ho.isLocal=Dn,ho.isUtcOffset=Sn,ho.isUtc=Cn,ho.isUTC=Cn,ho.zoneAbbr=ao,ho.zoneName=lo,ho.dates=C("dates accessor is deprecated. Use date instead.",to),ho.months=C("months accessor is deprecated. Use month instead",fe),ho.years=C("years accessor is deprecated. Use year instead",$t),ho.zone=C("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",gn),ho.isDSTShifted=C("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",xn);var fo=I.prototype;function mo(t,e,i,n){var r=yi(),o=m().set(n,e);return r[i](o,t)}function vo(t,e,i){if(d(t)&&(e=t,t=void 0),t=t||"",null!=e)return mo(t,e,i,"month");var n,r=[];for(n=0;n<12;n++)r[n]=mo(t,n,i,"month");return r}function go(t,e,i,n){"boolean"==typeof t?(d(e)&&(i=e,e=void 0),e=e||""):(i=e=t,t=!1,d(e)&&(i=e,e=void 0),e=e||"");var r,o=yi(),s=t?o._week.dow:0,a=[];if(null!=i)return mo(e,(i+s)%7,n,"day");for(r=0;r<7;r++)a[r]=mo(e,(r+s)%7,n,"day");return a}function yo(t,e){return vo(t,e,"months")}function bo(t,e){return vo(t,e,"monthsShort")}function _o(t,e,i){return go(t,e,i,"weekdays")}function wo(t,e,i){return go(t,e,i,"weekdaysShort")}function ko(t,e,i){return go(t,e,i,"weekdaysMin")}fo.calendar=N,fo.longDateFormat=X,fo.invalidDate=$,fo.ordinal=J,fo.preparse=po,fo.postformat=po,fo.relativeTime=tt,fo.pastFuture=et,fo.set=P,fo.eras=Or,fo.erasParse=Er,fo.erasConvertYear=Pr,fo.erasAbbrRegex=Fr,fo.erasNameRegex=Rr,fo.erasNarrowRegex=jr,fo.months=he,fo.monthsShort=ue,fo.monthsParse=ce,fo.monthsRegex=ge,fo.monthsShortRegex=ve,fo.week=Se,fo.firstDayOfYear=Me,fo.firstDayOfWeek=Te,fo.weekdays=He,fo.weekdaysMin=Be,fo.weekdaysShort=ze,fo.weekdaysParse=We,fo.weekdaysRegex=qe,fo.weekdaysShortRegex=$e,fo.weekdaysMinRegex=Ze,fo.isPM=ii,fo.meridiem=oi,mi("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===At(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),n.lang=C("moment.lang is deprecated. Use moment.locale instead.",mi),n.langData=C("moment.langData is deprecated. Use moment.localeData instead.",yi);var xo=Math.abs;function Do(){var t=this._data;return this._milliseconds=xo(this._milliseconds),this._days=xo(this._days),this._months=xo(this._months),t.milliseconds=xo(t.milliseconds),t.seconds=xo(t.seconds),t.minutes=xo(t.minutes),t.hours=xo(t.hours),t.months=xo(t.months),t.years=xo(t.years),this}function So(t,e,i,n){var r=On(e,i);return t._milliseconds+=n*r._milliseconds,t._days+=n*r._days,t._months+=n*r._months,t._bubble()}function Co(t,e){return So(this,t,e,1)}function To(t,e){return So(this,t,e,-1)}function Mo(t){return t<0?Math.floor(t):Math.ceil(t)}function Oo(){var t,e,i,n,r,o=this._milliseconds,s=this._days,a=this._months,l=this._data;return o>=0&&s>=0&&a>=0||o<=0&&s<=0&&a<=0||(o+=864e5*Mo(Po(a)+s),s=0,a=0),l.milliseconds=o%1e3,t=Pt(o/1e3),l.seconds=t%60,e=Pt(t/60),l.minutes=e%60,i=Pt(e/60),l.hours=i%24,s+=Pt(i/24),a+=r=Pt(Eo(s)),s-=Mo(Po(r)),n=Pt(a/12),a%=12,l.days=s,l.months=a,l.years=n,this}function Eo(t){return 4800*t/146097}function Po(t){return 146097*t/4800}function Ao(t){if(!this.isValid())return NaN;var e,i,n=this._milliseconds;if("month"===(t=nt(t))||"quarter"===t||"year"===t)switch(e=this._days+n/864e5,i=this._months+Eo(e),t){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(e=this._days+Math.round(Po(this._months)),t){case"week":return e/7+n/6048e5;case"day":return e+n/864e5;case"hour":return 24*e+n/36e5;case"minute":return 1440*e+n/6e4;case"second":return 86400*e+n/1e3;case"millisecond":return Math.floor(864e5*e)+n;default:throw new Error("Unknown unit "+t)}}function Io(t){return function(){return this.as(t)}}var Lo=Io("ms"),No=Io("s"),Ro=Io("m"),Fo=Io("h"),jo=Io("d"),Yo=Io("w"),Ho=Io("M"),zo=Io("Q"),Bo=Io("y"),Go=Lo;function Wo(){return On(this)}function Uo(t){return t=nt(t),this.isValid()?this[t+"s"]():NaN}function Vo(t){return function(){return this.isValid()?this._data[t]:NaN}}var Xo=Vo("milliseconds"),qo=Vo("seconds"),$o=Vo("minutes"),Zo=Vo("hours"),Ko=Vo("days"),Jo=Vo("months"),Qo=Vo("years");function ts(){return Pt(this.days()/7)}var es=Math.round,is={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function ns(t,e,i,n,r){return r.relativeTime(e||1,!!i,t,n)}function rs(t,e,i,n){var r=On(t).abs(),o=es(r.as("s")),s=es(r.as("m")),a=es(r.as("h")),l=es(r.as("d")),h=es(r.as("M")),u=es(r.as("w")),d=es(r.as("y")),c=o<=i.ss&&["s",o]||o<i.s&&["ss",o]||s<=1&&["m"]||s<i.m&&["mm",s]||a<=1&&["h"]||a<i.h&&["hh",a]||l<=1&&["d"]||l<i.d&&["dd",l];return null!=i.w&&(c=c||u<=1&&["w"]||u<i.w&&["ww",u]),(c=c||h<=1&&["M"]||h<i.M&&["MM",h]||d<=1&&["y"]||["yy",d])[2]=e,c[3]=+t>0,c[4]=n,ns.apply(null,c)}function os(t){return void 0===t?es:"function"==typeof t&&(es=t,!0)}function ss(t,e){return void 0!==is[t]&&(void 0===e?is[t]:(is[t]=e,"s"===t&&(is.ss=e-1),!0))}function as(t,e){if(!this.isValid())return this.localeData().invalidDate();var i,n,r=!1,o=is;return"object"==typeof t&&(e=t,t=!1),"boolean"==typeof t&&(r=t),"object"==typeof e&&(o=Object.assign({},is,e),null!=e.s&&null==e.ss&&(o.ss=e.s-1)),n=rs(this,!r,o,i=this.localeData()),r&&(n=i.pastFuture(+this,n)),i.postformat(n)}var ls=Math.abs;function hs(t){return(t>0)-(t<0)||+t}function us(){if(!this.isValid())return this.localeData().invalidDate();var t,e,i,n,r,o,s,a,l=ls(this._milliseconds)/1e3,h=ls(this._days),u=ls(this._months),d=this.asSeconds();return d?(t=Pt(l/60),e=Pt(t/60),l%=60,t%=60,i=Pt(u/12),u%=12,n=l?l.toFixed(3).replace(/\.?0+$/,""):"",r=d<0?"-":"",o=hs(this._months)!==hs(d)?"-":"",s=hs(this._days)!==hs(d)?"-":"",a=hs(this._milliseconds)!==hs(d)?"-":"",r+"P"+(i?o+i+"Y":"")+(u?o+u+"M":"")+(h?s+h+"D":"")+(e||t||l?"T":"")+(e?a+e+"H":"")+(t?a+t+"M":"")+(l?a+n+"S":"")):"P0D"}var ds=an.prototype;return ds.isValid=on,ds.abs=Do,ds.add=Co,ds.subtract=To,ds.as=Ao,ds.asMilliseconds=Lo,ds.asSeconds=No,ds.asMinutes=Ro,ds.asHours=Fo,ds.asDays=jo,ds.asWeeks=Yo,ds.asMonths=Ho,ds.asQuarters=zo,ds.asYears=Bo,ds.valueOf=Go,ds._bubble=Oo,ds.clone=Wo,ds.get=Uo,ds.milliseconds=Xo,ds.seconds=qo,ds.minutes=$o,ds.hours=Zo,ds.days=Ko,ds.weeks=ts,ds.months=Jo,ds.years=Qo,ds.humanize=as,ds.toISOString=us,ds.toString=us,ds.toJSON=us,ds.locale=ar,ds.localeData=hr,ds.toIsoString=C("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",us),ds.lang=lr,z("X",0,0,"unix"),z("x",0,0,"valueOf"),Tt("x",_t),Tt("X",xt),Lt("X",(function(t,e,i){i._d=new Date(1e3*parseFloat(t))})),Lt("x",(function(t,e,i){i._d=new Date(At(t))})),
//! moment.js
n.version="2.30.1",o($i),n.fn=ho,n.min=Qi,n.max=tn,n.now=en,n.utc=m,n.unix=uo,n.months=yo,n.isDate=c,n.locale=mi,n.invalid=b,n.duration=On,n.isMoment=D,n.weekdays=_o,n.parseZone=co,n.localeData=yi,n.isDuration=ln,n.monthsShort=bo,n.weekdaysMin=ko,n.defineLocale=vi,n.updateLocale=gi,n.locales=bi,n.weekdaysShort=wo,n.normalizeUnits=nt,n.relativeTimeRounding=os,n.relativeTimeThreshold=ss,n.calendarFormat=Bn,n.prototype=ho,n.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},n}()}(a)),a.exports}s=function(t){
//! moment.js locale configuration
function e(t,e,i,n){var r={m:["eine Minute","einer Minute"],h:["eine Stunde","einer Stunde"],d:["ein Tag","einem Tag"],dd:[t+" Tage",t+" Tagen"],w:["eine Woche","einer Woche"],M:["ein Monat","einem Monat"],MM:[t+" Monate",t+" Monaten"],y:["ein Jahr","einem Jahr"],yy:[t+" Jahre",t+" Jahren"]};return e?r[i][0]:r[i][1]}return t.defineLocale("de",{months:"Januar_Februar_März_April_Mai_Juni_Juli_August_September_Oktober_November_Dezember".split("_"),monthsShort:"Jan._Feb._März_Apr._Mai_Juni_Juli_Aug._Sep._Okt._Nov._Dez.".split("_"),monthsParseExact:!0,weekdays:"Sonntag_Montag_Dienstag_Mittwoch_Donnerstag_Freitag_Samstag".split("_"),weekdaysShort:"So._Mo._Di._Mi._Do._Fr._Sa.".split("_"),weekdaysMin:"So_Mo_Di_Mi_Do_Fr_Sa".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D. MMMM YYYY",LLL:"D. MMMM YYYY HH:mm",LLLL:"dddd, D. MMMM YYYY HH:mm"},calendar:{sameDay:"[heute um] LT [Uhr]",sameElse:"L",nextDay:"[morgen um] LT [Uhr]",nextWeek:"dddd [um] LT [Uhr]",lastDay:"[gestern um] LT [Uhr]",lastWeek:"[letzten] dddd [um] LT [Uhr]"},relativeTime:{future:"in %s",past:"vor %s",s:"ein paar Sekunden",ss:"%d Sekunden",m:e,mm:"%d Minuten",h:e,hh:"%d Stunden",d:e,dd:e,w:e,ww:"%d Wochen",M:e,MM:e,y:e,yy:e},dayOfMonthOrdinalParse:/\d{1,2}\./,ordinal:"%d.",week:{dow:1,doy:4}})},s(l()),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e="ene._feb._mar._abr._may._jun._jul._ago._sep._oct._nov._dic.".split("_"),i="ene_feb_mar_abr_may_jun_jul_ago_sep_oct_nov_dic".split("_"),n=[/^ene/i,/^feb/i,/^mar/i,/^abr/i,/^may/i,/^jun/i,/^jul/i,/^ago/i,/^sep/i,/^oct/i,/^nov/i,/^dic/i],r=/^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre|ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i;return t.defineLocale("es",{months:"enero_febrero_marzo_abril_mayo_junio_julio_agosto_septiembre_octubre_noviembre_diciembre".split("_"),monthsShort:function(t,n){return t?/-MMM-/.test(n)?i[t.month()]:e[t.month()]:e},monthsRegex:r,monthsShortRegex:r,monthsStrictRegex:/^(enero|febrero|marzo|abril|mayo|junio|julio|agosto|septiembre|octubre|noviembre|diciembre)/i,monthsShortStrictRegex:/^(ene\.?|feb\.?|mar\.?|abr\.?|may\.?|jun\.?|jul\.?|ago\.?|sep\.?|oct\.?|nov\.?|dic\.?)/i,monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"domingo_lunes_martes_miércoles_jueves_viernes_sábado".split("_"),weekdaysShort:"dom._lun._mar._mié._jue._vie._sáb.".split("_"),weekdaysMin:"do_lu_ma_mi_ju_vi_sá".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"H:mm",LTS:"H:mm:ss",L:"DD/MM/YYYY",LL:"D [de] MMMM [de] YYYY",LLL:"D [de] MMMM [de] YYYY H:mm",LLLL:"dddd, D [de] MMMM [de] YYYY H:mm"},calendar:{sameDay:function(){return"[hoy a la"+(1!==this.hours()?"s":"")+"] LT"},nextDay:function(){return"[mañana a la"+(1!==this.hours()?"s":"")+"] LT"},nextWeek:function(){return"dddd [a la"+(1!==this.hours()?"s":"")+"] LT"},lastDay:function(){return"[ayer a la"+(1!==this.hours()?"s":"")+"] LT"},lastWeek:function(){return"[el] dddd [pasado a la"+(1!==this.hours()?"s":"")+"] LT"},sameElse:"L"},relativeTime:{future:"en %s",past:"hace %s",s:"unos segundos",ss:"%d segundos",m:"un minuto",mm:"%d minutos",h:"una hora",hh:"%d horas",d:"un día",dd:"%d días",w:"una semana",ww:"%d semanas",M:"un mes",MM:"%d meses",y:"un año",yy:"%d años"},dayOfMonthOrdinalParse:/\d{1,2}º/,ordinal:"%dº",week:{dow:1,doy:4},invalidDate:"Fecha inválida"})})),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e=/(janv\.?|févr\.?|mars|avr\.?|mai|juin|juil\.?|août|sept\.?|oct\.?|nov\.?|déc\.?|janvier|février|mars|avril|mai|juin|juillet|août|septembre|octobre|novembre|décembre)/i,i=[/^janv/i,/^févr/i,/^mars/i,/^avr/i,/^mai/i,/^juin/i,/^juil/i,/^août/i,/^sept/i,/^oct/i,/^nov/i,/^déc/i],n=t.defineLocale("fr",{months:"janvier_février_mars_avril_mai_juin_juillet_août_septembre_octobre_novembre_décembre".split("_"),monthsShort:"janv._févr._mars_avr._mai_juin_juil._août_sept._oct._nov._déc.".split("_"),monthsRegex:e,monthsShortRegex:e,monthsStrictRegex:/^(janvier|février|mars|avril|mai|juin|juillet|août|septembre|octobre|novembre|décembre)/i,monthsShortStrictRegex:/(janv\.?|févr\.?|mars|avr\.?|mai|juin|juil\.?|août|sept\.?|oct\.?|nov\.?|déc\.?)/i,monthsParse:i,longMonthsParse:i,shortMonthsParse:i,weekdays:"dimanche_lundi_mardi_mercredi_jeudi_vendredi_samedi".split("_"),weekdaysShort:"dim._lun._mar._mer._jeu._ven._sam.".split("_"),weekdaysMin:"di_lu_ma_me_je_ve_sa".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD/MM/YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[Aujourd’hui à] LT",nextDay:"[Demain à] LT",nextWeek:"dddd [à] LT",lastDay:"[Hier à] LT",lastWeek:"dddd [dernier à] LT",sameElse:"L"},relativeTime:{future:"dans %s",past:"il y a %s",s:"quelques secondes",ss:"%d secondes",m:"une minute",mm:"%d minutes",h:"une heure",hh:"%d heures",d:"un jour",dd:"%d jours",w:"une semaine",ww:"%d semaines",M:"un mois",MM:"%d mois",y:"un an",yy:"%d ans"},dayOfMonthOrdinalParse:/\d{1,2}(er|)/,ordinal:function(t,e){switch(e){case"D":return t+(1===t?"er":"");default:case"M":case"Q":case"DDD":case"d":return t+(1===t?"er":"e");case"w":case"W":return t+(1===t?"re":"e")}},week:{dow:1,doy:4}});return n})),function(t,e){e(l())}(0,(function(t){return t.defineLocale("it",{months:"gennaio_febbraio_marzo_aprile_maggio_giugno_luglio_agosto_settembre_ottobre_novembre_dicembre".split("_"),monthsShort:"gen_feb_mar_apr_mag_giu_lug_ago_set_ott_nov_dic".split("_"),weekdays:"domenica_lunedì_martedì_mercoledì_giovedì_venerdì_sabato".split("_"),weekdaysShort:"dom_lun_mar_mer_gio_ven_sab".split("_"),weekdaysMin:"do_lu_ma_me_gi_ve_sa".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD/MM/YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:function(){return"[Oggi a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},nextDay:function(){return"[Domani a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},nextWeek:function(){return"dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},lastDay:function(){return"[Ieri a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},lastWeek:function(){return 0===this.day()?"[La scorsa] dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT":"[Lo scorso] dddd [a"+(this.hours()>1?"lle ":0===this.hours()?" ":"ll'")+"]LT"},sameElse:"L"},relativeTime:{future:"tra %s",past:"%s fa",s:"alcuni secondi",ss:"%d secondi",m:"un minuto",mm:"%d minuti",h:"un'ora",hh:"%d ore",d:"un giorno",dd:"%d giorni",w:"una settimana",ww:"%d settimane",M:"un mese",MM:"%d mesi",y:"un anno",yy:"%d anni"},dayOfMonthOrdinalParse:/\d{1,2}º/,ordinal:"%dº",week:{dow:1,doy:4}})})),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e=t.defineLocale("ja",{eras:[{since:"2019-05-01",offset:1,name:"令和",narrow:"㋿",abbr:"R"},{since:"1989-01-08",until:"2019-04-30",offset:1,name:"平成",narrow:"㍻",abbr:"H"},{since:"1926-12-25",until:"1989-01-07",offset:1,name:"昭和",narrow:"㍼",abbr:"S"},{since:"1912-07-30",until:"1926-12-24",offset:1,name:"大正",narrow:"㍽",abbr:"T"},{since:"1873-01-01",until:"1912-07-29",offset:6,name:"明治",narrow:"㍾",abbr:"M"},{since:"0001-01-01",until:"1873-12-31",offset:1,name:"西暦",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"紀元前",narrow:"BC",abbr:"BC"}],eraYearOrdinalRegex:/(元|\d+)年/,eraYearOrdinalParse:function(t,e){return"元"===e[1]?1:parseInt(e[1]||t,10)},months:"1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),monthsShort:"1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),weekdays:"日曜日_月曜日_火曜日_水曜日_木曜日_金曜日_土曜日".split("_"),weekdaysShort:"日_月_火_水_木_金_土".split("_"),weekdaysMin:"日_月_火_水_木_金_土".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"YYYY/MM/DD",LL:"YYYY年M月D日",LLL:"YYYY年M月D日 HH:mm",LLLL:"YYYY年M月D日 dddd HH:mm",l:"YYYY/MM/DD",ll:"YYYY年M月D日",lll:"YYYY年M月D日 HH:mm",llll:"YYYY年M月D日(ddd) HH:mm"},meridiemParse:/午前|午後/i,isPM:function(t){return"午後"===t},meridiem:function(t,e,i){return t<12?"午前":"午後"},calendar:{sameDay:"[今日] LT",nextDay:"[明日] LT",nextWeek:function(t){return t.week()!==this.week()?"[来週]dddd LT":"dddd LT"},lastDay:"[昨日] LT",lastWeek:function(t){return this.week()!==t.week()?"[先週]dddd LT":"dddd LT"},sameElse:"L"},dayOfMonthOrdinalParse:/\d{1,2}日/,ordinal:function(t,e){switch(e){case"y":return 1===t?"元年":t+"年";case"d":case"D":case"DDD":return t+"日";default:return t}},relativeTime:{future:"%s後",past:"%s前",s:"数秒",ss:"%d秒",m:"1分",mm:"%d分",h:"1時間",hh:"%d時間",d:"1日",dd:"%d日",M:"1ヶ月",MM:"%dヶ月",y:"1年",yy:"%d年"}});return e})),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e="jan._feb._mrt._apr._mei_jun._jul._aug._sep._okt._nov._dec.".split("_"),i="jan_feb_mrt_apr_mei_jun_jul_aug_sep_okt_nov_dec".split("_"),n=[/^jan/i,/^feb/i,/^(maart|mrt\.?)$/i,/^apr/i,/^mei$/i,/^jun[i.]?$/i,/^jul[i.]?$/i,/^aug/i,/^sep/i,/^okt/i,/^nov/i,/^dec/i],r=/^(januari|februari|maart|april|mei|ju[nl]i|augustus|september|oktober|november|december|jan\.?|feb\.?|mrt\.?|apr\.?|ju[nl]\.?|aug\.?|sep\.?|okt\.?|nov\.?|dec\.?)/i,o=t.defineLocale("nl",{months:"januari_februari_maart_april_mei_juni_juli_augustus_september_oktober_november_december".split("_"),monthsShort:function(t,n){return t?/-MMM-/.test(n)?i[t.month()]:e[t.month()]:e},monthsRegex:r,monthsShortRegex:r,monthsStrictRegex:/^(januari|februari|maart|april|mei|ju[nl]i|augustus|september|oktober|november|december)/i,monthsShortStrictRegex:/^(jan\.?|feb\.?|mrt\.?|apr\.?|mei|ju[nl]\.?|aug\.?|sep\.?|okt\.?|nov\.?|dec\.?)/i,monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"zondag_maandag_dinsdag_woensdag_donderdag_vrijdag_zaterdag".split("_"),weekdaysShort:"zo._ma._di._wo._do._vr._za.".split("_"),weekdaysMin:"zo_ma_di_wo_do_vr_za".split("_"),weekdaysParseExact:!0,longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD-MM-YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd D MMMM YYYY HH:mm"},calendar:{sameDay:"[vandaag om] LT",nextDay:"[morgen om] LT",nextWeek:"dddd [om] LT",lastDay:"[gisteren om] LT",lastWeek:"[afgelopen] dddd [om] LT",sameElse:"L"},relativeTime:{future:"over %s",past:"%s geleden",s:"een paar seconden",ss:"%d seconden",m:"één minuut",mm:"%d minuten",h:"één uur",hh:"%d uur",d:"één dag",dd:"%d dagen",w:"één week",ww:"%d weken",M:"één maand",MM:"%d maanden",y:"één jaar",yy:"%d jaar"},dayOfMonthOrdinalParse:/\d{1,2}(ste|de)/,ordinal:function(t){return t+(1===t||8===t||t>=20?"ste":"de")},week:{dow:1,doy:4}});return o})),function(t,e){e(l())}(0,(function(t){
//! moment.js locale configuration
var e="styczeń_luty_marzec_kwiecień_maj_czerwiec_lipiec_sierpień_wrzesień_październik_listopad_grudzień".split("_"),i="stycznia_lutego_marca_kwietnia_maja_czerwca_lipca_sierpnia_września_października_listopada_grudnia".split("_"),n=[/^sty/i,/^lut/i,/^mar/i,/^kwi/i,/^maj/i,/^cze/i,/^lip/i,/^sie/i,/^wrz/i,/^paź/i,/^lis/i,/^gru/i];function r(t){return t%10<5&&t%10>1&&~~(t/10)%10!=1}function o(t,e,i){var n=t+" ";switch(i){case"ss":return n+(r(t)?"sekundy":"sekund");case"m":return e?"minuta":"minutę";case"mm":return n+(r(t)?"minuty":"minut");case"h":return e?"godzina":"godzinę";case"hh":return n+(r(t)?"godziny":"godzin");case"ww":return n+(r(t)?"tygodnie":"tygodni");case"MM":return n+(r(t)?"miesiące":"miesięcy");case"yy":return n+(r(t)?"lata":"lat")}}return t.defineLocale("pl",{months:function(t,n){return t?/D MMMM/.test(n)?i[t.month()]:e[t.month()]:e},monthsShort:"sty_lut_mar_kwi_maj_cze_lip_sie_wrz_paź_lis_gru".split("_"),monthsParse:n,longMonthsParse:n,shortMonthsParse:n,weekdays:"niedziela_poniedziałek_wtorek_środa_czwartek_piątek_sobota".split("_"),weekdaysShort:"ndz_pon_wt_śr_czw_pt_sob".split("_"),weekdaysMin:"Nd_Pn_Wt_Śr_Cz_Pt_So".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY",LLL:"D MMMM YYYY HH:mm",LLLL:"dddd, D MMMM YYYY HH:mm"},calendar:{sameDay:"[Dziś o] LT",nextDay:"[Jutro o] LT",nextWeek:function(){switch(this.day()){case 0:return"[W niedzielę o] LT";case 2:return"[We wtorek o] LT";case 3:return"[W środę o] LT";case 6:return"[W sobotę o] LT";default:return"[W] dddd [o] LT"}},lastDay:"[Wczoraj o] LT",lastWeek:function(){switch(this.day()){case 0:return"[W zeszłą niedzielę o] LT";case 3:return"[W zeszłą środę o] LT";case 6:return"[W zeszłą sobotę o] LT";default:return"[W zeszły] dddd [o] LT"}},sameElse:"L"},relativeTime:{future:"za %s",past:"%s temu",s:"kilka sekund",ss:o,m:o,mm:o,h:o,hh:o,d:"1 dzień",dd:"%d dni",w:"tydzień",ww:o,M:"miesiąc",MM:o,y:"rok",yy:o},dayOfMonthOrdinalParse:/\d{1,2}\./,ordinal:"%d.",week:{dow:1,doy:4}})})),function(t,e){e(l())}(0,(function(t){function e(t,e,i){var n,r;return"m"===i?e?"минута":"минуту":t+" "+(n=+t,r={ss:e?"секунда_секунды_секунд":"секунду_секунды_секунд",mm:e?"минута_минуты_минут":"минуту_минуты_минут",hh:"час_часа_часов",dd:"день_дня_дней",ww:"неделя_недели_недель",MM:"месяц_месяца_месяцев",yy:"год_года_лет"}[i].split("_"),n%10==1&&n%100!=11?r[0]:n%10>=2&&n%10<=4&&(n%100<10||n%100>=20)?r[1]:r[2])}var i=[/^янв/i,/^фев/i,/^мар/i,/^апр/i,/^ма[йя]/i,/^июн/i,/^июл/i,/^авг/i,/^сен/i,/^окт/i,/^ноя/i,/^дек/i],n=t.defineLocale("ru",{months:{format:"января_февраля_марта_апреля_мая_июня_июля_августа_сентября_октября_ноября_декабря".split("_"),standalone:"январь_февраль_март_апрель_май_июнь_июль_август_сентябрь_октябрь_ноябрь_декабрь".split("_")},monthsShort:{format:"янв._февр._мар._апр._мая_июня_июля_авг._сент._окт._нояб._дек.".split("_"),standalone:"янв._февр._март_апр._май_июнь_июль_авг._сент._окт._нояб._дек.".split("_")},weekdays:{standalone:"воскресенье_понедельник_вторник_среда_четверг_пятница_суббота".split("_"),format:"воскресенье_понедельник_вторник_среду_четверг_пятницу_субботу".split("_"),isFormat:/\[ ?[Вв] ?(?:прошлую|следующую|эту)? ?] ?dddd/},weekdaysShort:"вс_пн_вт_ср_чт_пт_сб".split("_"),weekdaysMin:"вс_пн_вт_ср_чт_пт_сб".split("_"),monthsParse:i,longMonthsParse:i,shortMonthsParse:i,monthsRegex:/^(январ[ья]|янв\.?|феврал[ья]|февр?\.?|марта?|мар\.?|апрел[ья]|апр\.?|ма[йя]|июн[ья]|июн\.?|июл[ья]|июл\.?|августа?|авг\.?|сентябр[ья]|сент?\.?|октябр[ья]|окт\.?|ноябр[ья]|нояб?\.?|декабр[ья]|дек\.?)/i,monthsShortRegex:/^(январ[ья]|янв\.?|феврал[ья]|февр?\.?|марта?|мар\.?|апрел[ья]|апр\.?|ма[йя]|июн[ья]|июн\.?|июл[ья]|июл\.?|августа?|авг\.?|сентябр[ья]|сент?\.?|октябр[ья]|окт\.?|ноябр[ья]|нояб?\.?|декабр[ья]|дек\.?)/i,monthsStrictRegex:/^(январ[яь]|феврал[яь]|марта?|апрел[яь]|ма[яй]|июн[яь]|июл[яь]|августа?|сентябр[яь]|октябр[яь]|ноябр[яь]|декабр[яь])/i,monthsShortStrictRegex:/^(янв\.|февр?\.|мар[т.]|апр\.|ма[яй]|июн[ья.]|июл[ья.]|авг\.|сент?\.|окт\.|нояб?\.|дек\.)/i,longDateFormat:{LT:"H:mm",LTS:"H:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY г.",LLL:"D MMMM YYYY г., H:mm",LLLL:"dddd, D MMMM YYYY г., H:mm"},calendar:{sameDay:"[Сегодня, в] LT",nextDay:"[Завтра, в] LT",lastDay:"[Вчера, в] LT",nextWeek:function(t){if(t.week()===this.week())return 2===this.day()?"[Во] dddd, [в] LT":"[В] dddd, [в] LT";switch(this.day()){case 0:return"[В следующее] dddd, [в] LT";case 1:case 2:case 4:return"[В следующий] dddd, [в] LT";case 3:case 5:case 6:return"[В следующую] dddd, [в] LT"}},lastWeek:function(t){if(t.week()===this.week())return 2===this.day()?"[Во] dddd, [в] LT":"[В] dddd, [в] LT";switch(this.day()){case 0:return"[В прошлое] dddd, [в] LT";case 1:case 2:case 4:return"[В прошлый] dddd, [в] LT";case 3:case 5:case 6:return"[В прошлую] dddd, [в] LT"}},sameElse:"L"},relativeTime:{future:"через %s",past:"%s назад",s:"несколько секунд",ss:e,m:e,mm:e,h:"час",hh:e,d:"день",dd:e,w:"неделя",ww:e,M:"месяц",MM:e,y:"год",yy:e},meridiemParse:/ночи|утра|дня|вечера/i,isPM:function(t){return/^(дня|вечера)$/.test(t)},meridiem:function(t,e,i){return t<4?"ночи":t<12?"утра":t<17?"дня":"вечера"},dayOfMonthOrdinalParse:/\d{1,2}-(й|го|я)/,ordinal:function(t,e){switch(e){case"M":case"d":case"DDD":return t+"-й";case"D":return t+"-го";case"w":case"W":return t+"-я";default:return t}},week:{dow:1,doy:4}});return n})),function(t,e){e(l())}(0,(function(t){function e(t,e,i){var n,r;return"m"===i?e?"хвилина":"хвилину":"h"===i?e?"година":"годину":t+" "+(n=+t,r={ss:e?"секунда_секунди_секунд":"секунду_секунди_секунд",mm:e?"хвилина_хвилини_хвилин":"хвилину_хвилини_хвилин",hh:e?"година_години_годин":"годину_години_годин",dd:"день_дні_днів",MM:"місяць_місяці_місяців",yy:"рік_роки_років"}[i].split("_"),n%10==1&&n%100!=11?r[0]:n%10>=2&&n%10<=4&&(n%100<10||n%100>=20)?r[1]:r[2])}function i(t){return function(){return t+"о"+(11===this.hours()?"б":"")+"] LT"}}var n=t.defineLocale("uk",{months:{format:"січня_лютого_березня_квітня_травня_червня_липня_серпня_вересня_жовтня_листопада_грудня".split("_"),standalone:"січень_лютий_березень_квітень_травень_червень_липень_серпень_вересень_жовтень_листопад_грудень".split("_")},monthsShort:"січ_лют_бер_квіт_трав_черв_лип_серп_вер_жовт_лист_груд".split("_"),weekdays:function(t,e){var i={nominative:"неділя_понеділок_вівторок_середа_четвер_п’ятниця_субота".split("_"),accusative:"неділю_понеділок_вівторок_середу_четвер_п’ятницю_суботу".split("_"),genitive:"неділі_понеділка_вівторка_середи_четверга_п’ятниці_суботи".split("_")};return!0===t?i.nominative.slice(1,7).concat(i.nominative.slice(0,1)):t?i[/(\[[ВвУу]\]) ?dddd/.test(e)?"accusative":/\[?(?:минулої|наступної)? ?\] ?dddd/.test(e)?"genitive":"nominative"][t.day()]:i.nominative},weekdaysShort:"нд_пн_вт_ср_чт_пт_сб".split("_"),weekdaysMin:"нд_пн_вт_ср_чт_пт_сб".split("_"),longDateFormat:{LT:"HH:mm",LTS:"HH:mm:ss",L:"DD.MM.YYYY",LL:"D MMMM YYYY р.",LLL:"D MMMM YYYY р., HH:mm",LLLL:"dddd, D MMMM YYYY р., HH:mm"},calendar:{sameDay:i("[Сьогодні "),nextDay:i("[Завтра "),lastDay:i("[Вчора "),nextWeek:i("[У] dddd ["),lastWeek:function(){switch(this.day()){case 0:case 3:case 5:case 6:return i("[Минулої] dddd [").call(this);case 1:case 2:case 4:return i("[Минулого] dddd [").call(this)}},sameElse:"L"},relativeTime:{future:"за %s",past:"%s тому",s:"декілька секунд",ss:e,m:e,mm:e,h:"годину",hh:e,d:"день",dd:e,M:"місяць",MM:e,y:"рік",yy:e},meridiemParse:/ночі|ранку|дня|вечора/,isPM:function(t){return/^(дня|вечора)$/.test(t)},meridiem:function(t,e,i){return t<4?"ночі":t<12?"ранку":t<17?"дня":"вечора"},dayOfMonthOrdinalParse:/\d{1,2}-(й|го)/,ordinal:function(t,e){switch(e){case"M":case"d":case"DDD":case"w":case"W":return t+"-й";case"D":return t+"-го";default:return t}},week:{dow:1,doy:7}});return n}));var h=function(t){try{return!!t()}catch(t){return!0}},u=!h((function(){var t=function(){}.bind();return"function"!=typeof t||t.hasOwnProperty("prototype")})),d=u,c=Function.prototype,p=c.call,f=d&&c.bind.bind(p,p),m=d?f:function(t){return function(){return p.apply(t,arguments)}},v=Math.ceil,g=Math.floor,y=Math.trunc||function(t){var e=+t;return(e>0?g:v)(e)},b=function(t){var e=+t;return e!=e||0===e?0:y(e)},_=function(t){return t&&t.Math===Math&&t},w=_("object"==typeof globalThis&&globalThis)||_("object"==typeof window&&window)||_("object"==typeof self&&self)||_("object"==typeof e&&e)||function(){return this}()||e||Function("return this")(),k={exports:{}},x=w,D=Object.defineProperty,S=function(t,e){try{D(x,t,{value:e,configurable:!0,writable:!0})}catch(i){x[t]=e}return e},C="__core-js_shared__",T=w[C]||S(C,{}),M=T;(k.exports=function(t,e){return M[t]||(M[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.33.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.33.0/LICENSE",source:"https://github.com/zloirock/core-js"});var O,E,P=k.exports,A=function(t){return null==t},I=A,L=TypeError,N=function(t){if(I(t))throw new L("Can't call method on "+t);return t},R=N,F=Object,j=function(t){return F(R(t))},Y=j,H=m({}.hasOwnProperty),z=Object.hasOwn||function(t,e){return H(Y(t),e)},B=m,G=0,W=Math.random(),U=B(1..toString),V=function(t){return"Symbol("+(void 0===t?"":t)+")_"+U(++G+W,36)},X="undefined"!=typeof navigator&&String(navigator.userAgent)||"",q=w,$=X,Z=q.process,K=q.Deno,J=Z&&Z.versions||K&&K.version,Q=J&&J.v8;Q&&(E=(O=Q.split("."))[0]>0&&O[0]<4?1:+(O[0]+O[1])),!E&&$&&(!(O=$.match(/Edge\/(\d+)/))||O[1]>=74)&&(O=$.match(/Chrome\/(\d+)/))&&(E=+O[1]);var tt=E,et=tt,it=h,nt=w.String,rt=!!Object.getOwnPropertySymbols&&!it((function(){var t=Symbol("symbol detection");return!nt(t)||!(Object(t)instanceof Symbol)||!Symbol.sham&&et&&et<41})),ot=rt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,st=P,at=z,lt=V,ht=rt,ut=ot,dt=w.Symbol,ct=st("wks"),pt=ut?dt.for||dt:dt&&dt.withoutSetter||lt,ft=function(t){return at(ct,t)||(ct[t]=ht&&at(dt,t)?dt[t]:pt("Symbol."+t)),ct[t]},mt={};mt[ft("toStringTag")]="z";var vt="[object z]"===String(mt),gt="object"==typeof document&&document.all,yt={all:gt,IS_HTMLDDA:void 0===gt&&void 0!==gt},bt=yt.all,_t=yt.IS_HTMLDDA?function(t){return"function"==typeof t||t===bt}:function(t){return"function"==typeof t},wt=m,kt=wt({}.toString),xt=wt("".slice),Dt=function(t){return xt(kt(t),8,-1)},St=vt,Ct=_t,Tt=Dt,Mt=ft("toStringTag"),Ot=Object,Et="Arguments"===Tt(function(){return arguments}()),Pt=St?Tt:function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Ot(t),Mt))?i:Et?Tt(e):"Object"===(n=Tt(e))&&Ct(e.callee)?"Arguments":n},At=Pt,It=String,Lt=function(t){if("Symbol"===At(t))throw new TypeError("Cannot convert a Symbol value to a string");return It(t)},Nt=m,Rt=b,Ft=Lt,jt=N,Yt=Nt("".charAt),Ht=Nt("".charCodeAt),zt=Nt("".slice),Bt=function(t){return function(e,i){var n,r,o=Ft(jt(e)),s=Rt(i),a=o.length;return s<0||s>=a?t?"":void 0:(n=Ht(o,s))<55296||n>56319||s+1===a||(r=Ht(o,s+1))<56320||r>57343?t?Yt(o,s):n:t?zt(o,s,s+2):r-56320+(n-55296<<10)+65536}},Gt={codeAt:Bt(!1),charAt:Bt(!0)},Wt=_t,Ut=w.WeakMap,Vt=Wt(Ut)&&/native code/.test(String(Ut)),Xt=_t,qt=yt.all,$t=yt.IS_HTMLDDA?function(t){return"object"==typeof t?null!==t:Xt(t)||t===qt}:function(t){return"object"==typeof t?null!==t:Xt(t)},Zt=!h((function(){return 7!==Object.defineProperty({},1,{get:function(){return 7}})[1]})),Kt={},Jt=$t,Qt=w.document,te=Jt(Qt)&&Jt(Qt.createElement),ee=function(t){return te?Qt.createElement(t):{}},ie=ee,ne=!Zt&&!h((function(){return 7!==Object.defineProperty(ie("div"),"a",{get:function(){return 7}}).a})),re=Zt&&h((function(){return 42!==Object.defineProperty((function(){}),"prototype",{value:42,writable:!1}).prototype})),oe=$t,se=String,ae=TypeError,le=function(t){if(oe(t))return t;throw new ae(se(t)+" is not an object")},he=u,ue=Function.prototype.call,de=he?ue.bind(ue):function(){return ue.apply(ue,arguments)},ce={},pe=ce,fe=w,me=_t,ve=function(t){return me(t)?t:void 0},ge=function(t,e){return arguments.length<2?ve(pe[t])||ve(fe[t]):pe[t]&&pe[t][e]||fe[t]&&fe[t][e]},ye=m({}.isPrototypeOf),be=ge,_e=_t,we=ye,ke=Object,xe=ot?function(t){return"symbol"==typeof t}:function(t){var e=be("Symbol");return _e(e)&&we(e.prototype,ke(t))},De=String,Se=function(t){try{return De(t)}catch(t){return"Object"}},Ce=_t,Te=Se,Me=TypeError,Oe=function(t){if(Ce(t))return t;throw new Me(Te(t)+" is not a function")},Ee=Oe,Pe=A,Ae=function(t,e){var i=t[e];return Pe(i)?void 0:Ee(i)},Ie=de,Le=_t,Ne=$t,Re=TypeError,Fe=de,je=$t,Ye=xe,He=Ae,ze=function(t,e){var i,n;if("string"===e&&Le(i=t.toString)&&!Ne(n=Ie(i,t)))return n;if(Le(i=t.valueOf)&&!Ne(n=Ie(i,t)))return n;if("string"!==e&&Le(i=t.toString)&&!Ne(n=Ie(i,t)))return n;throw new Re("Can't convert object to primitive value")},Be=TypeError,Ge=ft("toPrimitive"),We=function(t,e){if(!je(t)||Ye(t))return t;var i,n=He(t,Ge);if(n){if(void 0===e&&(e="default"),i=Fe(n,t,e),!je(i)||Ye(i))return i;throw new Be("Can't convert object to primitive value")}return void 0===e&&(e="number"),ze(t,e)},Ue=xe,Ve=function(t){var e=We(t,"string");return Ue(e)?e:e+""},Xe=Zt,qe=ne,$e=re,Ze=le,Ke=Ve,Je=TypeError,Qe=Object.defineProperty,ti=Object.getOwnPropertyDescriptor,ei="enumerable",ii="configurable",ni="writable";Kt.f=Xe?$e?function(t,e,i){if(Ze(t),e=Ke(e),Ze(i),"function"==typeof t&&"prototype"===e&&"value"in i&&ni in i&&!i[ni]){var n=ti(t,e);n&&n[ni]&&(t[e]=i.value,i={configurable:ii in i?i[ii]:n[ii],enumerable:ei in i?i[ei]:n[ei],writable:!1})}return Qe(t,e,i)}:Qe:function(t,e,i){if(Ze(t),e=Ke(e),Ze(i),qe)try{return Qe(t,e,i)}catch(t){}if("get"in i||"set"in i)throw new Je("Accessors not supported");return"value"in i&&(t[e]=i.value),t};var ri,oi,si,ai=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},li=Kt,hi=ai,ui=Zt?function(t,e,i){return li.f(t,e,hi(1,i))}:function(t,e,i){return t[e]=i,t},di=V,ci=P("keys"),pi=function(t){return ci[t]||(ci[t]=di(t))},fi={},mi=Vt,vi=w,gi=$t,yi=ui,bi=z,_i=T,wi=pi,ki=fi,xi="Object already initialized",Di=vi.TypeError,Si=vi.WeakMap;if(mi||_i.state){var Ci=_i.state||(_i.state=new Si);Ci.get=Ci.get,Ci.has=Ci.has,Ci.set=Ci.set,ri=function(t,e){if(Ci.has(t))throw new Di(xi);return e.facade=t,Ci.set(t,e),e},oi=function(t){return Ci.get(t)||{}},si=function(t){return Ci.has(t)}}else{var Ti=wi("state");ki[Ti]=!0,ri=function(t,e){if(bi(t,Ti))throw new Di(xi);return e.facade=t,yi(t,Ti,e),e},oi=function(t){return bi(t,Ti)?t[Ti]:{}},si=function(t){return bi(t,Ti)}}var Mi={set:ri,get:oi,has:si,enforce:function(t){return si(t)?oi(t):ri(t,{})},getterFor:function(t){return function(e){var i;if(!gi(e)||(i=oi(e)).type!==t)throw new Di("Incompatible receiver, "+t+" required");return i}}},Oi=u,Ei=Function.prototype,Pi=Ei.apply,Ai=Ei.call,Ii="object"==typeof Reflect&&Reflect.apply||(Oi?Ai.bind(Pi):function(){return Ai.apply(Pi,arguments)}),Li=Dt,Ni=m,Ri=function(t){if("Function"===Li(t))return Ni(t)},Fi={},ji={},Yi={}.propertyIsEnumerable,Hi=Object.getOwnPropertyDescriptor,zi=Hi&&!Yi.call({1:2},1);ji.f=zi?function(t){var e=Hi(this,t);return!!e&&e.enumerable}:Yi;var Bi=h,Gi=Dt,Wi=Object,Ui=m("".split),Vi=Bi((function(){return!Wi("z").propertyIsEnumerable(0)}))?function(t){return"String"===Gi(t)?Ui(t,""):Wi(t)}:Wi,Xi=Vi,qi=N,$i=function(t){return Xi(qi(t))},Zi=Zt,Ki=de,Ji=ji,Qi=ai,tn=$i,en=Ve,nn=z,rn=ne,on=Object.getOwnPropertyDescriptor;Fi.f=Zi?on:function(t,e){if(t=tn(t),e=en(e),rn)try{return on(t,e)}catch(t){}if(nn(t,e))return Qi(!Ki(Ji.f,t,e),t[e])};var sn=h,an=_t,ln=/#|\.prototype\./,hn=function(t,e){var i=dn[un(t)];return i===pn||i!==cn&&(an(e)?sn(e):!!e)},un=hn.normalize=function(t){return String(t).replace(ln,".").toLowerCase()},dn=hn.data={},cn=hn.NATIVE="N",pn=hn.POLYFILL="P",fn=hn,mn=Oe,vn=u,gn=Ri(Ri.bind),yn=function(t,e){return mn(t),void 0===e?t:vn?gn(t,e):function(){return t.apply(e,arguments)}},bn=w,_n=Ii,wn=Ri,kn=_t,xn=Fi.f,Dn=fn,Sn=ce,Cn=yn,Tn=ui,Mn=z,On=function(t){var e=function(i,n,r){if(this instanceof e){switch(arguments.length){case 0:return new t;case 1:return new t(i);case 2:return new t(i,n)}return new t(i,n,r)}return _n(t,this,arguments)};return e.prototype=t.prototype,e},En=function(t,e){var i,n,r,o,s,a,l,h,u,d=t.target,c=t.global,p=t.stat,f=t.proto,m=c?bn:p?bn[d]:(bn[d]||{}).prototype,v=c?Sn:Sn[d]||Tn(Sn,d,{})[d],g=v.prototype;for(o in e)n=!(i=Dn(c?o:d+(p?".":"#")+o,t.forced))&&m&&Mn(m,o),a=v[o],n&&(l=t.dontCallGetSet?(u=xn(m,o))&&u.value:m[o]),s=n&&l?l:e[o],n&&typeof a==typeof s||(h=t.bind&&n?Cn(s,bn):t.wrap&&n?On(s):f&&kn(s)?wn(s):s,(t.sham||s&&s.sham||a&&a.sham)&&Tn(h,"sham",!0),Tn(v,o,h),f&&(Mn(Sn,r=d+"Prototype")||Tn(Sn,r,{}),Tn(Sn[r],o,s),t.real&&g&&(i||!g[o])&&Tn(g,o,s)))},Pn=Zt,An=z,In=Function.prototype,Ln=Pn&&Object.getOwnPropertyDescriptor,Nn=An(In,"name"),Rn={EXISTS:Nn,PROPER:Nn&&"something"===function(){}.name,CONFIGURABLE:Nn&&(!Pn||Pn&&Ln(In,"name").configurable)},Fn={},jn=b,Yn=Math.max,Hn=Math.min,zn=function(t,e){var i=jn(t);return i<0?Yn(i+e,0):Hn(i,e)},Bn=b,Gn=Math.min,Wn=function(t){return t>0?Gn(Bn(t),9007199254740991):0},Un=function(t){return Wn(t.length)},Vn=$i,Xn=zn,qn=Un,$n=function(t){return function(e,i,n){var r,o=Vn(e),s=qn(o),a=Xn(n,s);if(t&&i!=i){for(;s>a;)if((r=o[a++])!=r)return!0}else for(;s>a;a++)if((t||a in o)&&o[a]===i)return t||a||0;return!t&&-1}},Zn={includes:$n(!0),indexOf:$n(!1)},Kn=z,Jn=$i,Qn=Zn.indexOf,tr=fi,er=m([].push),ir=function(t,e){var i,n=Jn(t),r=0,o=[];for(i in n)!Kn(tr,i)&&Kn(n,i)&&er(o,i);for(;e.length>r;)Kn(n,i=e[r++])&&(~Qn(o,i)||er(o,i));return o},nr=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],rr=ir,or=nr,sr=Object.keys||function(t){return rr(t,or)},ar=Zt,lr=re,hr=Kt,ur=le,dr=$i,cr=sr;Fn.f=ar&&!lr?Object.defineProperties:function(t,e){ur(t);for(var i,n=dr(e),r=cr(e),o=r.length,s=0;o>s;)hr.f(t,i=r[s++],n[i]);return t};var pr,fr=ge("document","documentElement"),mr=le,vr=Fn,gr=nr,yr=fi,br=fr,_r=ee,wr="prototype",kr="script",xr=pi("IE_PROTO"),Dr=function(){},Sr=function(t){return"<"+kr+">"+t+"</"+kr+">"},Cr=function(t){t.write(Sr("")),t.close();var e=t.parentWindow.Object;return t=null,e},Tr=function(){try{pr=new ActiveXObject("htmlfile")}catch(t){}var t,e,i;Tr="undefined"!=typeof document?document.domain&&pr?Cr(pr):(e=_r("iframe"),i="java"+kr+":",e.style.display="none",br.appendChild(e),e.src=String(i),(t=e.contentWindow.document).open(),t.write(Sr("document.F=Object")),t.close(),t.F):Cr(pr);for(var n=gr.length;n--;)delete Tr[wr][gr[n]];return Tr()};yr[xr]=!0;var Mr,Or,Er,Pr=Object.create||function(t,e){var i;return null!==t?(Dr[wr]=mr(t),i=new Dr,Dr[wr]=null,i[xr]=t):i=Tr(),void 0===e?i:vr.f(i,e)},Ar=!h((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Ir=z,Lr=_t,Nr=j,Rr=Ar,Fr=pi("IE_PROTO"),jr=Object,Yr=jr.prototype,Hr=Rr?jr.getPrototypeOf:function(t){var e=Nr(t);if(Ir(e,Fr))return e[Fr];var i=e.constructor;return Lr(i)&&e instanceof i?i.prototype:e instanceof jr?Yr:null},zr=ui,Br=function(t,e,i,n){return n&&n.enumerable?t[e]=i:zr(t,e,i),t},Gr=h,Wr=_t,Ur=$t,Vr=Pr,Xr=Hr,qr=Br,$r=ft("iterator"),Zr=!1;[].keys&&("next"in(Er=[].keys())?(Or=Xr(Xr(Er)))!==Object.prototype&&(Mr=Or):Zr=!0);var Kr=!Ur(Mr)||Gr((function(){var t={};return Mr[$r].call(t)!==t}));Wr((Mr=Kr?{}:Vr(Mr))[$r])||qr(Mr,$r,(function(){return this}));var Jr={IteratorPrototype:Mr,BUGGY_SAFARI_ITERATORS:Zr},Qr=Pt,to=vt?{}.toString:function(){return"[object "+Qr(this)+"]"},eo=vt,io=Kt.f,no=ui,ro=z,oo=to,so=ft("toStringTag"),ao=function(t,e,i,n){if(t){var r=i?t:t.prototype;ro(r,so)||io(r,so,{configurable:!0,value:e}),n&&!eo&&no(r,"toString",oo)}},lo={},ho=Jr.IteratorPrototype,uo=Pr,co=ai,po=ao,fo=lo,mo=function(){return this},vo=m,go=Oe,yo=_t,bo=String,_o=TypeError,wo=function(t,e,i){try{return vo(go(Object.getOwnPropertyDescriptor(t,e)[i]))}catch(t){}},ko=le,xo=function(t){if("object"==typeof t||yo(t))return t;throw new _o("Can't set "+bo(t)+" as a prototype")},Do=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=wo(Object.prototype,"__proto__","set"))(i,[]),e=i instanceof Array}catch(t){}return function(i,n){return ko(i),xo(n),e?t(i,n):i.__proto__=n,i}}():void 0),So=En,Co=de,To=Rn,Mo=function(t,e,i,n){var r=e+" Iterator";return t.prototype=uo(ho,{next:co(+!n,i)}),po(t,r,!1,!0),fo[r]=mo,t},Oo=Hr,Eo=ao,Po=Br,Ao=lo,Io=Jr,Lo=To.PROPER,No=Io.BUGGY_SAFARI_ITERATORS,Ro=ft("iterator"),Fo="keys",jo="values",Yo="entries",Ho=function(){return this},zo=function(t,e,i,n,r,o,s){Mo(i,e,n);var a,l,h,u=function(t){if(t===r&&m)return m;if(!No&&t&&t in p)return p[t];switch(t){case Fo:case jo:case Yo:return function(){return new i(this,t)}}return function(){return new i(this)}},d=e+" Iterator",c=!1,p=t.prototype,f=p[Ro]||p["@@iterator"]||r&&p[r],m=!No&&f||u(r),v="Array"===e&&p.entries||f;if(v&&(a=Oo(v.call(new t)))!==Object.prototype&&a.next&&(Eo(a,d,!0,!0),Ao[d]=Ho),Lo&&r===jo&&f&&f.name!==jo&&(c=!0,m=function(){return Co(f,this)}),r)if(l={values:u(jo),keys:o?m:u(Fo),entries:u(Yo)},s)for(h in l)(No||c||!(h in p))&&Po(p,h,l[h]);else So({target:e,proto:!0,forced:No||c},l);return s&&p[Ro]!==m&&Po(p,Ro,m,{name:r}),Ao[e]=m,l},Bo=function(t,e){return{value:t,done:e}},Go=Gt.charAt,Wo=Lt,Uo=Mi,Vo=zo,Xo=Bo,qo="String Iterator",$o=Uo.set,Zo=Uo.getterFor(qo);Vo(String,"String",(function(t){$o(this,{type:qo,string:Wo(t),index:0})}),(function(){var t,e=Zo(this),i=e.string,n=e.index;return n>=i.length?Xo(void 0,!0):(t=Go(i,n),e.index+=t.length,Xo(t,!1))}));var Ko=de,Jo=le,Qo=Ae,ts=function(t,e,i){var n,r;Jo(t);try{if(!(n=Qo(t,"return"))){if("throw"===e)throw i;return i}n=Ko(n,t)}catch(t){r=!0,n=t}if("throw"===e)throw i;if(r)throw n;return Jo(n),i},es=le,is=ts,ns=lo,rs=ft("iterator"),os=Array.prototype,ss=function(t){return void 0!==t&&(ns.Array===t||os[rs]===t)},as=_t,ls=T,hs=m(Function.toString);as(ls.inspectSource)||(ls.inspectSource=function(t){return hs(t)});var us=ls.inspectSource,ds=m,cs=h,ps=_t,fs=Pt,ms=us,vs=function(){},gs=[],ys=ge("Reflect","construct"),bs=/^\s*(?:class|function)\b/,_s=ds(bs.exec),ws=!bs.test(vs),ks=function(t){if(!ps(t))return!1;try{return ys(vs,gs,t),!0}catch(t){return!1}},xs=function(t){if(!ps(t))return!1;switch(fs(t)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return ws||!!_s(bs,ms(t))}catch(t){return!0}};xs.sham=!0;var Ds=!ys||cs((function(){var t;return ks(ks.call)||!ks(Object)||!ks((function(){t=!0}))||t}))?xs:ks,Ss=Ve,Cs=Kt,Ts=ai,Ms=function(t,e,i){var n=Ss(e);n in t?Cs.f(t,n,Ts(0,i)):t[n]=i},Os=Pt,Es=Ae,Ps=A,As=lo,Is=ft("iterator"),Ls=function(t){if(!Ps(t))return Es(t,Is)||Es(t,"@@iterator")||As[Os(t)]},Ns=de,Rs=Oe,Fs=le,js=Se,Ys=Ls,Hs=TypeError,zs=function(t,e){var i=arguments.length<2?Ys(t):e;if(Rs(i))return Fs(Ns(i,t));throw new Hs(js(t)+" is not iterable")},Bs=yn,Gs=de,Ws=j,Us=function(t,e,i,n){try{return n?e(es(i)[0],i[1]):e(i)}catch(e){is(t,"throw",e)}},Vs=ss,Xs=Ds,qs=Un,$s=Ms,Zs=zs,Ks=Ls,Js=Array,Qs=ft("iterator"),ta=!1;try{var ea=0,ia={next:function(){return{done:!!ea++}},return:function(){ta=!0}};ia[Qs]=function(){return this},Array.from(ia,(function(){throw 2}))}catch(t){}var na=function(t,e){try{if(!e&&!ta)return!1}catch(t){return!1}var i=!1;try{var n={};n[Qs]=function(){return{next:function(){return{done:i=!0}}}},t(n)}catch(t){}return i},ra=function(t){var e=Ws(t),i=Xs(this),n=arguments.length,r=n>1?arguments[1]:void 0,o=void 0!==r;o&&(r=Bs(r,n>2?arguments[2]:void 0));var s,a,l,h,u,d,c=Ks(e),p=0;if(!c||this===Js&&Vs(c))for(s=qs(e),a=i?new this(s):Js(s);s>p;p++)d=o?r(e[p],p):e[p],$s(a,p,d);else for(u=(h=Zs(e,c)).next,a=i?new this:[];!(l=Gs(u,h)).done;p++)d=o?Us(h,r,[l.value,p],!0):l.value,$s(a,p,d);return a.length=p,a};En({target:"Array",stat:!0,forced:!na((function(t){Array.from(t)}))},{from:ra});var oa=ce.Array.from,sa=n(oa),aa=$i,la=lo,ha=Mi;Kt.f;var ua=zo,da=Bo,ca="Array Iterator",pa=ha.set,fa=ha.getterFor(ca);ua(Array,"Array",(function(t,e){pa(this,{type:ca,target:aa(t),index:0,kind:e})}),(function(){var t=fa(this),e=t.target,i=t.kind,n=t.index++;if(!e||n>=e.length)return t.target=void 0,da(void 0,!0);switch(i){case"keys":return da(n,!1);case"values":return da(e[n],!1)}return da([n,e[n]],!1)}),"values"),la.Arguments=la.Array;var ma=Ls,va={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},ga=w,ya=Pt,ba=ui,_a=lo,wa=ft("toStringTag");for(var ka in va){var xa=ga[ka],Da=xa&&xa.prototype;Da&&ya(Da)!==wa&&ba(Da,wa,ka),_a[ka]=_a.Array}var Sa=ma,Ca=n(Sa),Ta=n(Sa);function Ma(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}var Oa={exports:{}},Ea=En,Pa=Zt,Aa=Kt.f;Ea({target:"Object",stat:!0,forced:Object.defineProperty!==Aa,sham:!Pa},{defineProperty:Aa});var Ia=ce.Object,La=Oa.exports=function(t,e,i){return Ia.defineProperty(t,e,i)};Ia.defineProperty.sham&&(La.sham=!0);var Na=Oa.exports,Ra=Na,Fa=n(Ra),ja=Dt,Ya=Array.isArray||function(t){return"Array"===ja(t)},Ha=TypeError,za=function(t){if(t>9007199254740991)throw Ha("Maximum allowed index exceeded");return t},Ba=Ya,Ga=Ds,Wa=$t,Ua=ft("species"),Va=Array,Xa=function(t){var e;return Ba(t)&&(e=t.constructor,(Ga(e)&&(e===Va||Ba(e.prototype))||Wa(e)&&null===(e=e[Ua]))&&(e=void 0)),void 0===e?Va:e},qa=function(t,e){return new(Xa(t))(0===e?0:e)},$a=h,Za=tt,Ka=ft("species"),Ja=function(t){return Za>=51||!$a((function(){var e=[];return(e.constructor={})[Ka]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Qa=En,tl=h,el=Ya,il=$t,nl=j,rl=Un,ol=za,sl=Ms,al=qa,ll=Ja,hl=tt,ul=ft("isConcatSpreadable"),dl=hl>=51||!tl((function(){var t=[];return t[ul]=!1,t.concat()[0]!==t})),cl=function(t){if(!il(t))return!1;var e=t[ul];return void 0!==e?!!e:el(t)};Qa({target:"Array",proto:!0,arity:1,forced:!dl||!ll("concat")},{concat:function(t){var e,i,n,r,o,s=nl(this),a=al(s,0),l=0;for(e=-1,n=arguments.length;e<n;e++)if(cl(o=-1===e?s:arguments[e]))for(r=rl(o),ol(l+r),i=0;i<r;i++,l++)i in o&&sl(a,l,o[i]);else ol(l+1),sl(a,l++,o);return a.length=l,a}});var pl={},fl=ir,ml=nr.concat("length","prototype");pl.f=Object.getOwnPropertyNames||function(t){return fl(t,ml)};var vl={},gl=zn,yl=Un,bl=Ms,_l=Array,wl=Math.max,kl=function(t,e,i){for(var n=yl(t),r=gl(e,n),o=gl(void 0===i?n:i,n),s=_l(wl(o-r,0)),a=0;r<o;r++,a++)bl(s,a,t[r]);return s.length=a,s},xl=Dt,Dl=$i,Sl=pl.f,Cl=kl,Tl="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];vl.f=function(t){return Tl&&"Window"===xl(t)?function(t){try{return Sl(t)}catch(t){return Cl(Tl)}}(t):Sl(Dl(t))};var Ml={};Ml.f=Object.getOwnPropertySymbols;var Ol=Kt,El=function(t,e,i){return Ol.f(t,e,i)},Pl={},Al=ft;Pl.f=Al;var Il=ce,Ll=z,Nl=Pl,Rl=Kt.f,Fl=function(t){var e=Il.Symbol||(Il.Symbol={});Ll(e,t)||Rl(e,t,{value:Nl.f(t)})},jl=de,Yl=ge,Hl=ft,zl=Br,Bl=function(){var t=Yl("Symbol"),e=t&&t.prototype,i=e&&e.valueOf,n=Hl("toPrimitive");e&&!e[n]&&zl(e,n,(function(t){return jl(i,this)}),{arity:1})},Gl=yn,Wl=Vi,Ul=j,Vl=Un,Xl=qa,ql=m([].push),$l=function(t){var e=1===t,i=2===t,n=3===t,r=4===t,o=6===t,s=7===t,a=5===t||o;return function(l,h,u,d){for(var c,p,f=Ul(l),m=Wl(f),v=Gl(h,u),g=Vl(m),y=0,b=d||Xl,_=e?b(l,g):i||s?b(l,0):void 0;g>y;y++)if((a||y in m)&&(p=v(c=m[y],y,f),t))if(e)_[y]=p;else if(p)switch(t){case 3:return!0;case 5:return c;case 6:return y;case 2:ql(_,c)}else switch(t){case 4:return!1;case 7:ql(_,c)}return o?-1:n||r?r:_}},Zl={forEach:$l(0),map:$l(1),filter:$l(2),some:$l(3),every:$l(4),find:$l(5),findIndex:$l(6),filterReject:$l(7)},Kl=En,Jl=w,Ql=de,th=m,eh=Zt,ih=rt,nh=h,rh=z,oh=ye,sh=le,ah=$i,lh=Ve,hh=Lt,uh=ai,dh=Pr,ch=sr,ph=pl,fh=vl,mh=Ml,vh=Fi,gh=Kt,yh=Fn,bh=ji,_h=Br,wh=El,kh=P,xh=fi,Dh=V,Sh=ft,Ch=Pl,Th=Fl,Mh=Bl,Oh=ao,Eh=Mi,Ph=Zl.forEach,Ah=pi("hidden"),Ih="Symbol",Lh="prototype",Nh=Eh.set,Rh=Eh.getterFor(Ih),Fh=Object[Lh],jh=Jl.Symbol,Yh=jh&&jh[Lh],Hh=Jl.RangeError,zh=Jl.TypeError,Bh=Jl.QObject,Gh=vh.f,Wh=gh.f,Uh=fh.f,Vh=bh.f,Xh=th([].push),qh=kh("symbols"),$h=kh("op-symbols"),Zh=kh("wks"),Kh=!Bh||!Bh[Lh]||!Bh[Lh].findChild,Jh=function(t,e,i){var n=Gh(Fh,e);n&&delete Fh[e],Wh(t,e,i),n&&t!==Fh&&Wh(Fh,e,n)},Qh=eh&&nh((function(){return 7!==dh(Wh({},"a",{get:function(){return Wh(this,"a",{value:7}).a}})).a}))?Jh:Wh,tu=function(t,e){var i=qh[t]=dh(Yh);return Nh(i,{type:Ih,tag:t,description:e}),eh||(i.description=e),i},eu=function(t,e,i){t===Fh&&eu($h,e,i),sh(t);var n=lh(e);return sh(i),rh(qh,n)?(i.enumerable?(rh(t,Ah)&&t[Ah][n]&&(t[Ah][n]=!1),i=dh(i,{enumerable:uh(0,!1)})):(rh(t,Ah)||Wh(t,Ah,uh(1,{})),t[Ah][n]=!0),Qh(t,n,i)):Wh(t,n,i)},iu=function(t,e){sh(t);var i=ah(e),n=ch(i).concat(su(i));return Ph(n,(function(e){eh&&!Ql(nu,i,e)||eu(t,e,i[e])})),t},nu=function(t){var e=lh(t),i=Ql(Vh,this,e);return!(this===Fh&&rh(qh,e)&&!rh($h,e))&&(!(i||!rh(this,e)||!rh(qh,e)||rh(this,Ah)&&this[Ah][e])||i)},ru=function(t,e){var i=ah(t),n=lh(e);if(i!==Fh||!rh(qh,n)||rh($h,n)){var r=Gh(i,n);return!r||!rh(qh,n)||rh(i,Ah)&&i[Ah][n]||(r.enumerable=!0),r}},ou=function(t){var e=Uh(ah(t)),i=[];return Ph(e,(function(t){rh(qh,t)||rh(xh,t)||Xh(i,t)})),i},su=function(t){var e=t===Fh,i=Uh(e?$h:ah(t)),n=[];return Ph(i,(function(t){!rh(qh,t)||e&&!rh(Fh,t)||Xh(n,qh[t])})),n};ih||(jh=function(){if(oh(Yh,this))throw new zh("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?hh(arguments[0]):void 0,e=Dh(t),i=function(t){this===Fh&&Ql(i,$h,t),rh(this,Ah)&&rh(this[Ah],e)&&(this[Ah][e]=!1);var n=uh(1,t);try{Qh(this,e,n)}catch(t){if(!(t instanceof Hh))throw t;Jh(this,e,n)}};return eh&&Kh&&Qh(Fh,e,{configurable:!0,set:i}),tu(e,t)},_h(Yh=jh[Lh],"toString",(function(){return Rh(this).tag})),_h(jh,"withoutSetter",(function(t){return tu(Dh(t),t)})),bh.f=nu,gh.f=eu,yh.f=iu,vh.f=ru,ph.f=fh.f=ou,mh.f=su,Ch.f=function(t){return tu(Sh(t),t)},eh&&wh(Yh,"description",{configurable:!0,get:function(){return Rh(this).description}})),Kl({global:!0,constructor:!0,wrap:!0,forced:!ih,sham:!ih},{Symbol:jh}),Ph(ch(Zh),(function(t){Th(t)})),Kl({target:Ih,stat:!0,forced:!ih},{useSetter:function(){Kh=!0},useSimple:function(){Kh=!1}}),Kl({target:"Object",stat:!0,forced:!ih,sham:!eh},{create:function(t,e){return void 0===e?dh(t):iu(dh(t),e)},defineProperty:eu,defineProperties:iu,getOwnPropertyDescriptor:ru}),Kl({target:"Object",stat:!0,forced:!ih},{getOwnPropertyNames:ou}),Mh(),Oh(jh,Ih),xh[Ah]=!0;var au=rt&&!!Symbol.for&&!!Symbol.keyFor,lu=En,hu=ge,uu=z,du=Lt,cu=P,pu=au,fu=cu("string-to-symbol-registry"),mu=cu("symbol-to-string-registry");lu({target:"Symbol",stat:!0,forced:!pu},{for:function(t){var e=du(t);if(uu(fu,e))return fu[e];var i=hu("Symbol")(e);return fu[e]=i,mu[i]=e,i}});var vu=En,gu=z,yu=xe,bu=Se,_u=au,wu=P("symbol-to-string-registry");vu({target:"Symbol",stat:!0,forced:!_u},{keyFor:function(t){if(!yu(t))throw new TypeError(bu(t)+" is not a symbol");if(gu(wu,t))return wu[t]}});var ku=m([].slice),xu=Ya,Du=_t,Su=Dt,Cu=Lt,Tu=m([].push),Mu=En,Ou=ge,Eu=Ii,Pu=de,Au=m,Iu=h,Lu=_t,Nu=xe,Ru=ku,Fu=function(t){if(Du(t))return t;if(xu(t)){for(var e=t.length,i=[],n=0;n<e;n++){var r=t[n];"string"==typeof r?Tu(i,r):"number"!=typeof r&&"Number"!==Su(r)&&"String"!==Su(r)||Tu(i,Cu(r))}var o=i.length,s=!0;return function(t,e){if(s)return s=!1,e;if(xu(this))return e;for(var n=0;n<o;n++)if(i[n]===t)return e}}},ju=rt,Yu=String,Hu=Ou("JSON","stringify"),zu=Au(/./.exec),Bu=Au("".charAt),Gu=Au("".charCodeAt),Wu=Au("".replace),Uu=Au(1..toString),Vu=/[\uD800-\uDFFF]/g,Xu=/^[\uD800-\uDBFF]$/,qu=/^[\uDC00-\uDFFF]$/,$u=!ju||Iu((function(){var t=Ou("Symbol")("stringify detection");return"[null]"!==Hu([t])||"{}"!==Hu({a:t})||"{}"!==Hu(Object(t))})),Zu=Iu((function(){return'"\\udf06\\ud834"'!==Hu("\udf06\ud834")||'"\\udead"'!==Hu("\udead")})),Ku=function(t,e){var i=Ru(arguments),n=Fu(e);if(Lu(n)||void 0!==t&&!Nu(t))return i[1]=function(t,e){if(Lu(n)&&(e=Pu(n,this,Yu(t),e)),!Nu(e))return e},Eu(Hu,null,i)},Ju=function(t,e,i){var n=Bu(i,e-1),r=Bu(i,e+1);return zu(Xu,t)&&!zu(qu,r)||zu(qu,t)&&!zu(Xu,n)?"\\u"+Uu(Gu(t,0),16):t};Hu&&Mu({target:"JSON",stat:!0,arity:3,forced:$u||Zu},{stringify:function(t,e,i){var n=Ru(arguments),r=Eu($u?Ku:Hu,null,n);return Zu&&"string"==typeof r?Wu(r,Vu,Ju):r}});var Qu=Ml,td=j;En({target:"Object",stat:!0,forced:!rt||h((function(){Qu.f(1)}))},{getOwnPropertySymbols:function(t){var e=Qu.f;return e?e(td(t)):[]}}),Fl("asyncIterator"),Fl("hasInstance"),Fl("isConcatSpreadable"),Fl("iterator"),Fl("match"),Fl("matchAll"),Fl("replace"),Fl("search"),Fl("species"),Fl("split");var ed=Bl;Fl("toPrimitive"),ed();var id=ge,nd=ao;Fl("toStringTag"),nd(id("Symbol"),"Symbol"),Fl("unscopables"),ao(w.JSON,"JSON",!0);var rd=ce.Symbol,od=ft,sd=Kt.f,ad=od("metadata"),ld=Function.prototype;void 0===ld[ad]&&sd(ld,ad,{value:null}),Fl("asyncDispose"),Fl("dispose"),Fl("metadata");var hd=rd,ud=m,dd=ge("Symbol"),cd=dd.keyFor,pd=ud(dd.prototype.valueOf),fd=dd.isRegisteredSymbol||function(t){try{return void 0!==cd(pd(t))}catch(t){return!1}};En({target:"Symbol",stat:!0},{isRegisteredSymbol:fd});for(var md=P,vd=ge,gd=m,yd=xe,bd=ft,_d=vd("Symbol"),wd=_d.isWellKnownSymbol,kd=vd("Object","getOwnPropertyNames"),xd=gd(_d.prototype.valueOf),Dd=md("wks"),Sd=0,Cd=kd(_d),Td=Cd.length;Sd<Td;Sd++)try{var Md=Cd[Sd];yd(_d[Md])&&bd(Md)}catch(t){}var Od=function(t){if(wd&&wd(t))return!0;try{for(var e=xd(t),i=0,n=kd(Dd),r=n.length;i<r;i++)if(Dd[n[i]]==e)return!0}catch(t){}return!1};En({target:"Symbol",stat:!0,forced:!0},{isWellKnownSymbol:Od}),Fl("matcher"),Fl("observable"),En({target:"Symbol",stat:!0,name:"isRegisteredSymbol"},{isRegistered:fd}),En({target:"Symbol",stat:!0,name:"isWellKnownSymbol",forced:!0},{isWellKnown:Od}),Fl("metadataKey"),Fl("patternMatch"),Fl("replaceAll");var Ed=hd,Pd=n(Ed),Ad=Pl.f("iterator"),Id=Ad,Ld=n(Id);function Nd(t){return Nd="function"==typeof Pd&&"symbol"==typeof Ld?function(t){return typeof t}:function(t){return t&&"function"==typeof Pd&&t.constructor===Pd&&t!==Pd.prototype?"symbol":typeof t},Nd(t)}var Rd=n(Pl.f("toPrimitive"));function Fd(t){var e=function(t,e){if("object"!==Nd(t)||null===t)return t;var i=t[Rd];if(void 0!==i){var n=i.call(t,e||"default");if("object"!==Nd(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===Nd(e)?e:String(e)}function jd(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Fa(t,Fd(n.key),n)}}function Yd(t,e,i){return e&&jd(t.prototype,e),i&&jd(t,i),Fa(t,"prototype",{writable:!1}),t}En({target:"Array",stat:!0},{isArray:Ya});var Hd=ce.Array.isArray,zd=n(Hd);var Bd=Zt,Gd=Ya,Wd=TypeError,Ud=Object.getOwnPropertyDescriptor,Vd=Bd&&!function(){if(void 0!==this)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(t){return t instanceof TypeError}}()?function(t,e){if(Gd(t)&&!Ud(t,"length").writable)throw new Wd("Cannot set read only .length");return t.length=e}:function(t,e){return t.length=e},Xd=j,qd=Un,$d=Vd,Zd=za;En({target:"Array",proto:!0,arity:1,forced:h((function(){return 4294967297!==[].push.call({length:4294967296},1)}))||!function(){try{Object.defineProperty([],"length",{writable:!1}).push()}catch(t){return t instanceof TypeError}}()},{push:function(t){var e=Xd(this),i=qd(e),n=arguments.length;Zd(i+n);for(var r=0;r<n;r++)e[i]=arguments[r],i++;return $d(e,i),i}});var Kd=ce,Jd=function(t){return Kd[t+"Prototype"]},Qd=Jd("Array").push,tc=ye,ec=Qd,ic=Array.prototype,nc=function(t){var e=t.push;return t===ic||tc(ic,t)&&e===ic.push?ec:e},rc=nc,oc=n(rc);var sc=En,ac=Ya,lc=Ds,hc=$t,uc=zn,dc=Un,cc=$i,pc=Ms,fc=ft,mc=ku,vc=Ja("slice"),gc=fc("species"),yc=Array,bc=Math.max;sc({target:"Array",proto:!0,forced:!vc},{slice:function(t,e){var i,n,r,o=cc(this),s=dc(o),a=uc(t,s),l=uc(void 0===e?s:e,s);if(ac(o)&&(i=o.constructor,(lc(i)&&(i===yc||ac(i.prototype))||hc(i)&&null===(i=i[gc]))&&(i=void 0),i===yc||void 0===i))return mc(o,a,l);for(n=new(void 0===i?yc:i)(bc(l-a,0)),r=0;a<l;a++,r++)a in o&&pc(n,r,o[a]);return n.length=r,n}});var _c=Jd("Array").slice,wc=ye,kc=_c,xc=Array.prototype,Dc=function(t){var e=t.slice;return t===xc||wc(xc,t)&&e===xc.slice?kc:e},Sc=Dc,Cc=Sc,Tc=n(Cc),Mc=n(oa);function Oc(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function Ec(t,e){var i;if(t){if("string"==typeof t)return Oc(t,e);var n=Tc(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Mc(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Oc(t,e):void 0}}function Pc(t,e){return function(t){if(zd(t))return t}(t)||function(t,e){var i=null==t?null:void 0!==Pd&&Ca(t)||t["@@iterator"];if(null!=i){var n,r,o,s,a=[],l=!0,h=!1;try{if(o=(i=i.call(t)).next,0===e){if(Object(i)!==i)return;l=!1}else for(;!(l=(n=o.call(i)).done)&&(oc(a).call(a,n.value),a.length!==e);l=!0);}catch(t){h=!0,r=t}finally{try{if(!l&&null!=i.return&&(s=i.return(),Object(s)!==s))return}finally{if(h)throw r}}return a}}(t,e)||Ec(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function Ac(t){return function(t){if(zd(t))return Oc(t)}(t)||function(t){if(void 0!==Pd&&null!=Ca(t)||null!=t["@@iterator"])return Mc(t)}(t)||Ec(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Ic=n(rd),Lc=Jd("Array").concat,Nc=ye,Rc=Lc,Fc=Array.prototype,jc=function(t){var e=t.concat;return t===Fc||Nc(Fc,t)&&e===Fc.concat?Rc:e},Yc=n(jc),Hc=n(Sc),zc=ge,Bc=pl,Gc=Ml,Wc=le,Uc=m([].concat),Vc=zc("Reflect","ownKeys")||function(t){var e=Bc.f(Wc(t)),i=Gc.f;return i?Uc(e,i(t)):e};En({target:"Reflect",stat:!0},{ownKeys:Vc});var Xc=n(ce.Reflect.ownKeys),qc=n(Hd),$c=Zl.map;En({target:"Array",proto:!0,forced:!Ja("map")},{map:function(t){return $c(this,t,arguments.length>1?arguments[1]:void 0)}});var Zc=Jd("Array").map,Kc=ye,Jc=Zc,Qc=Array.prototype,tp=function(t){var e=t.map;return t===Qc||Kc(Qc,t)&&e===Qc.map?Jc:e},ep=n(tp),ip=j,np=sr;En({target:"Object",stat:!0,forced:h((function(){np(1)}))},{keys:function(t){return np(ip(t))}});var rp=n(ce.Object.keys),op=En,sp=Date,ap=m(sp.prototype.getTime);op({target:"Date",stat:!0},{now:function(){return ap(new sp)}});var lp=n(ce.Date.now),hp=m,up=Oe,dp=$t,cp=z,pp=ku,fp=u,mp=Function,vp=hp([].concat),gp=hp([].join),yp={},bp=fp?mp.bind:function(t){var e=up(this),i=e.prototype,n=pp(arguments,1),r=function(){var i=vp(n,pp(arguments));return this instanceof r?function(t,e,i){if(!cp(yp,e)){for(var n=[],r=0;r<e;r++)n[r]="a["+r+"]";yp[e]=mp("C,a","return new C("+gp(n,",")+")")}return yp[e](t,i)}(e,i.length,i):e.apply(t,i)};return dp(i)&&(r.prototype=i),r},_p=bp;En({target:"Function",proto:!0,forced:Function.bind!==_p},{bind:_p});var wp=Jd("Function").bind,kp=ye,xp=wp,Dp=Function.prototype,Sp=function(t){var e=t.bind;return t===Dp||kp(Dp,t)&&e===Dp.bind?xp:e},Cp=Sp,Tp=n(Cp),Mp=h,Op=function(t,e){var i=[][t];return!!i&&Mp((function(){i.call(null,e||function(){return 1},1)}))},Ep=Zl.forEach,Pp=Op("forEach")?[].forEach:function(t){return Ep(this,t,arguments.length>1?arguments[1]:void 0)};En({target:"Array",proto:!0,forced:[].forEach!==Pp},{forEach:Pp});var Ap=Jd("Array").forEach,Ip=Pt,Lp=z,Np=ye,Rp=Ap,Fp=Array.prototype,jp={DOMTokenList:!0,NodeList:!0},Yp=function(t){var e=t.forEach;return t===Fp||Np(Fp,t)&&e===Fp.forEach||Lp(jp,Ip(t))?Rp:e},Hp=n(Yp),zp=En,Bp=Ya,Gp=m([].reverse),Wp=[1,2];zp({target:"Array",proto:!0,forced:String(Wp)===String(Wp.reverse())},{reverse:function(){return Bp(this)&&(this.length=this.length),Gp(this)}});var Up=Jd("Array").reverse,Vp=ye,Xp=Up,qp=Array.prototype,$p=function(t){var e=t.reverse;return t===qp||Vp(qp,t)&&e===qp.reverse?Xp:e},Zp=$p,Kp=n(Zp),Jp=Se,Qp=TypeError,tf=function(t,e){if(!delete t[e])throw new Qp("Cannot delete property "+Jp(e)+" of "+Jp(t))},ef=En,nf=j,rf=zn,of=b,sf=Un,af=Vd,lf=za,hf=qa,uf=Ms,df=tf,cf=Ja("splice"),pf=Math.max,ff=Math.min;ef({target:"Array",proto:!0,forced:!cf},{splice:function(t,e){var i,n,r,o,s,a,l=nf(this),h=sf(l),u=rf(t,h),d=arguments.length;for(0===d?i=n=0:1===d?(i=0,n=h-u):(i=d-2,n=ff(pf(of(e),0),h-u)),lf(h+i-n),r=hf(l,n),o=0;o<n;o++)(s=u+o)in l&&uf(r,o,l[s]);if(r.length=n,i<n){for(o=u;o<h-n;o++)a=o+i,(s=o+n)in l?l[a]=l[s]:df(l,a);for(o=h;o>h-n+i;o--)df(l,o-1)}else if(i>n)for(o=h-n;o>u;o--)a=o+i-1,(s=o+n-1)in l?l[a]=l[s]:df(l,a);for(o=0;o<i;o++)l[o+u]=arguments[o+2];return af(l,h-n+i),r}});var mf=Jd("Array").splice,vf=ye,gf=mf,yf=Array.prototype,bf=function(t){var e=t.splice;return t===yf||vf(yf,t)&&e===yf.splice?gf:e},_f=n(bf),wf=Zt,kf=m,xf=de,Df=h,Sf=sr,Cf=Ml,Tf=ji,Mf=j,Of=Vi,Ef=Object.assign,Pf=Object.defineProperty,Af=kf([].concat),If=!Ef||Df((function(){if(wf&&1!==Ef({b:1},Ef(Pf({},"a",{enumerable:!0,get:function(){Pf(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol("assign detection"),n="abcdefghijklmnopqrst";return t[i]=7,n.split("").forEach((function(t){e[t]=t})),7!==Ef({},t)[i]||Sf(Ef({},e)).join("")!==n}))?function(t,e){for(var i=Mf(t),n=arguments.length,r=1,o=Cf.f,s=Tf.f;n>r;)for(var a,l=Of(arguments[r++]),h=o?Af(Sf(l),o(l)):Sf(l),u=h.length,d=0;u>d;)a=h[d++],wf&&!xf(s,l,a)||(i[a]=l[a]);return i}:Ef,Lf=If;En({target:"Object",stat:!0,arity:2,forced:Object.assign!==Lf},{assign:Lf});var Nf=n(ce.Object.assign),Rf=Zn.includes;En({target:"Array",proto:!0,forced:h((function(){return!Array(1).includes()}))},{includes:function(t){return Rf(this,t,arguments.length>1?arguments[1]:void 0)}});var Ff=Jd("Array").includes,jf=$t,Yf=Dt,Hf=ft("match"),zf=function(t){var e;return jf(t)&&(void 0!==(e=t[Hf])?!!e:"RegExp"===Yf(t))},Bf=TypeError,Gf=ft("match"),Wf=En,Uf=function(t){if(zf(t))throw new Bf("The method doesn't accept regular expressions");return t},Vf=N,Xf=Lt,qf=function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[Gf]=!1,"/./"[t](e)}catch(t){}}return!1},$f=m("".indexOf);Wf({target:"String",proto:!0,forced:!qf("includes")},{includes:function(t){return!!~$f(Xf(Vf(this)),Xf(Uf(t)),arguments.length>1?arguments[1]:void 0)}});var Zf=Jd("String").includes,Kf=ye,Jf=Ff,Qf=Zf,tm=Array.prototype,em=String.prototype,im=function(t){var e=t.includes;return t===tm||Kf(tm,t)&&e===tm.includes?Jf:"string"==typeof t||t===em||Kf(em,t)&&e===em.includes?Qf:e},nm=n(im),rm=j,om=Hr,sm=Ar;En({target:"Object",stat:!0,forced:h((function(){om(1)})),sham:!sm},{getPrototypeOf:function(t){return om(rm(t))}});var am=ce.Object.getPrototypeOf,lm=n(am),hm=Zl.filter;En({target:"Array",proto:!0,forced:!Ja("filter")},{filter:function(t){return hm(this,t,arguments.length>1?arguments[1]:void 0)}});var um=Jd("Array").filter,dm=ye,cm=um,pm=Array.prototype,fm=function(t){var e=t.filter;return t===pm||dm(pm,t)&&e===pm.filter?cm:e},mm=n(fm),vm=Zt,gm=h,ym=m,bm=Hr,_m=sr,wm=$i,km=ym(ji.f),xm=ym([].push),Dm=vm&&gm((function(){var t=Object.create(null);return t[2]=2,!km(t,2)})),Sm=function(t){return function(e){for(var i,n=wm(e),r=_m(n),o=Dm&&null===bm(n),s=r.length,a=0,l=[];s>a;)i=r[a++],vm&&!(o?i in n:km(n,i))||xm(l,t?[i,n[i]]:n[i]);return l}},Cm={entries:Sm(!0),values:Sm(!1)},Tm=Cm.values;En({target:"Object",stat:!0},{values:function(t){return Tm(t)}});var Mm=n(ce.Object.values),Om="\t\n\v\f\r                　\u2028\u2029\ufeff",Em=N,Pm=Lt,Am=Om,Im=m("".replace),Lm=RegExp("^["+Am+"]+"),Nm=RegExp("(^|[^"+Am+"])["+Am+"]+$"),Rm=function(t){return function(e){var i=Pm(Em(e));return 1&t&&(i=Im(i,Lm,"")),2&t&&(i=Im(i,Nm,"$1")),i}},Fm={start:Rm(1),end:Rm(2),trim:Rm(3)},jm=w,Ym=h,Hm=m,zm=Lt,Bm=Fm.trim,Gm=Om,Wm=jm.parseInt,Um=jm.Symbol,Vm=Um&&Um.iterator,Xm=/^[+-]?0x/i,qm=Hm(Xm.exec),$m=8!==Wm(Gm+"08")||22!==Wm(Gm+"0x16")||Vm&&!Ym((function(){Wm(Object(Vm))}))?function(t,e){var i=Bm(zm(t));return Wm(i,e>>>0||(qm(Xm,i)?16:10))}:Wm;En({global:!0,forced:parseInt!==$m},{parseInt:$m});var Zm=n(ce.parseInt),Km=En,Jm=Zn.indexOf,Qm=Op,tv=Ri([].indexOf),ev=!!tv&&1/tv([1],1,-0)<0;Km({target:"Array",proto:!0,forced:ev||!Qm("indexOf")},{indexOf:function(t){var e=arguments.length>1?arguments[1]:void 0;return ev?tv(this,t,e)||0:Jm(this,t,e)}});var iv=Jd("Array").indexOf,nv=ye,rv=iv,ov=Array.prototype,sv=function(t){var e=t.indexOf;return t===ov||nv(ov,t)&&e===ov.indexOf?rv:e},av=n(sv),lv=Cm.entries;En({target:"Object",stat:!0},{entries:function(t){return lv(t)}});var hv=n(ce.Object.entries);En({target:"Object",stat:!0,sham:!Zt},{create:Pr});var uv=ce.Object,dv=function(t,e){return uv.create(t,e)},cv=n(dv),pv=ce,fv=Ii;pv.JSON||(pv.JSON={stringify:JSON.stringify});var mv=function(t,e,i){return fv(pv.JSON.stringify,null,arguments)},vv=n(mv),gv="function"==typeof Bun&&Bun&&"string"==typeof Bun.version,yv=TypeError,bv=function(t,e){if(t<e)throw new yv("Not enough arguments");return t},_v=w,wv=Ii,kv=_t,xv=gv,Dv=X,Sv=ku,Cv=bv,Tv=_v.Function,Mv=/MSIE .\./.test(Dv)||xv&&function(){var t=_v.Bun.version.split(".");return t.length<3||"0"===t[0]&&(t[1]<3||"3"===t[1]&&"0"===t[2])}(),Ov=function(t,e){var i=e?2:1;return Mv?function(n,r){var o=Cv(arguments.length,1)>i,s=kv(n)?n:Tv(n),a=o?Sv(arguments,i):[],l=o?function(){wv(s,this,a)}:s;return e?t(l,r):t(l)}:t},Ev=En,Pv=w,Av=Ov(Pv.setInterval,!0);Ev({global:!0,bind:!0,forced:Pv.setInterval!==Av},{setInterval:Av});var Iv=En,Lv=w,Nv=Ov(Lv.setTimeout,!0);Iv({global:!0,bind:!0,forced:Lv.setTimeout!==Nv},{setTimeout:Nv});var Rv=n(ce.setTimeout),Fv=j,jv=zn,Yv=Un,Hv=function(t){for(var e=Fv(this),i=Yv(e),n=arguments.length,r=jv(n>1?arguments[1]:void 0,i),o=n>2?arguments[2]:void 0,s=void 0===o?i:jv(o,i);s>r;)e[r++]=t;return e};En({target:"Array",proto:!0},{fill:Hv});var zv=Jd("Array").fill,Bv=ye,Gv=zv,Wv=Array.prototype,Uv=function(t){var e=t.fill;return t===Wv||Bv(Wv,t)&&e===Wv.fill?Gv:e},Vv=n(Uv),Xv={exports:{}};!function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var r=0;r<n.length;r++)if((i=n[r])===e||i.fn===e){n.splice(r,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(i){n=0;for(var r=(i=i.slice(0)).length;n<r;++n)i[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}}(Xv);var qv,$v=n(Xv.exports);
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
	 * http://naver.github.io/egjs
	 *
	 * Forked By Naver egjs
	 * Copyright (c) hammerjs
	 * Licensed under the MIT license */
function Zv(){return Zv=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t},Zv.apply(this,arguments)}function Kv(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function Jv(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}qv="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var r in n)n.hasOwnProperty(r)&&(e[r]=n[r])}return e}:Object.assign;var Qv,tg=qv,eg=["","webkit","Moz","MS","ms","o"],ig="undefined"==typeof document?{style:{}}:document.createElement("div"),ng=Math.round,rg=Math.abs,og=Date.now;function sg(t,e){for(var i,n,r=e[0].toUpperCase()+e.slice(1),o=0;o<eg.length;){if((n=(i=eg[o])?i+r:e)in t)return n;o++}}Qv="undefined"==typeof window?{}:window;var ag=sg(ig.style,"touchAction"),lg=void 0!==ag;var hg="compute",ug="auto",dg="manipulation",cg="none",pg="pan-x",fg="pan-y",mg=function(){if(!lg)return!1;var t={},e=Qv.CSS&&Qv.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||Qv.CSS.supports("touch-action",i)})),t}(),vg="ontouchstart"in Qv,gg=void 0!==sg(Qv,"PointerEvent"),yg=vg&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),bg="touch",_g="mouse",wg=25,kg=1,xg=4,Dg=8,Sg=1,Cg=2,Tg=4,Mg=8,Og=16,Eg=Cg|Tg,Pg=Mg|Og,Ag=Eg|Pg,Ig=["x","y"],Lg=["clientX","clientY"];function Ng(t,e,i){var n;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(i,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(i,t[n],n,t)}function Rg(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function Fg(t,e){return t.indexOf(e)>-1}var jg=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){t===hg&&(t=this.compute()),lg&&this.manager.element.style&&mg[t]&&(this.manager.element.style[ag]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Ng(this.manager.recognizers,(function(e){Rg(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Fg(t,cg))return cg;var e=Fg(t,pg),i=Fg(t,fg);return e&&i?cg:e||i?e?pg:fg:Fg(t,dg)?dg:ug}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,r=Fg(n,cg)&&!mg[cg],o=Fg(n,fg)&&!mg[fg],s=Fg(n,pg)&&!mg[pg];if(r){var a=1===t.pointers.length,l=t.distance<2,h=t.deltaTime<250;if(a&&l&&h)return}if(!s||!o)return r||o&&i&Eg||s&&i&Pg?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Yg(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Hg(t){var e=t.length;if(1===e)return{x:ng(t[0].clientX),y:ng(t[0].clientY)};for(var i=0,n=0,r=0;r<e;)i+=t[r].clientX,n+=t[r].clientY,r++;return{x:ng(i/e),y:ng(n/e)}}function zg(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:ng(t.pointers[i].clientX),clientY:ng(t.pointers[i].clientY)},i++;return{timeStamp:og(),pointers:e,center:Hg(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Bg(t,e,i){i||(i=Ig);var n=e[i[0]]-t[i[0]],r=e[i[1]]-t[i[1]];return Math.sqrt(n*n+r*r)}function Gg(t,e,i){i||(i=Ig);var n=e[i[0]]-t[i[0]],r=e[i[1]]-t[i[1]];return 180*Math.atan2(r,n)/Math.PI}function Wg(t,e){return t===e?Sg:rg(t)>=rg(e)?t<0?Cg:Tg:e<0?Mg:Og}function Ug(t,e,i){return{x:e/t||0,y:i/t||0}}function Vg(t,e){var i=t.session,n=e.pointers,r=n.length;i.firstInput||(i.firstInput=zg(e)),r>1&&!i.firstMultiple?i.firstMultiple=zg(e):1===r&&(i.firstMultiple=!1);var o=i.firstInput,s=i.firstMultiple,a=s?s.center:o.center,l=e.center=Hg(n);e.timeStamp=og(),e.deltaTime=e.timeStamp-o.timeStamp,e.angle=Gg(a,l),e.distance=Bg(a,l),function(t,e){var i=e.center,n=t.offsetDelta||{},r=t.prevDelta||{},o=t.prevInput||{};e.eventType!==kg&&o.eventType!==xg||(r=t.prevDelta={x:o.deltaX||0,y:o.deltaY||0},n=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=r.x+(i.x-n.x),e.deltaY=r.y+(i.y-n.y)}(i,e),e.offsetDirection=Wg(e.deltaX,e.deltaY);var h,u,d=Ug(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=d.x,e.overallVelocityY=d.y,e.overallVelocity=rg(d.x)>rg(d.y)?d.x:d.y,e.scale=s?(h=s.pointers,Bg((u=n)[0],u[1],Lg)/Bg(h[0],h[1],Lg)):1,e.rotation=s?function(t,e){return Gg(e[1],e[0],Lg)+Gg(t[1],t[0],Lg)}(s.pointers,n):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,n,r,o,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(e.eventType!==Dg&&(a>wg||void 0===s.velocity)){var l=e.deltaX-s.deltaX,h=e.deltaY-s.deltaY,u=Ug(a,l,h);n=u.x,r=u.y,i=rg(u.x)>rg(u.y)?u.x:u.y,o=Wg(l,h),t.lastInterval=e}else i=s.velocity,n=s.velocityX,r=s.velocityY,o=s.direction;e.velocity=i,e.velocityX=n,e.velocityY=r,e.direction=o}(i,e);var c,p=t.element,f=e.srcEvent;Yg(c=f.composedPath?f.composedPath()[0]:f.path?f.path[0]:f.target,p)&&(p=c),e.target=p}function Xg(t,e,i){var n=i.pointers.length,r=i.changedPointers.length,o=e&kg&&n-r==0,s=e&(xg|Dg)&&n-r==0;i.isFirst=!!o,i.isFinal=!!s,o&&(t.session={}),i.eventType=e,Vg(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function qg(t){return t.trim().split(/\s+/g)}function $g(t,e,i){Ng(qg(e),(function(e){t.addEventListener(e,i,!1)}))}function Zg(t,e,i){Ng(qg(e),(function(e){t.removeEventListener(e,i,!1)}))}function Kg(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var Jg=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Rg(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&$g(this.element,this.evEl,this.domHandler),this.evTarget&&$g(this.target,this.evTarget,this.domHandler),this.evWin&&$g(Kg(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&Zg(this.element,this.evEl,this.domHandler),this.evTarget&&Zg(this.target,this.evTarget,this.domHandler),this.evWin&&Zg(Kg(this.element),this.evWin,this.domHandler)},t}();function Qg(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var n=0;n<t.length;){if(i&&t[n][i]==e||!i&&t[n]===e)return n;n++}return-1}var ty={pointerdown:kg,pointermove:2,pointerup:xg,pointercancel:Dg,pointerout:Dg},ey={2:bg,3:"pen",4:_g,5:"kinect"},iy="pointerdown",ny="pointermove pointerup pointercancel";Qv.MSPointerEvent&&!Qv.PointerEvent&&(iy="MSPointerDown",ny="MSPointerMove MSPointerUp MSPointerCancel");var ry=function(t){function e(){var i,n=e.prototype;return n.evEl=iy,n.evWin=ny,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return Kv(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,n=t.type.toLowerCase().replace("ms",""),r=ty[n],o=ey[t.pointerType]||t.pointerType,s=o===bg,a=Qg(e,t.pointerId,"pointerId");r&kg&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):r&(xg|Dg)&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,r,{pointers:e,changedPointers:[t],pointerType:o,srcEvent:t}),i&&e.splice(a,1))},e}(Jg);function oy(t){return Array.prototype.slice.call(t,0)}function sy(t,e,i){for(var n=[],r=[],o=0;o<t.length;){var s=e?t[o][e]:t[o];Qg(r,s)<0&&n.push(t[o]),r[o]=s,o++}return i&&(n=e?n.sort((function(t,i){return t[e]>i[e]})):n.sort()),n}var ay={touchstart:kg,touchmove:2,touchend:xg,touchcancel:Dg},ly=function(t){function e(){var i;return e.prototype.evTarget="touchstart touchmove touchend touchcancel",(i=t.apply(this,arguments)||this).targetIds={},i}return Kv(e,t),e.prototype.handler=function(t){var e=ay[t.type],i=hy.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:bg,srcEvent:t})},e}(Jg);function hy(t,e){var i,n,r=oy(t.touches),o=this.targetIds;if(e&(2|kg)&&1===r.length)return o[r[0].identifier]=!0,[r,r];var s=oy(t.changedTouches),a=[],l=this.target;if(n=r.filter((function(t){return Yg(t.target,l)})),e===kg)for(i=0;i<n.length;)o[n[i].identifier]=!0,i++;for(i=0;i<s.length;)o[s[i].identifier]&&a.push(s[i]),e&(xg|Dg)&&delete o[s[i].identifier],i++;return a.length?[sy(n.concat(a),"identifier",!0),a]:void 0}var uy={mousedown:kg,mousemove:2,mouseup:xg},dy=function(t){function e(){var i,n=e.prototype;return n.evEl="mousedown",n.evWin="mousemove mouseup",(i=t.apply(this,arguments)||this).pressed=!1,i}return Kv(e,t),e.prototype.handler=function(t){var e=uy[t.type];e&kg&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=xg),this.pressed&&(e&xg&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:_g,srcEvent:t}))},e}(Jg),cy=2500;function py(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=n.indexOf(i);t>-1&&n.splice(t,1)}),cy)}}function fy(t,e){t&kg?(this.primaryTouch=e.changedPointers[0].identifier,py.call(this,e)):t&(xg|Dg)&&py.call(this,e)}function my(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var r=this.lastTouches[n],o=Math.abs(e-r.x),s=Math.abs(i-r.y);if(o<=25&&s<=25)return!0}return!1}var vy=function(){return function(t){function e(e,i){var n;return(n=t.call(this,e,i)||this).handler=function(t,e,i){var r=i.pointerType===bg,o=i.pointerType===_g;if(!(o&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(r)fy.call(Jv(Jv(n)),e,i);else if(o&&my.call(Jv(Jv(n)),i))return;n.callback(t,e,i)}},n.touch=new ly(n.manager,n.handler),n.mouse=new dy(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Kv(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Jg)}();function gy(t,e,i){return!!Array.isArray(t)&&(Ng(t,i[e],i),!0)}var yy=32,by=1;function _y(t,e){var i=e.manager;return i?i.get(t):t}function wy(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}var ky=function(){function t(t){void 0===t&&(t={}),this.options=Zv({enable:!0},t),this.id=by++,this.manager=null,this.state=1,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return tg(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(gy(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=_y(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return gy(t,"dropRecognizeWith",this)||(t=_y(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(gy(t,"requireFailure",this))return this;var e=this.requireFail;return-1===Qg(e,t=_y(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(gy(t,"dropRequireFailure",this))return this;t=_y(t,this);var e=Qg(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function n(i){e.manager.emit(i,t)}i<8&&n(e.options.event+wy(i)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),i>=8&&n(e.options.event+wy(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=yy},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},e.recognize=function(t){var e=tg({},t);if(!Rg(this.options.enable,[this,e]))return this.reset(),void(this.state=yy);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),xy=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,Zv({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}Kv(e,t);var i=e.prototype;return i.getTouchAction=function(){return[dg]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,r=t.distance<i.threshold,o=t.deltaTime<i.time;if(this.reset(),t.eventType&kg&&0===this.count)return this.failTimeout();if(r&&o&&n){if(t.eventType!==xg)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||Bg(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),i.interval),2):8}return yy},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=yy}),this.options.interval),yy},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){8===this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(ky),Dy=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Zv({pointers:1},e))||this}Kv(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,n=6&e,r=this.attrTest(t);return n&&(i&Dg||!r)?16|e:n||r?i&xg?8|e:2&e?4|e:2:yy},e}(ky);function Sy(t){return t===Og?"down":t===Mg?"up":t===Cg?"left":t===Tg?"right":""}var Cy=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,Zv({event:"pan",threshold:10,pointers:1,direction:Ag},e))||this).pX=null,i.pY=null,i}Kv(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return t&Eg&&e.push(fg),t&Pg&&e.push(pg),e},i.directionTest=function(t){var e=this.options,i=!0,n=t.distance,r=t.direction,o=t.deltaX,s=t.deltaY;return r&e.direction||(e.direction&Eg?(r=0===o?Sg:o<0?Cg:Tg,i=o!==this.pX,n=Math.abs(t.deltaX)):(r=0===s?Sg:s<0?Mg:Og,i=s!==this.pY,n=Math.abs(t.deltaY))),t.direction=r,i&&n>e.threshold&&r&e.direction},i.attrTest=function(t){return Dy.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=Sy(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(Dy),Ty=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Zv({event:"swipe",threshold:10,velocity:.3,direction:Eg|Pg,pointers:1},e))||this}Kv(e,t);var i=e.prototype;return i.getTouchAction=function(){return Cy.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,n=this.options.direction;return n&(Eg|Pg)?i=e.overallVelocity:n&Eg?i=e.overallVelocityX:n&Pg&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&rg(i)>this.options.velocity&&e.eventType&xg},i.emit=function(t){var e=Sy(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Dy),My=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Zv({event:"pinch",threshold:0,pointers:2},e))||this}Kv(e,t);var i=e.prototype;return i.getTouchAction=function(){return[cg]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||2&this.state)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(Dy),Oy=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Zv({event:"rotate",threshold:0,pointers:2},e))||this}Kv(e,t);var i=e.prototype;return i.getTouchAction=function(){return[cg]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||2&this.state)},e}(Dy),Ey=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,Zv({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}Kv(e,t);var i=e.prototype;return i.getTouchAction=function(){return[ug]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,r=t.distance<i.threshold,o=t.deltaTime>i.time;if(this._input=t,!r||!n||t.eventType&(xg|Dg)&&!o)this.reset();else if(t.eventType&kg)this.reset(),this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),i.time);else if(t.eventType&xg)return 8;return yy},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){8===this.state&&(t&&t.eventType&xg?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=og(),this.manager.emit(this.options.event,this._input)))},e}(ky),Py={domEvents:!1,touchAction:hg,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Ay=[[Oy,{enable:!1}],[My,{enable:!1},["rotate"]],[Ty,{direction:Eg}],[Cy,{direction:Eg},["swipe"]],[xy],[xy,{event:"doubletap",taps:2},["tap"]],[Ey]];function Iy(t,e){var i,n=t.element;n.style&&(Ng(t.options.cssProps,(function(r,o){i=sg(n.style,o),e?(t.oldCssProps[i]=n.style[i],n.style[i]=r):n.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var Ly=function(){function t(t,e){var i,n=this;this.options=tg({},Py,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(gg?ry:yg?ly:vg?vy:dy))(i,Xg),this.touchAction=new jg(this,this.options.touchAction),Iy(this,!0),Ng(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return tg(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var n=this.recognizers,r=e.curRecognizer;(!r||r&&8&r.state)&&(e.curRecognizer=null,r=null);for(var o=0;o<n.length;)i=n[o],2===e.stopped||r&&i!==r&&!i.canRecognizeWith(r)?i.reset():i.recognize(t),!r&&14&i.state&&(e.curRecognizer=i,r=i),o++}},e.get=function(t){if(t instanceof ky)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(gy(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(gy(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,n=Qg(i,e);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return Ng(qg(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return Ng(qg(t),(function(t){e?i[t]&&i[t].splice(Qg(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](e),n++}},e.destroy=function(){this.element&&Iy(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Ny={touchstart:kg,touchmove:2,touchend:xg,touchcancel:Dg},Ry=function(t){function e(){var i,n=e.prototype;return n.evTarget="touchstart",n.evWin="touchstart touchmove touchend touchcancel",(i=t.apply(this,arguments)||this).started=!1,i}return Kv(e,t),e.prototype.handler=function(t){var e=Ny[t.type];if(e===kg&&(this.started=!0),this.started){var i=Fy.call(this,t,e);e&(xg|Dg)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:bg,srcEvent:t})}},e}(Jg);function Fy(t,e){var i=oy(t.touches),n=oy(t.changedTouches);return e&(xg|Dg)&&(i=sy(i.concat(n),"identifier",!0)),[i,n]}function jy(t,e,i){var n="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",r=window.console&&(window.console.warn||window.console.log);return r&&r.call(window.console,n,i),t.apply(this,arguments)}}var Yy=jy((function(t,e,i){for(var n=Object.keys(e),r=0;r<n.length;)(!i||i&&void 0===t[n[r]])&&(t[n[r]]=e[n[r]]),r++;return t}),"extend","Use `assign`."),Hy=jy((function(t,e){return Yy(t,e,!0)}),"merge","Use `assign`.");function zy(t,e,i){var n,r=e.prototype;(n=t.prototype=Object.create(r)).constructor=t,n._super=r,i&&tg(n,i)}function By(t,e){return function(){return t.apply(e,arguments)}}var Gy=function(){var t=function(t,e){return void 0===e&&(e={}),new Ly(t,Zv({recognizers:Ay.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=Ag,t.DIRECTION_DOWN=Og,t.DIRECTION_LEFT=Cg,t.DIRECTION_RIGHT=Tg,t.DIRECTION_UP=Mg,t.DIRECTION_HORIZONTAL=Eg,t.DIRECTION_VERTICAL=Pg,t.DIRECTION_NONE=Sg,t.DIRECTION_DOWN=Og,t.INPUT_START=kg,t.INPUT_MOVE=2,t.INPUT_END=xg,t.INPUT_CANCEL=Dg,t.STATE_POSSIBLE=1,t.STATE_BEGAN=2,t.STATE_CHANGED=4,t.STATE_ENDED=8,t.STATE_RECOGNIZED=8,t.STATE_CANCELLED=16,t.STATE_FAILED=yy,t.Manager=Ly,t.Input=Jg,t.TouchAction=jg,t.TouchInput=ly,t.MouseInput=dy,t.PointerEventInput=ry,t.TouchMouseInput=vy,t.SingleTouchInput=Ry,t.Recognizer=ky,t.AttrRecognizer=Dy,t.Tap=xy,t.Pan=Cy,t.Swipe=Ty,t.Pinch=My,t.Rotate=Oy,t.Press=Ey,t.on=$g,t.off=Zg,t.each=Ng,t.merge=Hy,t.extend=Yy,t.bindFn=By,t.assign=tg,t.inherit=zy,t.bindFn=By,t.prefixed=sg,t.toArray=oy,t.inArray=Qg,t.uniqueArray=sy,t.splitStr=qg,t.boolOrFn=Rg,t.hasParent=Yg,t.addEventListeners=$g,t.removeEventListeners=Zg,t.defaults=tg({},Py,{preset:Ay}),t}();Gy.defaults;var Wy=Gy;function Uy(t,e){var i=void 0!==Ic&&Ta(t)||t["@@iterator"];if(!i){if(qc(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return Vy(t,e);var n=Hc(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Vy(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function Vy(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var Xy=Ic("DELETE");function qy(t){for(var e,i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return $y.apply(void 0,Yc(e=[{},t]).call(e,n))}function $y(){var t=Zy.apply(void 0,arguments);return Jy(t),t}function Zy(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<2)return e[0];var n;if(e.length>2)return Zy.apply(void 0,Yc(n=[$y(e[0],e[1])]).call(n,Ac(Hc(e).call(e,2))));var r=e[0],o=e[1];if(r instanceof Date&&o instanceof Date)return r.setTime(o.getTime()),r;var s,a=Uy(Xc(o));try{for(a.s();!(s=a.n()).done;){var l=s.value;Object.prototype.propertyIsEnumerable.call(o,l)&&(o[l]===Xy?delete r[l]:null===r[l]||null===o[l]||"object"!==Nd(r[l])||"object"!==Nd(o[l])||qc(r[l])||qc(o[l])?r[l]=Ky(o[l]):r[l]=Zy(r[l],o[l]))}}catch(t){a.e(t)}finally{a.f()}return r}function Ky(t){return qc(t)?ep(t).call(t,(function(t){return Ky(t)})):"object"===Nd(t)&&null!==t?t instanceof Date?new Date(t.getTime()):Zy({},t):t}function Jy(t){for(var e=0,i=rp(t);e<i.length;e++){var n=i[e];t[n]===Xy?delete t[n]:"object"===Nd(t[n])&&null!==t[n]&&Jy(t[n])}}var Qy="undefined"!=typeof window?window.Hammer||Wy:function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(){return{set:t}}}}()};function tb(t){var e,i=this;this._cleanupQueue=[],this.active=!1,this._dom={container:t,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push((function(){i._dom.overlay.parentNode.removeChild(i._dom.overlay)}));var n=Qy(this._dom.overlay);n.on("tap",Tp(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push((function(){n.destroy()}));var r=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Hp(r).call(r,(function(t){n.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this._onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||i.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push((function(){document.body.removeEventListener("click",i._onClick)}))),this._escListener=function(t){("key"in t?"Escape"===t.key:27===t.keyCode)&&i.deactivate()}}$v(tb.prototype),tb.current=null,tb.prototype.destroy=function(){var t,e;this.deactivate();var i,n=Uy(Kp(t=_f(e=this._cleanupQueue).call(e,0)).call(t));try{for(n.s();!(i=n.n()).done;){(0,i.value)()}}catch(t){n.e(t)}finally{n.f()}},tb.prototype.activate=function(){tb.current&&tb.current.deactivate(),tb.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)},tb.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")},tb.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var eb=/^\/?Date\((-?\d+)/i,ib=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,nb=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,rb=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,ob=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function sb(t){return t instanceof Number||"number"==typeof t}function ab(t){return t instanceof String||"string"==typeof t}function lb(t){return"object"===Nd(t)&&null!==t}function hb(t,e,i,n){var r=!1;!0===n&&(r=null===e[i]&&void 0!==t[i]),r?delete t[i]:t[i]=e[i]}var ub=Nf;function db(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var r in e)if(Object.prototype.hasOwnProperty.call(e,r)||!0===i)if("object"===Nd(e[r])&&null!==e[r]&&lm(e[r])===Object.prototype)void 0===t[r]?t[r]=db({},e[r],i):"object"===Nd(t[r])&&null!==t[r]&&lm(t[r])===Object.prototype?db(t[r],e[r],i):hb(t,e,r,n);else if(qc(e[r])){var o;t[r]=Hc(o=e[r]).call(o)}else hb(t,e,r,n);return t}function cb(t){var e=Nd(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":qc(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function pb(t,e){var i;return Yc(i=[]).call(i,Ac(t),[e])}function fb(t){return Hc(t).call(t)}var mb=Mm;var vb={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),ab(t)?t:sb(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function gb(t){var e;switch(t.length){case 3:case 4:return(e=nb.exec(t))?{r:Zm(e[1]+e[1],16),g:Zm(e[2]+e[2],16),b:Zm(e[3]+e[3],16)}:null;case 6:case 7:return(e=ib.exec(t))?{r:Zm(e[1],16),g:Zm(e[2],16),b:Zm(e[3],16)}:null;default:return null}}function yb(t,e,i){var n;return"#"+Hc(n=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(n,1)}function bb(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),r=Math.max(t,Math.max(e,i));return n===r?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(r-n))/360,s:(r-n)/r,v:r}}function _b(t){var e=document.createElement("div"),i={};e.style.cssText=t;for(var n=0;n<e.style.length;++n)i[e.style[n]]=e.style.getPropertyValue(e.style[n]);return i}function wb(t,e,i){var n,r,o,s=Math.floor(6*t),a=6*t-s,l=i*(1-e),h=i*(1-a*e),u=i*(1-(1-a)*e);switch(s%6){case 0:n=i,r=u,o=l;break;case 1:n=h,r=i,o=l;break;case 2:n=l,r=i,o=u;break;case 3:n=l,r=h,o=i;break;case 4:n=u,r=l,o=i;break;case 5:n=i,r=l,o=h}return{r:Math.floor(255*n),g:Math.floor(255*r),b:Math.floor(255*o)}}function kb(t,e,i){var n=wb(t,e,i);return yb(n.r,n.g,n.b)}function xb(t){var e=gb(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return bb(e.r,e.g,e.b)}function Db(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function Sb(t){return rb.test(t)}function Cb(t){return ob.test(t)}function Tb(t){if(null===t||"object"!==Nd(t))return null;if(t instanceof Element)return t;var e=cv(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==Nd(t[i])&&(e[i]=Tb(t[i]));return e}var Mb={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},Ob=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Ma(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Yd(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return Mb[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===ab(t)){if(!0===Sb(t)){var r=t.substr(4).substr(0,t.length-5).split(",");i={r:r[0],g:r[1],b:r[2],a:1}}else if(!0===Cb(t)){var o=t.substr(5).substr(0,t.length-6).split(",");i={r:o[0],g:o[1],b:o[2],a:o[3]}}else if(!0===Db(t)){var s=gb(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+vv(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=Nf({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Rv((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=Nf({},t)),this.color=t;var e=bb(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,r=this.centerCoordinates.x+n*Math.sin(i*e.h),o=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=o-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=bb(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=wb(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=bb(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,r=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,r),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),Vv(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var r=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var o=document.createElement("DIV");o.style.color="red",o.style.fontWeight="bold",o.style.padding="10px",o.innerText="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(o)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerText="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerText="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerText="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerText="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerText="cancel",this.cancelButton.onclick=Tp(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerText="apply",this.applyButton.onclick=Tp(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerText="save",this.saveButton.onclick=Tp(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerText="load last",this.loadButton.onclick=Tp(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new Qy(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.on("hammer.input",(function(e){e.isFirst&&t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,r,o=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,o,s),this.centerCoordinates={x:.5*o,y:.5*s},this.r=.49*o;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(r=0;r<this.r;r++)e=this.centerCoordinates.x+r*Math.sin(l*n),i=this.centerCoordinates.y+r*Math.cos(l*n),a=wb(.002777777777777778*n,r*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,o,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,r=.5*this.colorPickerDiv.clientHeight,o=.5*this.colorPickerDiv.clientWidth,s=i-o,a=n-r,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),o),u=Math.cos(l)*h+r,d=Math.sin(l)*h+o;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=d-.5*this.colorPickerSelector.clientWidth+"px";var c=l/(2*Math.PI);c=c<0?c+1:c;var p=h/this.r,f=bb(this.color.r,this.color.g,this.color.b);f.h=c,f.s=p;var m=wb(f.h,f.s,f.v);m.a=this.color.a,this.color=m,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();function Eb(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<1)throw new TypeError("Invalid arguments.");if(1===e.length)return document.createTextNode(e[0]);var n=document.createElement(e[0]);return n.appendChild(Eb.apply(void 0,Ac(Hc(e).call(e,1)))),n}var Pb,Ab=function(){function t(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:function(){return!1};Ma(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.hideOption=o,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},Nf(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new Ob(r),this.wrapper=void 0}return Yd(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(qc(t))this.options.filter=t.join();else if("object"===Nd(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==mm(t)&&(this.options.filter=mm(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===mm(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=mm(this.options),e=0,i=!1;for(var n in this.configureOptions)Object.prototype.hasOwnProperty.call(this.configureOptions,n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===av(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return Hp(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerText=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");if(n.className="vis-configuration vis-config-label vis-config-s"+e.length,!0===i){for(;n.firstChild;)n.removeChild(n.firstChild);n.appendChild(Eb("i","b",t))}else n.innerText=t+":";return n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var r=0;void 0!==e&&-1!==av(t).call(t,e)&&(r=av(t).call(t,e));for(var o=0;o<t.length;o++){var s=document.createElement("option");s.value=t[o],o===r&&(s.selected="selected"),s.innerText=t[o],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],r=t[1],o=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=r,a.max=o}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){var u=1.2;e<0&&e*u<r?(a.min=Math.ceil(e*u),h=a.min,l="range increased"):e/u<r&&(a.min=Math.ceil(e/u),h=a.min,l="range increased"),e*u>o&&1!==o&&(a.max=Math.ceil(e*u),h=a.max,l="range increased"),a.value=e}else a.value=n;var d=document.createElement("input");d.className="vis-configuration vis-config-rangeinput",d.value=a.value;var c=this;a.onchange=function(){d.value=this.value,c._update(Number(this.value),i)},a.oninput=function(){d.value=this.value};var p=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,p,a,d);""!==l&&this.popupHistory[f]!==h&&(this.popupHistory[f]=h,this._setupPopup(l,f))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerText="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerText=t,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Rv((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Rv((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Nd(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var r=this;n.onchange=function(){r._update(this.checked,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var r=this;n.onchange=function(){r._update(this.value,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,r=t[1],o=document.createElement("div");"none"!==(e=void 0===e?r:e)?(o.className="vis-configuration vis-config-colorBlock",o.style.backgroundColor=e):o.className="vis-configuration vis-config-colorBlock none",e=void 0===e?r:e,o.onclick=function(){n._showColorPicker(e,o,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var r="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=r,n._update(r,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,r=mm(this.options),o=!1;for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){n=!0;var a=t[s],l=pb(e,s);if("function"==typeof r&&!1===(n=r(s,e))&&!qc(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){o=!0;var h=this._getValue(l);if(qc(a))this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){if(!this.hideOption(e,s,this.moduleOptions))if(void 0!==a.enabled){var u=pb(l,"enabled"),d=this._getValue(u);if(!0===d){var c=this._makeLabel(s,l,!0);this._makeItem(l,c),o=this._handleObject(a,l)||o}else this._makeCheckbox(a,d,l)}else{var p=this._makeLabel(s,l,!0);this._makeItem(l,p),o=this._handleObject(a,l)||o}}else console.error("dont know how to handle",a,s,l)}}return o}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var r=0;r<e.length;r++)"global"!==e[r]&&(void 0===n[e[r]]&&(n[e[r]]={}),r!==e.length-1?n=n[e[r]]:n[e[r]]=t);return i}},{key:"_printOptions",value:function(){for(var t=this.getOptions();this.optionsContainer.firstChild;)this.optionsContainer.removeChild(this.optionsContainer.firstChild);this.optionsContainer.appendChild(Eb("pre","const options = "+vv(t,null,2)))}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),Ib=function(){function t(e,i){Ma(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Yd(t,[{key:"setPosition",value:function(t,e){this.x=Zm(t),this.y=Zm(e)}},{key:"setText",value:function(t){if(t instanceof Element){for(;this.frame.firstChild;)this.frame.removeChild(this.frame.firstChild);this.frame.appendChild(t)}else this.frame.innerText=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,r=this.frame.parentNode.clientWidth,o=0,s=0;if("flip"==this.overflowMethod){var a=!1,l=!0;this.y-e<this.padding&&(l=!1),this.x+i>r-this.padding&&(a=!0),o=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(o=this.x)+i+this.padding>r&&(o=r-i-this.padding),o<this.padding&&(o=this.padding);this.frame.style.left=o+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),Lb=!1,Nb="background: #FFeeee; color: #dd0000",Rb=function(){function t(){Ma(this,t)}return Yd(t,null,[{key:"validate",value:function(e,i,n){Lb=!1,Pb=i;var r=i;return void 0!==n&&(r=i[n]),t.parse(e,r,[]),Lb}},{key:"parse",value:function(e,i,n){for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&t.check(r,e,i,n)}},{key:"check",value:function(e,i,n,r){if(void 0!==n[e]||void 0!==n.__any__){var o=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",s="object"===t.getType(i[e]));var a=n[o];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,o,a,r)}else t.getSuggestion(e,n,r)}},{key:"checkFields",value:function(e,i,n,r,o,s){var a=function(i){console.error("%c"+i+t.printLocation(s,e),Nb)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===av(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),Lb=!0):"object"===l&&"__any__"!==r&&(s=pb(s,e),t.parse(i[e],n[r],s)):void 0===o.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(rp(o))+". Received ["+l+'] "'+i[e]+'"'),Lb=!0)}},{key:"getType",value:function(t){var e=Nd(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":qc(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var r,o=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,Pb,[],!0);r=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':s.distance<=4&&o.distance>s.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(rp(i))+t.printLocation(n,e),console.error('%cUnknown option detected: "'+e+'"'+r,Nb),Lb=!0}},{key:"findInOptions",value:function(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var d=void 0;if(void 0!==i[u].__type__&&!0===r){var c=t.findInOptions(e,i[u],pb(n,u));o>c.distance&&(s=c.closestMatch,a=c.path,o=c.distance,h=c.indexMatch)}else{var p;-1!==av(p=u.toLowerCase()).call(p,l)&&(h=u),o>(d=t.levenshteinDistance(e,u))&&(s=u,a=fb(n),o=d)}}return{closestMatch:s,path:a,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var r=0;r<n+1;r++)i+="  ";i+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return vv(t).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,r=[];for(i=0;i<=e.length;i++)r[i]=[i];for(n=0;n<=t.length;n++)r[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?r[i][n]=r[i-1][n-1]:r[i][n]=Math.min(r[i-1][n-1]+1,Math.min(r[i][n-1]+1,r[i-1][n]+1));return r[e.length][t.length]}}]),t}(),Fb=tb,jb=Ob,Yb=Ab,Hb=Qy,zb=Ib,Bb=Nb,Gb=Rb,Wb=Object.freeze({__proto__:null,Activator:Fb,Alea:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return function(t){var e=function(){for(var t=function(){var t=4022871197;return function(e){for(var i=e.toString(),n=0;n<i.length;n++){var r=.02519603282416938*(t+=i.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)}}(),e=t(" "),i=t(" "),n=t(" "),r=0;r<arguments.length;r++)(e-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(e+=1),(i-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(i+=1),(n-=t(r<0||arguments.length<=r?void 0:arguments[r]))<0&&(n+=1);return[e,i,n]}(t),i=Pc(e,3),n=i[0],r=i[1],o=i[2],s=1,a=function(){var t=2091639*n+2.3283064365386963e-10*s;return n=r,r=o,o=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}(e.length?e:[lp()])},ColorPicker:jb,Configurator:Yb,DELETE:Xy,HSVToHex:kb,HSVToRGB:wb,Hammer:Hb,Popup:zb,RGBToHSV:bb,RGBToHex:yb,VALIDATOR_PRINT_STYLE:Bb,Validator:Gb,addClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=Yc(i).call(i,mm(n).call(n,(function(t){return!nm(i).call(i,t)}))),t.className=i.join(" ")},addCssText:function(t,e){for(var i=_b(e),n=0,r=hv(i);n<r.length;n++){var o=Pc(r[n],2),s=o[0],a=o[1];t.style.setProperty(s,a)}},binarySearchCustom:function(t,e,i,n){for(var r=0,o=0,s=t.length-1;o<=s&&r<1e4;){var a=Math.floor((o+s)/2),l=t[a],h=e(void 0===n?l[i]:l[i][n]);if(0==h)return a;-1==h?o=a+1:s=a-1,r++}return-1},binarySearchValue:function(t,e,i,n,r){var o,s,a,l,h=0,u=0,d=t.length-1;for(r=null!=r?r:function(t,e){return t==e?0:t<e?-1:1};u<=d&&h<1e4;){if(l=Math.floor(.5*(d+u)),o=t[Math.max(0,l-1)][i],s=t[l][i],a=t[Math.min(t.length-1,l+1)][i],0==r(s,e))return l;if(r(o,e)<0&&r(s,e)>0)return"before"==n?Math.max(0,l-1):l;if(r(s,e)<0&&r(a,e)>0)return"before"==n?l:Math.min(t.length-1,l+1);r(s,e)<0?u=l+1:d=l-1,h++}return-1},bridgeObject:Tb,copyAndExtendArray:pb,copyArray:fb,deepExtend:db,deepObjectAssign:$y,easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},extend:ub,fillIfDefined:function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var r in e)if(void 0!==i[r])if(null===i[r]||"object"!==Nd(i[r]))hb(e,i,r,n);else{var o=e[r],s=i[r];lb(o)&&lb(s)&&t(o,s,n)}},forEach:function(t,e){if(qc(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e(t[r],r,t)},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:cb,hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},hexToHSV:xb,hexToRGB:gb,insertSort:function(t,e){for(var i=0;i<t.length;i++){var n=t[i],r=void 0;for(r=i;r>0&&e(n,t[r-1])<0;r--)t[r]=t[r-1];t[r]=n}return t},isDate:function(t){if(t instanceof Date)return!0;if(ab(t)){if(eb.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:sb,isObject:lb,isString:ab,isValidHex:Db,isValidRGB:Sb,isValidRGBA:Cb,mergeOptions:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=function(t){return null!=t},o=function(t){return null!==t&&"object"===Nd(t)};if(!o(t))throw new Error("Parameter mergeTarget must be an object");if(!o(e))throw new Error("Parameter options must be an object");if(!r(i))throw new Error("Parameter option must have a value");if(!o(n))throw new Error("Parameter globalOptions must be an object");var s=e[i],a=o(n)&&!function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0}(n)?n[i]:void 0,l=a?a.enabled:void 0;if(void 0!==s){if("boolean"==typeof s)return o(t[i])||(t[i]={}),void(t[i].enabled=s);if(null===s&&!o(t[i])){if(!r(a))return;t[i]=cv(a)}if(o(s)){var h=!0;void 0!==s.enabled?h=s.enabled:void 0!==l&&(h=a.enabled),function(t,e,i){o(t[i])||(t[i]={});var n=e[i],r=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(r[s]=n[s])}(t,e,i),t[i].enabled=h}}},option:vb,overrideOpacity:function(t,e){if(nm(t).call(t,"rgba"))return t;if(nm(t).call(t,"rgb")){var i=t.substr(av(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=gb(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},parseColor:function(t,e){if(ab(t)){var i=t;if(Sb(i)){var n,r=ep(n=i.substr(4).substr(0,i.length-5).split(",")).call(n,(function(t){return Zm(t)}));i=yb(r[0],r[1],r[2])}if(!0===Db(i)){var o=xb(i),s={h:o.h,s:.8*o.s,v:Math.min(1,1.02*o.v)},a={h:o.h,s:Math.min(1,1.25*o.s),v:.8*o.v},l=kb(a.h,a.s,a.v),h=kb(s.h,s.s,s.v);return{background:i,border:l,highlight:{background:h,border:l},hover:{background:h,border:l}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:ab(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:ab(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:ab(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:ab(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},pureDeepObjectAssign:qy,recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var i=e.firstChild;i&&(t(i),e.removeChild(i))}},removeClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=mm(i).call(i,(function(t){return!nm(n).call(n,t)})),t.className=i.join(" ")},removeCssText:function(t,e){for(var i=_b(e),n=0,r=rp(i);n<r.length;n++){var o=r[n];t.style.removeProperty(o)}},selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Nd(e)){for(var i=cv(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==Nd(e[t[n]])&&(i[t[n]]=Tb(e[t[n]]));return i}return null},selectiveDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(qc(i))throw new TypeError("Arrays are not supported by deepExtend");for(var r=0;r<t.length;r++){var o=t[r];if(Object.prototype.hasOwnProperty.call(i,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?db(e[o],i[o],!1,n):hb(e,i,o,n);else{if(qc(i[o]))throw new TypeError("Arrays are not supported by deepExtend");hb(e,i,o,n)}}return e},selectiveExtend:function(t,e){if(!qc(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),r=2;r<i;r++)n[r-2]=arguments[r];for(var o=0,s=n;o<s.length;o++)for(var a=s[o],l=0;l<t.length;l++){var h=t[l];a&&Object.prototype.hasOwnProperty.call(a,h)&&(e[h]=a[h])}return e},selectiveNotDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(qc(i))throw new TypeError("Arrays are not supported by deepExtend");for(var r in i)if(Object.prototype.hasOwnProperty.call(i,r)&&!nm(t).call(t,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?db(e[r],i[r]):hb(e,i,r,n);else if(qc(i[r])){e[r]=[];for(var o=0;o<i[r].length;o++)e[r].push(i[r][o])}else hb(e,i,r,n);return e},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:mb,topMost:function(t,e){var i;qc(e)||(e=[e]);var n,r=Uy(t);try{for(r.s();!(n=r.n()).done;){var o=n.value;if(o){i=o[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){r.e(t)}finally{r.f()}return i},updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)}});function Ub(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])}function Vb(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}}function Xb(t){Ub(t),Vb(t),Ub(t)}function qb(t,e,i){var n;return e.hasOwnProperty(t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(n)),e[t].used.push(n),n}function $b(t,e,i,n){var r;return e.hasOwnProperty(t)?e[t].redundant.length>0?(r=e[t].redundant[0],e[t].redundant.shift()):(r=document.createElement(t),void 0!==n?i.insertBefore(r,n):i.appendChild(r)):(r=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?i.insertBefore(r,n):i.appendChild(r)),e[t].used.push(r),r}function Zb(t,e,i,n,r,o){var s;if("circle"==i.style?((s=qb("circle",n,r)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",e),s.setAttributeNS(null,"r",.5*i.size)):((s=qb("rect",n,r)).setAttributeNS(null,"x",t-.5*i.size),s.setAttributeNS(null,"y",e-.5*i.size),s.setAttributeNS(null,"width",i.size),s.setAttributeNS(null,"height",i.size)),void 0!==i.styles&&s.setAttributeNS(null,"style",i.styles),s.setAttributeNS(null,"class",i.className+" vis-point"),o){var a=qb("text",n,r);o.xOffset&&(t+=o.xOffset),o.yOffset&&(e+=o.yOffset),o.content&&(a.textContent=o.content),o.className&&a.setAttributeNS(null,"class",o.className+" vis-label"),a.setAttributeNS(null,"x",t),a.setAttributeNS(null,"y",e)}return s}function Kb(t,e,i,n,r,o,s,a){if(0!=n){n<0&&(e-=n*=-1);var l=qb("rect",o,s);l.setAttributeNS(null,"x",t-.5*i),l.setAttributeNS(null,"y",e),l.setAttributeNS(null,"width",i),l.setAttributeNS(null,"height",n),l.setAttributeNS(null,"class",r),a&&l.setAttributeNS(null,"style",a)}}function Jb(){try{return navigator?navigator.languages&&navigator.languages.length?navigator.languages:navigator.userLanguage||navigator.language||navigator.browserLanguage||"en":"en"}catch(t){return"en"}}var Qb=Object.freeze({__proto__:null,cleanupElements:Vb,drawBar:Kb,drawPoint:Zb,getDOMElement:$b,getNavigatorLanguage:Jb,getSVGElement:qb,prepareElements:Ub,resetElements:Xb});function t_(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var e_=dv,i_=n(e_);En({target:"Object",stat:!0},{setPrototypeOf:Do});var n_=ce.Object.setPrototypeOf,r_=n(n_),o_=n(Cp);function s_(t,e){var i;return s_=r_?o_(i=r_).call(i):function(t,e){return t.__proto__=e,t},s_(t,e)}function a_(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=i_(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),Fa(t,"prototype",{writable:!1}),e&&s_(t,e)}function l_(t,e){if(e&&("object"===Nd(e)||"function"==typeof e))return e;if(void 0!==e)throw new TypeError("Derived constructors may only return object or undefined");return t_(t)}var h_=am,u_=n(h_);function d_(t){var e;return d_=r_?o_(e=u_).call(e):function(t){return t.__proto__||u_(t)},d_(t)}function c_(t,e,i){return(e=Fd(e))in t?Fa(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}var p_={exports:{}},f_={exports:{}};!function(t){var e=Ed,i=Id;function n(r){return t.exports=n="function"==typeof e&&"symbol"==typeof i?function(t){return typeof t}:function(t){return t&&"function"==typeof e&&t.constructor===e&&t!==e.prototype?"symbol":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,n(r)}t.exports=n,t.exports.__esModule=!0,t.exports.default=t.exports}(f_);var m_=f_.exports,v_=Yp,g_=z,y_=Vc,b_=Fi,__=Kt,w_=$t,k_=ui,x_=Error,D_=m("".replace),S_=String(new x_("zxcasd").stack),C_=/\n\s*at [^:]*:[^\n]*/,T_=C_.test(S_),M_=ai,O_=!h((function(){var t=new Error("a");return!("stack"in t)||(Object.defineProperty(t,"stack",M_(1,7)),7!==t.stack)})),E_=ui,P_=function(t,e){if(T_&&"string"==typeof t&&!x_.prepareStackTrace)for(;e--;)t=D_(t,C_,"");return t},A_=O_,I_=Error.captureStackTrace,L_=yn,N_=de,R_=le,F_=Se,j_=ss,Y_=Un,H_=ye,z_=zs,B_=Ls,G_=ts,W_=TypeError,U_=function(t,e){this.stopped=t,this.result=e},V_=U_.prototype,X_=function(t,e,i){var n,r,o,s,a,l,h,u=i&&i.that,d=!(!i||!i.AS_ENTRIES),c=!(!i||!i.IS_RECORD),p=!(!i||!i.IS_ITERATOR),f=!(!i||!i.INTERRUPTED),m=L_(e,u),v=function(t){return n&&G_(n,"normal",t),new U_(!0,t)},g=function(t){return d?(R_(t),f?m(t[0],t[1],v):m(t[0],t[1])):f?m(t,v):m(t)};if(c)n=t.iterator;else if(p)n=t;else{if(!(r=B_(t)))throw new W_(F_(t)+" is not iterable");if(j_(r)){for(o=0,s=Y_(t);s>o;o++)if((a=g(t[o]))&&H_(V_,a))return a;return new U_(!1)}n=z_(t,r)}for(l=c?t.next:n.next;!(h=N_(l,n)).done;){try{a=g(h.value)}catch(t){G_(n,"throw",t)}if("object"==typeof a&&a&&H_(V_,a))return a}return new U_(!1)},q_=Lt,$_=En,Z_=ye,K_=Hr,J_=Do,Q_=function(t,e,i){for(var n=y_(e),r=__.f,o=b_.f,s=0;s<n.length;s++){var a=n[s];g_(t,a)||i&&g_(i,a)||r(t,a,o(e,a))}},tw=Pr,ew=ui,iw=ai,nw=function(t,e){w_(e)&&"cause"in e&&k_(t,"cause",e.cause)},rw=function(t,e,i,n){A_&&(I_?I_(t,e):E_(t,"stack",P_(i,n)))},ow=X_,sw=function(t,e){return void 0===t?arguments.length<2?"":e:q_(t)},aw=ft("toStringTag"),lw=Error,hw=[].push,uw=function(t,e){var i,n=Z_(dw,this);J_?i=J_(new lw,n?K_(this):dw):(i=n?this:tw(dw),ew(i,aw,"Error")),void 0!==e&&ew(i,"message",sw(e)),rw(i,uw,i.stack,1),arguments.length>2&&nw(i,arguments[2]);var r=[];return ow(t,hw,{that:r}),ew(i,"errors",r),i};J_?J_(uw,lw):Q_(uw,lw,{name:!0});var dw=uw.prototype=tw(lw.prototype,{constructor:iw(1,uw),message:iw(1,""),name:iw(1,"AggregateError")});$_({global:!0,constructor:!0,arity:2},{AggregateError:uw});var cw,pw,fw,mw,vw="process"===Dt(w.process),gw=ge,yw=El,bw=Zt,_w=ft("species"),ww=function(t){var e=gw(t);bw&&e&&!e[_w]&&yw(e,_w,{configurable:!0,get:function(){return this}})},kw=ye,xw=TypeError,Dw=function(t,e){if(kw(e,t))return t;throw new xw("Incorrect invocation")},Sw=Ds,Cw=Se,Tw=TypeError,Mw=function(t){if(Sw(t))return t;throw new Tw(Cw(t)+" is not a constructor")},Ow=le,Ew=Mw,Pw=A,Aw=ft("species"),Iw=function(t,e){var i,n=Ow(t).constructor;return void 0===n||Pw(i=Ow(n)[Aw])?e:Ew(i)},Lw=/(?:ipad|iphone|ipod).*applewebkit/i.test(X),Nw=w,Rw=Ii,Fw=yn,jw=_t,Yw=z,Hw=h,zw=fr,Bw=ku,Gw=ee,Ww=bv,Uw=Lw,Vw=vw,Xw=Nw.setImmediate,qw=Nw.clearImmediate,$w=Nw.process,Zw=Nw.Dispatch,Kw=Nw.Function,Jw=Nw.MessageChannel,Qw=Nw.String,tk=0,ek={},ik="onreadystatechange";Hw((function(){cw=Nw.location}));var nk=function(t){if(Yw(ek,t)){var e=ek[t];delete ek[t],e()}},rk=function(t){return function(){nk(t)}},ok=function(t){nk(t.data)},sk=function(t){Nw.postMessage(Qw(t),cw.protocol+"//"+cw.host)};Xw&&qw||(Xw=function(t){Ww(arguments.length,1);var e=jw(t)?t:Kw(t),i=Bw(arguments,1);return ek[++tk]=function(){Rw(e,void 0,i)},pw(tk),tk},qw=function(t){delete ek[t]},Vw?pw=function(t){$w.nextTick(rk(t))}:Zw&&Zw.now?pw=function(t){Zw.now(rk(t))}:Jw&&!Uw?(mw=(fw=new Jw).port2,fw.port1.onmessage=ok,pw=Fw(mw.postMessage,mw)):Nw.addEventListener&&jw(Nw.postMessage)&&!Nw.importScripts&&cw&&"file:"!==cw.protocol&&!Hw(sk)?(pw=sk,Nw.addEventListener("message",ok,!1)):pw=ik in Gw("script")?function(t){zw.appendChild(Gw("script"))[ik]=function(){zw.removeChild(this),nk(t)}}:function(t){setTimeout(rk(t),0)});var ak={set:Xw,clear:qw},lk=function(){this.head=null,this.tail=null};lk.prototype={add:function(t){var e={item:t,next:null},i=this.tail;i?i.next=e:this.head=e,this.tail=e},get:function(){var t=this.head;if(t)return null===(this.head=t.next)&&(this.tail=null),t.item}};var hk,uk,dk,ck,pk,fk=lk,mk=/ipad|iphone|ipod/i.test(X)&&"undefined"!=typeof Pebble,vk=/web0s(?!.*chrome)/i.test(X),gk=w,yk=yn,bk=Fi.f,_k=ak.set,wk=fk,kk=Lw,xk=mk,Dk=vk,Sk=vw,Ck=gk.MutationObserver||gk.WebKitMutationObserver,Tk=gk.document,Mk=gk.process,Ok=gk.Promise,Ek=bk(gk,"queueMicrotask"),Pk=Ek&&Ek.value;if(!Pk){var Ak=new wk,Ik=function(){var t,e;for(Sk&&(t=Mk.domain)&&t.exit();e=Ak.get();)try{e()}catch(t){throw Ak.head&&hk(),t}t&&t.enter()};kk||Sk||Dk||!Ck||!Tk?!xk&&Ok&&Ok.resolve?((ck=Ok.resolve(void 0)).constructor=Ok,pk=yk(ck.then,ck),hk=function(){pk(Ik)}):Sk?hk=function(){Mk.nextTick(Ik)}:(_k=yk(_k,gk),hk=function(){_k(Ik)}):(uk=!0,dk=Tk.createTextNode(""),new Ck(Ik).observe(dk,{characterData:!0}),hk=function(){dk.data=uk=!uk}),Pk=function(t){Ak.head||hk(),Ak.add(t)}}var Lk=Pk,Nk=function(t){try{return{error:!1,value:t()}}catch(t){return{error:!0,value:t}}},Rk=w.Promise,Fk="object"==typeof Deno&&Deno&&"object"==typeof Deno.version,jk=!Fk&&!vw&&"object"==typeof window&&"object"==typeof document,Yk=w,Hk=Rk,zk=_t,Bk=fn,Gk=us,Wk=ft,Uk=jk,Vk=Fk,Xk=tt,qk=Hk&&Hk.prototype,$k=Wk("species"),Zk=!1,Kk=zk(Yk.PromiseRejectionEvent),Jk=Bk("Promise",(function(){var t=Gk(Hk),e=t!==String(Hk);if(!e&&66===Xk)return!0;if(!qk.catch||!qk.finally)return!0;if(!Xk||Xk<51||!/native code/.test(t)){var i=new Hk((function(t){t(1)})),n=function(t){t((function(){}),(function(){}))};if((i.constructor={})[$k]=n,!(Zk=i.then((function(){}))instanceof n))return!0}return!e&&(Uk||Vk)&&!Kk})),Qk={CONSTRUCTOR:Jk,REJECTION_EVENT:Kk,SUBCLASSING:Zk},tx={},ex=Oe,ix=TypeError,nx=function(t){var e,i;this.promise=new t((function(t,n){if(void 0!==e||void 0!==i)throw new ix("Bad Promise constructor");e=t,i=n})),this.resolve=ex(e),this.reject=ex(i)};tx.f=function(t){return new nx(t)};var rx,ox,sx=En,ax=vw,lx=w,hx=de,ux=Br,dx=ao,cx=ww,px=Oe,fx=_t,mx=$t,vx=Dw,gx=Iw,yx=ak.set,bx=Lk,_x=function(t,e){try{1===arguments.length?console.error(t):console.error(t,e)}catch(t){}},wx=Nk,kx=fk,xx=Mi,Dx=Rk,Sx=Qk,Cx=tx,Tx="Promise",Mx=Sx.CONSTRUCTOR,Ox=Sx.REJECTION_EVENT,Ex=xx.getterFor(Tx),Px=xx.set,Ax=Dx&&Dx.prototype,Ix=Dx,Lx=Ax,Nx=lx.TypeError,Rx=lx.document,Fx=lx.process,jx=Cx.f,Yx=jx,Hx=!!(Rx&&Rx.createEvent&&lx.dispatchEvent),zx="unhandledrejection",Bx=function(t){var e;return!(!mx(t)||!fx(e=t.then))&&e},Gx=function(t,e){var i,n,r,o=e.value,s=1===e.state,a=s?t.ok:t.fail,l=t.resolve,h=t.reject,u=t.domain;try{a?(s||(2===e.rejection&&qx(e),e.rejection=1),!0===a?i=o:(u&&u.enter(),i=a(o),u&&(u.exit(),r=!0)),i===t.promise?h(new Nx("Promise-chain cycle")):(n=Bx(i))?hx(n,i,l,h):l(i)):h(o)}catch(t){u&&!r&&u.exit(),h(t)}},Wx=function(t,e){t.notified||(t.notified=!0,bx((function(){for(var i,n=t.reactions;i=n.get();)Gx(i,t);t.notified=!1,e&&!t.rejection&&Vx(t)})))},Ux=function(t,e,i){var n,r;Hx?((n=Rx.createEvent("Event")).promise=e,n.reason=i,n.initEvent(t,!1,!0),lx.dispatchEvent(n)):n={promise:e,reason:i},!Ox&&(r=lx["on"+t])?r(n):t===zx&&_x("Unhandled promise rejection",i)},Vx=function(t){hx(yx,lx,(function(){var e,i=t.facade,n=t.value;if(Xx(t)&&(e=wx((function(){ax?Fx.emit("unhandledRejection",n,i):Ux(zx,i,n)})),t.rejection=ax||Xx(t)?2:1,e.error))throw e.value}))},Xx=function(t){return 1!==t.rejection&&!t.parent},qx=function(t){hx(yx,lx,(function(){var e=t.facade;ax?Fx.emit("rejectionHandled",e):Ux("rejectionhandled",e,t.value)}))},$x=function(t,e,i){return function(n){t(e,n,i)}},Zx=function(t,e,i){t.done||(t.done=!0,i&&(t=i),t.value=e,t.state=2,Wx(t,!0))},Kx=function(t,e,i){if(!t.done){t.done=!0,i&&(t=i);try{if(t.facade===e)throw new Nx("Promise can't be resolved itself");var n=Bx(e);n?bx((function(){var i={done:!1};try{hx(n,e,$x(Kx,i,t),$x(Zx,i,t))}catch(e){Zx(i,e,t)}})):(t.value=e,t.state=1,Wx(t,!1))}catch(e){Zx({done:!1},e,t)}}};Mx&&(Lx=(Ix=function(t){vx(this,Lx),px(t),hx(rx,this);var e=Ex(this);try{t($x(Kx,e),$x(Zx,e))}catch(t){Zx(e,t)}}).prototype,(rx=function(t){Px(this,{type:Tx,done:!1,notified:!1,parent:!1,reactions:new kx,rejection:!1,state:0,value:void 0})}).prototype=ux(Lx,"then",(function(t,e){var i=Ex(this),n=jx(gx(this,Ix));return i.parent=!0,n.ok=!fx(t)||t,n.fail=fx(e)&&e,n.domain=ax?Fx.domain:void 0,0===i.state?i.reactions.add(n):bx((function(){Gx(n,i)})),n.promise})),ox=function(){var t=new rx,e=Ex(t);this.promise=t,this.resolve=$x(Kx,e),this.reject=$x(Zx,e)},Cx.f=jx=function(t){return t===Ix||undefined===t?new ox(t):Yx(t)}),sx({global:!0,constructor:!0,wrap:!0,forced:Mx},{Promise:Ix}),dx(Ix,Tx,!1,!0),cx(Tx);var Jx=Rk,Qx=Qk.CONSTRUCTOR||!na((function(t){Jx.all(t).then(void 0,(function(){}))})),tD=de,eD=Oe,iD=tx,nD=Nk,rD=X_;En({target:"Promise",stat:!0,forced:Qx},{all:function(t){var e=this,i=iD.f(e),n=i.resolve,r=i.reject,o=nD((function(){var i=eD(e.resolve),o=[],s=0,a=1;rD(t,(function(t){var l=s++,h=!1;a++,tD(i,e,t).then((function(t){h||(h=!0,o[l]=t,--a||n(o))}),r)})),--a||n(o)}));return o.error&&r(o.value),i.promise}});var oD=En,sD=Qk.CONSTRUCTOR;Rk&&Rk.prototype,oD({target:"Promise",proto:!0,forced:sD,real:!0},{catch:function(t){return this.then(void 0,t)}});var aD=de,lD=Oe,hD=tx,uD=Nk,dD=X_;En({target:"Promise",stat:!0,forced:Qx},{race:function(t){var e=this,i=hD.f(e),n=i.reject,r=uD((function(){var r=lD(e.resolve);dD(t,(function(t){aD(r,e,t).then(i.resolve,n)}))}));return r.error&&n(r.value),i.promise}});var cD=de,pD=tx;En({target:"Promise",stat:!0,forced:Qk.CONSTRUCTOR},{reject:function(t){var e=pD.f(this);return cD(e.reject,void 0,t),e.promise}});var fD=le,mD=$t,vD=tx,gD=function(t,e){if(fD(t),mD(e)&&e.constructor===t)return e;var i=vD.f(t);return(0,i.resolve)(e),i.promise},yD=En,bD=Rk,_D=Qk.CONSTRUCTOR,wD=gD,kD=ge("Promise"),xD=!_D;yD({target:"Promise",stat:!0,forced:true},{resolve:function(t){return wD(xD&&this===kD?bD:this,t)}});var DD=de,SD=Oe,CD=tx,TD=Nk,MD=X_;En({target:"Promise",stat:!0,forced:Qx},{allSettled:function(t){var e=this,i=CD.f(e),n=i.resolve,r=i.reject,o=TD((function(){var i=SD(e.resolve),r=[],o=0,s=1;MD(t,(function(t){var a=o++,l=!1;s++,DD(i,e,t).then((function(t){l||(l=!0,r[a]={status:"fulfilled",value:t},--s||n(r))}),(function(t){l||(l=!0,r[a]={status:"rejected",reason:t},--s||n(r))}))})),--s||n(r)}));return o.error&&r(o.value),i.promise}});var OD=de,ED=Oe,PD=ge,AD=tx,ID=Nk,LD=X_,ND="No one promise resolved";En({target:"Promise",stat:!0,forced:Qx},{any:function(t){var e=this,i=PD("AggregateError"),n=AD.f(e),r=n.resolve,o=n.reject,s=ID((function(){var n=ED(e.resolve),s=[],a=0,l=1,h=!1;LD(t,(function(t){var u=a++,d=!1;l++,OD(n,e,t).then((function(t){d||h||(h=!0,r(t))}),(function(t){d||h||(d=!0,s[u]=t,--l||o(new i(s,ND)))}))})),--l||o(new i(s,ND))}));return s.error&&o(s.value),n.promise}});var RD=En,FD=Rk,jD=h,YD=ge,HD=_t,zD=Iw,BD=gD,GD=FD&&FD.prototype;RD({target:"Promise",proto:!0,real:!0,forced:!!FD&&jD((function(){GD.finally.call({then:function(){}},(function(){}))}))},{finally:function(t){var e=zD(this,YD("Promise")),i=HD(t);return this.then(i?function(i){return BD(e,t()).then((function(){return i}))}:t,i?function(i){return BD(e,t()).then((function(){throw i}))}:t)}});var WD=ce.Promise,UD=tx;En({target:"Promise",stat:!0},{withResolvers:function(){var t=UD.f(this);return{promise:t.promise,resolve:t.resolve,reject:t.reject}}});var VD=WD,XD=tx,qD=Nk;En({target:"Promise",stat:!0,forced:!0},{try:function(t){var e=XD.f(this),i=qD(t);return(i.error?e.reject:e.resolve)(i.value),e.promise}});var $D=VD,ZD=Zp;!function(t){var e=m_.default,i=Ra,n=Ed,r=e_,o=h_,s=v_,a=rc,l=n_,h=$D,u=ZD,d=Cc;function c(){t.exports=c=function(){return f},t.exports.__esModule=!0,t.exports.default=t.exports;var p,f={},m=Object.prototype,v=m.hasOwnProperty,g=i||function(t,e,i){t[e]=i.value},y="function"==typeof n?n:{},b=y.iterator||"@@iterator",_=y.asyncIterator||"@@asyncIterator",w=y.toStringTag||"@@toStringTag";function k(t,e,n){return i(t,e,{value:n,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{k({},"")}catch(p){k=function(t,e,i){return t[e]=i}}function x(t,e,i,n){var o=e&&e.prototype instanceof E?e:E,s=r(o.prototype),a=new B(n||[]);return g(s,"_invoke",{value:j(t,i,a)}),s}function D(t,e,i){try{return{type:"normal",arg:t.call(e,i)}}catch(t){return{type:"throw",arg:t}}}f.wrap=x;var S="suspendedStart",C="suspendedYield",T="executing",M="completed",O={};function E(){}function P(){}function A(){}var I={};k(I,b,(function(){return this}));var L=o&&o(o(G([])));L&&L!==m&&v.call(L,b)&&(I=L);var N=A.prototype=E.prototype=r(I);function R(t){var e;s(e=["next","throw","return"]).call(e,(function(e){k(t,e,(function(t){return this._invoke(e,t)}))}))}function F(t,i){function n(r,o,s,a){var l=D(t[r],t,o);if("throw"!==l.type){var h=l.arg,u=h.value;return u&&"object"==e(u)&&v.call(u,"__await")?i.resolve(u.__await).then((function(t){n("next",t,s,a)}),(function(t){n("throw",t,s,a)})):i.resolve(u).then((function(t){h.value=t,s(h)}),(function(t){return n("throw",t,s,a)}))}a(l.arg)}var r;g(this,"_invoke",{value:function(t,e){function o(){return new i((function(i,r){n(t,e,i,r)}))}return r=r?r.then(o,o):o()}})}function j(t,e,i){var n=S;return function(r,o){if(n===T)throw new Error("Generator is already running");if(n===M){if("throw"===r)throw o;return{value:p,done:!0}}for(i.method=r,i.arg=o;;){var s=i.delegate;if(s){var a=Y(s,i);if(a){if(a===O)continue;return a}}if("next"===i.method)i.sent=i._sent=i.arg;else if("throw"===i.method){if(n===S)throw n=M,i.arg;i.dispatchException(i.arg)}else"return"===i.method&&i.abrupt("return",i.arg);n=T;var l=D(t,e,i);if("normal"===l.type){if(n=i.done?M:C,l.arg===O)continue;return{value:l.arg,done:i.done}}"throw"===l.type&&(n=M,i.method="throw",i.arg=l.arg)}}}function Y(t,e){var i=e.method,n=t.iterator[i];if(n===p)return e.delegate=null,"throw"===i&&t.iterator.return&&(e.method="return",e.arg=p,Y(t,e),"throw"===e.method)||"return"!==i&&(e.method="throw",e.arg=new TypeError("The iterator does not provide a '"+i+"' method")),O;var r=D(n,t.iterator,e.arg);if("throw"===r.type)return e.method="throw",e.arg=r.arg,e.delegate=null,O;var o=r.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=p),e.delegate=null,O):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,O)}function H(t){var e,i={tryLoc:t[0]};1 in t&&(i.catchLoc=t[1]),2 in t&&(i.finallyLoc=t[2],i.afterLoc=t[3]),a(e=this.tryEntries).call(e,i)}function z(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function B(t){this.tryEntries=[{tryLoc:"root"}],s(t).call(t,H,this),this.reset(!0)}function G(t){if(t||""===t){var i=t[b];if(i)return i.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var n=-1,r=function e(){for(;++n<t.length;)if(v.call(t,n))return e.value=t[n],e.done=!1,e;return e.value=p,e.done=!0,e};return r.next=r}}throw new TypeError(e(t)+" is not iterable")}return P.prototype=A,g(N,"constructor",{value:A,configurable:!0}),g(A,"constructor",{value:P,configurable:!0}),P.displayName=k(A,w,"GeneratorFunction"),f.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===P||"GeneratorFunction"===(e.displayName||e.name))},f.mark=function(t){return l?l(t,A):(t.__proto__=A,k(t,w,"GeneratorFunction")),t.prototype=r(N),t},f.awrap=function(t){return{__await:t}},R(F.prototype),k(F.prototype,_,(function(){return this})),f.AsyncIterator=F,f.async=function(t,e,i,n,r){void 0===r&&(r=h);var o=new F(x(t,e,i,n),r);return f.isGeneratorFunction(e)?o:o.next().then((function(t){return t.done?t.value:o.next()}))},R(N),k(N,w,"Generator"),k(N,b,(function(){return this})),k(N,"toString",(function(){return"[object Generator]"})),f.keys=function(t){var e=Object(t),i=[];for(var n in e)a(i).call(i,n);return u(i).call(i),function t(){for(;i.length;){var n=i.pop();if(n in e)return t.value=n,t.done=!1,t}return t.done=!0,t}},f.values=G,B.prototype={constructor:B,reset:function(t){var e;if(this.prev=0,this.next=0,this.sent=this._sent=p,this.done=!1,this.delegate=null,this.method="next",this.arg=p,s(e=this.tryEntries).call(e,z),!t)for(var i in this)"t"===i.charAt(0)&&v.call(this,i)&&!isNaN(+d(i).call(i,1))&&(this[i]=p)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function i(i,n){return o.type="throw",o.arg=t,e.next=i,n&&(e.method="next",e.arg=p),!!n}for(var n=this.tryEntries.length-1;n>=0;--n){var r=this.tryEntries[n],o=r.completion;if("root"===r.tryLoc)return i("end");if(r.tryLoc<=this.prev){var s=v.call(r,"catchLoc"),a=v.call(r,"finallyLoc");if(s&&a){if(this.prev<r.catchLoc)return i(r.catchLoc,!0);if(this.prev<r.finallyLoc)return i(r.finallyLoc)}else if(s){if(this.prev<r.catchLoc)return i(r.catchLoc,!0)}else{if(!a)throw new Error("try statement without catch or finally");if(this.prev<r.finallyLoc)return i(r.finallyLoc)}}}},abrupt:function(t,e){for(var i=this.tryEntries.length-1;i>=0;--i){var n=this.tryEntries[i];if(n.tryLoc<=this.prev&&v.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var r=n;break}}r&&("break"===t||"continue"===t)&&r.tryLoc<=e&&e<=r.finallyLoc&&(r=null);var o=r?r.completion:{};return o.type=t,o.arg=e,r?(this.method="next",this.next=r.finallyLoc,O):this.complete(o)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),O},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.finallyLoc===t)return this.complete(i.completion,i.afterLoc),z(i),O}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.tryLoc===t){var n=i.completion;if("throw"===n.type){var r=n.arg;z(i)}return r}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,i){return this.delegate={iterator:G(t),resultName:e,nextLoc:i},"next"===this.method&&(this.arg=p),O}},f}t.exports=c,t.exports.__esModule=!0,t.exports.default=t.exports}(p_);var KD=(0,p_.exports)(),JD=KD;try{regeneratorRuntime=KD}catch(t){"object"==typeof globalThis?globalThis.regeneratorRuntime=KD:Function("r","regeneratorRuntime = r")(KD)}var QD=n(JD),tS=Oe,eS=j,iS=Vi,nS=Un,rS=TypeError,oS=function(t){return function(e,i,n,r){tS(i);var o=eS(e),s=iS(o),a=nS(o),l=t?a-1:0,h=t?-1:1;if(n<2)for(;;){if(l in s){r=s[l],l+=h;break}if(l+=h,t?l<0:a<=l)throw new rS("Reduce of empty array with no initial value")}for(;t?l>=0:a>l;l+=h)l in s&&(r=i(r,s[l],l,o));return r}},sS={left:oS(!1),right:oS(!0)}.left;En({target:"Array",proto:!0,forced:!vw&&tt>79&&tt<83||!Op("reduce")},{reduce:function(t){var e=arguments.length;return sS(this,t,e,e>1?arguments[1]:void 0)}});var aS=Jd("Array").reduce,lS=ye,hS=aS,uS=Array.prototype,dS=function(t){var e=t.reduce;return t===uS||lS(uS,t)&&e===uS.reduce?hS:e},cS=n(dS),pS=Ya,fS=Un,mS=za,vS=yn,gS=function(t,e,i,n,r,o,s,a){for(var l,h,u=r,d=0,c=!!s&&vS(s,a);d<n;)d in i&&(l=c?c(i[d],d,e):i[d],o>0&&pS(l)?(h=fS(l),u=gS(t,e,l,h,u,o-1)-1):(mS(u+1),t[u]=l),u++),d++;return u},yS=gS,bS=Oe,_S=j,wS=Un,kS=qa;En({target:"Array",proto:!0},{flatMap:function(t){var e,i=_S(this),n=wS(i);return bS(t),(e=kS(i,0)).length=yS(e,i,i,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var xS=Jd("Array").flatMap,DS=ye,SS=xS,CS=Array.prototype,TS=function(t){var e=t.flatMap;return t===CS||DS(CS,t)&&e===CS.flatMap?SS:e},MS=n(TS),OS={exports:{}},ES=h((function(){if("function"==typeof ArrayBuffer){var t=new ArrayBuffer(8);Object.isExtensible(t)&&Object.defineProperty(t,"a",{value:8})}})),PS=h,AS=$t,IS=Dt,LS=ES,NS=Object.isExtensible,RS=PS((function(){NS(1)}))||LS?function(t){return!!AS(t)&&((!LS||"ArrayBuffer"!==IS(t))&&(!NS||NS(t)))}:NS,FS=!h((function(){return Object.isExtensible(Object.preventExtensions({}))})),jS=En,YS=m,HS=fi,zS=$t,BS=z,GS=Kt.f,WS=pl,US=vl,VS=RS,XS=FS,qS=!1,$S=V("meta"),ZS=0,KS=function(t){GS(t,$S,{value:{objectID:"O"+ZS++,weakData:{}}})},JS=OS.exports={enable:function(){JS.enable=function(){},qS=!0;var t=WS.f,e=YS([].splice),i={};i[$S]=1,t(i).length&&(WS.f=function(i){for(var n=t(i),r=0,o=n.length;r<o;r++)if(n[r]===$S){e(n,r,1);break}return n},jS({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:US.f}))},fastKey:function(t,e){if(!zS(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!BS(t,$S)){if(!VS(t))return"F";if(!e)return"E";KS(t)}return t[$S].objectID},getWeakData:function(t,e){if(!BS(t,$S)){if(!VS(t))return!0;if(!e)return!1;KS(t)}return t[$S].weakData},onFreeze:function(t){return XS&&qS&&VS(t)&&!BS(t,$S)&&KS(t),t}};HS[$S]=!0;var QS=OS.exports,tC=En,eC=w,iC=QS,nC=h,rC=ui,oC=X_,sC=Dw,aC=_t,lC=$t,hC=A,uC=ao,dC=Kt.f,cC=Zl.forEach,pC=Zt,fC=Mi.set,mC=Mi.getterFor,vC=function(t,e,i){var n,r=-1!==t.indexOf("Map"),o=-1!==t.indexOf("Weak"),s=r?"set":"add",a=eC[t],l=a&&a.prototype,h={};if(pC&&aC(a)&&(o||l.forEach&&!nC((function(){(new a).entries().next()})))){var u=(n=e((function(e,i){fC(sC(e,u),{type:t,collection:new a}),hC(i)||oC(i,e[s],{that:e,AS_ENTRIES:r})}))).prototype,d=mC(t);cC(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"===t||"set"===t;!(t in l)||o&&"clear"===t||rC(u,t,(function(i,n){var r=d(this).collection;if(!e&&o&&!lC(i))return"get"===t&&void 0;var s=r[t](0===i?0:i,n);return e?this:s}))})),o||dC(u,"size",{configurable:!0,get:function(){return d(this).collection.size}})}else n=i.getConstructor(e,t,r,s),iC.enable();return uC(n,t,!1,!0),h[t]=n,tC({global:!0,forced:!0},h),o||i.setStrong(n,t,r),n},gC=Br,yC=Pr,bC=El,_C=function(t,e,i){for(var n in e)i&&i.unsafe&&t[n]?t[n]=e[n]:gC(t,n,e[n],i);return t},wC=yn,kC=Dw,xC=A,DC=X_,SC=zo,CC=Bo,TC=ww,MC=Zt,OC=QS.fastKey,EC=Mi.set,PC=Mi.getterFor,AC={getConstructor:function(t,e,i,n){var r=t((function(t,r){kC(t,o),EC(t,{type:e,index:yC(null),first:void 0,last:void 0,size:0}),MC||(t.size=0),xC(r)||DC(r,t[n],{that:t,AS_ENTRIES:i})})),o=r.prototype,s=PC(e),a=function(t,e,i){var n,r,o=s(t),a=l(t,e);return a?a.value=i:(o.last=a={index:r=OC(e,!0),key:e,value:i,previous:n=o.last,next:void 0,removed:!1},o.first||(o.first=a),n&&(n.next=a),MC?o.size++:t.size++,"F"!==r&&(o.index[r]=a)),t},l=function(t,e){var i,n=s(t),r=OC(e);if("F"!==r)return n.index[r];for(i=n.first;i;i=i.next)if(i.key===e)return i};return _C(o,{clear:function(){for(var t=s(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,MC?t.size=0:this.size=0},delete:function(t){var e=this,i=s(e),n=l(e,t);if(n){var r=n.next,o=n.previous;delete i.index[n.index],n.removed=!0,o&&(o.next=r),r&&(r.previous=o),i.first===n&&(i.first=r),i.last===n&&(i.last=o),MC?i.size--:e.size--}return!!n},forEach:function(t){for(var e,i=s(this),n=wC(t,arguments.length>1?arguments[1]:void 0);e=e?e.next:i.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!l(this,t)}}),_C(o,i?{get:function(t){var e=l(this,t);return e&&e.value},set:function(t,e){return a(this,0===t?0:t,e)}}:{add:function(t){return a(this,t=0===t?0:t,t)}}),MC&&bC(o,"size",{configurable:!0,get:function(){return s(this).size}}),r},setStrong:function(t,e,i){var n=e+" Iterator",r=PC(e),o=PC(n);SC(t,e,(function(t,e){EC(this,{type:n,target:t,state:r(t),kind:e,last:void 0})}),(function(){for(var t=o(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?CC("keys"===e?i.key:"values"===e?i.value:[i.key,i.value],!1):(t.target=void 0,CC(void 0,!0))}),i?"entries":"values",!i,!0),TC(e)}};vC("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),AC);var IC=n(ce.Map);vC("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),AC);var LC=n(ce.Set),NC=n(Ad),RC=n(zs),FC=kl,jC=Math.floor,YC=function(t,e){var i=t.length,n=jC(i/2);return i<8?HC(t,e):zC(t,YC(FC(t,0,n),e),YC(FC(t,n),e),e)},HC=function(t,e){for(var i,n,r=t.length,o=1;o<r;){for(n=o,i=t[o];n&&e(t[n-1],i)>0;)t[n]=t[--n];n!==o++&&(t[n]=i)}return t},zC=function(t,e,i,n){for(var r=e.length,o=i.length,s=0,a=0;s<r||a<o;)t[s+a]=s<r&&a<o?n(e[s],i[a])<=0?e[s++]:i[a++]:s<r?e[s++]:i[a++];return t},BC=YC,GC=X.match(/firefox\/(\d+)/i),WC=!!GC&&+GC[1],UC=/MSIE|Trident/.test(X),VC=X.match(/AppleWebKit\/(\d+)\./),XC=!!VC&&+VC[1],qC=En,$C=m,ZC=Oe,KC=j,JC=Un,QC=tf,tT=Lt,eT=h,iT=BC,nT=Op,rT=WC,oT=UC,sT=tt,aT=XC,lT=[],hT=$C(lT.sort),uT=$C(lT.push),dT=eT((function(){lT.sort(void 0)})),cT=eT((function(){lT.sort(null)})),pT=nT("sort"),fT=!eT((function(){if(sT)return sT<70;if(!(rT&&rT>3)){if(oT)return!0;if(aT)return aT<603;var t,e,i,n,r="";for(t=65;t<76;t++){switch(e=String.fromCharCode(t),t){case 66:case 69:case 70:case 72:i=3;break;case 68:case 71:i=4;break;default:i=2}for(n=0;n<47;n++)lT.push({k:e+n,v:i})}for(lT.sort((function(t,e){return e.v-t.v})),n=0;n<lT.length;n++)e=lT[n].k.charAt(0),r.charAt(r.length-1)!==e&&(r+=e);return"DGBEFHACIJK"!==r}}));qC({target:"Array",proto:!0,forced:dT||!cT||!pT||!fT},{sort:function(t){void 0!==t&&ZC(t);var e=KC(this);if(fT)return void 0===t?hT(e):hT(e,t);var i,n,r=[],o=JC(e);for(n=0;n<o;n++)n in e&&uT(r,e[n]);for(iT(r,function(t){return function(e,i){return void 0===i?-1:void 0===e?1:void 0!==t?+t(e,i)||0:tT(e)>tT(i)?1:-1}}(t)),i=JC(r),n=0;n<i;)e[n]=r[n++];for(;n<o;)QC(e,n++);return e}});var mT=Jd("Array").sort,vT=ye,gT=mT,yT=Array.prototype,bT=function(t){var e=t.sort;return t===yT||vT(yT,t)&&e===yT.sort?gT:e},_T=n(bT),wT=Zl.some;En({target:"Array",proto:!0,forced:!Op("some")},{some:function(t){return wT(this,t,arguments.length>1?arguments[1]:void 0)}});var kT=Jd("Array").some,xT=ye,DT=kT,ST=Array.prototype,CT=function(t){var e=t.some;return t===ST||xT(ST,t)&&e===ST.some?DT:e},TT=n(CT),MT=Jd("Array").keys,OT=Pt,ET=z,PT=ye,AT=MT,IT=Array.prototype,LT={DOMTokenList:!0,NodeList:!0},NT=function(t){var e=t.keys;return t===IT||PT(IT,t)&&e===IT.keys||ET(LT,OT(t))?AT:e},RT=n(NT),FT=Jd("Array").values,jT=Pt,YT=z,HT=ye,zT=FT,BT=Array.prototype,GT={DOMTokenList:!0,NodeList:!0},WT=function(t){var e=t.values;return t===BT||HT(BT,t)&&e===BT.values||YT(GT,jT(t))?zT:e},UT=n(WT),VT=Jd("Array").entries,XT=Pt,qT=z,$T=ye,ZT=VT,KT=Array.prototype,JT={DOMTokenList:!0,NodeList:!0},QT=function(t){var e=t.entries;return t===KT||$T(KT,t)&&e===KT.entries||qT(JT,XT(t))?ZT:e},tM=n(QT),eM=n(Na),iM=En,nM=Ii,rM=bp,oM=Mw,sM=le,aM=$t,lM=Pr,hM=h,uM=ge("Reflect","construct"),dM=Object.prototype,cM=[].push,pM=hM((function(){function t(){}return!(uM((function(){}),[],t)instanceof t)})),fM=!hM((function(){uM((function(){}))})),mM=pM||fM;iM({target:"Reflect",stat:!0,forced:mM,sham:mM},{construct:function(t,e){oM(t),sM(e);var i=arguments.length<3?t:oM(arguments[2]);if(fM&&!pM)return uM(t,e,i);if(t===i){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return nM(cM,n,e),new(nM(rM,t,n))}var r=i.prototype,o=lM(aM(r)?r:dM),s=nM(t,o,e);return aM(s)?s:o}});var vM=n(ce.Reflect.construct),gM=n(ce.Object.getOwnPropertySymbols),yM={exports:{}},bM=En,_M=h,wM=$i,kM=Fi.f,xM=Zt;bM({target:"Object",stat:!0,forced:!xM||_M((function(){kM(1)})),sham:!xM},{getOwnPropertyDescriptor:function(t,e){return kM(wM(t),e)}});var DM=ce.Object,SM=yM.exports=function(t,e){return DM.getOwnPropertyDescriptor(t,e)};DM.getOwnPropertyDescriptor.sham&&(SM.sham=!0);var CM=n(yM.exports),TM=Vc,MM=$i,OM=Fi,EM=Ms;En({target:"Object",stat:!0,sham:!Zt},{getOwnPropertyDescriptors:function(t){for(var e,i,n=MM(t),r=OM.f,o=TM(n),s={},a=0;o.length>a;)void 0!==(i=r(n,e=o[a++]))&&EM(s,e,i);return s}});var PM=n(ce.Object.getOwnPropertyDescriptors),AM={exports:{}},IM=En,LM=Zt,NM=Fn.f;IM({target:"Object",stat:!0,forced:Object.defineProperties!==NM,sham:!LM},{defineProperties:NM});var RM=ce.Object,FM=AM.exports=function(t,e){return RM.defineProperties(t,e)};RM.defineProperties.sham&&(FM.sham=!0);var jM=n(AM.exports);let YM;const HM=new Uint8Array(16);function zM(){if(!YM&&(YM="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!YM))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return YM(HM)}const BM=[];for(let t=0;t<256;++t)BM.push((t+256).toString(16).slice(1));var GM,WM={randomUUID:"undefined"!=typeof crypto&&crypto.randomUUID&&crypto.randomUUID.bind(crypto)};function UM(t,e,i){if(WM.randomUUID&&!e&&!t)return WM.randomUUID();const n=(t=t||{}).random||(t.rng||zM)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,e){i=i||0;for(let t=0;t<16;++t)e[i+t]=n[t];return e}return function(t,e=0){return BM[t[e+0]]+BM[t[e+1]]+BM[t[e+2]]+BM[t[e+3]]+"-"+BM[t[e+4]]+BM[t[e+5]]+"-"+BM[t[e+6]]+BM[t[e+7]]+"-"+BM[t[e+8]]+BM[t[e+9]]+"-"+BM[t[e+10]]+BM[t[e+11]]+BM[t[e+12]]+BM[t[e+13]]+BM[t[e+14]]+BM[t[e+15]]}(n)}function VM(t,e){var i=rp(t);if(gM){var n=gM(t);e&&(n=mm(n).call(n,(function(e){return CM(t,e).enumerable}))),i.push.apply(i,n)}return i}function XM(t){for(var e=1;e<arguments.length;e++){var i,n,r=null!=arguments[e]?arguments[e]:{};e%2?Hp(i=VM(Object(r),!0)).call(i,(function(e){c_(t,e,r[e])})):PM?jM(t,PM(r)):Hp(n=VM(Object(r))).call(n,(function(e){eM(t,e,CM(r,e))}))}return t}function qM(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}function $M(t,e){var i=void 0!==Ic&&Ta(t)||t["@@iterator"];if(!i){if(qc(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return ZM(t,e);var n=Hc(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ZM(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function ZM(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var KM=function(){function t(e,i,n){var r,o,s;Ma(this,t),c_(this,"_source",void 0),c_(this,"_transformers",void 0),c_(this,"_target",void 0),c_(this,"_listeners",{add:Tp(r=this._add).call(r,this),remove:Tp(o=this._remove).call(o,this),update:Tp(s=this._update).call(s,this)}),this._source=e,this._transformers=i,this._target=n}return Yd(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return cS(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),JM=function(){function t(e){Ma(this,t),c_(this,"_source",void 0),c_(this,"_transformers",[]),this._source=e}return Yd(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return mm(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return ep(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return MS(e).call(e,t)})),this}},{key:"to",value:function(t){return new KM(this._source,this._transformers,t)}}]),t}();function QM(t){return"string"==typeof t||"number"==typeof t}var tO=function(){function t(e){Ma(this,t),c_(this,"delay",void 0),c_(this,"max",void 0),c_(this,"_queue",[]),c_(this,"_timeout",null),c_(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(e)}return Yd(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,i=0;i<e.length;i++){var n=e[i];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var i=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),r=0;r<t;r++)e[r]=arguments[r];i.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=Rv((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Hp(t=_f(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,i){var n=new t(i);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var r=[{name:"flush",original:void 0}];if(i&&i.replace)for(var o=0;o<i.replace.length;o++){var s=i.replace[o];r.push({name:s,original:e[s]}),n.replace(e,s)}return n._extended={object:e,methods:r},n}}]),t}(),eO=function(){function t(){Ma(this,t),c_(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),c_(this,"subscribe",t.prototype.on),c_(this,"unsubscribe",t.prototype.off)}return Yd(t,[{key:"_trigger",value:function(t,e,i){var n,r;if("*"===t)throw new Error("Cannot trigger event *");Hp(n=Yc(r=[]).call(r,Ac(this._subscribers[t]),Ac(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=i?i:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var i;this._subscribers[t]=mm(i=this._subscribers[t]).call(i,(function(t){return t!==e}))}}]),t}();GM=NC;var iO=function(){function t(e){Ma(this,t),c_(this,"_pairs",void 0),this._pairs=e}return Yd(t,[{key:GM,value:QD.mark((function t(){var e,i,n,r,o;return QD.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=$M(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Pc(i.value,2),r=n[0],o=n[1],t.next=7,[r,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:QD.mark((function t(){var e,i,n,r,o;return QD.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=$M(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Pc(i.value,2),r=n[0],o=n[1],t.next=7,[r,o];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:QD.mark((function t(){var e,i,n,r;return QD.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=$M(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Pc(i.value,1),r=n[0],t.next=7,r;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:QD.mark((function t(){var e,i,n,r;return QD.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=$M(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=Pc(i.value,2),r=n[1],t.next=7,r;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return ep(t=Ac(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return ep(t=Ac(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Ac(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=cv(null),i=$M(this._pairs);try{for(i.s();!(t=i.n()).done;){var n=Pc(t.value,2),r=n[0],o=n[1];e[r]=o}}catch(t){i.e(t)}finally{i.f()}return e}},{key:"toMap",value:function(){return new IC(this._pairs)}},{key:"toIdSet",value:function(){return new LC(this.toIdArray())}},{key:"toItemSet",value:function(){return new LC(this.toItemArray())}},{key:"cache",value:function(){return new t(Ac(this._pairs))}},{key:"distinct",value:function(t){var e,i=new LC,n=$M(this._pairs);try{for(n.s();!(e=n.n()).done;){var r=Pc(e.value,2),o=r[0],s=r[1];i.add(t(s,o))}}catch(t){n.e(t)}finally{n.f()}return i}},{key:"filter",value:function(e){var i=this._pairs;return new t(c_({},NC,QD.mark((function t(){var n,r,o,s,a;return QD.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=$M(i),t.prev=1,n.s();case 3:if((r=n.n()).done){t.next=10;break}if(o=Pc(r.value,2),s=o[0],a=o[1],!e(a,s)){t.next=8;break}return t.next=8,[s,a];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,i=$M(this._pairs);try{for(i.s();!(e=i.n()).done;){var n=Pc(e.value,2),r=n[0];t(n[1],r)}}catch(t){i.e(t)}finally{i.f()}}},{key:"map",value:function(e){var i=this._pairs;return new t(c_({},NC,QD.mark((function t(){var n,r,o,s,a;return QD.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=$M(i),t.prev=1,n.s();case 3:if((r=n.n()).done){t.next=9;break}return o=Pc(r.value,2),s=o[0],a=o[1],t.next=7,[s,e(a,s)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=RC(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],r=t(i.value[1],i.value[0]);!(i=e.next()).done;){var o=Pc(i.value,2),s=o[0],a=o[1],l=t(a,s);l>r&&(r=l,n=a)}return n}},{key:"min",value:function(t){var e=RC(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],r=t(i.value[1],i.value[0]);!(i=e.next()).done;){var o=Pc(i.value,2),s=o[0],a=o[1],l=t(a,s);l<r&&(r=l,n=a)}return n}},{key:"reduce",value:function(t,e){var i,n=$M(this._pairs);try{for(n.s();!(i=n.n()).done;){var r=Pc(i.value,2),o=r[0];e=t(e,r[1],o)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var i=this;return new t(c_({},NC,(function(){var t;return RC(_T(t=Ac(i._pairs)).call(t,(function(t,i){var n=Pc(t,2),r=n[0],o=n[1],s=Pc(i,2),a=s[0],l=s[1];return e(o,l,r,a)})))})))}}]),t}();var nO=function(t){a_(i,t);var e=qM(i);function i(t,n){var r;return Ma(this,i),c_(t_(r=e.call(this)),"flush",void 0),c_(t_(r),"length",void 0),c_(t_(r),"_options",void 0),c_(t_(r),"_data",void 0),c_(t_(r),"_idProp",void 0),c_(t_(r),"_queue",null),t&&!qc(t)&&(n=t,t=[]),r._options=n||{},r._data=new IC,r.length=0,r._idProp=r._options.fieldId||"id",t&&t.length&&r.add(t),r.setOptions(n),r}return Yd(i,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=tO.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===Nd(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var i,n=this,r=[];if(qc(t)){var o=ep(t).call(t,(function(t){return t[n._idProp]}));if(TT(o).call(o,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var s=0,a=t.length;s<a;s++)i=this._addItem(t[s]),r.push(i)}else{if(!t||"object"!==Nd(t))throw new Error("Unknown dataType");i=this._addItem(t),r.push(i)}return r.length&&this._trigger("add",{items:r},e),r}},{key:"update",value:function(t,e){var i=this,n=[],r=[],o=[],s=[],a=this._idProp,l=function(t){var e=t[a];if(null!=e&&i._data.has(e)){var l=t,h=Nf({},i._data.get(e)),u=i._updateItem(l);r.push(u),s.push(l),o.push(h)}else{var d=i._addItem(t);n.push(d)}};if(qc(t))for(var h=0,u=t.length;h<u;h++)t[h]&&"object"===Nd(t[h])?l(t[h]):console.warn("Ignoring input item, which is not an object at index "+h);else{if(!t||"object"!==Nd(t))throw new Error("Unknown dataType");l(t)}if(n.length&&this._trigger("add",{items:n},e),r.length){var d={items:r,oldData:o,data:s};this._trigger("update",d,e)}return Yc(n).call(n,r)}},{key:"updateOnly",value:function(t,e){var i,n=this;qc(t)||(t=[t]);var r=ep(i=ep(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(i,(function(t){var e=t.oldData,i=t.update,r=e[n._idProp],o=qy(e,i);return n._data.set(r,o),{id:r,oldData:e,updatedData:o}}));if(r.length){var o={items:ep(r).call(r,(function(t){return t.id})),oldData:ep(r).call(r,(function(t){return t.oldData})),data:ep(r).call(r,(function(t){return t.updatedData}))};return this._trigger("update",o,e),o.items}return[]}},{key:"get",value:function(t,e){var i=void 0,n=void 0,r=void 0;QM(t)?(i=t,r=e):qc(t)?(n=t,r=e):r=t;var o,s=r&&"Object"===r.returnType?"Object":"Array",a=r&&mm(r),l=[],h=void 0,u=void 0,d=void 0;if(null!=i)(h=this._data.get(i))&&a&&!a(h)&&(h=void 0);else if(null!=n)for(var c=0,p=n.length;c<p;c++)null==(h=this._data.get(n[c]))||a&&!a(h)||l.push(h);else for(var f,m=0,v=(u=Ac(RT(f=this._data).call(f))).length;m<v;m++)d=u[m],null==(h=this._data.get(d))||a&&!a(h)||l.push(h);if(r&&r.order&&null==i&&this._sort(l,r.order),r&&r.fields){var g=r.fields;if(null!=i&&null!=h)h=this._filterFields(h,g);else for(var y=0,b=l.length;y<b;y++)l[y]=this._filterFields(l[y],g)}if("Object"==s){for(var _={},w=0,k=l.length;w<k;w++){var x=l[w];_[x[this._idProp]]=x}return _}return null!=i?null!==(o=h)&&void 0!==o?o:null:l}},{key:"getIds",value:function(t){var e=this._data,i=t&&mm(t),n=t&&t.order,r=Ac(RT(e).call(e)),o=[];if(i)if(n){for(var s=[],a=0,l=r.length;a<l;a++){var h=r[a],u=this._data.get(h);null!=u&&i(u)&&s.push(u)}this._sort(s,n);for(var d=0,c=s.length;d<c;d++)o.push(s[d][this._idProp])}else for(var p=0,f=r.length;p<f;p++){var m=r[p],v=this._data.get(m);null!=v&&i(v)&&o.push(v[this._idProp])}else if(n){for(var g=[],y=0,b=r.length;y<b;y++){var _=r[y];g.push(e.get(_))}this._sort(g,n);for(var w=0,k=g.length;w<k;w++)o.push(g[w][this._idProp])}else for(var x=0,D=r.length;x<D;x++){var S=r[x],C=e.get(S);null!=C&&o.push(C[this._idProp])}return o}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var i=e&&mm(e),n=this._data,r=Ac(RT(n).call(n));if(e&&e.order)for(var o=this.get(e),s=0,a=o.length;s<a;s++){var l=o[s];t(l,l[this._idProp])}else for(var h=0,u=r.length;h<u;h++){var d=r[h],c=this._data.get(d);null==c||i&&!i(c)||t(c,d)}}},{key:"map",value:function(t,e){for(var i=e&&mm(e),n=[],r=this._data,o=Ac(RT(r).call(r)),s=0,a=o.length;s<a;s++){var l=o[s],h=this._data.get(l);null==h||i&&!i(h)||n.push(t(h,l))}return e&&e.order&&this._sort(n,e.order),n}},{key:"_filterFields",value:function(t,e){var i;return t?cS(i=qc(e)?e:rp(e)).call(i,(function(e,i){return e[i]=t[i],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var i=e;_T(t).call(t,(function(t,e){var n=t[i],r=e[i];return n>r?1:n<r?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");_T(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var i=[],n=[],r=qc(t)?t:[t],o=0,s=r.length;o<s;o++){var a=this._remove(r[o]);if(a){var l=a[this._idProp];null!=l&&(i.push(l),n.push(a))}}return i.length&&this._trigger("remove",{items:i,oldData:n},e),i}},{key:"_remove",value:function(t){var e;if(QM(t)?e=t:t&&"object"===Nd(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var i=this._data.get(e)||null;return this._data.delete(e),--this.length,i}return null}},{key:"clear",value:function(t){for(var e,i=Ac(RT(e=this._data).call(e)),n=[],r=0,o=i.length;r<o;r++)n.push(this._data.get(i[r]));return this._data.clear(),this.length=0,this._trigger("remove",{items:i,oldData:n},t),i}},{key:"max",value:function(t){var e,i,n=null,r=null,o=$M(UT(e=this._data).call(e));try{for(o.s();!(i=o.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==r||a>r)&&(n=s,r=a)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"min",value:function(t){var e,i,n=null,r=null,o=$M(UT(e=this._data).call(e));try{for(o.s();!(i=o.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==r||a<r)&&(n=s,r=a)}}catch(t){o.e(t)}finally{o.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,i=Ac(RT(e).call(e)),n=[],r=0,o=0,s=i.length;o<s;o++){for(var a=i[o],l=e.get(a)[t],h=!1,u=0;u<r;u++)if(n[u]==l){h=!0;break}h||void 0===l||(n[r]=l,r++)}return n}},{key:"_addItem",value:function(t){var e=function(t,e){return null==t[e]&&(t[e]=UM()),t}(t,this._idProp),i=e[this._idProp];if(this._data.has(i))throw new Error("Cannot add item: item with id "+i+" already exists");return this._data.set(i,e),++this.length,i}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+vv(t)+")");var i=this._data.get(e);if(!i)throw new Error("Cannot update item: no item with id "+e+" found");return this._data.set(e,XM(XM({},i),t)),e}},{key:"stream",value:function(t){if(t){var e=this._data;return new iO(c_({},NC,QD.mark((function i(){var n,r,o,s;return QD.wrap((function(i){for(;;)switch(i.prev=i.next){case 0:n=$M(t),i.prev=1,n.s();case 3:if((r=n.n()).done){i.next=11;break}if(o=r.value,null==(s=e.get(o))){i.next=9;break}return i.next=9,[o,s];case 9:i.next=3;break;case 11:i.next=16;break;case 13:i.prev=13,i.t0=i.catch(1),n.e(i.t0);case 16:return i.prev=16,n.f(),i.finish(16);case 19:case"end":return i.stop()}}),i,null,[[1,13,16,19]])}))))}var i;return new iO(c_({},NC,Tp(i=tM(this._data)).call(i,this._data)))}}]),i}(eO),rO=function(t){a_(i,t);var e=qM(i);function i(t,n){var r,o;return Ma(this,i),c_(t_(o=e.call(this)),"length",0),c_(t_(o),"_listener",void 0),c_(t_(o),"_data",void 0),c_(t_(o),"_ids",new LC),c_(t_(o),"_options",void 0),o._options=n||{},o._listener=Tp(r=o._onEvent).call(r,t_(o)),o.setData(t),o}return Yd(i,[{key:"idProp",get:function(){return this.getDataSet().idProp}},{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:mm(this._options)}),i=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:i})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:mm(this._options)}),r=0,o=n.length;r<o;r++){var s=n[r];this._ids.add(s)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new nO;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:mm(this._options)}),e=Ac(this._ids),i={},n=[],r=[],o=[],s=0,a=t.length;s<a;s++){var l=t[s];i[l]=!0,this._ids.has(l)||(n.push(l),this._ids.add(l))}for(var h=0,u=e.length;h<u;h++){var d=e[h],c=this._data.get(d);null==c?console.error("If you see this, report it please."):i[d]||(r.push(d),o.push(c),this._ids.delete(d))}this.length+=n.length-r.length,n.length&&this._trigger("add",{items:n}),r.length&&this._trigger("remove",{items:r,oldData:o})}},{key:"get",value:function(t,e){if(null==this._data)return null;var i,n=null;QM(t)||qc(t)?(n=t,i=e):i=t;var r=Nf({},this._options,i),o=mm(this._options),s=i&&mm(i);return o&&s&&(r.filter=function(t){return o(t)&&s(t)}),null==n?this._data.get(r):this._data.get(n,r)}},{key:"getIds",value:function(t){if(this._data.length){var e,i=mm(this._options),n=null!=t?mm(t):null;return e=n?i?function(t){return i(t)&&n(t)}:n:i,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var i,n,r=mm(this._options),o=e&&mm(e);n=o?r?function(t){return r(t)&&o(t)}:o:r,Hp(i=this._data).call(i,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var i,n,r=mm(this._options),o=e&&mm(e);return n=o?r?function(t){return r(t)&&o(t)}:o:r,ep(i=this._data).call(i,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||c_({},NC,Tp(e=RT(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;null!==(t=this._data)&&void 0!==t&&t.off&&this._data.off("*",this._listener);var e,n="This data view has already been disposed of.",r={get:function(){throw new Error(n)},set:function(){throw new Error(n)},configurable:!1},o=$M(Xc(i.prototype));try{for(o.s();!(e=o.n()).done;){var s=e.value;eM(this,s,r)}}catch(t){o.e(t)}finally{o.f()}}},{key:"_onEvent",value:function(t,e,i){if(e&&e.items&&this._data){var n=e.items,r=[],o=[],s=[],a=[],l=[],h=[];switch(t){case"add":for(var u=0,d=n.length;u<d;u++){var c=n[u];this.get(c)&&(this._ids.add(c),r.push(c))}break;case"update":for(var p=0,f=n.length;p<f;p++){var m=n[p];this.get(m)?this._ids.has(m)?(o.push(m),l.push(e.data[p]),a.push(e.oldData[p])):(this._ids.add(m),r.push(m)):this._ids.has(m)&&(this._ids.delete(m),s.push(m),h.push(e.oldData[p]))}break;case"remove":for(var v=0,g=n.length;v<g;v++){var y=n[v];this._ids.has(y)&&(this._ids.delete(y),s.push(y),h.push(e.oldData[v]))}}this.length+=r.length-s.length,r.length&&this._trigger("add",{items:r},i),o.length&&this._trigger("update",{items:o,oldData:a,data:l},i),s.length&&this._trigger("remove",{items:s,oldData:h},i)}}}]),i}(eO);function oO(t,e){return"object"===Nd(e)&&null!==e&&t===e.idProp&&"function"==typeof Hp(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof ep(e)&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.stream&&function(t,e){return"object"===Nd(e)&&null!==e&&t===e.idProp&&"function"==typeof e.add&&"function"==typeof e.clear&&"function"==typeof e.distinct&&"function"==typeof Hp(e)&&"function"==typeof e.get&&"function"==typeof e.getDataSet&&"function"==typeof e.getIds&&"number"==typeof e.length&&"function"==typeof ep(e)&&"function"==typeof e.max&&"function"==typeof e.min&&"function"==typeof e.off&&"function"==typeof e.on&&"function"==typeof e.remove&&"function"==typeof e.setOptions&&"function"==typeof e.stream&&"function"==typeof e.update&&"function"==typeof e.updateOnly}(t,e.getDataSet())}var sO=n("undefined"!=typeof window&&window.moment||l()),aO=n(l()),lO={exports:{}},hO={},uO={exports:{}},dO={};function cO(){var t={"align-content":!1,"align-items":!1,"align-self":!1,"alignment-adjust":!1,"alignment-baseline":!1,all:!1,"anchor-point":!1,animation:!1,"animation-delay":!1,"animation-direction":!1,"animation-duration":!1,"animation-fill-mode":!1,"animation-iteration-count":!1,"animation-name":!1,"animation-play-state":!1,"animation-timing-function":!1,azimuth:!1,"backface-visibility":!1,background:!0,"background-attachment":!0,"background-clip":!0,"background-color":!0,"background-image":!0,"background-origin":!0,"background-position":!0,"background-repeat":!0,"background-size":!0,"baseline-shift":!1,binding:!1,bleed:!1,"bookmark-label":!1,"bookmark-level":!1,"bookmark-state":!1,border:!0,"border-bottom":!0,"border-bottom-color":!0,"border-bottom-left-radius":!0,"border-bottom-right-radius":!0,"border-bottom-style":!0,"border-bottom-width":!0,"border-collapse":!0,"border-color":!0,"border-image":!0,"border-image-outset":!0,"border-image-repeat":!0,"border-image-slice":!0,"border-image-source":!0,"border-image-width":!0,"border-left":!0,"border-left-color":!0,"border-left-style":!0,"border-left-width":!0,"border-radius":!0,"border-right":!0,"border-right-color":!0,"border-right-style":!0,"border-right-width":!0,"border-spacing":!0,"border-style":!0,"border-top":!0,"border-top-color":!0,"border-top-left-radius":!0,"border-top-right-radius":!0,"border-top-style":!0,"border-top-width":!0,"border-width":!0,bottom:!1,"box-decoration-break":!0,"box-shadow":!0,"box-sizing":!0,"box-snap":!0,"box-suppress":!0,"break-after":!0,"break-before":!0,"break-inside":!0,"caption-side":!1,chains:!1,clear:!0,clip:!1,"clip-path":!1,"clip-rule":!1,color:!0,"color-interpolation-filters":!0,"column-count":!1,"column-fill":!1,"column-gap":!1,"column-rule":!1,"column-rule-color":!1,"column-rule-style":!1,"column-rule-width":!1,"column-span":!1,"column-width":!1,columns:!1,contain:!1,content:!1,"counter-increment":!1,"counter-reset":!1,"counter-set":!1,crop:!1,cue:!1,"cue-after":!1,"cue-before":!1,cursor:!1,direction:!1,display:!0,"display-inside":!0,"display-list":!0,"display-outside":!0,"dominant-baseline":!1,elevation:!1,"empty-cells":!1,filter:!1,flex:!1,"flex-basis":!1,"flex-direction":!1,"flex-flow":!1,"flex-grow":!1,"flex-shrink":!1,"flex-wrap":!1,float:!1,"float-offset":!1,"flood-color":!1,"flood-opacity":!1,"flow-from":!1,"flow-into":!1,font:!0,"font-family":!0,"font-feature-settings":!0,"font-kerning":!0,"font-language-override":!0,"font-size":!0,"font-size-adjust":!0,"font-stretch":!0,"font-style":!0,"font-synthesis":!0,"font-variant":!0,"font-variant-alternates":!0,"font-variant-caps":!0,"font-variant-east-asian":!0,"font-variant-ligatures":!0,"font-variant-numeric":!0,"font-variant-position":!0,"font-weight":!0,grid:!1,"grid-area":!1,"grid-auto-columns":!1,"grid-auto-flow":!1,"grid-auto-rows":!1,"grid-column":!1,"grid-column-end":!1,"grid-column-start":!1,"grid-row":!1,"grid-row-end":!1,"grid-row-start":!1,"grid-template":!1,"grid-template-areas":!1,"grid-template-columns":!1,"grid-template-rows":!1,"hanging-punctuation":!1,height:!0,hyphens:!1,icon:!1,"image-orientation":!1,"image-resolution":!1,"ime-mode":!1,"initial-letters":!1,"inline-box-align":!1,"justify-content":!1,"justify-items":!1,"justify-self":!1,left:!1,"letter-spacing":!0,"lighting-color":!0,"line-box-contain":!1,"line-break":!1,"line-grid":!1,"line-height":!1,"line-snap":!1,"line-stacking":!1,"line-stacking-ruby":!1,"line-stacking-shift":!1,"line-stacking-strategy":!1,"list-style":!0,"list-style-image":!0,"list-style-position":!0,"list-style-type":!0,margin:!0,"margin-bottom":!0,"margin-left":!0,"margin-right":!0,"margin-top":!0,"marker-offset":!1,"marker-side":!1,marks:!1,mask:!1,"mask-box":!1,"mask-box-outset":!1,"mask-box-repeat":!1,"mask-box-slice":!1,"mask-box-source":!1,"mask-box-width":!1,"mask-clip":!1,"mask-image":!1,"mask-origin":!1,"mask-position":!1,"mask-repeat":!1,"mask-size":!1,"mask-source-type":!1,"mask-type":!1,"max-height":!0,"max-lines":!1,"max-width":!0,"min-height":!0,"min-width":!0,"move-to":!1,"nav-down":!1,"nav-index":!1,"nav-left":!1,"nav-right":!1,"nav-up":!1,"object-fit":!1,"object-position":!1,opacity:!1,order:!1,orphans:!1,outline:!1,"outline-color":!1,"outline-offset":!1,"outline-style":!1,"outline-width":!1,overflow:!1,"overflow-wrap":!1,"overflow-x":!1,"overflow-y":!1,padding:!0,"padding-bottom":!0,"padding-left":!0,"padding-right":!0,"padding-top":!0,page:!1,"page-break-after":!1,"page-break-before":!1,"page-break-inside":!1,"page-policy":!1,pause:!1,"pause-after":!1,"pause-before":!1,perspective:!1,"perspective-origin":!1,pitch:!1,"pitch-range":!1,"play-during":!1,position:!1,"presentation-level":!1,quotes:!1,"region-fragment":!1,resize:!1,rest:!1,"rest-after":!1,"rest-before":!1,richness:!1,right:!1,rotation:!1,"rotation-point":!1,"ruby-align":!1,"ruby-merge":!1,"ruby-position":!1,"shape-image-threshold":!1,"shape-outside":!1,"shape-margin":!1,size:!1,speak:!1,"speak-as":!1,"speak-header":!1,"speak-numeral":!1,"speak-punctuation":!1,"speech-rate":!1,stress:!1,"string-set":!1,"tab-size":!1,"table-layout":!1,"text-align":!0,"text-align-last":!0,"text-combine-upright":!0,"text-decoration":!0,"text-decoration-color":!0,"text-decoration-line":!0,"text-decoration-skip":!0,"text-decoration-style":!0,"text-emphasis":!0,"text-emphasis-color":!0,"text-emphasis-position":!0,"text-emphasis-style":!0,"text-height":!0,"text-indent":!0,"text-justify":!0,"text-orientation":!0,"text-overflow":!0,"text-shadow":!0,"text-space-collapse":!0,"text-transform":!0,"text-underline-position":!0,"text-wrap":!0,top:!1,transform:!1,"transform-origin":!1,"transform-style":!1,transition:!1,"transition-delay":!1,"transition-duration":!1,"transition-property":!1,"transition-timing-function":!1,"unicode-bidi":!1,"vertical-align":!1,visibility:!1,"voice-balance":!1,"voice-duration":!1,"voice-family":!1,"voice-pitch":!1,"voice-range":!1,"voice-rate":!1,"voice-stress":!1,"voice-volume":!1,volume:!1,"white-space":!1,widows:!1,width:!0,"will-change":!1,"word-break":!0,"word-spacing":!0,"word-wrap":!0,"wrap-flow":!1,"wrap-through":!1,"writing-mode":!1,"z-index":!1};return t}var pO=/javascript\s*\:/gim;dO.whiteList=cO(),dO.getDefaultWhiteList=cO,dO.onAttr=function(t,e,i){},dO.onIgnoreAttr=function(t,e,i){},dO.safeAttrValue=function(t,e){return pO.test(e)?"":e};var fO={indexOf:function(t,e){var i,n;if(Array.prototype.indexOf)return t.indexOf(e);for(i=0,n=t.length;i<n;i++)if(t[i]===e)return i;return-1},forEach:function(t,e,i){var n,r;if(Array.prototype.forEach)return t.forEach(e,i);for(n=0,r=t.length;n<r;n++)e.call(i,t[n],n,t)},trim:function(t){return String.prototype.trim?t.trim():t.replace(/(^\s*)|(\s*$)/g,"")},trimRight:function(t){return String.prototype.trimRight?t.trimRight():t.replace(/(\s*$)/g,"")}};var mO=function(t,e){";"!==(t=fO.trimRight(t))[t.length-1]&&(t+=";");var i=t.length,n=!1,r=0,o=0,s="";function a(){if(!n){var i=fO.trim(t.slice(r,o)),a=i.indexOf(":");if(-1!==a){var l=fO.trim(i.slice(0,a)),h=fO.trim(i.slice(a+1));if(l){var u=e(r,s.length,l,h,i);u&&(s+=u+"; ")}}}r=o+1}for(;o<i;o++){var l=t[o];if("/"===l&&"*"===t[o+1]){var h=t.indexOf("*/",o+2);if(-1===h)break;r=(o=h+1)+1,n=!1}else"("===l?n=!0:")"===l?n=!1:";"===l?n||a():"\n"===l&&a()}return fO.trim(s)},vO=dO,gO=mO;function yO(t){return null==t}function bO(t){(t=function(t){var e={};for(var i in t)e[i]=t[i];return e}(t||{})).whiteList=t.whiteList||vO.whiteList,t.onAttr=t.onAttr||vO.onAttr,t.onIgnoreAttr=t.onIgnoreAttr||vO.onIgnoreAttr,t.safeAttrValue=t.safeAttrValue||vO.safeAttrValue,this.options=t}bO.prototype.process=function(t){if(!(t=(t=t||"").toString()))return"";var e=this.options,i=e.whiteList,n=e.onAttr,r=e.onIgnoreAttr,o=e.safeAttrValue,s=gO(t,(function(t,e,s,a,l){var h=i[s],u=!1;if(!0===h?u=h:"function"==typeof h?u=h(a):h instanceof RegExp&&(u=h.test(a)),!0!==u&&(u=!1),a=o(s,a)){var d,c={position:e,sourcePosition:t,source:l,isWhite:u};return u?yO(d=n(s,a,c))?s+":"+a:d:yO(d=r(s,a,c))?void 0:d}}));return s};var _O=bO;!function(t,e){var i=dO,n=_O;for(var r in e=t.exports=function(t,e){return new n(e).process(t)},e.FilterCSS=n,i)e[r]=i[r];"undefined"!=typeof window&&(window.filterCSS=t.exports)}(uO,uO.exports);var wO=uO.exports,kO={indexOf:function(t,e){var i,n;if(Array.prototype.indexOf)return t.indexOf(e);for(i=0,n=t.length;i<n;i++)if(t[i]===e)return i;return-1},forEach:function(t,e,i){var n,r;if(Array.prototype.forEach)return t.forEach(e,i);for(n=0,r=t.length;n<r;n++)e.call(i,t[n],n,t)},trim:function(t){return String.prototype.trim?t.trim():t.replace(/(^\s*)|(\s*$)/g,"")},spaceIndex:function(t){var e=/\s|\n|\t/.exec(t);return e?e.index:-1}},xO=wO.FilterCSS,DO=wO.getDefaultWhiteList,SO=kO;function CO(){return{a:["target","href","title"],abbr:["title"],address:[],area:["shape","coords","href","alt"],article:[],aside:[],audio:["autoplay","controls","crossorigin","loop","muted","preload","src"],b:[],bdi:["dir"],bdo:["dir"],big:[],blockquote:["cite"],br:[],caption:[],center:[],cite:[],code:[],col:["align","valign","span","width"],colgroup:["align","valign","span","width"],dd:[],del:["datetime"],details:["open"],div:[],dl:[],dt:[],em:[],figcaption:[],figure:[],font:["color","size","face"],footer:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],hr:[],i:[],img:["src","alt","title","width","height","loading"],ins:["datetime"],kbd:[],li:[],mark:[],nav:[],ol:[],p:[],pre:[],s:[],section:[],small:[],span:[],sub:[],summary:[],sup:[],strong:[],strike:[],table:["width","border","align","valign"],tbody:["align","valign"],td:["width","rowspan","colspan","align","valign"],tfoot:["align","valign"],th:["width","rowspan","colspan","align","valign"],thead:["align","valign"],tr:["rowspan","align","valign"],tt:[],u:[],ul:[],video:["autoplay","controls","crossorigin","loop","muted","playsinline","poster","preload","src","height","width"]}}var TO=new xO;function MO(t){return t.replace(OO,"&lt;").replace(EO,"&gt;")}var OO=/</g,EO=/>/g,PO=/"/g,AO=/&quot;/g,IO=/&#([a-zA-Z0-9]*);?/gim,LO=/&colon;?/gim,NO=/&newline;?/gim,RO=/((j\s*a\s*v\s*a|v\s*b|l\s*i\s*v\s*e)\s*s\s*c\s*r\s*i\s*p\s*t\s*|m\s*o\s*c\s*h\s*a):/gi,FO=/e\s*x\s*p\s*r\s*e\s*s\s*s\s*i\s*o\s*n\s*\(.*/gi,jO=/u\s*r\s*l\s*\(.*/gi;function YO(t){return t.replace(PO,"&quot;")}function HO(t){return t.replace(AO,'"')}function zO(t){return t.replace(IO,(function(t,e){return"x"===e[0]||"X"===e[0]?String.fromCharCode(parseInt(e.substr(1),16)):String.fromCharCode(parseInt(e,10))}))}function BO(t){return t.replace(LO,":").replace(NO," ")}function GO(t){for(var e="",i=0,n=t.length;i<n;i++)e+=t.charCodeAt(i)<32?" ":t.charAt(i);return SO.trim(e)}function WO(t){return t=GO(t=BO(t=zO(t=HO(t))))}function UO(t){return t=MO(t=YO(t))}hO.whiteList={a:["target","href","title"],abbr:["title"],address:[],area:["shape","coords","href","alt"],article:[],aside:[],audio:["autoplay","controls","crossorigin","loop","muted","preload","src"],b:[],bdi:["dir"],bdo:["dir"],big:[],blockquote:["cite"],br:[],caption:[],center:[],cite:[],code:[],col:["align","valign","span","width"],colgroup:["align","valign","span","width"],dd:[],del:["datetime"],details:["open"],div:[],dl:[],dt:[],em:[],figcaption:[],figure:[],font:["color","size","face"],footer:[],h1:[],h2:[],h3:[],h4:[],h5:[],h6:[],header:[],hr:[],i:[],img:["src","alt","title","width","height","loading"],ins:["datetime"],kbd:[],li:[],mark:[],nav:[],ol:[],p:[],pre:[],s:[],section:[],small:[],span:[],sub:[],summary:[],sup:[],strong:[],strike:[],table:["width","border","align","valign"],tbody:["align","valign"],td:["width","rowspan","colspan","align","valign"],tfoot:["align","valign"],th:["width","rowspan","colspan","align","valign"],thead:["align","valign"],tr:["rowspan","align","valign"],tt:[],u:[],ul:[],video:["autoplay","controls","crossorigin","loop","muted","playsinline","poster","preload","src","height","width"]},hO.getDefaultWhiteList=CO,hO.onTag=function(t,e,i){},hO.onIgnoreTag=function(t,e,i){},hO.onTagAttr=function(t,e,i){},hO.onIgnoreTagAttr=function(t,e,i){},hO.safeAttrValue=function(t,e,i,n){if(i=WO(i),"href"===e||"src"===e){if("#"===(i=SO.trim(i)))return"#";if("http://"!==i.substr(0,7)&&"https://"!==i.substr(0,8)&&"mailto:"!==i.substr(0,7)&&"tel:"!==i.substr(0,4)&&"data:image/"!==i.substr(0,11)&&"ftp://"!==i.substr(0,6)&&"./"!==i.substr(0,2)&&"../"!==i.substr(0,3)&&"#"!==i[0]&&"/"!==i[0])return""}else if("background"===e){if(RO.lastIndex=0,RO.test(i))return""}else if("style"===e){if(FO.lastIndex=0,FO.test(i))return"";if(jO.lastIndex=0,jO.test(i)&&(RO.lastIndex=0,RO.test(i)))return"";!1!==n&&(i=(n=n||TO).process(i))}return i=UO(i)},hO.escapeHtml=MO,hO.escapeQuote=YO,hO.unescapeQuote=HO,hO.escapeHtmlEntities=zO,hO.escapeDangerHtml5Entities=BO,hO.clearNonPrintableCharacter=GO,hO.friendlyAttrValue=WO,hO.escapeAttrValue=UO,hO.onIgnoreTagStripAll=function(){return""},hO.StripTagBody=function(t,e){"function"!=typeof e&&(e=function(){});var i=!Array.isArray(t),n=[],r=!1;return{onIgnoreTag:function(o,s,a){if(function(e){return!!i||-1!==SO.indexOf(t,e)}(o)){if(a.isClosing){var l="[/removed]",h=a.position+10;return n.push([!1!==r?r:a.position,h]),r=!1,l}return r||(r=a.position),"[removed]"}return e(o,s,a)},remove:function(t){var e="",i=0;return SO.forEach(n,(function(n){e+=t.slice(i,n[0]),i=n[1]})),e+=t.slice(i)}}},hO.stripCommentTag=function(t){for(var e="",i=0;i<t.length;){var n=t.indexOf("\x3c!--",i);if(-1===n){e+=t.slice(i);break}e+=t.slice(i,n);var r=t.indexOf("--\x3e",n);if(-1===r)break;i=r+3}return e},hO.stripBlankChar=function(t){var e=t.split("");return(e=e.filter((function(t){var e=t.charCodeAt(0);return 127!==e&&(!(e<=31)||(10===e||13===e))}))).join("")},hO.attributeWrapSign='"',hO.cssFilter=TO,hO.getDefaultCSSWhiteList=DO;var VO={},XO=kO;function qO(t){var e,i=XO.spaceIndex(t);return e=-1===i?t.slice(1,-1):t.slice(1,i+1),"/"===(e=XO.trim(e).toLowerCase()).slice(0,1)&&(e=e.slice(1)),"/"===e.slice(-1)&&(e=e.slice(0,-1)),e}function $O(t){return"</"===t.slice(0,2)}var ZO=/[^a-zA-Z0-9\\_:.-]/gim;function KO(t,e){for(;e<t.length;e++){var i=t[e];if(" "!==i)return"="===i?e:-1}}function JO(t,e){for(;e<t.length;e++){var i=t[e];if(" "!==i)return"'"===i||'"'===i?e:-1}}function QO(t,e){for(;e>0;e--){var i=t[e];if(" "!==i)return"="===i?e:-1}}function tE(t){return function(t){return'"'===t[0]&&'"'===t[t.length-1]||"'"===t[0]&&"'"===t[t.length-1]}(t)?t.substr(1,t.length-2):t}VO.parseTag=function(t,e,i){var n="",r=0,o=!1,s=!1,a=0,l=t.length,h="",u="";t:for(a=0;a<l;a++){var d=t.charAt(a);if(!1===o){if("<"===d){o=a;continue}}else if(!1===s){if("<"===d){n+=i(t.slice(r,a)),o=a,r=a;continue}if(">"===d||a===l-1){n+=i(t.slice(r,o)),h=qO(u=t.slice(o,a+1)),n+=e(o,n.length,h,u,$O(u)),r=a+1,o=!1;continue}if('"'===d||"'"===d)for(var c=1,p=t.charAt(a-c);""===p.trim()||"="===p;){if("="===p){s=d;continue t}p=t.charAt(a-++c)}}else if(d===s){s=!1;continue}}return r<l&&(n+=i(t.substr(r))),n},VO.parseAttr=function(t,e){var i=0,n=0,r=[],o=!1,s=t.length;function a(t,i){if(!((t=(t=XO.trim(t)).replace(ZO,"").toLowerCase()).length<1)){var n=e(t,i||"");n&&r.push(n)}}for(var l=0;l<s;l++){var h,u=t.charAt(l);if(!1!==o||"="!==u)if(!1===o||l!==n)if(/\s|\n|\t/.test(u)){if(t=t.replace(/\s|\n|\t/g," "),!1===o){if(-1===(h=KO(t,l))){a(XO.trim(t.slice(i,l))),o=!1,i=l+1;continue}l=h-1;continue}if(-1===(h=QO(t,l-1))){a(o,tE(XO.trim(t.slice(i,l)))),o=!1,i=l+1;continue}}else;else{if(-1===(h=t.indexOf(u,l+1)))break;a(o,XO.trim(t.slice(n+1,h))),o=!1,i=(l=h)+1}else o=t.slice(i,l),i=l+1,n='"'===t.charAt(i)||"'"===t.charAt(i)?i:JO(t,l+1)}return i<t.length&&(!1===o?a(t.slice(i)):a(o,tE(XO.trim(t.slice(i))))),XO.trim(r.join(" "))};var eE=wO.FilterCSS,iE=hO,nE=VO,rE=nE.parseTag,oE=nE.parseAttr,sE=kO;function aE(t){return null==t}function lE(t){(t=function(t){var e={};for(var i in t)e[i]=t[i];return e}(t||{})).stripIgnoreTag&&(t.onIgnoreTag&&console.error('Notes: cannot use these two options "stripIgnoreTag" and "onIgnoreTag" at the same time'),t.onIgnoreTag=iE.onIgnoreTagStripAll),t.whiteList||t.allowList?t.whiteList=function(t){var e={};for(var i in t)Array.isArray(t[i])?e[i.toLowerCase()]=t[i].map((function(t){return t.toLowerCase()})):e[i.toLowerCase()]=t[i];return e}(t.whiteList||t.allowList):t.whiteList=iE.whiteList,this.attributeWrapSign=!0===t.singleQuotedAttributeValue?"'":iE.attributeWrapSign,t.onTag=t.onTag||iE.onTag,t.onTagAttr=t.onTagAttr||iE.onTagAttr,t.onIgnoreTag=t.onIgnoreTag||iE.onIgnoreTag,t.onIgnoreTagAttr=t.onIgnoreTagAttr||iE.onIgnoreTagAttr,t.safeAttrValue=t.safeAttrValue||iE.safeAttrValue,t.escapeHtml=t.escapeHtml||iE.escapeHtml,this.options=t,!1===t.css?this.cssFilter=!1:(t.css=t.css||{},this.cssFilter=new eE(t.css))}lE.prototype.process=function(t){if(!(t=(t=t||"").toString()))return"";var e=this,i=e.options,n=i.whiteList,r=i.onTag,o=i.onIgnoreTag,s=i.onTagAttr,a=i.onIgnoreTagAttr,l=i.safeAttrValue,h=i.escapeHtml,u=e.attributeWrapSign,d=e.cssFilter;i.stripBlankChar&&(t=iE.stripBlankChar(t)),i.allowCommentTag||(t=iE.stripCommentTag(t));var c=!1;i.stripIgnoreTagBody&&(c=iE.StripTagBody(i.stripIgnoreTagBody,o),o=c.onIgnoreTag);var p=rE(t,(function(t,e,i,c,p){var f={sourcePosition:t,position:e,isClosing:p,isWhite:Object.prototype.hasOwnProperty.call(n,i)},m=r(i,c,f);if(!aE(m))return m;if(f.isWhite){if(f.isClosing)return"</"+i+">";var v=function(t){var e=sE.spaceIndex(t);if(-1===e)return{html:"",closing:"/"===t[t.length-2]};var i="/"===(t=sE.trim(t.slice(e+1,-1)))[t.length-1];return i&&(t=sE.trim(t.slice(0,-1))),{html:t,closing:i}}(c),g=n[i],y=oE(v.html,(function(t,e){var n=-1!==sE.indexOf(g,t),r=s(i,t,e,n);return aE(r)?n?(e=l(i,t,e,d))?t+"="+u+e+u:t:aE(r=a(i,t,e,n))?void 0:r:r}));return c="<"+i,y&&(c+=" "+y),v.closing&&(c+=" /"),c+=">"}return aE(m=o(i,c,f))?h(c):m}),h);return c&&(p=c.remove(p)),p};var hE=lE;!function(t,e){var i=hO,n=VO,r=hE;function o(t,e){return new r(e).process(t)}(e=t.exports=o).filterXSS=o,e.FilterXSS=r,function(){for(var t in i)e[t]=i[t];for(var r in n)e[r]=n[r]}(),"undefined"!=typeof window&&(window.filterXSS=t.exports),"undefined"!=typeof self&&"undefined"!=typeof DedicatedWorkerGlobalScope&&self instanceof DedicatedWorkerGlobalScope&&(self.filterXSS=t.exports)}(lO,lO.exports);var uE=n(lO.exports);function dE(t,e){var i=rp(t);if(gM){var n=gM(t);e&&(n=mm(n).call(n,(function(e){return CM(t,e).enumerable}))),i.push.apply(i,n)}return i}function cE(t){for(var e=1;e<arguments.length;e++){var i,n,r=null!=arguments[e]?arguments[e]:{};e%2?Hp(i=dE(Object(r),!0)).call(i,(function(e){c_(t,e,r[e])})):PM?jM(t,PM(r)):Hp(n=dE(Object(r))).call(n,(function(e){eM(t,e,CM(r,e))}))}return t}function pE(t){var e;if(!t)return!1;var i=null!==(e=t.idProp)&&void 0!==e?e:t._idProp;return!!i&&oO(i,t)}var fE=/^\/?Date\((-?\d+)/i,mE=/^\d+$/;function vE(t,e){var i;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return ab(t)&&!isNaN(Date.parse(t))?aO(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":try{return vE(t,"Moment").toDate()}catch(i){throw i instanceof TypeError?new TypeError("Cannot convert object of type "+cb(t)+" to type "+e):i}case"Moment":if(sb(t))return aO(t);if(t instanceof Date)return aO(t.valueOf());if(aO.isMoment(t))return aO(t);if(ab(t))return(i=fE.exec(t))?aO(Number(i[1])):(i=mE.exec(t),aO(i?Number(t):t));throw new TypeError("Cannot convert object of type "+cb(t)+" to type "+e);case"ISODate":if(sb(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(aO.isMoment(t))return t.toDate().toISOString();if(ab(t))return(i=fE.exec(t))?new Date(Number(i[1])).toISOString():aO(t).format();throw new Error("Cannot convert object of type "+cb(t)+" to type ISODate");case"ASPDate":if(sb(t))return"/Date("+t+")/";if(t instanceof Date||aO.isMoment(t))return"/Date("+t.valueOf()+")/";if(ab(t))return"/Date("+((i=fE.exec(t))?new Date(Number(i[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+cb(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function gE(t){var e,i,n,r,o,s,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{start:"Date",end:"Date"},l=t._idProp,h=new nO({fieldId:l}),u=ep(e=function(t){return new JM(t)}(t)).call(e,(function(t){var e;return cS(e=rp(t)).call(e,(function(e,i){return e[i]=vE(t[i],a[i]),e}),{})})).to(h);return u.all().start(),{add:function(){var e;return(e=t.getDataSet()).add.apply(e,arguments)},remove:function(){var e;return(e=t.getDataSet()).remove.apply(e,arguments)},update:function(){var e;return(e=t.getDataSet()).update.apply(e,arguments)},updateOnly:function(){var e;return(e=t.getDataSet()).updateOnly.apply(e,arguments)},clear:function(){var e;return(e=t.getDataSet()).clear.apply(e,arguments)},forEach:Tp(i=Hp(h)).call(i,h),get:Tp(n=h.get).call(n,h),getIds:Tp(r=h.getIds).call(r,h),off:Tp(o=h.off).call(o,h),on:Tp(s=h.on).call(s,h),get length(){return h.length},idProp:l,type:a,rawDS:t,coercedDS:h,dispose:function(){return u.stop()}}}var yE=function(t){var e=new uE.FilterXSS(t);return function(t){return e.process(t)}},bE=function(t){return t},_E=yE(),wE=cE(cE({},Wb),{},{convert:vE,setupXSSProtection:function(t){t&&(!0===t.disabled?(_E=bE,console.warn("You disabled XSS protection for vis-Timeline. I sure hope you know what you're doing!")):t.filterOptions&&(_E=yE(t.filterOptions)))}});eM(wE,"xss",{get:function(){return _E}});var kE=w,xE=h,DE=Lt,SE=Fm.trim,CE=Om,TE=m("".charAt),ME=kE.parseFloat,OE=kE.Symbol,EE=OE&&OE.iterator,PE=1/ME(CE+"-0")!=-1/0||EE&&!xE((function(){ME(Object(EE))}))?function(t){var e=SE(DE(t)),i=ME(e);return 0===i&&"-"===TE(e,0)?-0:i}:ME;En({global:!0,forced:parseFloat!==PE},{parseFloat:PE});var AE=n(ce.parseFloat),IE=function(){function t(e,i){Ma(this,t),this.options=null,this.props=null}return Yd(t,[{key:"setOptions",value:function(t){t&&wE.extend(this.options,t)}},{key:"redraw",value:function(){return!1}},{key:"destroy",value:function(){}},{key:"_isResized",value:function(){var t=this.props._previousWidth!==this.props.width||this.props._previousHeight!==this.props.height;return this.props._previousWidth=this.props.width,this.props._previousHeight=this.props.height,t}}]),t}(),LE=b,NE=Lt,RE=N,FE=RangeError;En({target:"String",proto:!0},{repeat:function(t){var e=NE(RE(this)),i="",n=LE(t);if(n<0||n===1/0)throw new FE("Wrong number of repetitions");for(;n>0;(n>>>=1)&&(e+=e))1&n&&(i+=e);return i}});var jE=Jd("String").repeat,YE=ye,HE=jE,zE=String.prototype,BE=function(t){var e=t.repeat;return"string"==typeof t||t===zE||YE(zE,t)&&e===zE.repeat?HE:e},GE=n(BE);function WE(t,e,i){if(i&&!qc(i))return WE(t,e,[i]);if(e.hiddenDates=[],i&&1==qc(i)){for(var n,r=0;r<i.length;r++)if(void 0===GE(i[r])){var o={};o.start=t(i[r].start).toDate().valueOf(),o.end=t(i[r].end).toDate().valueOf(),e.hiddenDates.push(o)}_T(n=e.hiddenDates).call(n,(function(t,e){return t.start-e.start}))}}function UE(t,e,i){if(i&&!qc(i))return UE(t,e,[i]);if(i&&void 0!==e.domProps.centerContainer.width){WE(t,e,i);for(var n=t(e.range.start),r=t(e.range.end),o=(e.range.end-e.range.start)/e.domProps.centerContainer.width,s=0;s<i.length;s++)if(void 0!==GE(i[s])){var a=t(i[s].start),l=t(i[s].end);if("Invalid Date"==a._d)throw new Error("Supplied start date is not valid: ".concat(i[s].start));if("Invalid Date"==l._d)throw new Error("Supplied end date is not valid: ".concat(i[s].end));if(l-a>=4*o){var h=0,u=r.clone();switch(GE(i[s])){case"daily":a.day()!=l.day()&&(h=1),a=a.dayOfYear(n.dayOfYear()).year(n.year()).subtract(7,"days"),l=l.dayOfYear(n.dayOfYear()).year(n.year()).subtract(7-h,"days"),u.add(1,"weeks");break;case"weekly":var d=l.diff(a,"days"),c=a.day();l=(a=a.date(n.date()).month(n.month()).year(n.year())).clone(),a=a.day(c).subtract(1,"weeks"),l=l.day(c).add(d,"days").subtract(1,"weeks"),u.add(1,"weeks");break;case"monthly":a.month()!=l.month()&&(h=1),a=a.month(n.month()).year(n.year()).subtract(1,"months"),l=l.month(n.month()).year(n.year()).subtract(1,"months").add(h,"months"),u.add(1,"months");break;case"yearly":a.year()!=l.year()&&(h=1),a=a.year(n.year()).subtract(1,"years"),l=l.year(n.year()).subtract(1,"years").add(h,"years"),u.add(1,"years");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",GE(i[s]))}for(;a<u;)switch(e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()}),GE(i[s])){case"daily":a=a.add(1,"days"),l=l.add(1,"days");break;case"weekly":a=a.add(1,"weeks"),l=l.add(1,"weeks");break;case"monthly":a=a.add(1,"months"),l=l.add(1,"months");break;case"yearly":a=a.add(1,"y"),l=l.add(1,"y");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",GE(i[s]))}e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()})}}VE(e);var p=iP(e.range.start,e.hiddenDates),f=iP(e.range.end,e.hiddenDates),m=e.range.start,v=e.range.end;1==p.hidden&&(m=1==e.range.startToFront?p.startDate-1:p.endDate+1),1==f.hidden&&(v=1==e.range.endToFront?f.startDate-1:f.endDate+1),1!=p.hidden&&1!=f.hidden||e.range._applyRange(m,v)}}function VE(t){for(var e,i=t.hiddenDates,n=[],r=0;r<i.length;r++)for(var o=0;o<i.length;o++)r!=o&&1!=i[o].remove&&1!=i[r].remove&&(i[o].start>=i[r].start&&i[o].end<=i[r].end?i[o].remove=!0:i[o].start>=i[r].start&&i[o].start<=i[r].end?(i[r].end=i[o].end,i[o].remove=!0):i[o].end>=i[r].start&&i[o].end<=i[r].end&&(i[r].start=i[o].start,i[o].remove=!0));for(r=0;r<i.length;r++)!0!==i[r].remove&&n.push(i[r]);t.hiddenDates=n,_T(e=t.hiddenDates).call(e,(function(t,e){return t.start-e.start}))}function XE(t,e,i){for(var n=!1,r=e.current.valueOf(),o=0;o<e.hiddenDates.length;o++){var s=e.hiddenDates[o].start,a=e.hiddenDates[o].end;if(r>=s&&r<a){n=!0;break}}if(1==n&&r<e._end.valueOf()&&r!=i){var l=t(i),h=t(a);l.year()!=h.year()?e.switchedYear=!0:l.month()!=h.month()?e.switchedMonth=!0:l.dayOfYear()!=h.dayOfYear()&&(e.switchedDay=!0),e.current=h}}function qE(t,e,i){var n;if(0==t.body.hiddenDates.length)return n=t.range.conversion(i),(e.valueOf()-n.offset)*n.scale;var r=iP(e,t.body.hiddenDates);1==r.hidden&&(e=r.startDate);var o=ZE(t.body.hiddenDates,t.range.start,t.range.end);if(e<t.range.start){n=t.range.conversion(i,o);var s=KE(t.body.hiddenDates,e,n.offset);return e=t.options.moment(e).toDate().valueOf(),e+=s,-(n.offset-e.valueOf())*n.scale}if(e>t.range.end){var a={start:t.range.start,end:e};return e=JE(t.options.moment,t.body.hiddenDates,a,e),n=t.range.conversion(i,o),(e.valueOf()-n.offset)*n.scale}return e=JE(t.options.moment,t.body.hiddenDates,t.range,e),n=t.range.conversion(i,o),(e.valueOf()-n.offset)*n.scale}function $E(t,e,i){if(0==t.body.hiddenDates.length){var n=t.range.conversion(i);return new Date(e/n.scale+n.offset)}var r=ZE(t.body.hiddenDates,t.range.start,t.range.end),o=(t.range.end-t.range.start-r)*e/i,s=tP(t.body.hiddenDates,t.range,o);return new Date(s+o+t.range.start)}function ZE(t,e,i){for(var n=0,r=0;r<t.length;r++){var o=t[r].start,s=t[r].end;o>=e&&s<i&&(n+=s-o)}return n}function KE(t,e,i){for(var n=0,r=0;r<t.length;r++){var o=t[r].start,s=t[r].end;o>=e&&s<=i&&(n+=s-o)}return n}function JE(t,e,i,n){return n=t(n).toDate().valueOf(),n-=QE(t,e,i,n)}function QE(t,e,i,n){var r=0;n=t(n).toDate().valueOf();for(var o=0;o<e.length;o++){var s=e[o].start,a=e[o].end;s>=i.start&&a<i.end&&n>=a&&(r+=a-s)}return r}function tP(t,e,i){for(var n=0,r=0,o=e.start,s=0;s<t.length;s++){var a=t[s].start,l=t[s].end;if(a>=e.start&&l<e.end){if(r+=a-o,o=l,r>=i)break;n+=l-a}}return n}function eP(t,e,i,n){var r=iP(e,t);return 1==r.hidden?i<0?1==n?r.startDate-(r.endDate-e)-1:r.startDate-1:1==n?r.endDate+(e-r.startDate)+1:r.endDate+1:e}function iP(t,e){for(var i=0;i<e.length;i++){var n=e[i].start,r=e[i].end;if(t>=n&&t<r)return{hidden:!0,startDate:n,endDate:r}}return{hidden:!1,startDate:n,endDate:r}}var nP=Object.freeze({__proto__:null,convertHiddenOptions:WE,correctTimeForHidden:JE,getAccumulatedHiddenDuration:tP,getHiddenDurationBefore:QE,getHiddenDurationBeforeStart:KE,getHiddenDurationBetween:ZE,getIsHidden:iP,printDates:function(t){for(var e=0;e<t.length;e++)console.log(e,new Date(t[e].start),new Date(t[e].end),t[e].start,t[e].end,t[e].remove)},removeDuplicates:VE,snapAwayFromHidden:eP,stepOverHiddenDates:XE,toScreen:qE,toTime:$E,updateHiddenDates:UE});function rP(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}var oP=function(t){a_(i,t);var e=rP(i);function i(t,n){var r,o,s,a,l,h,u,d;Ma(this,i),d=e.call(this);var c=sO().hours(0).minutes(0).seconds(0).milliseconds(0),p=c.clone().add(-3,"days").valueOf(),f=c.clone().add(3,"days").valueOf();return d.millisecondsPerPixelCache=void 0,void 0===n?(d.start=p,d.end=f):(d.start=n.start||p,d.end=n.end||f),d.rolling=!1,d.body=t,d.deltaDifference=0,d.scaleOffset=0,d.startToFront=!1,d.endToFront=!0,d.defaultOptions={rtl:!1,start:null,end:null,moment:sO,direction:"horizontal",moveable:!0,zoomable:!0,min:null,max:null,zoomMin:10,zoomMax:31536e10,rollingMode:{follow:!1,offset:.5}},d.options=wE.extend({},d.defaultOptions),d.props={touch:{}},d.animationTimer=null,d.body.emitter.on("panstart",Tp(r=d._onDragStart).call(r,t_(d))),d.body.emitter.on("panmove",Tp(o=d._onDrag).call(o,t_(d))),d.body.emitter.on("panend",Tp(s=d._onDragEnd).call(s,t_(d))),d.body.emitter.on("mousewheel",Tp(a=d._onMouseWheel).call(a,t_(d))),d.body.emitter.on("touch",Tp(l=d._onTouch).call(l,t_(d))),d.body.emitter.on("pinch",Tp(h=d._onPinch).call(h,t_(d))),d.body.dom.rollingModeBtn.addEventListener("click",Tp(u=d.startRolling).call(u,t_(d))),d.setOptions(n),d}return Yd(i,[{key:"setOptions",value:function(t){if(t){wE.selectiveExtend(["animation","direction","min","max","zoomMin","zoomMax","moveable","zoomable","moment","activate","hiddenDates","zoomKey","zoomFriction","rtl","showCurrentTime","rollingMode","horizontalScroll"],this.options,t),t.rollingMode&&t.rollingMode.follow&&this.startRolling(),("start"in t||"end"in t)&&this.setRange(t.start,t.end)}}},{key:"startRolling",value:function(){var t=this;!function e(){t.stopRolling(),t.rolling=!0;var i=t.end-t.start,n=wE.convert(new Date,"Date").valueOf(),r=t.options.rollingMode&&t.options.rollingMode.offset||.5,o=n-i*r,s=n+i*(1-r);t.setRange(o,s,{animation:!1}),(i=1/t.conversion(t.body.domProps.center.width).scale/10)<30&&(i=30),i>1e3&&(i=1e3),t.body.dom.rollingModeBtn.style.visibility="hidden",t.currentTimeTimer=Rv(e,i)}()}},{key:"stopRolling",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),this.rolling=!1,this.body.dom.rollingModeBtn.style.visibility="visible")}},{key:"setRange",value:function(t,e,i,n,r){i||(i={}),!0!==i.byUser&&(i.byUser=!1);var o=this,s=null!=t?wE.convert(t,"Date").valueOf():null,a=null!=e?wE.convert(e,"Date").valueOf():null;if(this._cancelAnimation(),this.millisecondsPerPixelCache=void 0,i.animation){var l,h=this.start,u=this.end,d="object"===Nd(i.animation)&&"duration"in i.animation?i.animation.duration:500,c="object"===Nd(i.animation)&&"easingFunction"in i.animation?i.animation.easingFunction:"easeInOutQuad",p=wE.easingFunctions[c];if(!p)throw new Error(Yc(l="Unknown easing function ".concat(vv(c),". Choose from: ")).call(l,rp(wE.easingFunctions).join(", ")));var f=lp(),m=!1;return function t(){if(!o.props.touch.dragging){var e=lp()-f,l=p(e/d),c=e>d,g=c||null===s?s:h+(s-h)*l,y=c||null===a?a:u+(a-u)*l;v=o._applyRange(g,y),UE(o.options.moment,o.body,o.options.hiddenDates),m=m||v;var b={start:new Date(o.start),end:new Date(o.end),byUser:i.byUser,event:i.event};if(r&&r(l,v,c),v&&o.body.emitter.emit("rangechange",b),c){if(m&&(o.body.emitter.emit("rangechanged",b),n))return n()}else o.animationTimer=Rv(t,20)}}()}var v=this._applyRange(s,a);if(UE(this.options.moment,this.body,this.options.hiddenDates),v){var g={start:new Date(this.start),end:new Date(this.end),byUser:i.byUser,event:i.event};if(this.body.emitter.emit("rangechange",g),clearTimeout(o.timeoutID),o.timeoutID=Rv((function(){o.body.emitter.emit("rangechanged",g)}),200),n)return n()}}},{key:"getMillisecondsPerPixel",value:function(){return void 0===this.millisecondsPerPixelCache&&(this.millisecondsPerPixelCache=(this.end-this.start)/this.body.dom.center.clientWidth),this.millisecondsPerPixelCache}},{key:"_cancelAnimation",value:function(){this.animationTimer&&(clearTimeout(this.animationTimer),this.animationTimer=null)}},{key:"_applyRange",value:function(t,e){var i,n=null!=t?wE.convert(t,"Date").valueOf():this.start,r=null!=e?wE.convert(e,"Date").valueOf():this.end,o=null!=this.options.max?wE.convert(this.options.max,"Date").valueOf():null,s=null!=this.options.min?wE.convert(this.options.min,"Date").valueOf():null;if(isNaN(n)||null===n)throw new Error('Invalid start "'.concat(t,'"'));if(isNaN(r)||null===r)throw new Error('Invalid end "'.concat(e,'"'));if(r<n&&(r=n),null!==s&&n<s&&(n+=i=s-n,r+=i,null!=o&&r>o&&(r=o)),null!==o&&r>o&&(n-=i=r-o,r-=i,null!=s&&n<s&&(n=s)),null!==this.options.zoomMin){var a=AE(this.options.zoomMin);if(a<0&&(a=0),r-n<a){this.end-this.start===a&&n>=this.start-.5&&r<=this.end?(n=this.start,r=this.end):(n-=(i=a-(r-n))/2,r+=i/2)}}if(null!==this.options.zoomMax){var l=AE(this.options.zoomMax);l<0&&(l=0),r-n>l&&(this.end-this.start===l&&n<this.start&&r>this.end?(n=this.start,r=this.end):(n+=(i=r-n-l)/2,r-=i/2))}var h=this.start!=n||this.end!=r;return n>=this.start&&n<=this.end||r>=this.start&&r<=this.end||this.start>=n&&this.start<=r||this.end>=n&&this.end<=r||this.body.emitter.emit("checkRangedItems"),this.start=n,this.end=r,h}},{key:"getRange",value:function(){return{start:this.start,end:this.end}}},{key:"conversion",value:function(t,e){return i.conversion(this.start,this.end,t,e)}},{key:"_onDragStart",value:function(t){this.deltaDifference=0,this.previousDelta=0,this.options.moveable&&this._isInsideRange(t)&&this.props.touch.allowDragging&&(this.stopRolling(),this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.dragging=!0,this.body.dom.root&&(this.body.dom.root.style.cursor="move"))}},{key:"_onDrag",value:function(t){if(t&&this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging){var e=this.options.direction;sP(e);var i="horizontal"==e?t.deltaX:t.deltaY;i-=this.deltaDifference;var n=this.props.touch.end-this.props.touch.start;n-=ZE(this.body.hiddenDates,this.start,this.end);var r,o="horizontal"==e?this.body.domProps.center.width:this.body.domProps.center.height;r=this.options.rtl?i/o*n:-i/o*n;var s=this.props.touch.start+r,a=this.props.touch.end+r,l=eP(this.body.hiddenDates,s,this.previousDelta-i,!0),h=eP(this.body.hiddenDates,a,this.previousDelta-i,!0);if(l!=s||h!=a)return this.deltaDifference+=i,this.props.touch.start=l,this.props.touch.end=h,void this._onDrag(t);this.previousDelta=i,this._applyRange(s,a);var u=new Date(this.start),d=new Date(this.end);this.body.emitter.emit("rangechange",{start:u,end:d,byUser:!0,event:t}),this.body.emitter.emit("panmove")}}},{key:"_onDragEnd",value:function(t){this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging&&(this.props.touch.dragging=!1,this.body.dom.root&&(this.body.dom.root.style.cursor="auto"),this.body.emitter.emit("rangechanged",{start:new Date(this.start),end:new Date(this.end),byUser:!0,event:t}))}},{key:"_onMouseWheel",value:function(t){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail?e=-t.detail/3:t.deltaY&&(e=-t.deltaY/3),!(this.options.zoomKey&&!t[this.options.zoomKey]&&this.options.zoomable||!this.options.zoomable&&this.options.moveable)&&this.options.zoomable&&this.options.moveable&&this._isInsideRange(t)&&e){var i,n,r=this.options.zoomFriction||5;if(i=e<0?1-e/r:1/(1+e/r),this.rolling){var o=this.options.rollingMode&&this.options.rollingMode.offset||.5;n=this.start+(this.end-this.start)*o}else{var s=this.getPointer({x:t.clientX,y:t.clientY},this.body.dom.center);n=this._pointerToDate(s)}this.zoom(i,n,e,t),t.preventDefault()}}},{key:"_onTouch",value:function(t){this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.allowDragging=!0,this.props.touch.center=null,this.props.touch.centerDate=null,this.scaleOffset=0,this.deltaDifference=0,wE.preventDefault(t)}},{key:"_onPinch",value:function(t){if(this.options.zoomable&&this.options.moveable){wE.preventDefault(t),this.props.touch.allowDragging=!1,this.props.touch.center||(this.props.touch.center=this.getPointer(t.center,this.body.dom.center),this.props.touch.centerDate=this._pointerToDate(this.props.touch.center)),this.stopRolling();var e=1/(t.scale+this.scaleOffset),i=this.props.touch.centerDate,n=ZE(this.body.hiddenDates,this.start,this.end),r=QE(this.options.moment,this.body.hiddenDates,this,i),o=n-r,s=i-r+(this.props.touch.start-(i-r))*e,a=i+o+(this.props.touch.end-(i+o))*e;this.startToFront=1-e<=0,this.endToFront=e-1<=0;var l=eP(this.body.hiddenDates,s,1-e,!0),h=eP(this.body.hiddenDates,a,e-1,!0);l==s&&h==a||(this.props.touch.start=l,this.props.touch.end=h,this.scaleOffset=1-t.scale,s=l,a=h);var u={animation:!1,byUser:!0,event:t};this.setRange(s,a,u),this.startToFront=!1,this.endToFront=!0}}},{key:"_isInsideRange",value:function(t){var e=t.center?t.center.x:t.clientX,i=this.body.dom.centerContainer.getBoundingClientRect(),n=this.options.rtl?e-i.left:i.right-e,r=this.body.util.toTime(n);return r>=this.start&&r<=this.end}},{key:"_pointerToDate",value:function(t){var e,i=this.options.direction;if(sP(i),"horizontal"==i)return this.body.util.toTime(t.x).valueOf();var n=this.body.domProps.center.height;return e=this.conversion(n),t.y/e.scale+e.offset}},{key:"getPointer",value:function(t,e){var i=e.getBoundingClientRect();return this.options.rtl?{x:i.right-t.x,y:t.y-i.top}:{x:t.x-i.left,y:t.y-i.top}}},{key:"zoom",value:function(t,e,i,n){null==e&&(e=(this.start+this.end)/2);var r=ZE(this.body.hiddenDates,this.start,this.end),o=QE(this.options.moment,this.body.hiddenDates,this,e),s=r-o,a=e-o+(this.start-(e-o))*t,l=e+s+(this.end-(e+s))*t;this.startToFront=!(i>0),this.endToFront=!(-i>0);var h=eP(this.body.hiddenDates,a,i,!0),u=eP(this.body.hiddenDates,l,-i,!0);h==a&&u==l||(a=h,l=u);var d={animation:!1,byUser:!0,event:n};this.setRange(a,l,d),this.startToFront=!1,this.endToFront=!0}},{key:"move",value:function(t){var e=this.end-this.start,i=this.start+e*t,n=this.end+e*t;this.start=i,this.end=n}},{key:"moveTo",value:function(t){var e=(this.start+this.end)/2-t,i=this.start-e,n=this.end-e;this.setRange(i,n,{animation:!1,byUser:!0,event:null})}},{key:"destroy",value:function(){this.stopRolling()}}],[{key:"conversion",value:function(t,e,i,n){return void 0===n&&(n=0),0!=i&&e-t!=0?{offset:t,scale:i/(e-t-n)}:{offset:0,scale:1}}}]),i}(IE);function sP(t){if("horizontal"!=t&&"vertical"!=t)throw new TypeError('Unknown direction "'.concat(t,'". Choose "horizontal" or "vertical".'))}var aP,lP=n(ce.setInterval),hP=null;"undefined"!=typeof window?aP=function t(e,i){var n=i||{preventDefault:!1};if(e.Manager){var r=e,o=function(e,i){var o=Object.create(n);return i&&r.assign(o,i),t(new r(e,o),o)};return r.assign(o,r),o.Manager=function(e,i){var o=Object.create(n);return i&&r.assign(o,i),t(new r.Manager(e,o),o)},o}var s=Object.create(e),a=e.element;function l(t){return t.match(/[^ ]+/g)}function h(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var i=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof i&&(t.srcEvent.stopPropagation=function(){i(),t.stopPropagation()}),t.firstTarget=hP;for(var n=hP;n&&!e;){var r=n.hammer;if(r)for(var o,s=0;s<r.length;s++)if(o=r[s]._handlers[t.type])for(var a=0;a<o.length&&!e;a++)o[a](t);n=n.parentNode}}return a.hammer||(a.hammer=[]),a.hammer.push(s),e.on("hammer.input",(function(t){!0!==n.preventDefault&&n.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(hP=t.target)})),s._handlers={},s.on=function(t,i){return l(t).forEach((function(t){var n=s._handlers[t];n||(s._handlers[t]=n=[],e.on(t,h)),n.push(i)})),s},s.off=function(t,i){return l(t).forEach((function(t){var n=s._handlers[t];n&&((n=i?n.filter((function(t){return t!==i})):[]).length>0?s._handlers[t]=n:(e.off(t,h),delete s._handlers[t]))})),s},s.emit=function(t,i){hP=i.target,e.emit(t,i)},s.destroy=function(){var t=e.element.hammer,i=t.indexOf(s);-1!==i&&t.splice(i,1),t.length||delete e.element.hammer,s._handlers={},e.destroy()},s}(window.Hammer||Wy,{preventDefault:"mouse"}):aP=function(){return function(){var t=function(){};return{on:t,off:t,destroy:t,emit:t,get:function(e){return{set:t}}}}()};var uP=aP;function dP(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)}var cP=function(){function t(e,i,n,r,o){Ma(this,t),this.moment=o&&o.moment||sO,this.options=o||{},this.current=this.moment(),this._start=this.moment(),this._end=this.moment(),this.autoScale=!0,this.scale="day",this.step=1,this.setRange(e,i,n),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,qc(r)?this.hiddenDates=r:this.hiddenDates=null!=r?[r]:[],this.format=t.FORMAT}return Yd(t,[{key:"setMoment",value:function(t){this.moment=t,this.current=this.moment(this.current.valueOf()),this._start=this.moment(this._start.valueOf()),this._end=this.moment(this._end.valueOf())}},{key:"setFormat",value:function(e){var i=wE.deepExtend({},t.FORMAT);this.format=wE.deepExtend(i,e)}},{key:"setRange",value:function(t,e,i){if(!(t instanceof Date&&e instanceof Date))throw"No legal start or end date in method setRange";this._start=null!=t?this.moment(t.valueOf()):lp(),this._end=null!=e?this.moment(e.valueOf()):lp(),this.autoScale&&this.setMinimumStep(i)}},{key:"start",value:function(){this.current=this._start.clone(),this.roundToMinor()}},{key:"roundToMinor",value:function(){switch("week"==this.scale&&this.current.weekday(0),this.scale){case"year":this.current=this.current.year(this.step*Math.floor(this.current.year()/this.step)).month(0);case"month":this.current=this.current.date(1);case"week":case"day":case"weekday":this.current=this.current.hours(0);case"hour":this.current=this.current.minutes(0);case"minute":this.current=this.current.seconds(0);case"second":this.current=this.current.milliseconds(0)}if(1!=this.step){var t=this.current.clone();switch(this.scale){case"millisecond":this.current=this.current.subtract(this.current.milliseconds()%this.step,"milliseconds");break;case"second":this.current=this.current.subtract(this.current.seconds()%this.step,"seconds");break;case"minute":this.current=this.current.subtract(this.current.minutes()%this.step,"minutes");break;case"hour":this.current=this.current.subtract(this.current.hours()%this.step,"hours");break;case"weekday":case"day":this.current=this.current.subtract((this.current.date()-1)%this.step,"day");break;case"week":this.current=this.current.subtract(this.current.week()%this.step,"week");break;case"month":this.current=this.current.subtract(this.current.month()%this.step,"month");break;case"year":this.current=this.current.subtract(this.current.year()%this.step,"year")}t.isSame(this.current)||(this.current=this.moment(eP(this.hiddenDates,this.current.valueOf(),-1,!0)))}}},{key:"hasNext",value:function(){return this.current.valueOf()<=this._end.valueOf()}},{key:"next",value:function(){var t=this.current.valueOf();switch(this.scale){case"millisecond":this.current=this.current.add(this.step,"millisecond");break;case"second":this.current=this.current.add(this.step,"second");break;case"minute":this.current=this.current.add(this.step,"minute");break;case"hour":this.current=this.current.add(this.step,"hour"),this.current.month()<6?this.current=this.current.subtract(this.current.hours()%this.step,"hour"):this.current.hours()%this.step!=0&&(this.current=this.current.add(this.step-this.current.hours()%this.step,"hour"));break;case"weekday":case"day":this.current=this.current.add(this.step,"day");break;case"week":if(0!==this.current.weekday())this.current=this.current.weekday(0).add(this.step,"week");else if(!1===this.options.showMajorLabels)this.current=this.current.add(this.step,"week");else{var e=this.current.clone();e.add(1,"week"),e.isSame(this.current,"month")?this.current=this.current.add(this.step,"week"):this.current=this.current.add(this.step,"week").date(1)}break;case"month":this.current=this.current.add(this.step,"month");break;case"year":this.current=this.current.add(this.step,"year")}if(1!=this.step)switch(this.scale){case"millisecond":this.current.milliseconds()>0&&this.current.milliseconds()<this.step&&(this.current=this.current.milliseconds(0));break;case"second":this.current.seconds()>0&&this.current.seconds()<this.step&&(this.current=this.current.seconds(0));break;case"minute":this.current.minutes()>0&&this.current.minutes()<this.step&&(this.current=this.current.minutes(0));break;case"hour":this.current.hours()>0&&this.current.hours()<this.step&&(this.current=this.current.hours(0));break;case"weekday":case"day":this.current.date()<this.step+1&&(this.current=this.current.date(1));break;case"week":this.current.week()<this.step&&(this.current=this.current.week(1));break;case"month":this.current.month()<this.step&&(this.current=this.current.month(0))}this.current.valueOf()==t&&(this.current=this._end.clone()),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,XE(this.moment,this,t)}},{key:"getCurrent",value:function(){return this.current.clone()}},{key:"setScale",value:function(t){t&&"string"==typeof t.scale&&(this.scale=t.scale,this.step=t.step>0?t.step:1,this.autoScale=!1)}},{key:"setAutoScale",value:function(t){this.autoScale=t}},{key:"setMinimumStep",value:function(t){if(null!=t){var e=31104e6,i=2592e6,n=864e5,r=36e5,o=6e4,s=1e3;1e3*e>t&&(this.scale="year",this.step=1e3),500*e>t&&(this.scale="year",this.step=500),100*e>t&&(this.scale="year",this.step=100),50*e>t&&(this.scale="year",this.step=50),10*e>t&&(this.scale="year",this.step=10),5*e>t&&(this.scale="year",this.step=5),e>t&&(this.scale="year",this.step=1),7776e6>t&&(this.scale="month",this.step=3),i>t&&(this.scale="month",this.step=1),6048e5>t&&this.options.showWeekScale&&(this.scale="week",this.step=1),1728e5>t&&(this.scale="day",this.step=2),n>t&&(this.scale="day",this.step=1),432e5>t&&(this.scale="weekday",this.step=1),144e5>t&&(this.scale="hour",this.step=4),r>t&&(this.scale="hour",this.step=1),9e5>t&&(this.scale="minute",this.step=15),6e5>t&&(this.scale="minute",this.step=10),3e5>t&&(this.scale="minute",this.step=5),o>t&&(this.scale="minute",this.step=1),15e3>t&&(this.scale="second",this.step=15),1e4>t&&(this.scale="second",this.step=10),5e3>t&&(this.scale="second",this.step=5),s>t&&(this.scale="second",this.step=1),200>t&&(this.scale="millisecond",this.step=200),100>t&&(this.scale="millisecond",this.step=100),50>t&&(this.scale="millisecond",this.step=50),10>t&&(this.scale="millisecond",this.step=10),5>t&&(this.scale="millisecond",this.step=5),1>t&&(this.scale="millisecond",this.step=1)}}},{key:"isMajor",value:function(){if(1==this.switchedYear)switch(this.scale){case"year":case"month":case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedMonth)switch(this.scale){case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedDay)switch(this.scale){case"millisecond":case"second":case"minute":case"hour":return!0;default:return!1}var t=this.moment(this.current);switch(this.scale){case"millisecond":return 0==t.milliseconds();case"second":return 0==t.seconds();case"minute":return 0==t.hours()&&0==t.minutes();case"hour":return 0==t.hours();case"weekday":case"day":return this.options.showWeekScale?1==t.isoWeekday():1==t.date();case"week":return 1==t.date();case"month":return 0==t.month();default:return!1}}},{key:"getLabelMinor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.minorLabels)return this.format.minorLabels(t,this.scale,this.step);var e=this.format.minorLabels[this.scale];return"week"===this.scale&&1===t.date()&&0!==t.weekday()?"":e&&e.length>0?this.moment(t).format(e):""}},{key:"getLabelMajor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.majorLabels)return this.format.majorLabels(t,this.scale,this.step);var e=this.format.majorLabels[this.scale];return e&&e.length>0?this.moment(t).format(e):""}},{key:"getClassName",value:function(){var t,e=this.moment,i=this.moment(this.current),n=i.locale?i.locale("en"):i.lang("en"),r=this.step,o=[];function s(t){return t/r%2==0?" vis-even":" vis-odd"}function a(t){return t.isSame(lp(),"day")?" vis-today":t.isSame(e().add(1,"day"),"day")?" vis-tomorrow":t.isSame(e().add(-1,"day"),"day")?" vis-yesterday":""}function l(t){return t.isSame(lp(),"week")?" vis-current-week":""}function h(t){return t.isSame(lp(),"month")?" vis-current-month":""}switch(this.scale){case"millisecond":o.push(a(n)),o.push(s(n.milliseconds()));break;case"second":o.push(a(n)),o.push(s(n.seconds()));break;case"minute":o.push(a(n)),o.push(s(n.minutes()));break;case"hour":o.push(Yc(t="vis-h".concat(n.hours())).call(t,4==this.step?"-h"+(n.hours()+4):"")),o.push(a(n)),o.push(s(n.hours()));break;case"weekday":o.push("vis-".concat(n.format("dddd").toLowerCase())),o.push(a(n)),o.push(l(n)),o.push(s(n.date()));break;case"day":o.push("vis-day".concat(n.date())),o.push("vis-".concat(n.format("MMMM").toLowerCase())),o.push(a(n)),o.push(h(n)),o.push(this.step<=2?a(n):""),o.push(this.step<=2?"vis-".concat(n.format("dddd").toLowerCase()):""),o.push(s(n.date()-1));break;case"week":o.push("vis-week".concat(n.format("w"))),o.push(l(n)),o.push(s(n.week()));break;case"month":o.push("vis-".concat(n.format("MMMM").toLowerCase())),o.push(h(n)),o.push(s(n.month()));break;case"year":o.push("vis-year".concat(n.year())),o.push(function(t){return t.isSame(lp(),"year")?" vis-current-year":""}(n)),o.push(s(n.year()))}return mm(o).call(o,String).join(" ")}}],[{key:"snap",value:function(t,e,i){var n=sO(t);if("year"==e){var r=n.year()+Math.round(n.month()/12);n=n.year(Math.round(r/i)*i).month(0).date(0).hours(0).minutes(0).seconds(0).milliseconds(0)}else if("month"==e)n=(n=n.date()>15?n.date(1).add(1,"month"):n.date(1)).hours(0).minutes(0).seconds(0).milliseconds(0);else if("week"==e)n=(n=n.weekday()>2?n.weekday(0).add(1,"week"):n.weekday(0)).hours(0).minutes(0).seconds(0).milliseconds(0);else if("day"==e){switch(i){case 5:case 2:n=n.hours(24*Math.round(n.hours()/24));break;default:n=n.hours(12*Math.round(n.hours()/12))}n=n.minutes(0).seconds(0).milliseconds(0)}else if("weekday"==e){switch(i){case 5:case 2:n=n.hours(12*Math.round(n.hours()/12));break;default:n=n.hours(6*Math.round(n.hours()/6))}n=n.minutes(0).seconds(0).milliseconds(0)}else if("hour"==e){if(4===i)n=n.minutes(60*Math.round(n.minutes()/60));else n=n.minutes(30*Math.round(n.minutes()/30));n=n.seconds(0).milliseconds(0)}else if("minute"==e){switch(i){case 15:case 10:n=n.minutes(5*Math.round(n.minutes()/5)).seconds(0);break;case 5:n=n.seconds(60*Math.round(n.seconds()/60));break;default:n=n.seconds(30*Math.round(n.seconds()/30))}n=n.milliseconds(0)}else if("second"==e)switch(i){case 15:case 10:n=n.seconds(5*Math.round(n.seconds()/5)).milliseconds(0);break;case 5:n=n.milliseconds(1e3*Math.round(n.milliseconds()/1e3));break;default:n=n.milliseconds(500*Math.round(n.milliseconds()/500))}else if("millisecond"==e){var o=i>5?i/2:1;n=n.milliseconds(Math.round(n.milliseconds()/o)*o)}return n}}]),t}();function pP(t,e){void 0===e&&(e={});var i=e.insertAt;if(t&&"undefined"!=typeof document){var n=document.head||document.getElementsByTagName("head")[0],r=document.createElement("style");r.type="text/css","top"===i&&n.firstChild?n.insertBefore(r,n.firstChild):n.appendChild(r),r.styleSheet?r.styleSheet.cssText=t:r.appendChild(document.createTextNode(t))}}cP.FORMAT={minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}};function fP(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}pP(".vis-time-axis{overflow:hidden;position:relative}.vis-time-axis.vis-foreground{left:0;top:0;width:100%}.vis-time-axis.vis-background{height:100%;left:0;position:absolute;top:0;width:100%}.vis-time-axis .vis-text{box-sizing:border-box;color:#4d4d4d;overflow:hidden;padding:3px;position:absolute;white-space:nowrap}.vis-time-axis .vis-text.vis-measure{margin-left:0;margin-right:0;padding-left:0;padding-right:0;position:absolute;visibility:hidden}.vis-time-axis .vis-grid.vis-vertical{border-left:1px solid;position:absolute}.vis-time-axis .vis-grid.vis-vertical-rtl{border-right:1px solid;position:absolute}.vis-time-axis .vis-grid.vis-minor{border-color:#e5e5e5}.vis-time-axis .vis-grid.vis-major{border-color:#bfbfbf}");var mP=function(t){a_(i,t);var e=fP(i);function i(t,n){var r;return Ma(this,i),(r=e.call(this)).dom={foreground:null,lines:[],majorTexts:[],minorTexts:[],redundant:{lines:[],majorTexts:[],minorTexts:[]}},r.props={range:{start:0,end:0,minimumStep:0},lineTop:0},r.defaultOptions={orientation:{axis:"bottom"},showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,maxMinorChars:7,format:wE.extend({},cP.FORMAT),moment:sO,timeAxis:null},r.options=wE.extend({},r.defaultOptions),r.body=t,r._create(),r.setOptions(n),r}return Yd(i,[{key:"setOptions",value:function(t){t&&(wE.selectiveExtend(["showMinorLabels","showMajorLabels","showWeekScale","maxMinorChars","hiddenDates","timeAxis","moment","rtl"],this.options,t),wE.selectiveDeepExtend(["format"],this.options,t),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.axis=t.orientation:"object"===Nd(t.orientation)&&"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis)),"locale"in t&&("function"==typeof sO.locale?sO.locale(t.locale):sO.lang(t.locale)))}},{key:"_create",value:function(){this.dom.foreground=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.foreground.className="vis-time-axis vis-foreground",this.dom.background.className="vis-time-axis vis-background"}},{key:"destroy",value:function(){this.dom.foreground.parentNode&&this.dom.foreground.parentNode.removeChild(this.dom.foreground),this.dom.background.parentNode&&this.dom.background.parentNode.removeChild(this.dom.background),this.body=null}},{key:"redraw",value:function(){var t=this.props,e=this.dom.foreground,i=this.dom.background,n="top"==this.options.orientation.axis?this.body.dom.top:this.body.dom.bottom,r=e.parentNode!==n;this._calculateCharSize();var o=this.options.showMinorLabels&&"none"!==this.options.orientation.axis,s=this.options.showMajorLabels&&"none"!==this.options.orientation.axis;t.minorLabelHeight=o?t.minorCharHeight:0,t.majorLabelHeight=s?t.majorCharHeight:0,t.height=t.minorLabelHeight+t.majorLabelHeight,t.width=e.offsetWidth,t.minorLineHeight=this.body.domProps.root.height-t.majorLabelHeight-("top"==this.options.orientation.axis?this.body.domProps.bottom.height:this.body.domProps.top.height),t.minorLineWidth=1,t.majorLineHeight=t.minorLineHeight+t.majorLabelHeight,t.majorLineWidth=1;var a=e.nextSibling,l=i.nextSibling;return e.parentNode&&e.parentNode.removeChild(e),i.parentNode&&i.parentNode.removeChild(i),e.style.height="".concat(this.props.height,"px"),this._repaintLabels(),a?n.insertBefore(e,a):n.appendChild(e),l?this.body.dom.backgroundVertical.insertBefore(i,l):this.body.dom.backgroundVertical.appendChild(i),this._isResized()||r}},{key:"_repaintLabels",value:function(){var t=this.options.orientation.axis,e=wE.convert(this.body.range.start,"Number"),i=wE.convert(this.body.range.end,"Number"),n=this.body.util.toTime((this.props.minorCharWidth||10)*this.options.maxMinorChars).valueOf(),r=n-QE(this.options.moment,this.body.hiddenDates,this.body.range,n);r-=this.body.util.toTime(0).valueOf();var o=new cP(new Date(e),new Date(i),r,this.body.hiddenDates,this.options);o.setMoment(this.options.moment),this.options.format&&o.setFormat(this.options.format),this.options.timeAxis&&o.setScale(this.options.timeAxis),this.step=o;var s,a,l,h,u,d,c=this.dom;c.redundant.lines=c.lines,c.redundant.majorTexts=c.majorTexts,c.redundant.minorTexts=c.minorTexts,c.lines=[],c.majorTexts=[],c.minorTexts=[];var p,f,m,v=0,g=void 0,y=0,b=1e3;for(o.start(),a=o.getCurrent(),h=this.body.util.toScreen(a);o.hasNext()&&y<b;){if(y++,u=o.isMajor(),m=o.getClassName(),s=a,l=h,o.next(),a=o.getCurrent(),p=v,v=(h=this.body.util.toScreen(a))-l,"week"===o.scale)d=!0;else d=v>=.4*p;if(this.options.showMinorLabels&&d){var _=this._repaintMinorText(l,o.getLabelMinor(s),t,m);_.style.width="".concat(v,"px")}u&&this.options.showMajorLabels?(l>0&&(null==g&&(g=l),_=this._repaintMajorText(l,o.getLabelMajor(s),t,m)),f=this._repaintMajorLine(l,v,t,m)):d?f=this._repaintMinorLine(l,v,t,m):f&&(f.style.width="".concat(Zm(f.style.width)+v,"px"))}if(y!==b||vP||(console.warn("Something is wrong with the Timeline scale. Limited drawing of grid lines to ".concat(b," lines.")),vP=!0),this.options.showMajorLabels){var w=this.body.util.toTime(0),k=o.getLabelMajor(w),x=k.length*(this.props.majorCharWidth||10)+10;(null==g||x<g)&&this._repaintMajorText(0,k,t,m)}Hp(wE).call(wE,this.dom.redundant,(function(t){for(;t.length;){var e=t.pop();e&&e.parentNode&&e.parentNode.removeChild(e)}}))}},{key:"_repaintMinorText",value:function(t,e,i,n){var r=this.dom.redundant.minorTexts.shift();if(!r){var o=document.createTextNode("");(r=document.createElement("div")).appendChild(o),this.dom.foreground.appendChild(r)}this.dom.minorTexts.push(r),r.innerHTML=wE.xss(e);var s="top"==i?this.props.majorLabelHeight:0;return this._setXY(r,t,s),r.className="vis-text vis-minor ".concat(n),r}},{key:"_repaintMajorText",value:function(t,e,i,n){var r=this.dom.redundant.majorTexts.shift();if(!r){var o=document.createElement("div");(r=document.createElement("div")).appendChild(o),this.dom.foreground.appendChild(r)}r.childNodes[0].innerHTML=wE.xss(e),r.className="vis-text vis-major ".concat(n);var s="top"==i?0:this.props.minorLabelHeight;return this._setXY(r,t,s),this.dom.majorTexts.push(r),r}},{key:"_setXY",value:function(t,e,i){var n,r=this.options.rtl?-1*e:e;t.style.transform=Yc(n="translate(".concat(r,"px, ")).call(n,i,"px)")}},{key:"_repaintMinorLine",value:function(t,e,i,n){var r,o=this.dom.redundant.lines.shift();o||(o=document.createElement("div"),this.dom.background.appendChild(o)),this.dom.lines.push(o);var s=this.props;o.style.width="".concat(e,"px"),o.style.height="".concat(s.minorLineHeight,"px");var a="top"==i?s.majorLabelHeight:this.body.domProps.top.height,l=t-s.minorLineWidth/2;return this._setXY(o,l,a),o.className=Yc(r="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-minor ")).call(r,n),o}},{key:"_repaintMajorLine",value:function(t,e,i,n){var r,o=this.dom.redundant.lines.shift();o||(o=document.createElement("div"),this.dom.background.appendChild(o)),this.dom.lines.push(o);var s=this.props;o.style.width="".concat(e,"px"),o.style.height="".concat(s.majorLineHeight,"px");var a="top"==i?0:this.body.domProps.top.height,l=t-s.majorLineWidth/2;return this._setXY(o,l,a),o.className=Yc(r="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-major ")).call(r,n),o}},{key:"_calculateCharSize",value:function(){this.dom.measureCharMinor||(this.dom.measureCharMinor=document.createElement("DIV"),this.dom.measureCharMinor.className="vis-text vis-minor vis-measure",this.dom.measureCharMinor.style.position="absolute",this.dom.measureCharMinor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMinor)),this.props.minorCharHeight=this.dom.measureCharMinor.clientHeight,this.props.minorCharWidth=this.dom.measureCharMinor.clientWidth,this.dom.measureCharMajor||(this.dom.measureCharMajor=document.createElement("DIV"),this.dom.measureCharMajor.className="vis-text vis-major vis-measure",this.dom.measureCharMajor.style.position="absolute",this.dom.measureCharMajor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMajor)),this.props.majorCharHeight=this.dom.measureCharMajor.clientHeight,this.props.majorCharWidth=this.dom.measureCharMajor.clientWidth}}]),i}(IE),vP=!1;function gP(t){var e,i=t&&t.preventDefault||!1,n=t&&t.container||window,r={},o={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){h(t,"keydown")},l=function(t){h(t,"keyup")},h=function(t,e){if(void 0!==o[e][t.keyCode]){for(var n=o[e][t.keyCode],r=0;r<n.length;r++)(void 0===n[r].shift||1==n[r].shift&&1==t.shiftKey||0==n[r].shift&&0==t.shiftKey)&&n[r].fn(t);1==i&&t.preventDefault()}};return r.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===o[i][s[t].code]&&(o[i][s[t].code]=[]),o[i][s[t].code].push({fn:e,shift:s[t].shift})},r.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&r.bind(i,t,e)},r.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},r.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],r=o[i][s[t].code];if(void 0!==r)for(var a=0;a<r.length;a++)r[a].fn==e&&r[a].shift==s[t].shift||n.push(o[i][s[t].code][a]);o[i][s[t].code]=n}else o[i][s[t].code]=[]},r.reset=function(){o={keydown:{},keyup:{}}},r.destroy=function(){o={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",l,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",l,!0),r}function yP(t){var e,i;this.active=!1,this.dom={container:t},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=uP(this.dom.overlay),this.hammer.on("tap",Tp(e=this._onTapOverlay).call(e,this));var n=this,r=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Hp(r).call(r,(function(t){n.hammer.on(t,(function(t){t.stopPropagation()}))})),document&&document.body&&(this.onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||n.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=gP(),this.escListener=Tp(i=this.deactivate).call(i,this)}pP(".vis .overlay{height:100%;left:0;position:absolute;top:0;width:100%;z-index:10}.vis-active{box-shadow:0 0 10px #86d5f8}"),$v(yP.prototype),yP.current=null,yP.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},yP.prototype.activate=function(){var t;yP.current&&yP.current.deactivate(),yP.current=this,this.active=!0,this.dom.overlay.style.display="none",wE.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),Tp(t=this.keycharm).call(t,"esc",this.escListener)},yP.prototype.deactivate=function(){yP.current===this&&(yP.current=null),this.active=!1,this.dom.overlay.style.display="",wE.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},yP.prototype._onTapOverlay=function(t){this.activate(),t.stopPropagation()};var bP={current:"current",time:"time",deleteSelected:"Delete selected"},_P={current:"attuale",time:"tempo",deleteSelected:"Cancella la selezione"},wP={current:"huidige",time:"tijd",deleteSelected:"Selectie verwijderen"},kP={current:"Aktuelle",time:"Zeit",deleteSelected:"Lösche Auswahl"},xP={current:"actuel",time:"heure",deleteSelected:"Effacer la selection"},DP={current:"corriente",time:"hora",deleteSelected:"Eliminar selección"},SP={current:"поточний",time:"час",deleteSelected:"Видалити обране"},CP={current:"текущее",time:"время",deleteSelected:"Удалить выбранное"},TP={current:"aktualny",time:"czas",deleteSelected:"Usuń wybrane"},MP={current:"atual",time:"data",deleteSelected:"Apagar selecionado"},OP={current:"現在",time:"時刻",deleteSelected:"選択されたものを削除"},EP={current:"nuvarande",time:"tid",deleteSelected:"Radera valda"},PP={current:"nåværende",time:"tid",deleteSelected:"Slett valgte"},AP={current:"einamas",time:"laikas",deleteSelected:"Pašalinti pasirinktą"},IP={en:bP,en_EN:bP,en_US:bP,it:_P,it_IT:_P,it_CH:_P,nl:wP,nl_NL:wP,nl_BE:wP,de:kP,de_DE:kP,fr:xP,fr_FR:xP,fr_CA:xP,fr_BE:xP,es:DP,es_ES:DP,uk:SP,uk_UA:SP,ru:CP,ru_RU:CP,pl:TP,pl_PL:TP,pt:MP,pt_BR:MP,pt_PT:MP,ja:OP,ja_JP:OP,lt:AP,lt_LT:AP,sv:EP,sv_SE:EP,nb:PP,nn:PP,nb_NO:PP,nn_NO:PP};function LP(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}pP(".vis-custom-time{background-color:#6e94ff;cursor:move;width:2px;z-index:1}.vis-custom-time>.vis-custom-time-marker{background-color:inherit;color:#fff;cursor:auto;font-size:12px;padding:3px 5px;top:0;white-space:nowrap;z-index:inherit}");var NP=function(t){a_(i,t);var e=LP(i);function i(t,n){var r,o;Ma(this,i),(o=e.call(this)).body=t,o.defaultOptions={moment:sO,locales:IP,locale:"en",id:void 0,title:void 0},o.options=wE.extend({},o.defaultOptions),o.setOptions(n),o.options.locales=wE.extend({},IP,o.options.locales);var s=o.defaultOptions.locales[o.defaultOptions.locale];return Hp(r=rp(o.options.locales)).call(r,(function(t){o.options.locales[t]=wE.extend({},s,o.options.locales[t])})),n&&null!=n.time?o.customTime=n.time:o.customTime=new Date,o.eventParams={},o._create(),o}return Yd(i,[{key:"setOptions",value:function(t){t&&wE.selectiveExtend(["moment","locale","locales","id","title","rtl","snap"],this.options,t)}},{key:"_create",value:function(){var t,e,i,n=document.createElement("div");n["custom-time"]=this,n.className="vis-custom-time ".concat(this.options.id||""),n.style.position="absolute",n.style.top="0px",n.style.height="100%",this.bar=n;var r=document.createElement("div");function o(t){this.body.range._onMouseWheel(t)}r.style.position="relative",r.style.top="0px",this.options.rtl?r.style.right="-10px":r.style.left="-10px",r.style.height="100%",r.style.width="20px",r.addEventListener?(r.addEventListener("mousewheel",Tp(o).call(o,this),!1),r.addEventListener("DOMMouseScroll",Tp(o).call(o,this),!1)):r.attachEvent("onmousewheel",Tp(o).call(o,this)),n.appendChild(r),this.hammer=new uP(r),this.hammer.on("panstart",Tp(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",Tp(e=this._onDrag).call(e,this)),this.hammer.on("panend",Tp(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:uP.DIRECTION_ALL}),this.hammer.get("press").set({time:1e4})}},{key:"destroy",value:function(){this.hide(),this.hammer.destroy(),this.hammer=null,this.body=null}},{key:"redraw",value:function(){var t=this.body.dom.backgroundVertical;this.bar.parentNode!=t&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),t.appendChild(this.bar));var e=this.body.util.toScreen(this.customTime),i=this.options.locales[this.options.locale];i||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),i=this.options.locales.en);var n,r=this.options.title;void 0===r?r=(r=Yc(n="".concat(i.time,": ")).call(n,this.options.moment(this.customTime).format("dddd, MMMM Do YYYY, H:mm:ss"))).charAt(0).toUpperCase()+r.substring(1):"function"==typeof r&&(r=r.call(this,this.customTime));return this.options.rtl?this.bar.style.right="".concat(e,"px"):this.bar.style.left="".concat(e,"px"),this.bar.title=r,!1}},{key:"hide",value:function(){this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar)}},{key:"setCustomTime",value:function(t){this.customTime=wE.convert(t,"Date"),this.redraw()}},{key:"getCustomTime",value:function(){return new Date(this.customTime.valueOf())}},{key:"setCustomMarker",value:function(t,e){var i,n;(this.marker&&this.bar.removeChild(this.marker),this.marker=document.createElement("div"),this.marker.className="vis-custom-time-marker",this.marker.innerHTML=wE.xss(t),this.marker.style.position="absolute",e)&&(this.marker.setAttribute("contenteditable","true"),this.marker.addEventListener("pointerdown",(function(){this.marker.focus()})),this.marker.addEventListener("input",Tp(i=this._onMarkerChange).call(i,this)),this.marker.title=t,this.marker.addEventListener("blur",Tp(n=function(t){this.title!=t.target.innerHTML&&(this._onMarkerChanged(t),this.title=t.target.innerHTML)}).call(n,this)));this.bar.appendChild(this.marker)}},{key:"setCustomTitle",value:function(t){this.options.title=t}},{key:"_onDragStart",value:function(t){this.eventParams.dragging=!0,this.eventParams.customTime=this.customTime,t.stopPropagation()}},{key:"_onDrag",value:function(t){if(this.eventParams.dragging){var e=this.options.rtl?-1*t.deltaX:t.deltaX,i=this.body.util.toScreen(this.eventParams.customTime)+e,n=this.body.util.toTime(i),r=this.body.util.getScale(),o=this.body.util.getStep(),s=this.options.snap,a=s?s(n,r,o):n;this.setCustomTime(a),this.body.emitter.emit("timechange",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation()}}},{key:"_onDragEnd",value:function(t){this.eventParams.dragging&&(this.body.emitter.emit("timechanged",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation())}},{key:"_onMarkerChange",value:function(t){this.body.emitter.emit("markerchange",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}},{key:"_onMarkerChanged",value:function(t){this.body.emitter.emit("markerchanged",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}}],[{key:"customTimeFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("custom-time"))return e["custom-time"];e=e.parentNode}return null}}]),i}(IE);pP("");pP('.vis-current-time{background-color:#ff7f6e;pointer-events:none;width:2px;z-index:1}.vis-rolling-mode-btn{background:#3876c2;border-radius:50%;color:#fff;cursor:pointer;font-size:28px;font-weight:700;height:40px;opacity:.8;position:absolute;right:20px;text-align:center;top:7px;width:40px}.vis-rolling-mode-btn:before{content:"\\26F6"}.vis-rolling-mode-btn:hover{opacity:1}');pP(".vis-panel{box-sizing:border-box;margin:0;padding:0;position:absolute}.vis-panel.vis-bottom,.vis-panel.vis-center,.vis-panel.vis-left,.vis-panel.vis-right,.vis-panel.vis-top{border:1px #bfbfbf}.vis-panel.vis-center,.vis-panel.vis-left,.vis-panel.vis-right{border-bottom-style:solid;border-top-style:solid;overflow:hidden}.vis-left.vis-panel.vis-vertical-scroll,.vis-right.vis-panel.vis-vertical-scroll{height:100%;overflow-x:hidden;overflow-y:scroll}.vis-left.vis-panel.vis-vertical-scroll{direction:rtl}.vis-left.vis-panel.vis-vertical-scroll .vis-content,.vis-right.vis-panel.vis-vertical-scroll{direction:ltr}.vis-right.vis-panel.vis-vertical-scroll .vis-content{direction:rtl}.vis-panel.vis-bottom,.vis-panel.vis-center,.vis-panel.vis-top{border-left-style:solid;border-right-style:solid}.vis-background{overflow:hidden}.vis-panel>.vis-content{position:relative}.vis-panel .vis-shadow{box-shadow:0 0 10px rgba(0,0,0,.8);height:1px;position:absolute;width:100%}.vis-panel .vis-shadow.vis-top{left:0;top:-1px}.vis-panel .vis-shadow.vis-bottom{bottom:-1px;left:0}");pP(".vis-graph-group0{fill:#4f81bd;fill-opacity:0;stroke-width:2px;stroke:#4f81bd}.vis-graph-group1{fill:#f79646;fill-opacity:0;stroke-width:2px;stroke:#f79646}.vis-graph-group2{fill:#8c51cf;fill-opacity:0;stroke-width:2px;stroke:#8c51cf}.vis-graph-group3{fill:#75c841;fill-opacity:0;stroke-width:2px;stroke:#75c841}.vis-graph-group4{fill:#ff0100;fill-opacity:0;stroke-width:2px;stroke:#ff0100}.vis-graph-group5{fill:#37d8e6;fill-opacity:0;stroke-width:2px;stroke:#37d8e6}.vis-graph-group6{fill:#042662;fill-opacity:0;stroke-width:2px;stroke:#042662}.vis-graph-group7{fill:#00ff26;fill-opacity:0;stroke-width:2px;stroke:#00ff26}.vis-graph-group8{fill:#f0f;fill-opacity:0;stroke-width:2px;stroke:#f0f}.vis-graph-group9{fill:#8f3938;fill-opacity:0;stroke-width:2px;stroke:#8f3938}.vis-timeline .vis-fill{fill-opacity:.1;stroke:none}.vis-timeline .vis-bar{fill-opacity:.5;stroke-width:1px}.vis-timeline .vis-point{stroke-width:2px;fill-opacity:1}.vis-timeline .vis-legend-background{stroke-width:1px;fill-opacity:.9;fill:#fff;stroke:#c2c2c2}.vis-timeline .vis-outline{stroke-width:1px;fill-opacity:1;fill:#fff;stroke:#e5e5e5}.vis-timeline .vis-icon-fill{fill-opacity:.3;stroke:none}");pP(".vis-timeline{border:1px solid #bfbfbf;box-sizing:border-box;margin:0;overflow:hidden;padding:0;position:relative}.vis-loading-screen{height:100%;left:0;position:absolute;top:0;width:100%}");pP(".vis [class*=span]{min-height:0;width:auto}");var RP=function(){function t(){Ma(this,t)}return Yd(t,[{key:"_create",value:function(t){var e,i,n,r=this;this.dom={},this.dom.container=t,this.dom.container.style.position="relative",this.dom.root=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.backgroundVertical=document.createElement("div"),this.dom.backgroundHorizontal=document.createElement("div"),this.dom.centerContainer=document.createElement("div"),this.dom.leftContainer=document.createElement("div"),this.dom.rightContainer=document.createElement("div"),this.dom.center=document.createElement("div"),this.dom.left=document.createElement("div"),this.dom.right=document.createElement("div"),this.dom.top=document.createElement("div"),this.dom.bottom=document.createElement("div"),this.dom.shadowTop=document.createElement("div"),this.dom.shadowBottom=document.createElement("div"),this.dom.shadowTopLeft=document.createElement("div"),this.dom.shadowBottomLeft=document.createElement("div"),this.dom.shadowTopRight=document.createElement("div"),this.dom.shadowBottomRight=document.createElement("div"),this.dom.rollingModeBtn=document.createElement("div"),this.dom.loadingScreen=document.createElement("div"),this.dom.root.className="vis-timeline",this.dom.background.className="vis-panel vis-background",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical",this.dom.backgroundHorizontal.className="vis-panel vis-background vis-horizontal",this.dom.centerContainer.className="vis-panel vis-center",this.dom.leftContainer.className="vis-panel vis-left",this.dom.rightContainer.className="vis-panel vis-right",this.dom.top.className="vis-panel vis-top",this.dom.bottom.className="vis-panel vis-bottom",this.dom.left.className="vis-content",this.dom.center.className="vis-content",this.dom.right.className="vis-content",this.dom.shadowTop.className="vis-shadow vis-top",this.dom.shadowBottom.className="vis-shadow vis-bottom",this.dom.shadowTopLeft.className="vis-shadow vis-top",this.dom.shadowBottomLeft.className="vis-shadow vis-bottom",this.dom.shadowTopRight.className="vis-shadow vis-top",this.dom.shadowBottomRight.className="vis-shadow vis-bottom",this.dom.rollingModeBtn.className="vis-rolling-mode-btn",this.dom.loadingScreen.className="vis-loading-screen",this.dom.root.appendChild(this.dom.background),this.dom.root.appendChild(this.dom.backgroundVertical),this.dom.root.appendChild(this.dom.backgroundHorizontal),this.dom.root.appendChild(this.dom.centerContainer),this.dom.root.appendChild(this.dom.leftContainer),this.dom.root.appendChild(this.dom.rightContainer),this.dom.root.appendChild(this.dom.top),this.dom.root.appendChild(this.dom.bottom),this.dom.root.appendChild(this.dom.rollingModeBtn),this.dom.centerContainer.appendChild(this.dom.center),this.dom.leftContainer.appendChild(this.dom.left),this.dom.rightContainer.appendChild(this.dom.right),this.dom.centerContainer.appendChild(this.dom.shadowTop),this.dom.centerContainer.appendChild(this.dom.shadowBottom),this.dom.leftContainer.appendChild(this.dom.shadowTopLeft),this.dom.leftContainer.appendChild(this.dom.shadowBottomLeft),this.dom.rightContainer.appendChild(this.dom.shadowTopRight),this.dom.rightContainer.appendChild(this.dom.shadowBottomRight),this.props={root:{},background:{},centerContainer:{},leftContainer:{},rightContainer:{},center:{},left:{},right:{},top:{},bottom:{},border:{},scrollTop:0,scrollTopMin:0},this.on("rangechange",(function(){!0===r.initialDrawDone&&r._redraw()})),this.on("rangechanged",(function(){r.initialRangeChangeDone||(r.initialRangeChangeDone=!0)})),this.on("touch",Tp(e=this._onTouch).call(e,this)),this.on("panmove",Tp(i=this._onDrag).call(i,this));var o=this;this._origRedraw=Tp(n=this._redraw).call(n,this),this._redraw=wE.throttle(this._origRedraw),this.on("_change",(function(t){o.itemSet&&o.itemSet.initialItemSetDrawn&&t&&1==t.queue?o._redraw():o._origRedraw()})),this.hammer=new uP(this.dom.root);var s=this.hammer.get("pinch").set({enable:!0});s&&function(t){t.getTouchAction=function(){return["pan-y"]}}(s),this.hammer.get("pan").set({threshold:5,direction:uP.DIRECTION_ALL}),this.timelineListeners={};var a,l,h=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];function u(t){this.isActive()&&this.emit("mousewheel",t);var e=0,i=0;if("detail"in t&&(i=-1*t.detail),"wheelDelta"in t&&(i=t.wheelDelta),"wheelDeltaY"in t&&(i=t.wheelDeltaY),"wheelDeltaX"in t&&(e=-1*t.wheelDeltaX),"axis"in t&&t.axis===t.HORIZONTAL_AXIS&&(e=-1*i,i=0),"deltaY"in t&&(i=-1*t.deltaY),"deltaX"in t&&(e=t.deltaX),t.deltaMode&&(1===t.deltaMode?(e*=40,i*=40):(e*=40,i*=800)),this.options.preferZoom){if(!this.options.zoomKey||t[this.options.zoomKey])return}else if(this.options.zoomKey&&t[this.options.zoomKey])return;if(this.options.verticalScroll||this.options.horizontalScroll)if(this.options.verticalScroll&&Math.abs(i)>=Math.abs(e)){var n=this.props.scrollTop,r=n+i;if(this.isActive())this._setScrollTop(r)!==n&&(this._redraw(),this.emit("scroll",t),t.preventDefault())}else if(this.options.horizontalScroll){var o=(Math.abs(e)>=Math.abs(i)?e:i)/120*(this.range.end-this.range.start)/20,s=this.range.start+o,a=this.range.end+o,l={animation:!1,byUser:!0,event:t};this.range.setRange(s,a,l),t.preventDefault()}}Hp(h).call(h,(function(t){var e=function(e){o.isActive()&&o.emit(t,e)};o.hammer.on(t,e),o.timelineListeners[t]=e})),dP(this.hammer,(function(t){o.emit("touch",t)})),a=this.hammer,(l=function(t){o.emit("release",t)}).inputHandler=function(t){t.isFinal&&l(t)},a.on("hammer.input",l.inputHandler);var d="onwheel"in document.createElement("div")?"wheel":void 0!==document.onmousewheel?"mousewheel":this.dom.centerContainer.addEventListener?"DOMMouseScroll":"onmousewheel";function c(t){if(o.options.verticalScroll&&(t.preventDefault(),o.isActive())){var e=-t.target.scrollTop;o._setScrollTop(e),o._redraw(),o.emit("scrollSide",t)}}this.dom.top.addEventListener,this.dom.bottom.addEventListener,this.dom.centerContainer.addEventListener(d,Tp(u).call(u,this),!1),this.dom.top.addEventListener(d,Tp(u).call(u,this),!1),this.dom.bottom.addEventListener(d,Tp(u).call(u,this),!1),this.dom.left.parentNode.addEventListener("scroll",Tp(c).call(c,this)),this.dom.right.parentNode.addEventListener("scroll",Tp(c).call(c,this));var p=!1;function f(t){var e;if(t.preventDefault&&(o.emit("dragover",o.getEventProperties(t)),t.preventDefault()),av(e=t.target.className).call(e,"timeline")>-1&&!p)return t.dataTransfer.dropEffect="move",p=!0,!1}function m(t){t.preventDefault&&t.preventDefault(),t.stopPropagation&&t.stopPropagation();try{var e=JSON.parse(t.dataTransfer.getData("text"));if(!e||!e.content)return}catch(t){return!1}return p=!1,t.center={x:t.clientX,y:t.clientY},"item"!==e.target?o.itemSet._onAddItem(t):o.itemSet._onDropObjectOnItem(t),o.emit("drop",o.getEventProperties(t)),!1}if(this.dom.center.addEventListener("dragover",Tp(f).call(f,this),!1),this.dom.center.addEventListener("drop",Tp(m).call(m,this),!1),this.customTimes=[],this.touch={},this.redrawCount=0,this.initialDrawDone=!1,this.initialRangeChangeDone=!1,!t)throw new Error("No container provided");t.appendChild(this.dom.root),t.appendChild(this.dom.loadingScreen)}},{key:"setOptions",value:function(t){var e;if(t){if(wE.selectiveExtend(["width","height","minHeight","maxHeight","autoResize","start","end","clickToUse","dataAttributes","hiddenDates","locale","locales","moment","preferZoom","rtl","zoomKey","horizontalScroll","verticalScroll","longSelectPressTime","snap"],this.options,t),this.dom.rollingModeBtn.style.visibility="hidden",this.options.rtl&&(this.dom.container.style.direction="rtl",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical-rtl"),this.options.verticalScroll&&(this.options.rtl?this.dom.rightContainer.className="vis-panel vis-right vis-vertical-scroll":this.dom.leftContainer.className="vis-panel vis-left vis-vertical-scroll"),"object"!==Nd(this.options.orientation)&&(this.options.orientation={item:void 0,axis:void 0}),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation={item:t.orientation,axis:t.orientation}:"object"===Nd(t.orientation)&&("item"in t.orientation&&(this.options.orientation.item=t.orientation.item),"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis))),"both"===this.options.orientation.axis){if(!this.timeAxis2){var i=this.timeAxis2=new mP(this.body,this.options);i.setOptions=function(t){var e=t?wE.extend({},t):{};e.orientation="top",mP.prototype.setOptions.call(i,e)},this.components.push(i)}}else if(this.timeAxis2){var n,r,o=av(n=this.components).call(n,this.timeAxis2);if(-1!==o)_f(r=this.components).call(r,o,1);this.timeAxis2.destroy(),this.timeAxis2=null}"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),"hiddenDates"in this.options&&WE(this.options.moment,this.body,this.options.hiddenDates),"clickToUse"in t&&(t.clickToUse?this.activator||(this.activator=new yP(this.dom.root)):this.activator&&(this.activator.destroy(),delete this.activator)),this._initAutoResize()}if(Hp(e=this.components).call(e,(function(e){return e.setOptions(t)})),"configure"in t){var s;this.configurator||(this.configurator=this._createConfigurator()),this.configurator.setOptions(t.configure);var a=wE.deepExtend({},this.options);Hp(s=this.components).call(s,(function(t){wE.deepExtend(a,t.options)})),this.configurator.setModuleOptions({global:a})}this._redraw()}},{key:"isActive",value:function(){return!this.activator||this.activator.active}},{key:"destroy",value:function(){var t;for(var e in this.setItems(null),this.setGroups(null),this.off(),this._stopAutoResize(),this.dom.root.parentNode&&this.dom.root.parentNode.removeChild(this.dom.root),this.dom=null,this.activator&&(this.activator.destroy(),delete this.activator),this.timelineListeners)this.timelineListeners.hasOwnProperty(e)&&delete this.timelineListeners[e];this.timelineListeners=null,this.hammer&&this.hammer.destroy(),this.hammer=null,Hp(t=this.components).call(t,(function(t){return t.destroy()})),this.body=null}},{key:"setCustomTime",value:function(t,e){var i,n=mm(i=this.customTimes).call(i,(function(t){return e===t.options.id}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(vv(e)));n.length>0&&n[0].setCustomTime(t)}},{key:"getCustomTime",value:function(t){var e,i=mm(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===i.length)throw new Error("No custom time bar found with id ".concat(vv(t)));return i[0].getCustomTime()}},{key:"setCustomTimeMarker",value:function(t,e,i){var n,r=mm(n=this.customTimes).call(n,(function(t){return t.options.id===e}));if(0===r.length)throw new Error("No custom time bar found with id ".concat(vv(e)));r.length>0&&r[0].setCustomMarker(t,i)}},{key:"setCustomTimeTitle",value:function(t,e){var i,n=mm(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(vv(e)));if(n.length>0)return n[0].setCustomTitle(t)}},{key:"getEventProperties",value:function(t){return{event:t}}},{key:"addCustomTime",value:function(t,e){var i,n=void 0!==t?wE.convert(t,"Date"):new Date,r=TT(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(r)throw new Error("A custom time with id ".concat(vv(e)," already exists"));var o=new NP(this.body,wE.extend({},this.options,{time:n,id:e,snap:this.itemSet?this.itemSet.options.snap:this.options.snap}));return this.customTimes.push(o),this.components.push(o),this._redraw(),e}},{key:"removeCustomTime",value:function(t){var e,i=this,n=mm(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(vv(t)));Hp(n).call(n,(function(t){var e,n,r,o;_f(e=i.customTimes).call(e,av(n=i.customTimes).call(n,t),1),_f(r=i.components).call(r,av(o=i.components).call(o,t),1),t.destroy()}))}},{key:"getVisibleItems",value:function(){return this.itemSet&&this.itemSet.getVisibleItems()||[]}},{key:"getItemsAtCurrentTime",value:function(t){return this.time=t,this.itemSet&&this.itemSet.getItemsAtCurrentTime(this.time)||[]}},{key:"getVisibleGroups",value:function(){return this.itemSet&&this.itemSet.getVisibleGroups()||[]}},{key:"fit",value:function(t,e){var i=this.getDataRange();if(null!==i.min||null!==i.max){var n=i.max-i.min,r=new Date(i.min.valueOf()-.01*n),o=new Date(i.max.valueOf()+.01*n),s=!t||void 0===t.animation||t.animation;this.range.setRange(r,o,{animation:s},e)}}},{key:"getDataRange",value:function(){throw new Error("Cannot invoke abstract method getDataRange")}},{key:"setWindow",value:function(t,e,i,n){var r,o;"function"==typeof arguments[2]&&(n=arguments[2],i={}),1==arguments.length?(r=void 0===(o=arguments[0]).animation||o.animation,this.range.setRange(o.start,o.end,{animation:r})):2==arguments.length&&"function"==typeof arguments[1]?(n=arguments[1],r=void 0===(o=arguments[0]).animation||o.animation,this.range.setRange(o.start,o.end,{animation:r},n)):(r=!i||void 0===i.animation||i.animation,this.range.setRange(t,e,{animation:r},n))}},{key:"moveTo",value:function(t,e,i){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.range.end-this.range.start,r=wE.convert(t,"Date").valueOf(),o=r-n/2,s=r+n/2,a=!e||void 0===e.animation||e.animation;this.range.setRange(o,s,{animation:a},i)}},{key:"getWindow",value:function(){var t=this.range.getRange();return{start:new Date(t.start),end:new Date(t.end)}}},{key:"zoomIn",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),r=n.start.valueOf(),o=n.end.valueOf(),s=o-r,a=(s-s/(1+t))/2,l=r+a,h=o-a;this.setWindow(l,h,e,i)}}},{key:"zoomOut",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),r=n.start.valueOf(),o=n.end.valueOf(),s=o-r,a=r-s*t/2,l=o+s*t/2;this.setWindow(a,l,e,i)}}},{key:"redraw",value:function(){this._redraw()}},{key:"_redraw",value:function(){var t;this.redrawCount++;var e=this.dom;if(e&&e.container&&0!=e.root.offsetWidth){var i=!1,n=this.options,r=this.props;UE(this.options.moment,this.body,this.options.hiddenDates),"top"==n.orientation?(wE.addClassName(e.root,"vis-top"),wE.removeClassName(e.root,"vis-bottom")):(wE.removeClassName(e.root,"vis-top"),wE.addClassName(e.root,"vis-bottom")),n.rtl?(wE.addClassName(e.root,"vis-rtl"),wE.removeClassName(e.root,"vis-ltr")):(wE.addClassName(e.root,"vis-ltr"),wE.removeClassName(e.root,"vis-rtl")),e.root.style.maxHeight=wE.option.asSize(n.maxHeight,""),e.root.style.minHeight=wE.option.asSize(n.minHeight,""),e.root.style.width=wE.option.asSize(n.width,"");var o=e.root.offsetWidth;r.border.left=1,r.border.right=1,r.border.top=1,r.border.bottom=1,r.center.height=e.center.offsetHeight,r.left.height=e.left.offsetHeight,r.right.height=e.right.offsetHeight,r.top.height=e.top.clientHeight||-r.border.top,r.bottom.height=Math.round(e.bottom.getBoundingClientRect().height)||e.bottom.clientHeight||-r.border.bottom;var s=Math.max(r.left.height,r.center.height,r.right.height),a=r.top.height+s+r.bottom.height+r.border.top+r.border.bottom;e.root.style.height=wE.option.asSize(n.height,"".concat(a,"px")),r.root.height=e.root.offsetHeight,r.background.height=r.root.height;var l=r.root.height-r.top.height-r.bottom.height;r.centerContainer.height=l,r.leftContainer.height=l,r.rightContainer.height=r.leftContainer.height,r.root.width=o,r.background.width=r.root.width,this.initialDrawDone||(r.scrollbarWidth=wE.getScrollBarWidth());var h=e.leftContainer.clientWidth,u=e.rightContainer.clientWidth;n.verticalScroll?n.rtl?(r.left.width=h||-r.border.left,r.right.width=u+r.scrollbarWidth||-r.border.right):(r.left.width=h+r.scrollbarWidth||-r.border.left,r.right.width=u||-r.border.right):(r.left.width=h||-r.border.left,r.right.width=u||-r.border.right),this._setDOM();var d=this._updateScrollTop();"top"!=n.orientation.item&&(d+=Math.max(r.centerContainer.height-r.center.height-r.border.top-r.border.bottom,0)),e.center.style.transform="translateY(".concat(d,"px)");var c=0==r.scrollTop?"hidden":"",p=r.scrollTop==r.scrollTopMin?"hidden":"";e.shadowTop.style.visibility=c,e.shadowBottom.style.visibility=p,e.shadowTopLeft.style.visibility=c,e.shadowBottomLeft.style.visibility=p,e.shadowTopRight.style.visibility=c,e.shadowBottomRight.style.visibility=p,n.verticalScroll&&(e.rightContainer.className="vis-panel vis-right vis-vertical-scroll",e.leftContainer.className="vis-panel vis-left vis-vertical-scroll",e.shadowTopRight.style.visibility="hidden",e.shadowBottomRight.style.visibility="hidden",e.shadowTopLeft.style.visibility="hidden",e.shadowBottomLeft.style.visibility="hidden",e.left.style.top="0px",e.right.style.top="0px"),(!n.verticalScroll||r.center.height<r.centerContainer.height)&&(e.left.style.top="".concat(d,"px"),e.right.style.top="".concat(d,"px"),e.rightContainer.className=e.rightContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),e.leftContainer.className=e.leftContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),r.left.width=h||-r.border.left,r.right.width=u||-r.border.right,this._setDOM());var f=r.center.height>r.centerContainer.height;this.hammer.get("pan").set({direction:f?uP.DIRECTION_ALL:uP.DIRECTION_HORIZONTAL}),this.hammer.get("press").set({time:this.options.longSelectPressTime}),Hp(t=this.components).call(t,(function(t){i=t.redraw()||i}));if(i){if(this.redrawCount<5)return void this.body.emitter.emit("_change");console.log("WARNING: infinite loop in redraw?")}else this.redrawCount=0;this.body.emitter.emit("changed")}}},{key:"_setDOM",value:function(){var t=this.props,e=this.dom;t.leftContainer.width=t.left.width,t.rightContainer.width=t.right.width;var i=t.root.width-t.left.width-t.right.width;t.center.width=i,t.centerContainer.width=i,t.top.width=i,t.bottom.width=i,e.background.style.height="".concat(t.background.height,"px"),e.backgroundVertical.style.height="".concat(t.background.height,"px"),e.backgroundHorizontal.style.height="".concat(t.centerContainer.height,"px"),e.centerContainer.style.height="".concat(t.centerContainer.height,"px"),e.leftContainer.style.height="".concat(t.leftContainer.height,"px"),e.rightContainer.style.height="".concat(t.rightContainer.height,"px"),e.background.style.width="".concat(t.background.width,"px"),e.backgroundVertical.style.width="".concat(t.centerContainer.width,"px"),e.backgroundHorizontal.style.width="".concat(t.background.width,"px"),e.centerContainer.style.width="".concat(t.center.width,"px"),e.top.style.width="".concat(t.top.width,"px"),e.bottom.style.width="".concat(t.bottom.width,"px"),e.background.style.left="0",e.background.style.top="0",e.backgroundVertical.style.left="".concat(t.left.width+t.border.left,"px"),e.backgroundVertical.style.top="0",e.backgroundHorizontal.style.left="0",e.backgroundHorizontal.style.top="".concat(t.top.height,"px"),e.centerContainer.style.left="".concat(t.left.width,"px"),e.centerContainer.style.top="".concat(t.top.height,"px"),e.leftContainer.style.left="0",e.leftContainer.style.top="".concat(t.top.height,"px"),e.rightContainer.style.left="".concat(t.left.width+t.center.width,"px"),e.rightContainer.style.top="".concat(t.top.height,"px"),e.top.style.left="".concat(t.left.width,"px"),e.top.style.top="0",e.bottom.style.left="".concat(t.left.width,"px"),e.bottom.style.top="".concat(t.top.height+t.centerContainer.height,"px"),e.center.style.left="0",e.left.style.left="0",e.right.style.left="0"}},{key:"setCurrentTime",value:function(t){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");this.currentTime.setCurrentTime(t)}},{key:"getCurrentTime",value:function(){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");return this.currentTime.getCurrentTime()}},{key:"_toTime",value:function(t){return $E(this,t,this.props.center.width)}},{key:"_toGlobalTime",value:function(t){return $E(this,t,this.props.root.width)}},{key:"_toScreen",value:function(t){return qE(this,t,this.props.center.width)}},{key:"_toGlobalScreen",value:function(t){return qE(this,t,this.props.root.width)}},{key:"_initAutoResize",value:function(){1==this.options.autoResize?this._startAutoResize():this._stopAutoResize()}},{key:"_startAutoResize",value:function(){var t=this;this._stopAutoResize(),this._onResize=function(){if(1==t.options.autoResize){if(t.dom.root){var e=t.dom.root.offsetHeight,i=t.dom.root.offsetWidth;i==t.props.lastWidth&&e==t.props.lastHeight||(t.props.lastWidth=i,t.props.lastHeight=e,t.props.scrollbarWidth=wE.getScrollBarWidth(),t.body.emitter.emit("_change"))}}else t._stopAutoResize()},window.addEventListener("resize",this._onResize),t.dom.root&&(t.props.lastWidth=t.dom.root.offsetWidth,t.props.lastHeight=t.dom.root.offsetHeight),this.watchTimer=lP(this._onResize,1e3)}},{key:"_stopAutoResize",value:function(){this.watchTimer&&(clearInterval(this.watchTimer),this.watchTimer=void 0),this._onResize&&(window.removeEventListener("resize",this._onResize),this._onResize=null)}},{key:"_onTouch",value:function(t){this.touch.allowDragging=!0,this.touch.initialScrollTop=this.props.scrollTop}},{key:"_onPinch",value:function(t){this.touch.allowDragging=!1}},{key:"_onDrag",value:function(t){if(t&&this.touch.allowDragging){var e=t.deltaY,i=this._getScrollTop(),n=this._setScrollTop(this.touch.initialScrollTop+e);this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),n!=i&&this.emit("verticalDrag")}}},{key:"_setScrollTop",value:function(t){return this.props.scrollTop=t,this._updateScrollTop(),this.props.scrollTop}},{key:"_updateScrollTop",value:function(){var t=Math.min(this.props.centerContainer.height-this.props.border.top-this.props.border.bottom-this.props.center.height,0);return t!=this.props.scrollTopMin&&("top"!=this.options.orientation.item&&(this.props.scrollTop+=t-this.props.scrollTopMin),this.props.scrollTopMin=t),this.props.scrollTop>0&&(this.props.scrollTop=0),this.props.scrollTop<t&&(this.props.scrollTop=t),this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),this.props.scrollTop}},{key:"_getScrollTop",value:function(){return this.props.scrollTop}},{key:"_createConfigurator",value:function(){throw new Error("Cannot invoke abstract method _createConfigurator")}}]),t}();function FP(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}$v(RP.prototype);var jP=function(t){a_(i,t);var e=FP(i);function i(t,n){var r,o;Ma(this,i),(o=e.call(this)).body=t,o.defaultOptions={rtl:!1,showCurrentTime:!0,alignCurrentTime:void 0,moment:sO,locales:IP,locale:"en"},o.options=wE.extend({},o.defaultOptions),o.setOptions(n),o.options.locales=wE.extend({},IP,o.options.locales);var s=o.defaultOptions.locales[o.defaultOptions.locale];return Hp(r=rp(o.options.locales)).call(r,(function(t){o.options.locales[t]=wE.extend({},s,o.options.locales[t])})),o.offset=0,o._create(),o}return Yd(i,[{key:"_create",value:function(){var t=document.createElement("div");t.className="vis-current-time",t.style.position="absolute",t.style.top="0px",t.style.height="100%",this.bar=t}},{key:"destroy",value:function(){this.options.showCurrentTime=!1,this.redraw(),this.body=null}},{key:"setOptions",value:function(t){t&&wE.selectiveExtend(["rtl","showCurrentTime","alignCurrentTime","moment","locale","locales"],this.options,t)}},{key:"redraw",value:function(){if(this.options.showCurrentTime){var t,e,i=this.body.dom.backgroundVertical;this.bar.parentNode!=i&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),i.appendChild(this.bar),this.start());var n=this.options.moment(lp()+this.offset);this.options.alignCurrentTime&&(n=n.startOf(this.options.alignCurrentTime));var r=this.body.util.toScreen(n),o=this.options.locales[this.options.locale];o||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),o=this.options.locales.en);var s=Yc(t=Yc(e="".concat(o.current," ")).call(e,o.time,": ")).call(t,n.format("dddd, MMMM Do YYYY, H:mm:ss"));s=s.charAt(0).toUpperCase()+s.substring(1),this.options.rtl?this.bar.style.transform="translateX(".concat(-1*r,"px)"):this.bar.style.transform="translateX(".concat(r,"px)"),this.bar.title=s}else this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),this.stop();return!1}},{key:"start",value:function(){var t=this;!function e(){t.stop();var i=1/t.body.range.conversion(t.body.domProps.center.width).scale/10;i<30&&(i=30),i>1e3&&(i=1e3),t.redraw(),t.body.emitter.emit("currentTimeTick"),t.currentTimeTimer=Rv(e,i)}()}},{key:"stop",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),delete this.currentTimeTimer)}},{key:"setCurrentTime",value:function(t){var e=wE.convert(t,"Date").valueOf(),i=lp();this.offset=e-i,this.redraw()}},{key:"getCurrentTime",value:function(){return new Date(lp()+this.offset)}}]),i}(IE),YP=En,HP=Zl.find,zP="find",BP=!0;zP in[]&&Array(1)[zP]((function(){BP=!1})),YP({target:"Array",proto:!0,forced:BP},{find:function(t){return HP(this,t,arguments.length>1?arguments[1]:void 0)}});var GP=Jd("Array").find,WP=ye,UP=GP,VP=Array.prototype,XP=function(t){var e=t.find;return t===VP||WP(VP,t)&&e===VP.find?UP:e},qP=n(XP),$P=En,ZP=Zl.findIndex,KP="findIndex",JP=!0;KP in[]&&Array(1)[KP]((function(){JP=!1})),$P({target:"Array",proto:!0,forced:JP},{findIndex:function(t){return ZP(this,t,arguments.length>1?arguments[1]:void 0)}});var QP=Jd("Array").findIndex,tA=ye,eA=QP,iA=Array.prototype,nA=function(t){var e=t.findIndex;return t===iA||tA(iA,t)&&e===iA.findIndex?eA:e},rA=n(nA);function oA(t,e){var i=void 0!==Ic&&Ta(t)||t["@@iterator"];if(!i){if(qc(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return sA(t,e);var n=Hc(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return sA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function sA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var aA=.001;function lA(t){_T(t).call(t,(function(t,e){return t.data.start-e.data.start}))}function hA(t){_T(t).call(t,(function(t,e){return("end"in t.data?t.data.end:t.data.start)-("end"in e.data?e.data.end:e.data.start)}))}function uA(t,e,i,n){return null===mA(t,e.item,!1,(function(t){return t.stack&&(i||null===t.top)}),(function(t){return t.stack}),(function(t){return e.axis}),n)}function dA(t,e,i){var n=mA(t,e.item,!1,(function(t){return t.stack}),(function(t){return!0}),(function(t){return t.baseTop}));i.height=n-i.top+.5*e.item.vertical}function cA(t,e,i,n){for(var r=0;r<t.length;r++)if(null==t[r].data.subgroup)t[r].top=e.item.vertical;else if(void 0!==t[r].data.subgroup&&n){var o=0;for(var s in i)i.hasOwnProperty(s)&&1==i[s].visible&&i[s].index<i[t[r].data.subgroup].index&&(o+=i[s].height,i[t[r].data.subgroup].top=o);t[r].top=o+.5*e.item.vertical}n||pA(t,e,i)}function pA(t,e,i){var n;mA(_T(n=Mm(i)).call(n,(function(t,e){return t.index>e.index?1:t.index<e.index?-1:0})),{vertical:0},!0,(function(t){return!0}),(function(t){return!0}),(function(t){return 0}));for(var r=0;r<t.length;r++)void 0!==t[r].data.subgroup&&(t[r].top=i[t[r].data.subgroup].top+.5*e.item.vertical)}function fA(t,e,i){var n=!1,r=[];for(var o in i)i[o].hasOwnProperty("index")?r[i[o].index]=o:r.push(o);for(var s=0;s<r.length;s++)if(o=r[s],i.hasOwnProperty(o)){for(var a in n=n||i[o].stack,i[o].top=0,i)i[a].visible&&i[o].index>i[a].index&&(i[o].top+=i[a].height);for(var l=t[o],h=0;h<l.length;h++)void 0!==l[h].data.subgroup&&(l[h].top=i[l[h].data.subgroup].top+.5*e.item.vertical,i[o].stack&&(l[h].baseTop=l[h].top));n&&i[o].stack&&dA(t[o],e,i[o])}}function mA(t,e,n,r,o,s,a){var l=function(t){return t.start},h=function(t){return t.end};if(!n){var u=!(!t[0]||!t[0].options.rtl);l=u?function(t){return t.right}:function(t){return t.left},h=function(t){return l(t)+t.width+e.horizontal}}var d,c=[],p=[],f=null,m=0,v=oA(t);try{var g=function(){var t=d.value;if(r(t))c.push(t);else if(o(t)){var e=l(t);null!==f&&e<f-aA&&(m=0),f=e,m=vA(p,(function(t){return l(t)-aA>e}),m),_f(p).call(p,m,0,t),m++}};for(v.s();!(d=v.n()).done;)g()}catch(t){v.e(t)}finally{v.f()}f=null;var y=null;m=0;for(var b,_=0,w=0,k=0,x=function(){var t,n,r=c.shift();r.top=s(r);var u=l(r),d=h(r);null!==f&&u<f-aA&&(_=0,w=0,m=0,y=null),f=u,_=vA(p,(function(t){return u<h(t)-aA}),_),(null===y||y<d-aA)&&(w=vA(p,(function(t){return d<l(t)-aA}),Math.max(_,w))),null!==y&&y-aA>d&&(w=function(t,e,n,r){n||(n=0);r||(r=t.length);for(i=r-1;i>=n;i--)if(e(t[i]))return i;return n-1}(p,(function(t){return d+aA>=l(t)}),_,w)+1);for(var v,g,b,x=_T(t=mm(n=Hc(p).call(p,_,w)).call(n,(function(t){return u<h(t)-aA&&d-aA>l(t)}))).call(t,(function(t,e){return t.top-e.top})),D=0;D<x.length;D++){var S=x[D];g=S,b=e,(v=r).top-b.vertical+aA<g.top+g.height&&v.top+v.height+b.vertical-aA>g.top&&(r.top=S.top+S.height+e.vertical)}o(r)&&(m=vA(p,(function(t){return l(t)-aA>u}),m),_f(p).call(p,m,0,r),m++);var C=r.top+r.height;if(C>k&&(k=C),a&&a())return{v:null}};c.length>0;)if(b=x())return b.v;return k}function vA(t,e,i){var n;i||(i=0);var r=rA(n=Hc(t).call(t,i)).call(n,e);return-1===r?t.length:r+i}var gA=Object.freeze({__proto__:null,nostack:cA,orderByEnd:hA,orderByStart:lA,stack:uA,stackSubgroups:pA,stackSubgroupsWithInnerStack:fA,substack:dA}),yA="__background__",bA=function(){function t(e,i,n){var r=this;if(Ma(this,t),this.groupId=e,this.subgroups={},this.subgroupStack={},this.subgroupStackAll=!1,this.subgroupVisibility={},this.doInnerStack=!1,this.shouldBailStackItems=!1,this.subgroupIndex=0,this.subgroupOrderer=i&&i.subgroupOrder,this.itemSet=n,this.isVisible=null,this.stackDirty=!0,this._disposeCallbacks=[],i&&i.nestedGroups&&(this.nestedGroups=i.nestedGroups,0==i.showNested?this.showNested=!1:this.showNested=!0),i&&i.subgroupStack)if("boolean"==typeof i.subgroupStack)this.doInnerStack=i.subgroupStack,this.subgroupStackAll=i.subgroupStack;else for(var o in i.subgroupStack)this.subgroupStack[o]=i.subgroupStack[o],this.doInnerStack=this.doInnerStack||i.subgroupStack[o];i&&i.heightMode?this.heightMode=i.heightMode:this.heightMode=n.options.groupHeightMode,this.nestedInGroup=null,this.dom={},this.props={label:{width:0,height:0}},this.className=null,this.items={},this.visibleItems=[],this.itemsInRange=[],this.orderedItems={byStart:[],byEnd:[]},this.checkRangedItems=!1;var s=function(){r.checkRangedItems=!0};this.itemSet.body.emitter.on("checkRangedItems",s),this._disposeCallbacks.push((function(){r.itemSet.body.emitter.off("checkRangedItems",s)})),this._create(),this.setData(i)}return Yd(t,[{key:"_create",value:function(){var t=document.createElement("div");this.itemSet.options.groupEditable.order?t.className="vis-label draggable":t.className="vis-label",this.dom.label=t;var e=document.createElement("div");e.className="vis-inner",t.appendChild(e),this.dom.inner=e;var i=document.createElement("div");i.className="vis-group",i["vis-group"]=this,this.dom.foreground=i,this.dom.background=document.createElement("div"),this.dom.background.className="vis-group",this.dom.axis=document.createElement("div"),this.dom.axis.className="vis-group",this.dom.marker=document.createElement("div"),this.dom.marker.style.visibility="hidden",this.dom.marker.style.position="absolute",this.dom.marker.innerHTML="",this.dom.background.appendChild(this.dom.marker)}},{key:"setData",value:function(t){if(!this.itemSet.groupTouchParams.isDragging){var e,i,n;if(t&&t.subgroupVisibility)for(var r in t.subgroupVisibility)this.subgroupVisibility[r]=t.subgroupVisibility[r];if(this.itemSet.options&&this.itemSet.options.groupTemplate)e=(i=Tp(n=this.itemSet.options.groupTemplate).call(n,this))(t,this.dom.inner);else e=t&&t.content;if(e instanceof Element){for(;this.dom.inner.firstChild;)this.dom.inner.removeChild(this.dom.inner.firstChild);this.dom.inner.appendChild(e)}else e instanceof Object&&e.isReactComponent||(e instanceof Object?i(t,this.dom.inner):this.dom.inner.innerHTML=null!=e?wE.xss(e):wE.xss(this.groupId||""));this.dom.label.title=t&&t.title||"",this.dom.inner.firstChild?wE.removeClassName(this.dom.inner,"vis-hidden"):wE.addClassName(this.dom.inner,"vis-hidden"),t&&t.nestedGroups?(this.nestedGroups&&this.nestedGroups==t.nestedGroups||(this.nestedGroups=t.nestedGroups),void 0===t.showNested&&void 0!==this.showNested||(0==t.showNested?this.showNested=!1:this.showNested=!0),wE.addClassName(this.dom.label,"vis-nesting-group"),this.showNested?(wE.removeClassName(this.dom.label,"collapsed"),wE.addClassName(this.dom.label,"expanded")):(wE.removeClassName(this.dom.label,"expanded"),wE.addClassName(this.dom.label,"collapsed"))):this.nestedGroups&&(this.nestedGroups=null,wE.removeClassName(this.dom.label,"collapsed"),wE.removeClassName(this.dom.label,"expanded"),wE.removeClassName(this.dom.label,"vis-nesting-group")),t&&(t.treeLevel||t.nestedInGroup)?(wE.addClassName(this.dom.label,"vis-nested-group"),t.treeLevel?wE.addClassName(this.dom.label,"vis-group-level-"+t.treeLevel):wE.addClassName(this.dom.label,"vis-group-level-unknown-but-gte1")):wE.addClassName(this.dom.label,"vis-group-level-0");var o=t&&t.className||null;o!=this.className&&(this.className&&(wE.removeClassName(this.dom.label,this.className),wE.removeClassName(this.dom.foreground,this.className),wE.removeClassName(this.dom.background,this.className),wE.removeClassName(this.dom.axis,this.className)),wE.addClassName(this.dom.label,o),wE.addClassName(this.dom.foreground,o),wE.addClassName(this.dom.background,o),wE.addClassName(this.dom.axis,o),this.className=o),this.style&&(wE.removeCssText(this.dom.label,this.style),this.style=null),t&&t.style&&(wE.addCssText(this.dom.label,t.style),this.style=t.style)}}},{key:"getLabelWidth",value:function(){return this.props.label.width}},{key:"_didMarkerHeightChange",value:function(){var t=this.dom.marker.clientHeight;if(t!=this.lastMarkerHeight){this.lastMarkerHeight=t;var e={},i=0;if(Hp(wE).call(wE,this.items,(function(t,n){if(t.dirty=!0,t.displayed){e[n]=t.redraw(!0),i=e[n].length}})),i>0)for(var n=function(t){Hp(wE).call(wE,e,(function(e){e[t]()}))},r=0;r<i;r++)n(r);return!0}return!1}},{key:"_calculateGroupSizeAndPosition",value:function(){var t=this.dom.foreground,e=t.offsetTop,i=t.offsetLeft,n=t.offsetWidth;this.top=e,this.right=i,this.width=n}},{key:"_shouldBailItemsRedraw",value:function(){var t=this,e=this.itemSet.options.onTimeout,i={relativeBailingTime:this.itemSet.itemsSettingTime,bailTimeMs:e&&e.timeoutMs,userBailFunction:e&&e.callback,shouldBailStackItems:this.shouldBailStackItems},n=null;if(!this.itemSet.initialDrawDone){if(i.shouldBailStackItems)return!0;Math.abs(lp()-new Date(i.relativeBailingTime))>i.bailTimeMs&&(i.userBailFunction&&null==this.itemSet.userContinueNotBail?i.userBailFunction((function(e){t.itemSet.userContinueNotBail=e,n=!e})):n=0==t.itemSet.userContinueNotBail)}return n}},{key:"_redrawItems",value:function(t,e,i,n){var r=this;if(t||this.stackDirty||this.isVisible&&!e){var o,s,a,l,h,u,d={byEnd:mm(o=this.orderedItems.byEnd).call(o,(function(t){return!t.isCluster})),byStart:mm(s=this.orderedItems.byStart).call(s,(function(t){return!t.isCluster}))},c={byEnd:Ac(new LC(mm(a=ep(l=this.orderedItems.byEnd).call(l,(function(t){return t.cluster}))).call(a,(function(t){return!!t})))),byStart:Ac(new LC(mm(h=ep(u=this.orderedItems.byStart).call(u,(function(t){return t.cluster}))).call(h,(function(t){return!!t}))))},p=function(){var t,e,i,o=r._updateItemsInRange(d,mm(t=r.visibleItems).call(t,(function(t){return!t.isCluster})),n),s=r._updateClustersInRange(c,mm(e=r.visibleItems).call(e,(function(t){return t.isCluster})),n);return Yc(i=[]).call(i,Ac(o),Ac(s))},f=function(t){var e={},i=function(i){var n,o=mm(n=r.visibleItems).call(n,(function(t){return t.data.subgroup===i}));e[i]=t?_T(o).call(o,(function(e,i){return t(e.data,i.data)})):o};for(var n in r.subgroups)i(n);return e};if("function"==typeof this.itemSet.options.order){var m=this;if(this.doInnerStack&&this.itemSet.options.stackSubgroups){fA(f(this.itemSet.options.order),i,this.subgroups),this.visibleItems=p(),this._updateSubGroupHeights(i)}else{var v,g,y,b;this.visibleItems=p(),this._updateSubGroupHeights(i);var _=_T(v=mm(g=Hc(y=this.visibleItems).call(y)).call(g,(function(t){return t.isCluster||!t.isCluster&&!t.cluster}))).call(v,(function(t,e){return m.itemSet.options.order(t.data,e.data)}));this.shouldBailStackItems=uA(_,i,!0,Tp(b=this._shouldBailItemsRedraw).call(b,this))}}else{var w;if(this.visibleItems=p(),this._updateSubGroupHeights(i),this.itemSet.options.stack)if(this.doInnerStack&&this.itemSet.options.stackSubgroups)fA(f(),i,this.subgroups);else this.shouldBailStackItems=uA(this.visibleItems,i,!0,Tp(w=this._shouldBailItemsRedraw).call(w,this));else cA(this.visibleItems,i,this.subgroups,this.itemSet.options.stackSubgroups)}for(var k=0;k<this.visibleItems.length;k++)this.visibleItems[k].repositionX(),void 0!==this.subgroupVisibility[this.visibleItems[k].data.subgroup]&&(this.subgroupVisibility[this.visibleItems[k].data.subgroup]||this.visibleItems[k].hide());this.itemSet.options.cluster&&Hp(wE).call(wE,this.items,(function(t){t.cluster&&t.displayed&&t.hide()})),this.shouldBailStackItems&&this.itemSet.body.emitter.emit("destroyTimeline"),this.stackDirty=!1}}},{key:"_didResize",value:function(t,e){t=wE.updateProperty(this,"height",e)||t;var i=this.dom.inner.clientWidth,n=this.dom.inner.clientHeight;return t=wE.updateProperty(this.props.label,"width",i)||t,t=wE.updateProperty(this.props.label,"height",n)||t}},{key:"_applyGroupHeight",value:function(t){this.dom.background.style.height="".concat(t,"px"),this.dom.foreground.style.height="".concat(t,"px"),this.dom.label.style.height="".concat(t,"px")}},{key:"_updateItemsVerticalPosition",value:function(t){for(var e=0,i=this.visibleItems.length;e<i;e++){var n=this.visibleItems[e];n.repositionY(t),this.isVisible||this.groupId==yA||n.displayed&&n.hide()}}},{key:"redraw",value:function(t,e,i,n){var r,o,s,a,l,h,u,d=this,c=!1,p=this.isVisible,f=[function(){i=d._didMarkerHeightChange.call(d)||i},Tp(r=this._updateSubGroupHeights).call(r,this,e),Tp(o=this._calculateGroupSizeAndPosition).call(o,this),function(){var i;d.isVisible=Tp(i=d._isGroupVisible).call(i,d)(t,e)},function(){var n;Tp(n=d._redrawItems).call(n,d)(i,p,e,t)},Tp(s=this._updateSubgroupsSizes).call(s,this),function(){var t;h=Tp(t=d._calculateHeight).call(t,d)(e)},Tp(a=this._calculateGroupSizeAndPosition).call(a,this),function(){var t;c=Tp(t=d._didResize).call(t,d)(c,h)},function(){var t;Tp(t=d._applyGroupHeight).call(t,d)(h)},function(){var t;Tp(t=d._updateItemsVerticalPosition).call(t,d)(e)},Tp(l=function(){return!d.isVisible&&d.height&&(c=!1),c}).call(l,this)];return n?f:(Hp(f).call(f,(function(t){u=t()})),u)}},{key:"_updateSubGroupHeights",value:function(t){var e=this;if(rp(this.subgroups).length>0){var i=this;this._resetSubgroups(),Hp(wE).call(wE,this.visibleItems,(function(n){void 0!==n.data.subgroup&&(i.subgroups[n.data.subgroup].height=Math.max(i.subgroups[n.data.subgroup].height,n.height+t.item.vertical),i.subgroups[n.data.subgroup].visible=void 0===e.subgroupVisibility[n.data.subgroup]||Boolean(e.subgroupVisibility[n.data.subgroup]))}))}}},{key:"_isGroupVisible",value:function(t,e){return this.top<=t.body.domProps.centerContainer.height-t.body.domProps.scrollTop+e.axis&&this.top+this.height+e.axis>=-t.body.domProps.scrollTop}},{key:"_calculateHeight",value:function(t){var e,i;if((i="fixed"===this.heightMode?wE.toArray(this.items):this.visibleItems).length>0){var n=i[0].top,r=i[0].top+i[0].height;if(Hp(wE).call(wE,i,(function(t){n=Math.min(n,t.top),r=Math.max(r,t.top+t.height)})),n>t.axis){var o=n-t.axis;r-=o,Hp(wE).call(wE,i,(function(t){t.top-=o}))}e=Math.ceil(r+t.item.vertical/2),"fitItems"!==this.heightMode&&(e=Math.max(e,this.props.label.height))}else e=this.props.label.height;return e}},{key:"show",value:function(){this.dom.label.parentNode||this.itemSet.dom.labelSet.appendChild(this.dom.label),this.dom.foreground.parentNode||this.itemSet.dom.foreground.appendChild(this.dom.foreground),this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background),this.dom.axis.parentNode||this.itemSet.dom.axis.appendChild(this.dom.axis)}},{key:"hide",value:function(){var t=this.dom.label;t.parentNode&&t.parentNode.removeChild(t);var e=this.dom.foreground;e.parentNode&&e.parentNode.removeChild(e);var i=this.dom.background;i.parentNode&&i.parentNode.removeChild(i);var n=this.dom.axis;n.parentNode&&n.parentNode.removeChild(n)}},{key:"add",value:function(t){var e;if(this.items[t.id]=t,t.setParent(this),this.stackDirty=!0,void 0!==t.data.subgroup&&(this._addToSubgroup(t),this.orderSubgroups()),!nm(e=this.visibleItems).call(e,t)){var i=this.itemSet.body.range;this._checkIfVisible(t,this.visibleItems,i)}}},{key:"_addToSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;null!=e&&void 0===this.subgroups[e]&&(this.subgroups[e]={height:0,top:0,start:t.data.start,end:t.data.end||t.data.start,visible:!1,index:this.subgroupIndex,items:[],stack:this.subgroupStackAll||this.subgroupStack[e]||!1},this.subgroupIndex++),new Date(t.data.start)<new Date(this.subgroups[e].start)&&(this.subgroups[e].start=t.data.start);var i=t.data.end||t.data.start;new Date(i)>new Date(this.subgroups[e].end)&&(this.subgroups[e].end=i),this.subgroups[e].items.push(t)}},{key:"_updateSubgroupsSizes",value:function(){var t=this;if(t.subgroups){var e=function(){var e,n=t.subgroups[i].items[0].data.end||t.subgroups[i].items[0].data.start,r=t.subgroups[i].items[0].data.start,o=n-1;Hp(e=t.subgroups[i].items).call(e,(function(t){new Date(t.data.start)<new Date(r)&&(r=t.data.start);var e=t.data.end||t.data.start;new Date(e)>new Date(o)&&(o=e)})),t.subgroups[i].start=r,t.subgroups[i].end=new Date(o-1)};for(var i in t.subgroups)e()}}},{key:"orderSubgroups",value:function(){if(void 0!==this.subgroupOrderer){var t=[];if("string"==typeof this.subgroupOrderer){for(var e in this.subgroups)t.push({subgroup:e,sortField:this.subgroups[e].items[0].data[this.subgroupOrderer]});_T(t).call(t,(function(t,e){return t.sortField-e.sortField}))}else if("function"==typeof this.subgroupOrderer){for(var i in this.subgroups)t.push(this.subgroups[i].items[0].data);_T(t).call(t,this.subgroupOrderer)}if(t.length>0)for(var n=0;n<t.length;n++)this.subgroups[t[n].subgroup].index=n}}},{key:"_resetSubgroups",value:function(){for(var t in this.subgroups)this.subgroups.hasOwnProperty(t)&&(this.subgroups[t].visible=!1,this.subgroups[t].height=0)}},{key:"remove",value:function(t){var e,i;delete this.items[t.id],t.setParent(null),this.stackDirty=!0;var n=av(e=this.visibleItems).call(e,t);-1!=n&&_f(i=this.visibleItems).call(i,n,1),void 0!==t.data.subgroup&&(this._removeFromSubgroup(t),this.orderSubgroups())}},{key:"_removeFromSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;if(null!=e){var i=this.subgroups[e];if(i){var n,r,o=av(n=i.items).call(n,t);if(o>=0)_f(r=i.items).call(r,o,1),i.items.length?this._updateSubgroupsSizes():delete this.subgroups[e]}}}},{key:"removeFromDataSet",value:function(t){this.itemSet.removeItem(t.id)}},{key:"order",value:function(){for(var t=wE.toArray(this.items),e=[],i=[],n=0;n<t.length;n++)void 0!==t[n].data.end&&i.push(t[n]),e.push(t[n]);this.orderedItems={byStart:e,byEnd:i},lA(this.orderedItems.byStart),hA(this.orderedItems.byEnd)}},{key:"_updateItemsInRange",value:function(t,e,i){var n=[],r={};if(!this.isVisible&&void 0!==this.height&&this.groupId!=yA){for(var o=0;o<e.length;o++){var s=e[o];s.displayed&&s.hide()}return n}var a=(i.end-i.start)/4,l=i.start-a,h=i.end+a;if(e.length>0)for(var u=0;u<e.length;u++)this._checkIfVisibleWithReference(e[u],n,r,i);var d=wE.binarySearchCustom(t.byStart,(function(t){return t<l?-1:t<=h?0:1}),"data","start");if(this._traceVisible(d,t.byStart,n,r,(function(t){return t.data.start<l||t.data.start>h})),1==this.checkRangedItems){this.checkRangedItems=!1;for(var c=0;c<t.byEnd.length;c++)this._checkIfVisibleWithReference(t.byEnd[c],n,r,i)}else{var p=wE.binarySearchCustom(t.byEnd,(function(t){var e=t.start;return t.end<l?-1:e<=h?0:1}),"data");this._traceVisible(p,t.byEnd,n,r,(function(t){return t.data.end<l||t.data.start>h}))}for(var f={},m=0,v=0;v<n.length;v++){var g=n[v];if(!g.displayed){f[v]=g.redraw(!0),m=f[v].length}}if(m>0)for(var y=function(t){Hp(wE).call(wE,f,(function(e){e[t]()}))},b=0;b<m;b++)y(b);for(var _=0;_<n.length;_++)n[_].repositionX();return n}},{key:"_traceVisible",value:function(t,e,i,n,r){if(-1!=t){for(var o=t;o>=0;o--){var s=e[o];if(r(s))break;s.isCluster&&!s.hasItems()||s.cluster||void 0===n[s.id]&&(n[s.id]=!0,i.push(s))}for(var a=t+1;a<e.length;a++){var l=e[a];if(r(l))break;l.isCluster&&!l.hasItems()||l.cluster||void 0===n[l.id]&&(n[l.id]=!0,i.push(l))}}}},{key:"_checkIfVisible",value:function(t,e,i){t.isVisible(i)?(t.displayed||t.show(),t.repositionX(),e.push(t)):t.displayed&&t.hide()}},{key:"_checkIfVisibleWithReference",value:function(t,e,i,n){t.isVisible(n)?void 0===i[t.id]&&(i[t.id]=!0,e.push(t)):t.displayed&&t.hide()}},{key:"_updateClustersInRange",value:function(t,e,i){var n=[],r={};if(e.length>0)for(var o=0;o<e.length;o++)this._checkIfVisibleWithReference(e[o],n,r,i);for(var s=0;s<t.byStart.length;s++)this._checkIfVisibleWithReference(t.byStart[s],n,r,i);for(var a=0;a<t.byEnd.length;a++)this._checkIfVisibleWithReference(t.byEnd[a],n,r,i);for(var l={},h=0,u=0;u<n.length;u++){var d=n[u];if(!d.displayed){l[u]=d.redraw(!0),h=l[u].length}}if(h>0)for(var c=0;c<h;c++)Hp(wE).call(wE,l,(function(t){t[c]()}));for(var p=0;p<n.length;p++)n[p].repositionX();return n}},{key:"changeSubgroup",value:function(t,e,i){this._removeFromSubgroup(t,e),this._addToSubgroup(t,i),this.orderSubgroups()}},{key:"dispose",value:function(){var t;for(this.hide();t=this._disposeCallbacks.pop();)t()}}]),t}();function _A(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}var wA=function(t){a_(i,t);var e=_A(i);function i(t,n,r){var o;return Ma(this,i),(o=e.call(this,t,n,r)).width=0,o.height=0,o.top=0,o.left=0,o}return Yd(i,[{key:"redraw",value:function(t,e,i){this.visibleItems=this._updateItemsInRange(this.orderedItems,this.visibleItems,t),this.width=this.dom.background.offsetWidth,this.dom.background.style.height="0";for(var n=0,r=this.visibleItems.length;n<r;n++){this.visibleItems[n].repositionY(e)}return!1}},{key:"show",value:function(){this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background)}}]),i}(bA);function kA(t,e){var i=void 0!==Ic&&Ta(t)||t["@@iterator"];if(!i){if(qc(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return xA(t,e);var n=Hc(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return xA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function xA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}pP('.vis-item{background-color:#d5ddf6;border-color:#97b0f8;border-width:1px;color:#1a1a1a;display:inline-block;position:absolute;z-index:1}.vis-item.vis-selected{background-color:#fff785;border-color:#ffc200;z-index:2}.vis-editable.vis-selected{cursor:move}.vis-item.vis-point.vis-selected{background-color:#fff785}.vis-item.vis-box{border-radius:2px;border-style:solid;text-align:center}.vis-item.vis-point{background:none}.vis-item.vis-dot{border-radius:4px;border-style:solid;border-width:4px;padding:0;position:absolute}.vis-item.vis-range{border-radius:2px;border-style:solid;box-sizing:border-box}.vis-item.vis-background{background-color:rgba(213,221,246,.4);border:none;box-sizing:border-box;margin:0;padding:0}.vis-item .vis-item-overflow{height:100%;margin:0;overflow:hidden;padding:0;position:relative;width:100%}.vis-item-visible-frame{white-space:nowrap}.vis-item.vis-range .vis-item-content{display:inline-block;position:relative}.vis-item.vis-background .vis-item-content{display:inline-block;position:absolute}.vis-item.vis-line{border-left-style:solid;border-left-width:1px;padding:0;position:absolute;width:0}.vis-item .vis-item-content{box-sizing:border-box;padding:5px;white-space:nowrap}.vis-item .vis-onUpdateTime-tooltip{background:#4f81bd;border-radius:1px;color:#fff;padding:5px;position:absolute;text-align:center;transition:.4s;-o-transition:.4s;-moz-transition:.4s;-webkit-transition:.4s;white-space:nowrap;width:200px}.vis-item .vis-delete,.vis-item .vis-delete-rtl{box-sizing:border-box;cursor:pointer;height:24px;padding:0 5px;position:absolute;top:0;-webkit-transition:background .2s linear;-moz-transition:background .2s linear;-ms-transition:background .2s linear;-o-transition:background .2s linear;transition:background .2s linear;width:24px}.vis-item .vis-delete{right:-24px}.vis-item .vis-delete-rtl{left:-24px}.vis-item .vis-delete-rtl:after,.vis-item .vis-delete:after{color:red;content:"\\00D7";font-family:arial,sans-serif;font-size:22px;font-weight:700;-webkit-transition:color .2s linear;-moz-transition:color .2s linear;-ms-transition:color .2s linear;-o-transition:color .2s linear;transition:color .2s linear}.vis-item .vis-delete-rtl:hover,.vis-item .vis-delete:hover{background:red}.vis-item .vis-delete-rtl:hover:after,.vis-item .vis-delete:hover:after{color:#fff}.vis-item .vis-drag-center{cursor:move;height:100%;left:0;position:absolute;top:0;width:100%}.vis-item.vis-range .vis-drag-left{cursor:w-resize;left:-4px}.vis-item.vis-range .vis-drag-left,.vis-item.vis-range .vis-drag-right{height:100%;max-width:20%;min-width:2px;position:absolute;top:0;width:24px}.vis-item.vis-range .vis-drag-right{cursor:e-resize;right:-4px}.vis-range.vis-item.vis-readonly .vis-drag-left,.vis-range.vis-item.vis-readonly .vis-drag-right{cursor:auto}.vis-item.vis-cluster{border-radius:2px;border-style:solid;text-align:center;vertical-align:center}.vis-item.vis-cluster-line{border-left-style:solid;border-left-width:1px;padding:0;position:absolute;width:0}.vis-item.vis-cluster-dot{border-radius:4px;border-style:solid;border-width:4px;padding:0;position:absolute}');var DA=function(){function t(e,i,n){var r,o=this;Ma(this,t),this.id=null,this.parent=null,this.data=e,this.dom=null,this.conversion=i||{},this.defaultOptions={locales:IP,locale:"en"},this.options=wE.extend({},this.defaultOptions,n),this.options.locales=wE.extend({},IP,this.options.locales);var s=this.defaultOptions.locales[this.defaultOptions.locale];Hp(r=rp(this.options.locales)).call(r,(function(t){o.options.locales[t]=wE.extend({},s,o.options.locales[t])})),this.selected=!1,this.displayed=!1,this.groupShowing=!0,this.selectable=n&&n.selectable||!1,this.dirty=!0,this.top=null,this.right=null,this.left=null,this.width=null,this.height=null,this.setSelectability(e),this.editable=null,this._updateEditStatus()}return Yd(t,[{key:"select",value:function(){this.selectable&&(this.selected=!0,this.dirty=!0,this.displayed&&this.redraw())}},{key:"unselect",value:function(){this.selected=!1,this.dirty=!0,this.displayed&&this.redraw()}},{key:"setData",value:function(t){null!=t.group&&this.data.group!=t.group&&null!=this.parent&&this.parent.itemSet._moveToGroup(this,t.group),this.setSelectability(t),this.parent&&(this.parent.stackDirty=!0),null!=t.subgroup&&this.data.subgroup!=t.subgroup&&null!=this.parent&&this.parent.changeSubgroup(this,this.data.subgroup,t.subgroup),this.data=t,this._updateEditStatus(),this.dirty=!0,this.displayed&&this.redraw()}},{key:"setSelectability",value:function(t){t&&(this.selectable=void 0===t.selectable||Boolean(t.selectable))}},{key:"setParent",value:function(t){this.displayed?(this.hide(),this.parent=t,this.parent&&this.show()):this.parent=t}},{key:"isVisible",value:function(t){return!1}},{key:"show",value:function(){return!1}},{key:"hide",value:function(){return!1}},{key:"redraw",value:function(){}},{key:"repositionX",value:function(){}},{key:"repositionY",value:function(){}},{key:"_repaintDragCenter",value:function(){if(this.selected&&this.editable.updateTime&&!this.dom.dragCenter){var t,e,i=this,n=document.createElement("div");n.className="vis-drag-center",n.dragCenterItem=this,this.hammerDragCenter=new uP(n),this.hammerDragCenter.on("tap",(function(t){i.parent.itemSet.body.emitter.emit("click",{event:t,item:i.id})})),this.hammerDragCenter.on("doubletap",(function(t){t.stopPropagation(),i.parent.itemSet._onUpdateItem(i),i.parent.itemSet.body.emitter.emit("doubleClick",{event:t,item:i.id})})),this.hammerDragCenter.on("panstart",(function(t){t.stopPropagation(),i.parent.itemSet._onDragStart(t)})),this.hammerDragCenter.on("panmove",Tp(t=i.parent.itemSet._onDrag).call(t,i.parent.itemSet)),this.hammerDragCenter.on("panend",Tp(e=i.parent.itemSet._onDragEnd).call(e,i.parent.itemSet)),this.hammerDragCenter.get("press").set({time:1e4}),this.dom.box?this.dom.dragLeft?this.dom.box.insertBefore(n,this.dom.dragLeft):this.dom.box.appendChild(n):this.dom.point&&this.dom.point.appendChild(n),this.dom.dragCenter=n}else!this.selected&&this.dom.dragCenter&&(this.dom.dragCenter.parentNode&&this.dom.dragCenter.parentNode.removeChild(this.dom.dragCenter),this.dom.dragCenter=null,this.hammerDragCenter&&(this.hammerDragCenter.destroy(),this.hammerDragCenter=null))}},{key:"_repaintDeleteButton",value:function(t){var e=(this.options.editable.overrideItems||null==this.editable)&&this.options.editable.remove||!this.options.editable.overrideItems&&null!=this.editable&&this.editable.remove;if(this.selected&&e&&!this.dom.deleteButton){var i=this,n=document.createElement("div");this.options.rtl?n.className="vis-delete-rtl":n.className="vis-delete";var r=this.options.locales[this.options.locale];r||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),r=this.options.locales.en),n.title=r.deleteSelected,this.hammerDeleteButton=new uP(n).on("tap",(function(t){t.stopPropagation(),i.parent.removeFromDataSet(i)})),t.appendChild(n),this.dom.deleteButton=n}else this.selected&&e||!this.dom.deleteButton||(this.dom.deleteButton.parentNode&&this.dom.deleteButton.parentNode.removeChild(this.dom.deleteButton),this.dom.deleteButton=null,this.hammerDeleteButton&&(this.hammerDeleteButton.destroy(),this.hammerDeleteButton=null))}},{key:"_repaintOnItemUpdateTimeTooltip",value:function(t){if(this.options.tooltipOnItemUpdateTime){var e=(this.options.editable.updateTime||!0===this.data.editable)&&!1!==this.data.editable;if(this.selected&&e&&!this.dom.onItemUpdateTimeTooltip){var i=document.createElement("div");i.className="vis-onUpdateTime-tooltip",t.appendChild(i),this.dom.onItemUpdateTimeTooltip=i}else!this.selected&&this.dom.onItemUpdateTimeTooltip&&(this.dom.onItemUpdateTimeTooltip.parentNode&&this.dom.onItemUpdateTimeTooltip.parentNode.removeChild(this.dom.onItemUpdateTimeTooltip),this.dom.onItemUpdateTimeTooltip=null);if(this.dom.onItemUpdateTimeTooltip){this.dom.onItemUpdateTimeTooltip.style.visibility=this.parent.itemSet.touchParams.itemIsDragging?"visible":"hidden",this.dom.onItemUpdateTimeTooltip.style.transform="translateX(-50%)",this.dom.onItemUpdateTimeTooltip.style.left="50%";var n,r,o=this.parent.itemSet.body.domProps.scrollTop;if(("top"==this.options.orientation.item?this.top:this.parent.height-this.top-this.height)+this.parent.top-50<-o?(this.dom.onItemUpdateTimeTooltip.style.bottom="",this.dom.onItemUpdateTimeTooltip.style.top="".concat(this.height+2,"px")):(this.dom.onItemUpdateTimeTooltip.style.top="",this.dom.onItemUpdateTimeTooltip.style.bottom="".concat(this.height+2,"px")),this.options.tooltipOnItemUpdateTime&&this.options.tooltipOnItemUpdateTime.template)n=Tp(r=this.options.tooltipOnItemUpdateTime.template).call(r,this)(this.data);else n="start: ".concat(sO(this.data.start).format("MM/DD/YYYY hh:mm")),this.data.end&&(n+="<br> end: ".concat(sO(this.data.end).format("MM/DD/YYYY hh:mm")));this.dom.onItemUpdateTimeTooltip.innerHTML=wE.xss(n)}}}},{key:"_getItemData",value:function(){return this.parent.itemSet.itemsData.get(this.id)}},{key:"_updateContents",value:function(t){var e,i,n,r,o,s,a=this._getItemData(),l=(this.dom.box||this.dom.point).getElementsByClassName("vis-item-visible-frame")[0];this.options.visibleFrameTemplate?(r=Tp(o=this.options.visibleFrameTemplate).call(o,this),n=wE.xss(r(a,l))):n="";if(l)if(n instanceof Object&&!(n instanceof Element))r(a,l);else if(this._contentToString(this.itemVisibleFrameContent)!==this._contentToString(n)){if(n instanceof Element)l.innerHTML="",l.appendChild(n);else if(null!=n)l.innerHTML=wE.xss(n);else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.itemVisibleFrameContent=n}this.options.template?e=(i=Tp(s=this.options.template).call(s,this))(a,t,this.data):e=this.data.content;if(e instanceof Object&&!(e instanceof Element))i(a,t);else if(this._contentToString(this.content)!==this._contentToString(e)){if(e instanceof Element)t.innerHTML="",t.appendChild(e);else if(null!=e)t.innerHTML=wE.xss(e);else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.content=e}}},{key:"_updateDataAttributes",value:function(t){if(this.options.dataAttributes&&this.options.dataAttributes.length>0){var e=[];if(qc(this.options.dataAttributes))e=this.options.dataAttributes;else{if("all"!=this.options.dataAttributes)return;e=rp(this.data)}var i,n=kA(e);try{for(n.s();!(i=n.n()).done;){var r=i.value,o=this.data[r];null!=o?t.setAttribute("data-".concat(r),o):t.removeAttribute("data-".concat(r))}}catch(t){n.e(t)}finally{n.f()}}}},{key:"_updateStyle",value:function(t){this.style&&(wE.removeCssText(t,this.style),this.style=null),this.data.style&&(wE.addCssText(t,this.data.style),this.style=this.data.style)}},{key:"_contentToString",value:function(t){return"string"==typeof t?t:t&&"outerHTML"in t?t.outerHTML:t}},{key:"_updateEditStatus",value:function(){this.options&&("boolean"==typeof this.options.editable?this.editable={updateTime:this.options.editable,updateGroup:this.options.editable,remove:this.options.editable}:"object"===Nd(this.options.editable)&&(this.editable={},wE.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.options.editable))),this.options&&this.options.editable&&!0===this.options.editable.overrideItems||this.data&&("boolean"==typeof this.data.editable?this.editable={updateTime:this.data.editable,updateGroup:this.data.editable,remove:this.data.editable}:"object"===Nd(this.data.editable)&&(this.editable={},wE.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.data.editable)))}},{key:"getWidthLeft",value:function(){return 0}},{key:"getWidthRight",value:function(){return 0}},{key:"getTitle",value:function(){var t;return this.options.tooltip&&this.options.tooltip.template?Tp(t=this.options.tooltip.template).call(t,this)(this._getItemData(),this.data):this.data.title}}]),t}();function SA(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}DA.prototype.stack=!0;var CA=function(t){a_(i,t);var e=SA(i);function i(t,n,r){var o;if(Ma(this,i),(o=e.call(this,t,n,r)).props={dot:{width:0,height:0},line:{width:0,height:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return o}return Yd(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e,i=this.data.align||this.options.align,n=this.width*t.getMillisecondsPerPixel();return e="right"==i?this.data.start.getTime()>t.start&&this.data.start.getTime()-n<t.end:"left"==i?this.data.start.getTime()+n>t.start&&this.data.start.getTime()<t.end:this.data.start.getTime()+n/2>t.start&&this.data.start.getTime()-n/2<t.end,e}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-line",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-dot",this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}if(!this.dom.line.parentNode){var e=this.parent.dom.background;if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className="vis-item vis-box".concat(e),this.dom.line.className="vis-item vis-line".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},dot:{height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},line:{width:this.dom.line.offsetWidth},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.props.dot.height=t.dot.height,this.props.dot.width=t.dot.width,this.props.line.width=t.line.width,this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.box)}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Tp(e=this._createDomElement).call(e,this),Tp(i=this._appendDomElement).call(i,this),Tp(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(o=a._getDomComponentsSizes())},function(){var t;a.dirty&&Tp(t=a._updateDomComponentsSizes).call(t,a)(o)},Tp(r=this._repaintDomAdditionals).call(r,this)];return t?l:(Hp(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.remove?t.box.remove():t.box.parentNode&&t.box.parentNode.removeChild(t.box),t.line.remove?t.line.remove():t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.remove?t.dot.remove():t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot),this.displayed=!1}}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n;if(void 0!==e||void 0!==i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3]?-1*e:e;t.style.transform=void 0!==i?void 0!==e?Yc(n="translate(".concat(r,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.box,this.boxX,this.boxY,t),e(this.dom.dot,this.dotX,this.dotY,t),e(this.dom.line,this.lineX,this.lineY,t)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=void 0===this.data.align?this.options.align:this.data.align,i=this.props.line.width,n=this.props.dot.width;"right"==e?(this.boxX=t-this.width,this.lineX=t-i,this.dotX=t-i/2-n/2):"left"==e?(this.boxX=t,this.lineX=t,this.dotX=t+i/2-n/2):(this.boxX=t-this.width/2,this.lineX=this.options.rtl?t-i:t-i/2,this.dotX=t-n/2),this.options.rtl?this.right=this.boxX:this.left=this.boxX,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.line.style;if("top"==t){var i=this.parent.top+this.top+1;this.boxY=this.top||0,e.height="".concat(i,"px"),e.bottom="",e.top="0"}else{var n=this.parent.itemSet.props.height-this.parent.top-this.parent.height+this.top;this.boxY=this.parent.height-this.top-(this.height||0),e.height="".concat(n,"px"),e.top="",e.bottom="0"}this.dotY=-this.props.dot.height/2,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}}]),i}(DA);function TA(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}var MA=function(t){a_(i,t);var e=TA(i);function i(t,n,r){var o;if(Ma(this,i),(o=e.call(this,t,n,r)).props={dot:{top:0,width:0,height:0},content:{height:0,marginLeft:0,marginRight:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return o}return Yd(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e=this.width*t.getMillisecondsPerPixel();return this.data.start.getTime()+e>t.start&&this.data.start<t.end}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.point=document.createElement("div"),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.point.appendChild(this.dom.content),this.dom.dot=document.createElement("div"),this.dom.point.appendChild(this.dom.dot),this.dom.point["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.point.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.point)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.point),this._updateStyle(this.dom.point);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.point.className="vis-item vis-point".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{dot:{width:this.dom.dot.offsetWidth,height:this.dom.dot.offsetHeight},content:{width:this.dom.content.offsetWidth,height:this.dom.content.offsetHeight},point:{width:this.dom.point.offsetWidth,height:this.dom.point.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.dot.width=t.dot.width,this.props.dot.height=t.dot.height,this.props.content.height=t.content.height,this.options.rtl?this.dom.content.style.marginRight="".concat(this.props.dot.width/2,"px"):this.dom.content.style.marginLeft="".concat(this.props.dot.width/2,"px"),this.width=t.point.width,this.height=t.point.height,this.dom.dot.style.top="".concat((this.height-this.props.dot.height)/2,"px");var e=this.props.dot.width,i=this.options.rtl?e/2:e/2*-1;this.dom.dot.style.transform="translateX(".concat(i,"px"),this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.point),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.point)}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Tp(e=this._createDomElement).call(e,this),Tp(i=this._appendDomElement).call(i,this),Tp(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(o=a._getDomComponentsSizes())},function(){var t;a.dirty&&Tp(t=a._updateDomComponentsSizes).call(t,a)(o)},Tp(r=this._repaintDomAdditionals).call(r,this)];return t?l:(Hp(l).call(l,(function(t){s=t()})),s)}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n;if(void 0!==e||void 0!==i){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3]?-1*e:e;t.style.transform=void 0!==i?void 0!==e?Yc(n="translate(".concat(r,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.point,this.pointX,this.pointY,t)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){this.displayed&&(this.dom.point.parentNode&&this.dom.point.parentNode.removeChild(this.dom.point),this.displayed=!1)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start);this.pointX=t,this.options.rtl?this.right=t-this.props.dot.width:this.left=t-this.props.dot.width,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item;this.pointY="top"==t?this.top:this.parent.height-this.top-this.height,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.props.dot.width}},{key:"getWidthRight",value:function(){return this.props.dot.width}}]),i}(DA);function OA(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}var EA=function(t){a_(i,t);var e=OA(i);function i(t,n,r){var o;if(Ma(this,i),(o=e.call(this,t,n,r)).props={content:{width:0}},o.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return o}return Yd(i,[{key:"isVisible",value:function(t){return!this.cluster&&(this.data.start<t.end&&this.data.end>t.start)}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.visibleFrame=document.createElement("div"),this.dom.visibleFrame.className="vis-item-visible-frame",this.dom.box.appendChild(this.dom.visibleFrame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className=this.baseClassName+e,this.dom.content.style.maxWidth="none"}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.frame).overflow,this.whiteSpace="nowrap"!==window.getComputedStyle(this.dom.content).whiteSpace,{content:{width:this.dom.content.offsetWidth},box:{height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=t.box.height,this.dom.content.style.maxWidth="",this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDeleteButton(this.dom.box),this._repaintDragCenter(),this._repaintDragLeft(),this._repaintDragRight()}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Tp(e=this._createDomElement).call(e,this),Tp(i=this._appendDomElement).call(i,this),Tp(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(o=Tp(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&Tp(t=a._updateDomComponentsSizes).call(t,a)(o)},Tp(r=this._repaintDomAdditionals).call(r,this)];return t?l:(Hp(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom.box;t.parentNode&&t.parentNode.removeChild(t),this.displayed=!1}}},{key:"repositionX",value:function(t){var e,i,n=this.parent.width,r=this.conversion.toScreen(this.data.start),o=this.conversion.toScreen(this.data.end),s=void 0===this.data.align?this.options.align:this.data.align;!1===this.data.limitSize||void 0!==t&&!0!==t||(r<-n&&(r=-n),o>2*n&&(o=2*n));var a=Math.max(Math.round(1e3*(o-r))/1e3,1);switch(this.overflow?(this.options.rtl?this.right=r:this.left=r,this.width=a+this.props.content.width,i=this.props.content.width):(this.options.rtl?this.right=r:this.left=r,this.width=a,i=Math.min(o-r,this.props.content.width)),this.options.rtl?this.dom.box.style.transform="translateX(".concat(-1*this.right,"px)"):this.dom.box.style.transform="translateX(".concat(this.left,"px)"),this.dom.box.style.width="".concat(a,"px"),this.whiteSpace&&(this.height=this.dom.box.offsetHeight),s){case"left":this.dom.content.style.transform="translateX(0)";break;case"right":if(this.options.rtl){var l=-1*Math.max(a-i,0);this.dom.content.style.transform="translateX(".concat(l,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max(a-i,0),"px)");break;case"center":if(this.options.rtl){var h=-1*Math.max((a-i)/2,0);this.dom.content.style.transform="translateX(".concat(h,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max((a-i)/2,0),"px)");break;default:if(e=this.overflow?o>0?Math.max(-r,0):-i:r<0?-r:0,this.options.rtl){var u=-1*e;this.dom.content.style.transform="translateX(".concat(u,"px)")}else this.dom.content.style.transform="translateX(".concat(e,"px)")}}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;e.style.top="".concat("top"==t?this.top:this.parent.height-this.top-this.height,"px")}},{key:"_repaintDragLeft",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragLeft){var t=document.createElement("div");t.className="vis-drag-left",t.dragLeftItem=this,this.dom.box.appendChild(t),this.dom.dragLeft=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragLeft||(this.dom.dragLeft.parentNode&&this.dom.dragLeft.parentNode.removeChild(this.dom.dragLeft),this.dom.dragLeft=null)}},{key:"_repaintDragRight",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragRight){var t=document.createElement("div");t.className="vis-drag-right",t.dragRightItem=this,this.dom.box.appendChild(t),this.dom.dragRight=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragRight||(this.dom.dragRight.parentNode&&this.dom.dragRight.parentNode.removeChild(this.dom.dragRight),this.dom.dragRight=null)}}]),i}(DA);function PA(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}EA.prototype.baseClassName="vis-item vis-range";var AA=function(t){a_(i,t);var e=PA(i);function i(t,n,r){var o;if(Ma(this,i),(o=e.call(this,t,n,r)).props={content:{width:0}},o.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return o}return Yd(i,[{key:"isVisible",value:function(t){return this.data.start<t.end&&this.data.end>t.start}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.background;if(!t)throw new Error("Cannot redraw item: parent has no background container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.content),this._updateStyle(this.dom.box);var t=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"");this.dom.box.className=this.baseClassName+t}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.content).overflow,{content:{width:this.dom.content.offsetWidth}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=0,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a=this,l=[Tp(e=this._createDomElement).call(e,this),Tp(i=this._appendDomElement).call(i,this),Tp(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(o=Tp(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&Tp(t=a._updateDomComponentsSizes).call(t,a)(o)},Tp(r=this._repaintDomAdditionals).call(r,this)];return t?l:(Hp(l).call(l,(function(t){s=t()})),s)}},{key:"repositionY",value:function(t){var e,i=this.options.orientation.item;if(void 0!==this.data.subgroup){var n=this.data.subgroup;this.dom.box.style.height="".concat(this.parent.subgroups[n].height,"px"),this.dom.box.style.top="".concat("top"==i?this.parent.top+this.parent.subgroups[n].top:this.parent.top+this.parent.height-this.parent.subgroups[n].top-this.parent.subgroups[n].height,"px"),this.dom.box.style.bottom=""}else this.parent instanceof wA?(e=Math.max(this.parent.height,this.parent.itemSet.body.domProps.center.height,this.parent.itemSet.body.domProps.centerContainer.height),this.dom.box.style.bottom="bottom"==i?"0":"",this.dom.box.style.top="top"==i?"0":""):(e=this.parent.height,this.dom.box.style.top="".concat(this.parent.top,"px"),this.dom.box.style.bottom="");this.dom.box.style.height="".concat(e,"px")}}]),i}(DA);AA.prototype.baseClassName="vis-item vis-background",AA.prototype.stack=!1,AA.prototype.show=EA.prototype.show,AA.prototype.hide=EA.prototype.hide,AA.prototype.repositionX=EA.prototype.repositionX;pP("div.vis-tooltip{background-color:#f5f4ed;border:1px solid #808074;-moz-border-radius:3px;-webkit-border-radius:3px;border-radius:3px;box-shadow:3px 3px 10px rgba(0,0,0,.2);color:#000;font-family:verdana;font-size:14px;padding:5px;pointer-events:none;position:absolute;visibility:hidden;white-space:nowrap;z-index:5}");var IA=function(){function t(e,i){Ma(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Yd(t,[{key:"setPosition",value:function(t,e){this.x=Zm(t),this.y=Zm(e)}},{key:"setText",value:function(t){t instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(t)):this.frame.innerHTML=wE.xss(t)}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,r=this.frame.parentNode.clientWidth,o=0,s=0;if("flip"==this.overflowMethod||"none"==this.overflowMethod){var a=!1,l=!0;"flip"==this.overflowMethod&&(this.y-e<this.padding&&(l=!1),this.x+i>r-this.padding&&(a=!0)),o=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(o=this.x)+i+this.padding>r&&(o=r-i-this.padding),o<this.padding&&(o=this.padding);this.frame.style.left=o+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),LA=Zl.every;En({target:"Array",proto:!0,forced:!Op("every")},{every:function(t){return LA(this,t,arguments.length>1?arguments[1]:void 0)}});var NA=Jd("Array").every,RA=ye,FA=NA,jA=Array.prototype,YA=function(t){var e=t.every;return t===jA||RA(jA,t)&&e===jA.every?FA:e},HA=n(YA);function zA(t,e){var i=void 0!==Ic&&Ta(t)||t["@@iterator"];if(!i){if(qc(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return BA(t,e);var n=Hc(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return BA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function BA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function GA(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}var WA=function(t){a_(i,t);var e=GA(i);function i(t,n,r){var o;Ma(this,i);var s=Nf({},{fitOnDoubleClick:!0},r,{editable:!1});if((o=e.call(this,t,n,s)).props={content:{width:0,height:0}},!t||null==t.uiItems)throw new Error('Property "uiItems" missing in item '+t.id);return o.id=UM(),o.group=t.group,o._setupRange(),o.emitter=o.data.eventEmitter,o.range=o.data.range,o.attached=!1,o.isCluster=!0,o.data.isCluster=!0,o}return Yd(i,[{key:"hasItems",value:function(){return this.data.uiItems&&this.data.uiItems.length&&this.attached}},{key:"setUiItems",value:function(t){this.detach(),this.data.uiItems=t,this._setupRange(),this.attach()}},{key:"isVisible",value:function(t){var e=this.data.end?this.data.end-this.data.start:0,i=this.width*t.getMillisecondsPerPixel(),n=Math.max(this.data.start.getTime()+e,this.data.start.getTime()+i);return this.data.start<t.end&&n>t.start&&this.hasItems()}},{key:"getData",value:function(){return{isCluster:!0,id:this.id,items:this.data.items||[],data:this.data}}},{key:"redraw",value:function(t){var e,i,n,r,o,s,a,l,h=[Tp(e=this._createDomElement).call(e,this),Tp(i=this._appendDomElement).call(i,this),Tp(n=this._updateDirtyDomComponents).call(n,this),Tp(r=function(){this.dirty&&(a=this._getDomComponentsSizes())}).call(r,this),Tp(o=function(){var t;this.dirty&&Tp(t=this._updateDomComponentsSizes).call(t,this)(a)}).call(o,this),Tp(s=this._repaintDomAdditionals).call(s,this)];return t?h:(Hp(h).call(h,(function(t){l=t()})),l)}},{key:"show",value:function(){this.displayed||this.redraw()}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.parentNode&&t.box.parentNode.removeChild(t.box),this.options.showStipes&&(t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot)),this.displayed=!1}}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=this.data.end?this.conversion.toScreen(this.data.end):0;if(e)this.repositionXWithRanges(t,e);else{var i=void 0===this.data.align?this.options.align:this.data.align;this.repositionXWithoutRanges(t,i)}this.options.showStipes&&(this.dom.line.style.display=this._isStipeVisible()?"block":"none",this.dom.dot.style.display=this._isStipeVisible()?"block":"none",this._isStipeVisible()&&this.repositionStype(t,e))}},{key:"repositionStype",value:function(t,e){this.dom.line.style.display="block",this.dom.dot.style.display="block";var i=this.dom.line.offsetWidth,n=this.dom.dot.offsetWidth;if(e){var r=i+t+(e-t)/2,o=r-n/2,s=this.options.rtl?-1*r:r,a=this.options.rtl?-1*o:o;this.dom.line.style.transform="translateX(".concat(s,"px)"),this.dom.dot.style.transform="translateX(".concat(a,"px)")}else{var l=this.options.rtl?-1*t:t,h=this.options.rtl?-1*(t-n/2):t-n/2;this.dom.line.style.transform="translateX(".concat(l,"px)"),this.dom.dot.style.transform="translateX(".concat(h,"px)")}}},{key:"repositionXWithoutRanges",value:function(t,e){"right"==e?this.options.rtl?(this.right=t-this.width,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width,this.dom.box.style.left=this.left+"px"):"left"==e?this.options.rtl?(this.right=t,this.dom.box.style.right=this.right+"px"):(this.left=t,this.dom.box.style.left=this.left+"px"):this.options.rtl?(this.right=t-this.width/2,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width/2,this.dom.box.style.left=this.left+"px")}},{key:"repositionXWithRanges",value:function(t,e){var i=Math.round(Math.max(e-t+.5,1));this.options.rtl?this.right=t:this.left=t,this.width=Math.max(i,this.minWidth||0),this.options.rtl?this.dom.box.style.right=this.right+"px":this.dom.box.style.left=this.left+"px",this.dom.box.style.width=i+"px"}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;if(e.style.top="top"==t?(this.top||0)+"px":(this.parent.height-this.top-this.height||0)+"px",this.options.showStipes){if("top"==t)this.dom.line.style.top="0",this.dom.line.style.height=this.parent.top+this.top+1+"px",this.dom.line.style.bottom="";else{var i=this.parent.itemSet.props.height,n=i-this.parent.top-this.parent.height+this.top;this.dom.line.style.top=i-n+"px",this.dom.line.style.bottom="0"}this.dom.dot.style.top=-this.dom.dot.offsetHeight/2+"px"}}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}},{key:"move",value:function(){this.repositionX(),this.repositionY()}},{key:"attach",value:function(){var t,e,i=zA(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){e.value.cluster=this}}catch(t){i.e(t)}finally{i.f()}this.data.items=ep(t=this.data.uiItems).call(t,(function(t){return t.data})),this.attached=!0,this.dirty=!0}},{key:"detach",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this.hasItems()){var e,i=zA(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){delete e.value.cluster}}catch(t){i.e(t)}finally{i.f()}this.attached=!1,t&&this.group&&(this.group.remove(this),this.group=null),this.data.items=[],this.dirty=!0}}},{key:"_onDoubleClick",value:function(){this._fit()}},{key:"_setupRange",value:function(){var t,e,i,n=ep(t=this.data.uiItems).call(t,(function(t){return{start:t.data.start.valueOf(),end:t.data.end?t.data.end.valueOf():t.data.start.valueOf()}}));this.data.min=Math.min.apply(Math,Ac(ep(n).call(n,(function(t){return Math.min(t.start,t.end||t.start)})))),this.data.max=Math.max.apply(Math,Ac(ep(n).call(n,(function(t){return Math.max(t.start,t.end||t.start)}))));var r=ep(e=this.data.uiItems).call(e,(function(t){return t.center})),o=cS(r).call(r,(function(t,e){return t+e}),0)/this.data.uiItems.length;TT(i=this.data.uiItems).call(i,(function(t){return t.data.end}))?(this.data.start=new Date(this.data.min),this.data.end=new Date(this.data.max)):(this.data.start=new Date(o),this.data.end=null)}},{key:"_getUiItems",value:function(){var t,e=this;return this.data.uiItems&&this.data.uiItems.length?mm(t=this.data.uiItems).call(t,(function(t){return t.cluster===e})):[]}},{key:"_createDomElement",value:function(){if(!this.dom){var t;if(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.options.showStipes&&(this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-cluster-line",this.dom.line.style.display="none",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-cluster-dot",this.dom.dot.style.display="none"),this.options.fitOnDoubleClick)this.dom.box.ondblclick=Tp(t=i.prototype._onDoubleClick).call(t,this);this.dom.box["vis-item"]=this,this.dirty=!0}}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}var e=this.parent.dom.background;if(this.options.showStipes){if(!this.dom.line.parentNode){if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.baseClassName+" "+(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+" vis-readonly";this.dom.box.className="vis-item "+t,this.options.showStipes&&(this.dom.line.className="vis-item vis-cluster-line "+(this.selected?" vis-selected":""),this.dom.dot.className="vis-item vis-cluster-dot "+(this.selected?" vis-selected":"")),this.data.end&&(this.dom.content.style.maxWidth="none")}}},{key:"_getDomComponentsSizes",value:function(){var t={previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}};return this.options.showStipes&&(t.dot={height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},t.line={width:this.dom.line.offsetWidth}),t}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.data.end?this.minWidth=t.box.width:this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box)}},{key:"_isStipeVisible",value:function(){return this.minWidth>=this.width||!this.data.end}},{key:"_getFitRange",value:function(){var t=.05*(this.data.max-this.data.min)/2;return{fitStart:this.data.min-t,fitEnd:this.data.max+t}}},{key:"_fit",value:function(){if(this.emitter){var t=this._getFitRange(),e=t.fitStart,i=t.fitEnd,n={start:new Date(e),end:new Date(i),animation:!0};this.emitter.emit("fit",n)}}},{key:"_getItemData",value:function(){return this.data}}]),i}(DA);function UA(t,e){var i=void 0!==Ic&&Ta(t)||t["@@iterator"];if(!i){if(qc(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return VA(t,e);var n=Hc(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return VA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function VA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}WA.prototype.baseClassName="vis-item vis-range vis-cluster";var XA="__ungrouped__",qA=function(){function t(e){Ma(this,t),this.itemSet=e,this.groups={},this.cache={},this.cache[-1]=[]}return Yd(t,[{key:"createClusterItem",value:function(t,e,i){return new WA(t,e,i)}},{key:"setItems",value:function(t,e){this.items=t||[],this.dataChanged=!0,this.applyOnChangedLevel=!1,e&&e.applyOnChangedLevel&&(this.applyOnChangedLevel=e.applyOnChangedLevel)}},{key:"updateData",value:function(){this.dataChanged=!0,this.applyOnChangedLevel=!1}},{key:"getClusters",value:function(t,e,i){var n="boolean"==typeof i?{}:i,r=n.maxItems,o=n.clusterCriteria;o||(o=function(){return!0}),r=r||1;var s=-1,a=0;if(e>0){if(e>=1)return[];s=Math.abs(Math.round(Math.log(100/e)/Math.log(2))),a=Math.abs(Math.pow(2,s))}if(this.dataChanged){var l=s!=this.cacheLevel;(!this.applyOnChangedLevel||l)&&(this._dropLevelsCache(),this._filterData())}this.cacheLevel=s;var h=this.cache[s];if(!h){for(var u in h=[],this.groups)if(this.groups.hasOwnProperty(u))for(var d=this.groups[u],c=d.length,p=0;p<c;){for(var f=d[p],m=1,v=p-1;v>=0&&f.center-d[v].center<a/2;)!d[v].cluster&&o(f.data,d[v].data)&&m++,v--;for(var g=p+1;g<d.length&&d[g].center-f.center<a/2;)o(f.data,d[g].data)&&m++,g++;for(var y=h.length-1;y>=0&&f.center-h[y].center<a;)f.group==h[y].group&&o(f.data,h[y].data)&&m++,y--;if(m>r){for(var b=m-r+1,_=[],w=p;_.length<b&&w<d.length;)o(d[p].data,d[w].data)&&_.push(d[w]),w++;var k=this.itemSet.getGroupId(f.data),x=this.itemSet.groups[k]||this.itemSet.groups[XA],D=this._getClusterForItems(_,x,t,i);h.push(D),p+=b}else delete f.cluster,p+=1}this.cache[s]=h}return h}},{key:"_filterData",value:function(){var t={};this.groups=t;for(var e=0,i=Mm(this.items);e<i.length;e++){var n=i[e],r=n.parent?n.parent.groupId:"",o=t[r];o||(o=[],t[r]=o),o.push(n),n.data.start&&(n.data.end?n.center=(n.data.start.valueOf()+n.data.end.valueOf())/2:n.center=n.data.start.valueOf())}for(var s in t){var a;if(t.hasOwnProperty(s))_T(a=t[s]).call(a,(function(t,e){return t.center-e.center}))}this.dataChanged=!1}},{key:"_getClusterForItems",value:function(t,e,i,n){var r,o,s=ep(r=i||[]).call(r,(function(t){var e;return{cluster:t,itemsIds:new LC(ep(e=t.data.uiItems).call(e,(function(t){return t.id})))}}));if(s.length){var a,l=UA(s);try{var h=function(){var e=a.value;if(e.itemsIds.size===t.length&&HA(t).call(t,(function(t){return e.itemsIds.has(t.id)})))return o=e.cluster,1};for(l.s();!(a=l.n()).done&&!h(););}catch(t){l.e(t)}finally{l.f()}}if(o)return o.setUiItems(t),o.group!==e&&(o.group&&o.group.remove(o),e&&(e.add(o),o.group=e)),o;var u=n.titleTemplate||"",d={toScreen:this.itemSet.body.util.toScreen,toTime:this.itemSet.body.util.toTime},c=u.replace(/{count}/,t.length),p='<div title="'+c+'">'+t.length+"</div>",f=Nf({},n,this.itemSet.options),m={content:p,title:c,group:e,uiItems:t,eventEmitter:this.itemSet.body.emitter,range:this.itemSet.body.range};return o=this.createClusterItem(m,d,f),e&&(e.add(o),o.group=e),o.attach(),o}},{key:"_dropLevelsCache",value:function(){this.cache={},this.cacheLevel=-1,this.cache[this.cacheLevel]=[]}}]),t}();pP('.vis-itemset{box-sizing:border-box;margin:0;padding:0;position:relative}.vis-itemset .vis-background,.vis-itemset .vis-foreground{height:100%;overflow:visible;position:absolute;width:100%}.vis-axis{height:0;left:0;position:absolute;width:100%;z-index:1}.vis-foreground .vis-group{border-bottom:1px solid #bfbfbf;box-sizing:border-box;position:relative}.vis-foreground .vis-group:last-child{border-bottom:none}.vis-nesting-group{cursor:pointer}.vis-label.vis-nested-group.vis-group-level-unknown-but-gte1{background:#f5f5f5}.vis-label.vis-nested-group.vis-group-level-0{background-color:#fff}.vis-ltr .vis-label.vis-nested-group.vis-group-level-0 .vis-inner{padding-left:0}.vis-rtl .vis-label.vis-nested-group.vis-group-level-0 .vis-inner{padding-right:0}.vis-label.vis-nested-group.vis-group-level-1{background-color:rgba(0,0,0,.05)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-1 .vis-inner{padding-left:15px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-1 .vis-inner{padding-right:15px}.vis-label.vis-nested-group.vis-group-level-2{background-color:rgba(0,0,0,.1)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-2 .vis-inner{padding-left:30px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-2 .vis-inner{padding-right:30px}.vis-label.vis-nested-group.vis-group-level-3{background-color:rgba(0,0,0,.15)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-3 .vis-inner{padding-left:45px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-3 .vis-inner{padding-right:45px}.vis-label.vis-nested-group.vis-group-level-4{background-color:rgba(0,0,0,.2)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-4 .vis-inner{padding-left:60px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-4 .vis-inner{padding-right:60px}.vis-label.vis-nested-group.vis-group-level-5{background-color:rgba(0,0,0,.25)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-5 .vis-inner{padding-left:75px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-5 .vis-inner{padding-right:75px}.vis-label.vis-nested-group.vis-group-level-6{background-color:rgba(0,0,0,.3)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-6 .vis-inner{padding-left:90px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-6 .vis-inner{padding-right:90px}.vis-label.vis-nested-group.vis-group-level-7{background-color:rgba(0,0,0,.35)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-7 .vis-inner{padding-left:105px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-7 .vis-inner{padding-right:105px}.vis-label.vis-nested-group.vis-group-level-8{background-color:rgba(0,0,0,.4)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-8 .vis-inner{padding-left:120px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-8 .vis-inner{padding-right:120px}.vis-label.vis-nested-group.vis-group-level-9{background-color:rgba(0,0,0,.45)}.vis-ltr .vis-label.vis-nested-group.vis-group-level-9 .vis-inner{padding-left:135px}.vis-rtl .vis-label.vis-nested-group.vis-group-level-9 .vis-inner{padding-right:135px}.vis-label.vis-nested-group{background-color:rgba(0,0,0,.5)}.vis-ltr .vis-label.vis-nested-group .vis-inner{padding-left:150px}.vis-rtl .vis-label.vis-nested-group .vis-inner{padding-right:150px}.vis-group-level-unknown-but-gte1{border:1px solid red}.vis-label.vis-nesting-group:before{display:inline-block;width:15px}.vis-label.vis-nesting-group.expanded:before{content:"\\25BC"}.vis-label.vis-nesting-group.collapsed:before{content:"\\25B6"}.vis-rtl .vis-label.vis-nesting-group.collapsed:before{content:"\\25C0"}.vis-ltr .vis-label:not(.vis-nesting-group):not(.vis-group-level-0){padding-left:15px}.vis-rtl .vis-label:not(.vis-nesting-group):not(.vis-group-level-0){padding-right:15px}.vis-overlay{height:100%;left:0;position:absolute;top:0;width:100%;z-index:10}');function $A(t,e){var i=void 0!==Ic&&Ta(t)||t["@@iterator"];if(!i){if(qc(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return ZA(t,e);var n=Hc(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return ZA(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function ZA(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function KA(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}pP(".vis-labelset{overflow:hidden}.vis-labelset,.vis-labelset .vis-label{box-sizing:border-box;position:relative}.vis-labelset .vis-label{border-bottom:1px solid #bfbfbf;color:#4d4d4d;left:0;top:0;width:100%}.vis-labelset .vis-label.draggable{cursor:pointer}.vis-group-is-dragging{background:rgba(0,0,0,.1)}.vis-labelset .vis-label:last-child{border-bottom:none}.vis-labelset .vis-label .vis-inner{display:inline-block;padding:5px}.vis-labelset .vis-label .vis-inner.vis-hidden{padding:0}");var JA="__ungrouped__",QA="__background__",tI=function(t){a_(i,t);var e=KA(i);function i(t,n){var r;Ma(this,i),(r=e.call(this)).body=t,r.defaultOptions={type:null,orientation:{item:"bottom"},align:"auto",stack:!0,stackSubgroups:!0,groupOrderSwap:function(t,e,i){var n=e.order;e.order=t.order,t.order=n},groupOrder:"order",selectable:!0,multiselect:!1,longSelectPressTime:251,itemsAlwaysDraggable:{item:!1,range:!1},editable:{updateTime:!1,updateGroup:!1,add:!1,remove:!1,overrideItems:!1},groupEditable:{order:!1,add:!1,remove:!1},snap:cP.snap,onDropObjectOnItem:function(t,e,i){i(e)},onAdd:function(t,e){e(t)},onUpdate:function(t,e){e(t)},onMove:function(t,e){e(t)},onRemove:function(t,e){e(t)},onMoving:function(t,e){e(t)},onAddGroup:function(t,e){e(t)},onMoveGroup:function(t,e){e(t)},onRemoveGroup:function(t,e){e(t)},margin:{item:{horizontal:10,vertical:10},axis:20},showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:500},tooltipOnItemUpdateTime:!1},r.options=wE.extend({},r.defaultOptions),r.options.rtl=n.rtl,r.options.onTimeout=n.onTimeout,r.conversion={toScreen:t.util.toScreen,toTime:t.util.toTime},r.dom={},r.props={},r.hammer=null;var o=t_(r);return r.itemsData=null,r.groupsData=null,r.itemsSettingTime=null,r.initialItemSetDrawn=!1,r.userContinueNotBail=null,r.sequentialSelection=!1,r.itemListeners={add:function(t,e,i){o._onAdd(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()},update:function(t,e,i){o._onUpdate(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()},remove:function(t,e,i){o._onRemove(e.items),o.options.cluster&&o.clusterGenerator.setItems(o.items,{applyOnChangedLevel:!1}),o.redraw()}},r.groupListeners={add:function(t,e,i){if(o._onAddGroups(e.items),o.groupsData&&o.groupsData.length>0){var n,r=o.groupsData.getDataSet();Hp(n=r.get()).call(n,(function(t){if(t.nestedGroups){var e;0!=t.showNested&&(t.showNested=!0);var n=[];Hp(e=t.nestedGroups).call(e,(function(e){var i=r.get(e);i&&(i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),n=Yc(n).call(n,i))})),r.update(n,i)}}))}},update:function(t,e,i){o._onUpdateGroups(e.items)},remove:function(t,e,i){o._onRemoveGroups(e.items)}},r.items={},r.groups={},r.groupIds=[],r.selection=[],r.popup=null,r.popupTimer=null,r.touchParams={},r.groupTouchParams={group:null,isDragging:!1},r._create(),r.setOptions(n),r.clusters=[],r}return Yd(i,[{key:"_create",value:function(){var t,e,i,n,r,o,s,a,l,h,u,d,c,p,f,m=this,v=document.createElement("div");v.className="vis-itemset",v["vis-itemset"]=this,this.dom.frame=v;var g=document.createElement("div");g.className="vis-background",v.appendChild(g),this.dom.background=g;var y=document.createElement("div");y.className="vis-foreground",v.appendChild(y),this.dom.foreground=y;var b=document.createElement("div");b.className="vis-axis",this.dom.axis=b;var _=document.createElement("div");_.className="vis-labelset",this.dom.labelSet=_,this._updateUngrouped();var w=new wA(QA,null,this);w.show(),this.groups[QA]=w,this.hammer=new uP(this.body.dom.centerContainer),this.hammer.on("hammer.input",(function(t){t.isFirst&&m._onTouch(t)})),this.hammer.on("panstart",Tp(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",Tp(e=this._onDrag).call(e,this)),this.hammer.on("panend",Tp(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:uP.ALL}),this.hammer.get("press").set({time:1e4}),this.hammer.on("tap",Tp(n=this._onSelectItem).call(n,this)),this.hammer.on("press",Tp(r=this._onMultiSelectItem).call(r,this)),this.hammer.get("press").set({time:1e4}),this.hammer.on("doubletap",Tp(o=this._onAddItem).call(o,this)),this.options.rtl?this.groupHammer=new uP(this.body.dom.rightContainer):this.groupHammer=new uP(this.body.dom.leftContainer),this.groupHammer.on("tap",Tp(s=this._onGroupClick).call(s,this)),this.groupHammer.on("panstart",Tp(a=this._onGroupDragStart).call(a,this)),this.groupHammer.on("panmove",Tp(l=this._onGroupDrag).call(l,this)),this.groupHammer.on("panend",Tp(h=this._onGroupDragEnd).call(h,this)),this.groupHammer.get("pan").set({threshold:5,direction:uP.DIRECTION_VERTICAL}),this.body.dom.centerContainer.addEventListener("mouseover",Tp(u=this._onMouseOver).call(u,this)),this.body.dom.centerContainer.addEventListener("mouseout",Tp(d=this._onMouseOut).call(d,this)),this.body.dom.centerContainer.addEventListener("mousemove",Tp(c=this._onMouseMove).call(c,this)),this.body.dom.centerContainer.addEventListener("contextmenu",Tp(p=this._onDragEnd).call(p,this)),this.body.dom.centerContainer.addEventListener("mousewheel",Tp(f=this._onMouseWheel).call(f,this)),this.show()}},{key:"setOptions",value:function(t){var e=this;if(t){var i,n;wE.selectiveExtend(["type","rtl","align","order","stack","stackSubgroups","selectable","multiselect","sequentialSelection","multiselectPerGroup","longSelectPressTime","groupOrder","dataAttributes","template","groupTemplate","visibleFrameTemplate","hide","snap","groupOrderSwap","showTooltips","tooltip","tooltipOnItemUpdateTime","groupHeightMode","onTimeout"],this.options,t),"itemsAlwaysDraggable"in t&&("boolean"==typeof t.itemsAlwaysDraggable?(this.options.itemsAlwaysDraggable.item=t.itemsAlwaysDraggable,this.options.itemsAlwaysDraggable.range=!1):"object"===Nd(t.itemsAlwaysDraggable)&&(wE.selectiveExtend(["item","range"],this.options.itemsAlwaysDraggable,t.itemsAlwaysDraggable),this.options.itemsAlwaysDraggable.item||(this.options.itemsAlwaysDraggable.range=!1))),"sequentialSelection"in t&&"boolean"==typeof t.sequentialSelection&&(this.options.sequentialSelection=t.sequentialSelection),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.item="top"===t.orientation?"top":"bottom":"object"===Nd(t.orientation)&&"item"in t.orientation&&(this.options.orientation.item=t.orientation.item)),"margin"in t&&("number"==typeof t.margin?(this.options.margin.axis=t.margin,this.options.margin.item.horizontal=t.margin,this.options.margin.item.vertical=t.margin):"object"===Nd(t.margin)&&(wE.selectiveExtend(["axis"],this.options.margin,t.margin),"item"in t.margin&&("number"==typeof t.margin.item?(this.options.margin.item.horizontal=t.margin.item,this.options.margin.item.vertical=t.margin.item):"object"===Nd(t.margin.item)&&wE.selectiveExtend(["horizontal","vertical"],this.options.margin.item,t.margin.item)))),Hp(i=["locale","locales"]).call(i,(function(i){i in t&&(e.options[i]=t[i])})),"editable"in t&&("boolean"==typeof t.editable?(this.options.editable.updateTime=t.editable,this.options.editable.updateGroup=t.editable,this.options.editable.add=t.editable,this.options.editable.remove=t.editable,this.options.editable.overrideItems=!1):"object"===Nd(t.editable)&&wE.selectiveExtend(["updateTime","updateGroup","add","remove","overrideItems"],this.options.editable,t.editable)),"groupEditable"in t&&("boolean"==typeof t.groupEditable?(this.options.groupEditable.order=t.groupEditable,this.options.groupEditable.add=t.groupEditable,this.options.groupEditable.remove=t.groupEditable):"object"===Nd(t.groupEditable)&&wE.selectiveExtend(["order","add","remove"],this.options.groupEditable,t.groupEditable));Hp(n=["onDropObjectOnItem","onAdd","onUpdate","onRemove","onMove","onMoving","onAddGroup","onMoveGroup","onRemoveGroup"]).call(n,(function(i){var n=t[i];if(n){var r;if("function"!=typeof n)throw new Error(Yc(r="option ".concat(i," must be a function ")).call(r,i,"(item, callback)"));e.options[i]=n}})),t.cluster?(Nf(this.options,{cluster:t.cluster}),this.clusterGenerator||(this.clusterGenerator=new qA(this)),this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.clusterGenerator?(this._detachAllClusters(),this.clusters=[],this.clusterGenerator=null,this.options.cluster=void 0,this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.markDirty()}}},{key:"markDirty",value:function(t){this.groupIds=[],t&&(t.refreshItems&&Hp(wE).call(wE,this.items,(function(t){t.dirty=!0,t.displayed&&t.redraw()})),t.restackGroups&&Hp(wE).call(wE,this.groups,(function(t,e){e!==QA&&(t.stackDirty=!0)})))}},{key:"destroy",value:function(){this.clearPopupTimer(),this.hide(),this.setItems(null),this.setGroups(null),this.hammer&&this.hammer.destroy(),this.groupHammer&&this.groupHammer.destroy(),this.hammer=null,this.body=null,this.conversion=null}},{key:"hide",value:function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.axis.parentNode&&this.dom.axis.parentNode.removeChild(this.dom.axis),this.dom.labelSet.parentNode&&this.dom.labelSet.parentNode.removeChild(this.dom.labelSet)}},{key:"show",value:function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame),this.dom.axis.parentNode||this.body.dom.backgroundVertical.appendChild(this.dom.axis),this.dom.labelSet.parentNode||(this.options.rtl?this.body.dom.right.appendChild(this.dom.labelSet):this.body.dom.left.appendChild(this.dom.labelSet))}},{key:"setPopupTimer",value:function(t){if(this.clearPopupTimer(),t){var e=this.options.tooltip.delay||"number"==typeof this.options.tooltip.delay?this.options.tooltip.delay:500;this.popupTimer=Rv((function(){t.show()}),e)}}},{key:"clearPopupTimer",value:function(){null!=this.popupTimer&&(clearTimeout(this.popupTimer),this.popupTimer=null)}},{key:"setSelection",value:function(t){var e;null==t&&(t=[]),qc(t)||(t=[t]);var i,n=mm(e=this.selection).call(e,(function(e){return-1===av(t).call(t,e)})),r=$A(n);try{for(r.s();!(i=r.n()).done;){var o=i.value,s=this.getItemById(o);s&&s.unselect()}}catch(t){r.e(t)}finally{r.f()}this.selection=Ac(t);var a,l=$A(t);try{for(l.s();!(a=l.n()).done;){var h=a.value,u=this.getItemById(h);u&&u.select()}}catch(t){l.e(t)}finally{l.f()}}},{key:"getSelection",value:function(){var t;return Yc(t=this.selection).call(t,[])}},{key:"getVisibleItems",value:function(){var t,e,i=this.body.range.getRange();this.options.rtl?(t=this.body.util.toScreen(i.start),e=this.body.util.toScreen(i.end)):(e=this.body.util.toScreen(i.start),t=this.body.util.toScreen(i.end));var n=[];for(var r in this.groups)if(this.groups.hasOwnProperty(r)){var o,s=this.groups[r],a=$A(s.isVisible?s.visibleItems:[]);try{for(a.s();!(o=a.n()).done;){var l=o.value;this.options.rtl?l.right<e&&l.right+l.width>t&&n.push(l.id):l.left<t&&l.left+l.width>e&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getItemsAtCurrentTime",value:function(t){var e,i;this.options.rtl?(e=this.body.util.toScreen(t),i=this.body.util.toScreen(t)):(i=this.body.util.toScreen(t),e=this.body.util.toScreen(t));var n=[];for(var r in this.groups)if(this.groups.hasOwnProperty(r)){var o,s=this.groups[r],a=$A(s.isVisible?s.visibleItems:[]);try{for(a.s();!(o=a.n()).done;){var l=o.value;this.options.rtl?l.right<i&&l.right+l.width>e&&n.push(l.id):l.left<e&&l.left+l.width>i&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getVisibleGroups",value:function(){var t=[];for(var e in this.groups){if(this.groups.hasOwnProperty(e))this.groups[e].isVisible&&t.push(e)}return t}},{key:"getItemById",value:function(t){var e;return this.items[t]||qP(e=this.clusters).call(e,(function(e){return e.id===t}))}},{key:"_deselect",value:function(t){for(var e=this.selection,i=0,n=e.length;i<n;i++)if(e[i]==t){_f(e).call(e,i,1);break}}},{key:"redraw",value:function(){var t=this.options.margin,e=this.body.range,i=wE.option.asSize,n=this.options,r=n.orientation.item,o=!1,s=this.dom.frame;this.props.top=this.body.domProps.top.height+this.body.domProps.border.top,this.options.rtl?this.props.right=this.body.domProps.right.width+this.body.domProps.border.right:this.props.left=this.body.domProps.left.width+this.body.domProps.border.left,s.className="vis-itemset",this.options.cluster&&this._clusterItems(),o=this._orderGroups()||o;var a=e.end-e.start,l=a!=this.lastVisibleInterval||this.props.width!=this.props.lastWidth,h=e.start!=this.lastRangeStart,u=n.stack!=this.lastStack,d=n.stackSubgroups!=this.lastStackSubgroups,c=l||h||u||d;this.lastVisibleInterval=a,this.lastRangeStart=e.start,this.lastStack=n.stack,this.lastStackSubgroups=n.stackSubgroups,this.props.lastWidth=this.props.width;var p=this._firstGroup(),f={item:t.item,axis:t.axis},m={item:t.item,axis:t.item.vertical/2},v=0,g=t.axis+t.item.vertical;this.groups[QA].redraw(e,m,c);var y={},b=0;if(Hp(wE).call(wE,this.groups,(function(t,i){if(i!==QA){var n=t==p?f:m;y[i]=t.redraw(e,n,c,!0),b=y[i].length}})),b>0){for(var _={},w=function(t){Hp(wE).call(wE,y,(function(e,i){_[i]=e[t]()}))},k=0;k<b;k++)w(k);Hp(wE).call(wE,this.groups,(function(t,e){if(e!==QA){var i=_[e];o=i||o,v+=t.height}})),v=Math.max(v,g)}return v=Math.max(v,g),s.style.height=i(v),this.props.width=s.offsetWidth,this.props.height=v,this.dom.axis.style.top=i("top"==r?this.body.domProps.top.height+this.body.domProps.border.top:this.body.domProps.top.height+this.body.domProps.centerContainer.height),this.options.rtl?this.dom.axis.style.right="0":this.dom.axis.style.left="0",this.hammer.get("press").set({time:this.options.longSelectPressTime}),this.initialItemSetDrawn=!0,o=this._isResized()||o}},{key:"_firstGroup",value:function(){var t="top"==this.options.orientation.item?0:this.groupIds.length-1,e=this.groupIds[t];return this.groups[e]||this.groups[JA]||null}},{key:"_updateUngrouped",value:function(){var t,e,i=this.groups[JA];if(this.groupsData){if(i)for(e in i.dispose(),delete this.groups[JA],this.items)if(this.items.hasOwnProperty(e)){(t=this.items[e]).parent&&t.parent.remove(t);var n=this.getGroupId(t.data),r=this.groups[n];r&&r.add(t)||t.hide()}}else if(!i){for(e in i=new bA(null,null,this),this.groups[JA]=i,this.items)this.items.hasOwnProperty(e)&&(t=this.items[e],i.add(t));i.show()}}},{key:"getLabelSet",value:function(){return this.dom.labelSet}},{key:"setItems",value:function(t){this.itemsSettingTime=new Date;var e,i=this,n=this.itemsData;if(t){if(!pE(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.itemsData=gE(t)}else this.itemsData=null;if(n&&(Hp(wE).call(wE,this.itemListeners,(function(t,e){n.off(e,t)})),n.dispose(),e=n.getIds(),this._onRemove(e)),this.itemsData){var r=this.id;Hp(wE).call(wE,this.itemListeners,(function(t,e){i.itemsData.on(e,t,r)})),e=this.itemsData.getIds(),this._onAdd(e),this._updateUngrouped()}this.body.emitter.emit("_change",{queue:!0})}},{key:"getItems",value:function(){return null!=this.itemsData?this.itemsData.rawDS:null}},{key:"setGroups",value:function(t){var e,i=this;if(this.groupsData&&(Hp(wE).call(wE,this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null,this._onRemoveGroups(e)),t){if(!pE(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var n,r=this.groupsData.getDataSet();Hp(n=r.get()).call(n,(function(t){var e;t.nestedGroups&&Hp(e=t.nestedGroups).call(e,(function(e){var i=r.get(e);i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),r.update(i)}))}));var o=this.id;Hp(wE).call(wE,this.groupListeners,(function(t,e){i.groupsData.on(e,t,o)})),e=this.groupsData.getIds(),this._onAddGroups(e)}this._updateUngrouped(),this._order(),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems(),this.markDirty({refreshItems:!0,restackGroups:!0})),this.body.emitter.emit("_change",{queue:!0})}},{key:"getGroups",value:function(){return this.groupsData}},{key:"removeItem",value:function(t){var e=this,i=this.itemsData.get(t);i&&this.options.onRemove(i,(function(i){i&&e.itemsData.remove(t)}))}},{key:"_getType",value:function(t){return t.type||this.options.type||(t.end?"range":"box")}},{key:"getGroupId",value:function(t){return"background"==this._getType(t)&&null==t.group?QA:this.groupsData?t.group:JA}},{key:"_onUpdate",value:function(t){var e=this,n=this;Hp(t).call(t,(function(t){var r,o=n.itemsData.get(t),s=n.items[t],a=o?n._getType(o):null,l=i.types[a];if(s&&(l&&s instanceof l?n._updateItem(s,o):(r=s.selected,n._removeItem(s),s=null)),!s&&o){if(!l)throw new TypeError('Unknown item type "'.concat(a,'"'));(s=new l(o,n.conversion,n.options)).id=t,n._addItem(s),r&&(e.selection.push(t),s.select())}})),this._order(),this.options.cluster&&(this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this._clusterItems()),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemove",value:function(t){var e=0,i=this;Hp(t).call(t,(function(t){var n=i.items[t];n&&(e++,i._removeItem(n))})),e&&(this._order(),this.body.emitter.emit("_change",{queue:!0}))}},{key:"_order",value:function(){Hp(wE).call(wE,this.groups,(function(t){t.order()}))}},{key:"_onUpdateGroups",value:function(t){this._onAddGroups(t)}},{key:"_onAddGroups",value:function(t){var e=this;Hp(t).call(t,(function(t){var i=e.groupsData.get(t),n=e.groups[t];if(n)n.setData(i);else{if(t==JA||t==QA)throw new Error("Illegal group id. ".concat(t," is a reserved id."));var r=cv(e.options);for(var o in wE.extend(r,{height:null}),n=new bA(t,i,e),e.groups[t]=n,e.items)if(e.items.hasOwnProperty(o)){var s=e.items[o];s.data.group==t&&n.add(s)}n.order(),n.show()}})),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemoveGroups",value:function(t){var e=this;Hp(t).call(t,(function(t){var i=e.groups[t];i&&(i.dispose(),delete e.groups[t])})),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems()),this.markDirty({restackGroups:!!this.options.cluster}),this.body.emitter.emit("_change",{queue:!0})}},{key:"_orderGroups",value:function(){if(this.groupsData){var t=this.groupsData.getIds({order:this.options.groupOrder});t=this._orderNestedGroups(t);var e=!wE.equalArray(t,this.groupIds);if(e){var i=this.groups;Hp(t).call(t,(function(t){i[t].hide()})),Hp(t).call(t,(function(t){i[t].show()})),this.groupIds=t}return e}return!1}},{key:"_orderNestedGroups",value:function(t){var e=this;return function t(e,i){var n=[];return Hp(i).call(i,(function(i){if(n.push(i),e.groupsData.get(i).nestedGroups){var r,o=ep(r=e.groupsData.get({filter:function(t){return t.nestedInGroup==i},order:e.options.groupOrder})).call(r,(function(t){return t.id}));n=Yc(n).call(n,t(e,o))}})),n}(this,mm(t).call(t,(function(t){return!e.groupsData.get(t).nestedInGroup})))}},{key:"_addItem",value:function(t){this.items[t.id]=t;var e=this.getGroupId(t.data),i=this.groups[e];i?i&&i.data&&i.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1,i&&i.add(t)}},{key:"_updateItem",value:function(t,e){t.setData(e);var i=this.getGroupId(t.data),n=this.groups[i];n?n&&n.data&&n.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1}},{key:"_removeItem",value:function(t){var e,i;t.hide(),delete this.items[t.id];var n=av(e=this.selection).call(e,t.id);-1!=n&&_f(i=this.selection).call(i,n,1),t.parent&&t.parent.remove(t),null!=this.popup&&this.popup.hide()}},{key:"_constructByEndArray",value:function(t){for(var e=[],i=0;i<t.length;i++)t[i]instanceof EA&&e.push(t[i]);return e}},{key:"_onTouch",value:function(t){this.touchParams.item=this.itemFromTarget(t),this.touchParams.dragLeftItem=t.target.dragLeftItem||!1,this.touchParams.dragRightItem=t.target.dragRightItem||!1,this.touchParams.itemProps=null}},{key:"_getGroupIndex",value:function(t){for(var e=0;e<this.groupIds.length;e++)if(t==this.groupIds[e])return e}},{key:"_onDragStart",value:function(t){var e=this;if(!this.touchParams.itemIsDragging){var i,n=this.touchParams.item||null,r=this;if(n&&(n.selected||this.options.itemsAlwaysDraggable.item)){if(this.options.editable.overrideItems&&!this.options.editable.updateTime&&!this.options.editable.updateGroup)return;if(null!=n.editable&&!n.editable.updateTime&&!n.editable.updateGroup&&!this.options.editable.overrideItems)return;var o=this.touchParams.dragLeftItem,s=this.touchParams.dragRightItem;if(this.touchParams.itemIsDragging=!0,this.touchParams.selectedItem=n,o)i={item:o,initialX:t.center.x,dragLeft:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(s)i={item:s,initialX:t.center.x,dragRight:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey))this._onDragStartAddItem(t);else{this.groupIds.length<1&&this.redraw();var a=this._getGroupIndex(n.data.group),l=this.options.itemsAlwaysDraggable.item&&!n.selected?[n.id]:this.getSelection();this.touchParams.itemProps=ep(l).call(l,(function(i){var n=r.items[i],o=r._getGroupIndex(n.data.group);return{item:n,initialX:t.center.x,groupOffset:a-o,data:e._cloneItemData(n.data)}}))}t.stopPropagation()}else this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey)&&this._onDragStartAddItem(t)}}},{key:"_onDragStartAddItem",value:function(t){var e=this.options.snap||null,i=this.dom.frame.getBoundingClientRect(),n=this.options.rtl?i.right-t.center.x+10:t.center.x-i.left-10,r=this.body.util.toTime(n),o=this.body.util.getScale(),s=this.body.util.getStep(),a=e?e(r,o,s):r,l={type:"range",start:a,end:a,content:"new item"},h=UM();l[this.itemsData.idProp]=h;var u=this.groupFromTarget(t);u&&(l.group=u.groupId);var d=new EA(l,this.conversion,this.options);d.id=h,d.data=this._cloneItemData(l),this._addItem(d),this.touchParams.selectedItem=d;var c={item:d,initialX:t.center.x,data:d.data};this.options.rtl?c.dragLeft=!0:c.dragRight=!0,this.touchParams.itemProps=[c],t.stopPropagation()}},{key:"_onDrag",value:function(t){var e=this;if(null!=this.popup&&this.options.showTooltips&&!this.popup.hidden){var i=this.body.dom.centerContainer,n=i.getBoundingClientRect();this.popup.setPosition(t.center.x-n.left+i.offsetLeft,t.center.y-n.top+i.offsetTop),this.popup.show()}if(this.touchParams.itemProps){var r;t.stopPropagation();var o=this,s=this.options.snap||null,a=this.body.dom.root.offsetLeft,l=this.options.rtl?a+this.body.domProps.right.width:a+this.body.domProps.left.width,h=this.body.util.getScale(),u=this.body.util.getStep(),d=this.touchParams.selectedItem,c=(this.options.editable.overrideItems||null==d.editable)&&this.options.editable.updateGroup||!this.options.editable.overrideItems&&null!=d.editable&&d.editable.updateGroup,p=null;if(c&&d&&null!=d.data.group){var f=o.groupFromTarget(t);f&&(p=this._getGroupIndex(f.groupId))}Hp(r=this.touchParams.itemProps).call(r,(function(i){var n,r,a,f,m,v=o.body.util.toTime(t.center.x-l),g=o.body.util.toTime(i.initialX-l);n=e.options.rtl?-(v-g):v-g;var y=e._cloneItemData(i.item.data);if(null==i.item.editable||i.item.editable.updateTime||i.item.editable.updateGroup||o.options.editable.overrideItems){if((e.options.editable.overrideItems||null==d.editable)&&e.options.editable.updateTime||!e.options.editable.overrideItems&&null!=d.editable&&d.editable.updateTime)if(i.dragLeft)e.options.rtl?null!=y.end&&(a=wE.convert(i.data.end,"Date"),m=new Date(a.valueOf()+n),y.end=s?s(m,h,u):m):null!=y.start&&(r=wE.convert(i.data.start,"Date"),f=new Date(r.valueOf()+n),y.start=s?s(f,h,u):f);else if(i.dragRight)e.options.rtl?null!=y.start&&(r=wE.convert(i.data.start,"Date"),f=new Date(r.valueOf()+n),y.start=s?s(f,h,u):f):null!=y.end&&(a=wE.convert(i.data.end,"Date"),m=new Date(a.valueOf()+n),y.end=s?s(m,h,u):m);else if(null!=y.start)if(r=wE.convert(i.data.start,"Date").valueOf(),f=new Date(r+n),null!=y.end){var b=(a=wE.convert(i.data.end,"Date")).valueOf()-r.valueOf();y.start=s?s(f,h,u):f,y.end=new Date(y.start.valueOf()+b)}else y.start=s?s(f,h,u):f;if(c&&!i.dragLeft&&!i.dragRight&&null!=p&&null!=y.group){var _=p-i.groupOffset;_=Math.max(0,_),_=Math.min(o.groupIds.length-1,_),y.group=o.groupIds[_]}y=e._cloneItemData(y),o.options.onMoving(y,(function(t){t&&i.item.setData(e._cloneItemData(t,"Date"))}))}})),this.body.emitter.emit("_change")}}},{key:"_moveToGroup",value:function(t,e){var i=this.groups[e];if(i&&i.groupId!=t.data.group){var n=t.parent;n.remove(t),n.order(),t.data.group=i.groupId,i.add(t),i.order()}}},{key:"_onDragEnd",value:function(t){var e=this;if(this.touchParams.itemIsDragging=!1,this.touchParams.itemProps){t.stopPropagation();var i=this,n=this.touchParams.itemProps;this.touchParams.itemProps=null,Hp(n).call(n,(function(t){var n=t.item.id;if(null!=i.itemsData.get(n)){var r=e._cloneItemData(t.item.data);i.options.onMove(r,(function(r){r?(r[e.itemsData.idProp]=n,e.itemsData.update(r)):(t.item.setData(t.data),i.body.emitter.emit("_change"))}))}else i.options.onAdd(t.item.data,(function(e){i._removeItem(t.item),e&&i.itemsData.add(e),i.body.emitter.emit("_change")}))}))}}},{key:"_onGroupClick",value:function(t){var e=this,i=this.groupFromTarget(t);Rv((function(){e.toggleGroupShowNested(i)}),1)}},{key:"toggleGroupShowNested",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;if(t&&t.nestedGroups){var i=this.groupsData.getDataSet();t.showNested=null!=e?!!e:!t.showNested;var n=i.get(t.groupId);n.showNested=t.showNested;for(var r,o=t.nestedGroups,s=o;s.length>0;){var a=s;s=[];for(var l=0;l<a.length;l++){var h=i.get(a[l]);h.nestedGroups&&(s=Yc(s).call(s,h.nestedGroups))}s.length>0&&(o=Yc(o).call(o,s))}if(n.showNested){for(var u=i.get(n.nestedGroups),d=0;d<u.length;d++){var c=u[d];c.nestedGroups&&c.nestedGroups.length>0&&(null==c.showNested||1==c.showNested)&&u.push.apply(u,Ac(i.get(c.nestedGroups)))}r=ep(u).call(u,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}))}else{var p;r=ep(p=i.get(o)).call(p,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!n.showNested,t}))}i.update(Yc(r).call(r,n)),n.showNested?(wE.removeClassName(t.dom.label,"collapsed"),wE.addClassName(t.dom.label,"expanded")):(wE.removeClassName(t.dom.label,"expanded"),wE.addClassName(t.dom.label,"collapsed"))}}},{key:"toggleGroupDragClassName",value:function(t){t.dom.label.classList.toggle("vis-group-is-dragging"),t.dom.foreground.classList.toggle("vis-group-is-dragging")}},{key:"_onGroupDragStart",value:function(t){this.groupTouchParams.isDragging||this.options.groupEditable.order&&(this.groupTouchParams.group=this.groupFromTarget(t),this.groupTouchParams.group&&(t.stopPropagation(),this.groupTouchParams.isDragging=!0,this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.originalOrder=this.groupsData.getIds({order:this.options.groupOrder})))}},{key:"_onGroupDrag",value:function(t){if(this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this.groupsData.getDataSet(),i=this.groupFromTarget(t);if(i&&i.height!=this.groupTouchParams.group.height){var n=i.top<this.groupTouchParams.group.top,r=t.center?t.center.y:t.clientY,o=i.dom.foreground.getBoundingClientRect(),s=this.groupTouchParams.group.height;if(n){if(o.top+s<r)return}else{var a=i.height;if(o.top+a-s>r)return}}if(i&&i!=this.groupTouchParams.group){var l=e.get(i.groupId),h=e.get(this.groupTouchParams.group.groupId);h&&l&&(this.options.groupOrderSwap(h,l,e),e.update(h),e.update(l));var u=e.getIds({order:this.options.groupOrder});if(!wE.equalArray(u,this.groupTouchParams.originalOrder))for(var d=this.groupTouchParams.originalOrder,c=this.groupTouchParams.group.groupId,p=Math.min(d.length,u.length),f=0,m=0,v=0;f<p;){for(;f+m<p&&f+v<p&&u[f+m]==d[f+v];)f++;if(f+m>=p)break;if(u[f+m]==c)m=1;else if(d[f+v]==c)v=1;else{var g=av(u).call(u,d[f+v]),y=e.get(u[f+m]),b=e.get(d[f+v]);this.options.groupOrderSwap(y,b,e),e.update(y),e.update(b);var _=u[f+m];u[f+m]=d[f+v],u[g]=_,f++}}}}}},{key:"_onGroupDragEnd",value:function(t){if(this.groupTouchParams.isDragging=!1,this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this,i=e.groupTouchParams.group.groupId,n=e.groupsData.getDataSet(),r=wE.extend({},n.get(i));e.options.onMoveGroup(r,(function(t){if(t)t[n._idProp]=i,n.update(t);else{var r=n.getIds({order:e.options.groupOrder});if(!wE.equalArray(r,e.groupTouchParams.originalOrder))for(var o=e.groupTouchParams.originalOrder,s=Math.min(o.length,r.length),a=0;a<s;){for(;a<s&&r[a]==o[a];)a++;if(a>=s)break;var l=av(r).call(r,o[a]),h=n.get(r[a]),u=n.get(o[a]);e.options.groupOrderSwap(h,u,n),n.update(h),n.update(u);var d=r[a];r[a]=o[a],r[l]=d,a++}}})),e.body.emitter.emit("groupDragged",{groupId:i}),this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.group=null}}},{key:"_onSelectItem",value:function(t){if(this.options.selectable){var e=t.srcEvent&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey),i=t.srcEvent&&t.srcEvent.shiftKey;if(e||i)this._onMultiSelectItem(t);else{var n=this.getSelection(),r=this.itemFromTarget(t),o=r&&r.selectable?[r.id]:[];this.setSelection(o);var s=this.getSelection();(s.length>0||n.length>0)&&this.body.emitter.emit("select",{items:s,event:t})}}}},{key:"_onMouseOver",value:function(t){var e=this.itemFromTarget(t);if(e&&e!==this.itemFromRelatedTarget(t)){var i=e.getTitle();if(this.options.showTooltips&&i){null==this.popup&&(this.popup=new IA(this.body.dom.root,this.options.tooltip.overflowMethod||"flip")),this.popup.setText(i);var n=this.body.dom.centerContainer,r=n.getBoundingClientRect();this.popup.setPosition(t.clientX-r.left+n.offsetLeft,t.clientY-r.top+n.offsetTop),this.setPopupTimer(this.popup)}else this.clearPopupTimer(),null!=this.popup&&this.popup.hide();this.body.emitter.emit("itemover",{item:e.id,event:t})}}},{key:"_onMouseOut",value:function(t){var e=this.itemFromTarget(t);e&&(e!==this.itemFromRelatedTarget(t)&&(this.clearPopupTimer(),null!=this.popup&&this.popup.hide(),this.body.emitter.emit("itemout",{item:e.id,event:t})))}},{key:"_onMouseMove",value:function(t){if(this.itemFromTarget(t)&&(null!=this.popupTimer&&this.setPopupTimer(this.popup),this.options.showTooltips&&this.options.tooltip.followMouse&&this.popup&&!this.popup.hidden)){var e=this.body.dom.centerContainer,i=e.getBoundingClientRect();this.popup.setPosition(t.clientX-i.left+e.offsetLeft,t.clientY-i.top+e.offsetTop),this.popup.show()}}},{key:"_onMouseWheel",value:function(t){this.touchParams.itemIsDragging&&this._onDragEnd(t)}},{key:"_onUpdateItem",value:function(t){if(this.options.selectable&&(this.options.editable.updateTime||this.options.editable.updateGroup)){var e=this;if(t){var i=e.itemsData.get(t.id);this.options.onUpdate(i,(function(t){t&&e.itemsData.update(t)}))}}}},{key:"_onDropObjectOnItem",value:function(t){var e=this.itemFromTarget(t),i=JSON.parse(t.dataTransfer.getData("text"));this.options.onDropObjectOnItem(i,e)}},{key:"_onAddItem",value:function(t){if(this.options.selectable&&this.options.editable.add){var e,i,n=this,r=this.options.snap||null,o=this.dom.frame.getBoundingClientRect(),s=this.options.rtl?o.right-t.center.x:t.center.x-o.left,a=this.body.util.toTime(s),l=this.body.util.getScale(),h=this.body.util.getStep();"drop"==t.type?((i=JSON.parse(t.dataTransfer.getData("text"))).content=i.content?i.content:"new item",i.start=i.start?i.start:r?r(a,l,h):a,i.type=i.type||"box",i[this.itemsData.idProp]=i.id||UM(),"range"!=i.type||i.end||(e=this.body.util.toTime(s+this.props.width/5),i.end=r?r(e,l,h):e)):((i={start:r?r(a,l,h):a,content:"new item"})[this.itemsData.idProp]=UM(),"range"===this.options.type&&(e=this.body.util.toTime(s+this.props.width/5),i.end=r?r(e,l,h):e));var u=this.groupFromTarget(t);u&&(i.group=u.groupId),i=this._cloneItemData(i),this.options.onAdd(i,(function(e){e&&(n.itemsData.add(e),"drop"==t.type&&n.setSelection([e.id]))}))}}},{key:"_onMultiSelectItem",value:function(t){var e=this;if(this.options.selectable){var n=this.itemFromTarget(t);if(n){var r=this.options.multiselect?this.getSelection():[];if((t.srcEvent&&t.srcEvent.shiftKey||!1||this.options.sequentialSelection)&&this.options.multiselect){var o=this.itemsData.get(n.id).group,s=void 0;this.options.multiselectPerGroup&&r.length>0&&(s=this.itemsData.get(r[0]).group),this.options.multiselectPerGroup&&null!=s&&s!=o||r.push(n.id);var a=i._getItemRange(this.itemsData.get(r));if(!this.options.multiselectPerGroup||s==o)for(var l in r=[],this.items)if(this.items.hasOwnProperty(l)){var h=this.items[l],u=h.data.start,d=void 0!==h.data.end?h.data.end:u;!(u>=a.min&&d<=a.max)||this.options.multiselectPerGroup&&s!=this.itemsData.get(h.id).group||h instanceof AA||r.push(h.id)}}else{var c=av(r).call(r,n.id);-1==c?r.push(n.id):_f(r).call(r,c,1)}var p=mm(r).call(r,(function(t){return e.getItemById(t).selectable}));this.setSelection(p),this.body.emitter.emit("select",{items:this.getSelection(),event:t})}}}},{key:"itemFromElement",value:function(t){for(var e=t;e;){if(e.hasOwnProperty("vis-item"))return e["vis-item"];e=e.parentNode}return null}},{key:"itemFromTarget",value:function(t){return this.itemFromElement(t.target)}},{key:"itemFromRelatedTarget",value:function(t){return this.itemFromElement(t.relatedTarget)}},{key:"groupFromTarget",value:function(t){var e=t.center?t.center.y:t.clientY,i=this.groupIds;i.length<=0&&this.groupsData&&(i=this.groupsData.getIds({order:this.options.groupOrder}));for(var n=0;n<i.length;n++){var r=i[n],o=this.groups[r],s=o.dom.foreground,a=s.getBoundingClientRect();if(e>=a.top&&e<a.top+s.offsetHeight)return o;if("top"===this.options.orientation.item){if(n===this.groupIds.length-1&&e>a.top)return o}else if(0===n&&e<a.top+s.offset)return o}return null}},{key:"_cloneItemData",value:function(t,e){var i=wE.extend({},t);return e||(e=this.itemsData.type),null!=i.start&&(i.start=wE.convert(i.start,e&&e.start||"Date")),null!=i.end&&(i.end=wE.convert(i.end,e&&e.end||"Date")),i}},{key:"_clusterItems",value:function(){if(this.options.cluster){var t=this.body.range.conversion(this.body.domProps.center.width).scale,e=this.clusterGenerator.getClusters(this.clusters,t,this.options.cluster);if(this.clusters!=e){if(this._detachAllClusters(),e){var i,n=$A(e);try{for(n.s();!(i=n.n()).done;){i.value.attach()}}catch(t){n.e(t)}finally{n.f()}this.clusters=e}this._updateClusters(e)}}}},{key:"_detachAllClusters",value:function(){if(this.options.cluster&&this.clusters&&this.clusters.length){var t,e=$A(this.clusters);try{for(e.s();!(t=e.n()).done;){t.value.detach()}}catch(t){e.e(t)}finally{e.f()}}}},{key:"_updateClusters",value:function(t){if(this.clusters&&this.clusters.length){var e,i,n=new LC(ep(t).call(t,(function(t){return t.id}))),r=mm(e=this.clusters).call(e,(function(t){return!n.has(t.id)})),o=!1,s=$A(r);try{for(s.s();!(i=s.n()).done;){var a,l,h=i.value,u=av(a=this.selection).call(a,h.id);if(-1!==u)h.unselect(),_f(l=this.selection).call(l,u,1),o=!0}}catch(t){s.e(t)}finally{s.f()}if(o){var d=this.getSelection();this.body.emitter.emit("select",{items:d,event:event})}}this.clusters=t||[]}}],[{key:"_getItemRange",value:function(t){var e=null,i=null;return Hp(t).call(t,(function(t){(null==i||t.start<i)&&(i=t.start),null!=t.end?(null==e||t.end>e)&&(e=t.end):(null==e||t.start>e)&&(e=t.start)})),{min:i,max:e}}},{key:"itemSetFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("vis-itemset"))return e["vis-itemset"];e=e.parentNode}return null}}]),i}(IE);tI.types={background:AA,box:CA,range:EA,point:MA},tI.prototype._onAdd=tI.prototype._onUpdate;var eI,iI=!1,nI="background: #FFeeee; color: #dd0000",rI=function(){function t(){Ma(this,t)}return Yd(t,null,[{key:"validate",value:function(e,i,n){iI=!1,eI=i;var r=i;return void 0!==n&&(r=i[n]),t.parse(e,r,[]),iI}},{key:"parse",value:function(e,i,n){for(var r in e)e.hasOwnProperty(r)&&t.check(r,e,i,n)}},{key:"check",value:function(e,i,n,r){if(void 0!==n[e]||void 0!==n.__any__){var o=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(o="__any__",s="object"===t.getType(i[e]));var a=n[o];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,o,a,r)}else t.getSuggestion(e,n,r)}},{key:"checkFields",value:function(e,i,n,r,o,s){var a=function(i){console.log("%c"+i+t.printLocation(s,e),nI)},l=t.getType(i[e]),h=o[l];void 0!==h?"array"===t.getType(h)&&-1===av(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),iI=!0):"object"===l&&"__any__"!==r&&(s=wE.copyAndExtendArray(s,e),t.parse(i[e],n[r],s)):void 0===o.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(rp(o))+". Received ["+l+'] "'+i[e]+'"'),iI=!0)}},{key:"getType",value:function(t){var e=Nd(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":qc(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var r,o=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,eI,[],!0);r=void 0!==o.indexMatch?" in "+t.printLocation(o.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+o.indexMatch+'"?\n\n':s.distance<=4&&o.distance>s.distance?" in "+t.printLocation(o.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):o.distance<=8?'. Did you mean "'+o.closestMatch+'"?'+t.printLocation(o.path,e):". Did you mean one of these: "+t.print(rp(i))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+r,nI),iI=!0}},{key:"findInOptions",value:function(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var d=void 0;if(void 0!==i[u].__type__&&!0===r){var c=t.findInOptions(e,i[u],wE.copyAndExtendArray(n,u));o>c.distance&&(s=c.closestMatch,a=c.path,o=c.distance,h=c.indexMatch)}else{var p;-1!==av(p=u.toLowerCase()).call(p,l)&&(h=u),o>(d=t.levenshteinDistance(e,u))&&(s=u,a=wE.copyArray(n),o=d)}}return{closestMatch:s,path:a,distance:o,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i="\n\n"+(arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n")+"options = {\n",n=0;n<t.length;n++){for(var r=0;r<n+1;r++)i+="  ";i+=t[n]+": {\n"}for(var o=0;o<t.length+1;o++)i+="  ";i+=e+"\n";for(var s=0;s<t.length+1;s++){for(var a=0;a<t.length-s;a++)i+="  ";i+="}\n"}return i+"\n\n"}},{key:"print",value:function(t){return vv(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,r=[];for(i=0;i<=e.length;i++)r[i]=[i];for(n=0;n<=t.length;n++)r[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?r[i][n]=r[i-1][n-1]:r[i][n]=Math.min(r[i-1][n-1]+1,Math.min(r[i][n-1]+1,r[i-1][n]+1));return r[e.length][t.length]}}]),t}(),oI="string",sI="boolean",aI="number",lI="array",hI="date",uI="object",dI="moment",cI={configure:{enabled:{boolean:sI},filter:{boolean:sI,function:"function"},container:{dom:"dom"},__type__:{object:uI,boolean:sI,function:"function"}},align:{string:oI},alignCurrentTime:{string:oI,undefined:"undefined"},rtl:{boolean:sI,undefined:"undefined"},rollingMode:{follow:{boolean:sI},offset:{number:aI,undefined:"undefined"},__type__:{object:uI}},onTimeout:{timeoutMs:{number:aI},callback:{function:"function"},__type__:{object:uI}},verticalScroll:{boolean:sI,undefined:"undefined"},horizontalScroll:{boolean:sI,undefined:"undefined"},autoResize:{boolean:sI},throttleRedraw:{number:aI},clickToUse:{boolean:sI},dataAttributes:{string:oI,array:lI},editable:{add:{boolean:sI,undefined:"undefined"},remove:{boolean:sI,undefined:"undefined"},updateGroup:{boolean:sI,undefined:"undefined"},updateTime:{boolean:sI,undefined:"undefined"},overrideItems:{boolean:sI,undefined:"undefined"},__type__:{boolean:sI,object:uI}},end:{number:aI,date:hI,string:oI,moment:dI},format:{minorLabels:{millisecond:{string:oI,undefined:"undefined"},second:{string:oI,undefined:"undefined"},minute:{string:oI,undefined:"undefined"},hour:{string:oI,undefined:"undefined"},weekday:{string:oI,undefined:"undefined"},day:{string:oI,undefined:"undefined"},week:{string:oI,undefined:"undefined"},month:{string:oI,undefined:"undefined"},year:{string:oI,undefined:"undefined"},__type__:{object:uI,function:"function"}},majorLabels:{millisecond:{string:oI,undefined:"undefined"},second:{string:oI,undefined:"undefined"},minute:{string:oI,undefined:"undefined"},hour:{string:oI,undefined:"undefined"},weekday:{string:oI,undefined:"undefined"},day:{string:oI,undefined:"undefined"},week:{string:oI,undefined:"undefined"},month:{string:oI,undefined:"undefined"},year:{string:oI,undefined:"undefined"},__type__:{object:uI,function:"function"}},__type__:{object:uI}},moment:{function:"function"},groupHeightMode:{string:oI},groupOrder:{string:oI,function:"function"},groupEditable:{add:{boolean:sI,undefined:"undefined"},remove:{boolean:sI,undefined:"undefined"},order:{boolean:sI,undefined:"undefined"},__type__:{boolean:sI,object:uI}},groupOrderSwap:{function:"function"},height:{string:oI,number:aI},hiddenDates:{start:{date:hI,number:aI,string:oI,moment:dI},end:{date:hI,number:aI,string:oI,moment:dI},repeat:{string:oI},__type__:{object:uI,array:lI}},itemsAlwaysDraggable:{item:{boolean:sI,undefined:"undefined"},range:{boolean:sI,undefined:"undefined"},__type__:{boolean:sI,object:uI}},limitSize:{boolean:sI},locale:{string:oI},locales:{__any__:{any:"any"},__type__:{object:uI}},longSelectPressTime:{number:aI},margin:{axis:{number:aI},item:{horizontal:{number:aI,undefined:"undefined"},vertical:{number:aI,undefined:"undefined"},__type__:{object:uI,number:aI}},__type__:{object:uI,number:aI}},max:{date:hI,number:aI,string:oI,moment:dI},maxHeight:{number:aI,string:oI},maxMinorChars:{number:aI},min:{date:hI,number:aI,string:oI,moment:dI},minHeight:{number:aI,string:oI},moveable:{boolean:sI},multiselect:{boolean:sI},multiselectPerGroup:{boolean:sI},onAdd:{function:"function"},onDropObjectOnItem:{function:"function"},onUpdate:{function:"function"},onMove:{function:"function"},onMoving:{function:"function"},onRemove:{function:"function"},onAddGroup:{function:"function"},onMoveGroup:{function:"function"},onRemoveGroup:{function:"function"},onInitialDrawComplete:{function:"function"},order:{function:"function"},orientation:{axis:{string:oI,undefined:"undefined"},item:{string:oI,undefined:"undefined"},__type__:{string:oI,object:uI}},selectable:{boolean:sI},sequentialSelection:{boolean:sI},showCurrentTime:{boolean:sI},showMajorLabels:{boolean:sI},showMinorLabels:{boolean:sI},showWeekScale:{boolean:sI},stack:{boolean:sI},stackSubgroups:{boolean:sI},cluster:{maxItems:{number:aI,undefined:"undefined"},titleTemplate:{string:oI,undefined:"undefined"},clusterCriteria:{function:"function",undefined:"undefined"},showStipes:{boolean:sI,undefined:"undefined"},fitOnDoubleClick:{boolean:sI,undefined:"undefined"},__type__:{boolean:sI,object:uI}},snap:{function:"function",null:"null"},start:{date:hI,number:aI,string:oI,moment:dI},template:{function:"function"},loadingScreenTemplate:{function:"function"},groupTemplate:{function:"function"},visibleFrameTemplate:{string:oI,function:"function"},showTooltips:{boolean:sI},tooltip:{followMouse:{boolean:sI},overflowMethod:{string:["cap","flip","none"]},delay:{number:aI},template:{function:"function"},__type__:{object:uI}},tooltipOnItemUpdateTime:{template:{function:"function"},__type__:{boolean:sI,object:uI}},timeAxis:{scale:{string:oI,undefined:"undefined"},step:{number:aI,undefined:"undefined"},__type__:{object:uI}},type:{string:oI},width:{string:oI,number:aI},preferZoom:{boolean:sI},zoomable:{boolean:sI},zoomKey:{string:["ctrlKey","altKey","shiftKey","metaKey",""]},zoomFriction:{number:aI},zoomMax:{number:aI},zoomMin:{number:aI},xss:{disabled:{boolean:sI},filterOptions:{__any__:{any:"any"},__type__:{object:uI}},__type__:{object:uI}},__type__:{object:uI}},pI={global:{align:["center","left","right"],alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],direction:!1,autoResize:!0,clickToUse:!1,editable:{add:!1,remove:!1,updateGroup:!1,updateTime:!1},end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}},groupHeightMode:["auto","fixed","fitItems"],groupsDraggable:!1,height:"",locale:"",longSelectPressTime:251,margin:{axis:[20,0,100,1],item:{horizontal:[10,0,100,1],vertical:[10,0,100,1]}},max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!1,multiselect:!1,multiselectPerGroup:!1,orientation:{axis:["both","bottom","top"],item:["bottom","top"]},preferZoom:!1,selectable:!0,showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,stack:!0,stackSubgroups:!0,cluster:!1,start:"",showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:[500,0,99999,100]},tooltipOnItemUpdateTime:!1,type:["box","point","range","background"],width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","shiftKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],xss:{disabled:!1}}},fI={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},mI=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Ma(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Yd(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return fI[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===wE.isString(t)){if(!0===wE.isValidRGB(t)){var r=t.substr(4).substr(0,t.length-5).split(",");i={r:r[0],g:r[1],b:r[2],a:1}}else if(!0===wE.isValidRGBA(t)){var o=t.substr(5).substr(0,t.length-6).split(",");i={r:o[0],g:o[1],b:o[2],a:o[3]}}else if(!0===wE.isValidHex(t)){var s=wE.hexToRGB(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+vv(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this;!0===(!(arguments.length>0&&void 0!==arguments[0])||arguments[0])&&(this.previousColor=wE.extend({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Rv((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){!0===(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(this.initialColor=wE.extend({},t)),this.color=t;var e=wE.RGBToHSV(t.r,t.g,t.b),i=2*Math.PI,n=this.r*e.s,r=this.centerCoordinates.x+n*Math.sin(i*e.h),o=this.centerCoordinates.y+n*Math.cos(i*e.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=o-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=wE.RGBToHSV(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=wE.HSVToRGB(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=wE.RGBToHSV(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,r=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,r),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),Vv(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var r=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(r.webkitBackingStorePixelRatio||r.mozBackingStorePixelRatio||r.msBackingStorePixelRatio||r.oBackingStorePixelRatio||r.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var o=document.createElement("DIV");o.style.color="red",o.style.fontWeight="bold",o.style.padding="10px",o.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(o)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=Tp(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=Tp(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=Tp(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=Tp(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new uP(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),dP(this.hammer,(function(e){t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,r,o=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,o,s),this.centerCoordinates={x:.5*o,y:.5*s},this.r=.49*o;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(r=0;r<this.r;r++)e=this.centerCoordinates.x+r*Math.sin(l*n),i=this.centerCoordinates.y+r*Math.cos(l*n),a=wE.HSVToRGB(.002777777777777778*n,r*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,o,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,r=.5*this.colorPickerDiv.clientHeight,o=.5*this.colorPickerDiv.clientWidth,s=i-o,a=n-r,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),o),u=Math.cos(l)*h+r,d=Math.sin(l)*h+o;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=d-.5*this.colorPickerSelector.clientWidth+"px";var c=l/(2*Math.PI);c=c<0?c+1:c;var p=h/this.r,f=wE.RGBToHSV(this.color.r,this.color.g,this.color.b);f.h=c,f.s=p;var m=wE.HSVToRGB(f.h,f.s,f.v);m.a=this.color.a,this.color=m,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}();pP('div.vis-configuration{display:block;float:left;font-size:12px;position:relative}div.vis-configuration-wrapper{display:block;width:700px}div.vis-configuration-wrapper:after{clear:both;content:"";display:block}div.vis-configuration.vis-config-option-container{background-color:#fff;border:2px solid #f7f8fa;border-radius:4px;display:block;left:10px;margin-top:20px;padding-left:5px;width:495px}div.vis-configuration.vis-config-button{background-color:#f7f8fa;border:2px solid #ceced0;border-radius:4px;cursor:pointer;display:block;height:25px;left:10px;line-height:25px;margin-bottom:30px;margin-top:20px;padding-left:5px;vertical-align:middle;width:495px}div.vis-configuration.vis-config-button.hover{background-color:#4588e6;border:2px solid #214373;color:#fff}div.vis-configuration.vis-config-item{display:block;float:left;height:25px;line-height:25px;vertical-align:middle;width:495px}div.vis-configuration.vis-config-item.vis-config-s2{background-color:#f7f8fa;border-radius:3px;left:10px;padding-left:5px}div.vis-configuration.vis-config-item.vis-config-s3{background-color:#e4e9f0;border-radius:3px;left:20px;padding-left:5px}div.vis-configuration.vis-config-item.vis-config-s4{background-color:#cfd8e6;border-radius:3px;left:30px;padding-left:5px}div.vis-configuration.vis-config-header{font-size:18px;font-weight:700}div.vis-configuration.vis-config-label{height:25px;line-height:25px;width:120px}div.vis-configuration.vis-config-label.vis-config-s3{width:110px}div.vis-configuration.vis-config-label.vis-config-s4{width:100px}div.vis-configuration.vis-config-colorBlock{border:1px solid #444;border-radius:2px;cursor:pointer;height:19px;margin:0;padding:0;top:1px;width:30px}input.vis-configuration.vis-config-checkbox{left:-5px}input.vis-configuration.vis-config-rangeinput{margin:0;padding:1px;pointer-events:none;position:relative;top:-5px;width:60px}input.vis-configuration.vis-config-range{-webkit-appearance:none;background-color:transparent;border:0 solid #fff;height:20px;width:300px}input.vis-configuration.vis-config-range::-webkit-slider-runnable-track{background:#dedede;background:-moz-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#dedede),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#dedede,#c8c8c8 99%);background:-o-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:linear-gradient(180deg,#dedede 0,#c8c8c8 99%);border:1px solid #999;border-radius:3px;box-shadow:0 0 3px 0 #aaa;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#dedede",endColorstr="#c8c8c8",GradientType=0);height:5px;width:300px}input.vis-configuration.vis-config-range::-webkit-slider-thumb{-webkit-appearance:none;background:#3876c2;background:-moz-linear-gradient(top,#3876c2 0,#385380 100%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#3876c2),color-stop(100%,#385380));background:-webkit-linear-gradient(top,#3876c2,#385380);background:-o-linear-gradient(top,#3876c2 0,#385380 100%);background:-ms-linear-gradient(top,#3876c2 0,#385380 100%);background:linear-gradient(180deg,#3876c2 0,#385380);border:1px solid #14334b;border-radius:50%;box-shadow:0 0 1px 0 #111927;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#3876c2",endColorstr="#385380",GradientType=0);height:17px;margin-top:-7px;width:17px}input.vis-configuration.vis-config-range:focus{outline:none}input.vis-configuration.vis-config-range:focus::-webkit-slider-runnable-track{background:#9d9d9d;background:-moz-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#9d9d9d),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#9d9d9d,#c8c8c8 99%);background:-o-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#9d9d9d 0,#c8c8c8 99%);background:linear-gradient(180deg,#9d9d9d 0,#c8c8c8 99%);filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#9d9d9d",endColorstr="#c8c8c8",GradientType=0)}input.vis-configuration.vis-config-range::-moz-range-track{background:#dedede;background:-moz-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-webkit-gradient(linear,left top,left bottom,color-stop(0,#dedede),color-stop(99%,#c8c8c8));background:-webkit-linear-gradient(top,#dedede,#c8c8c8 99%);background:-o-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:-ms-linear-gradient(top,#dedede 0,#c8c8c8 99%);background:linear-gradient(180deg,#dedede 0,#c8c8c8 99%);border:1px solid #999;border-radius:3px;box-shadow:0 0 3px 0 #aaa;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#dedede",endColorstr="#c8c8c8",GradientType=0);height:10px;width:300px}input.vis-configuration.vis-config-range::-moz-range-thumb{background:#385380;border:none;border-radius:50%;height:16px;width:16px}input.vis-configuration.vis-config-range:-moz-focusring{outline:1px solid #fff;outline-offset:-1px}input.vis-configuration.vis-config-range::-ms-track{background:transparent;border-color:transparent;border-width:6px 0;color:transparent;height:5px;width:300px}input.vis-configuration.vis-config-range::-ms-fill-lower{background:#777;border-radius:10px}input.vis-configuration.vis-config-range::-ms-fill-upper{background:#ddd;border-radius:10px}input.vis-configuration.vis-config-range::-ms-thumb{background:#385380;border:none;border-radius:50%;height:16px;width:16px}input.vis-configuration.vis-config-range:focus::-ms-fill-lower{background:#888}input.vis-configuration.vis-config-range:focus::-ms-fill-upper{background:#ccc}.vis-configuration-popup{background:rgba(57,76,89,.85);border:2px solid #f2faff;border-radius:4px;color:#fff;font-size:14px;height:30px;line-height:30px;position:absolute;text-align:center;-webkit-transition:opacity .3s ease-in-out;-moz-transition:opacity .3s ease-in-out;transition:opacity .3s ease-in-out;width:150px}.vis-configuration-popup:after,.vis-configuration-popup:before{border:solid transparent;content:" ";height:0;left:100%;pointer-events:none;position:absolute;top:50%;width:0}.vis-configuration-popup:after{border-color:rgba(136,183,213,0) rgba(136,183,213,0) rgba(136,183,213,0) rgba(57,76,89,.85);border-width:8px;margin-top:-8px}.vis-configuration-popup:before{border-color:rgba(194,225,245,0) rgba(194,225,245,0) rgba(194,225,245,0) #f2faff;border-width:12px;margin-top:-12px}');var vI=function(){function t(e,i,n){var r=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;Ma(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},wE.extend(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new mI(r),this.wrapper=void 0}return Yd(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(qc(t))this.options.filter=t.join();else if("object"===Nd(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==mm(t)&&(this.options.filter=mm(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===mm(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=mm(this.options),e=0,i=!1;for(var n in this.configureOptions)this.configureOptions.hasOwnProperty(n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===av(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),r=1;r<i;r++)n[r-1]=arguments[r];return Hp(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerHTML=wE.xss(t),this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");return n.className="vis-configuration vis-config-label vis-config-s"+e.length,n.innerHTML=!0===i?wE.xss("<i><b>"+t+":</b></i>"):wE.xss(t+":"),n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var r=0;void 0!==e&&-1!==av(t).call(t,e)&&(r=av(t).call(t,e));for(var o=0;o<t.length;o++){var s=document.createElement("option");s.value=t[o],o===r&&(s.selected="selected"),s.innerHTML=t[o],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],r=t[1],o=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=r,a.max=o}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){var u=1.2;e<0&&e*u<r?(a.min=Math.ceil(e*u),h=a.min,l="range increased"):e/u<r&&(a.min=Math.ceil(e/u),h=a.min,l="range increased"),e*u>o&&1!==o&&(a.max=Math.ceil(e*u),h=a.max,l="range increased"),a.value=e}else a.value=n;var d=document.createElement("input");d.className="vis-configuration vis-config-rangeinput",d.value=Number(a.value);var c=this;a.onchange=function(){d.value=this.value,c._update(Number(this.value),i)},a.oninput=function(){d.value=this.value};var p=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,p,a,d);""!==l&&this.popupHistory[f]!==h&&(this.popupHistory[f]=h,this._setupPopup(l,f))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerHTML=wE.xss(t),n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Rv((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Rv((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Nd(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var r=this;n.onchange=function(){r._update(this.checked,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var r=this;n.onchange=function(){r._update(this.value,i)};var o=this._makeLabel(i[i.length-1],i);this._makeItem(i,o,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,r=t[1],o=document.createElement("div");"none"!==(e=void 0===e?r:e)?(o.className="vis-configuration vis-config-colorBlock",o.style.backgroundColor=e):o.className="vis-configuration vis-config-colorBlock none",e=void 0===e?r:e,o.onclick=function(){n._showColorPicker(e,o,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var r="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=r,n._update(r,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,r=mm(this.options),o=!1;for(var s in t)if(t.hasOwnProperty(s)){n=!0;var a=t[s],l=wE.copyAndExtendArray(e,s);if("function"==typeof r&&!1===(n=r(s,e))&&!qc(a)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){o=!0;var h=this._getValue(l);if(qc(a))this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){var u=!0;if(-1!==av(e).call(e,"physics")&&this.moduleOptions.physics.solver!==s&&(u=!1),!0===u)if(void 0!==a.enabled){var d=wE.copyAndExtendArray(l,"enabled"),c=this._getValue(d);if(!0===c){var p=this._makeLabel(s,l,!0);this._makeItem(l,p),o=this._handleObject(a,l)||o}else this._makeCheckbox(a,c,l)}else{var f=this._makeLabel(s,l,!0);this._makeItem(l,f),o=this._handleObject(a,l)||o}}else console.error("dont know how to handle",a,s,l)}}return o}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var r=0;r<e.length;r++)"global"!==e[r]&&(void 0===n[e[r]]&&(n[e[r]]={}),r!==e.length-1?n=n[e[r]]:n[e[r]]=t);return i}},{key:"_printOptions",value:function(){var t=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+vv(t,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}();function gI(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}var yI=function(t){a_(i,t);var e=gI(i);function i(t,n,r,o){var s,a,l,h,u,d,c,p;if(Ma(this,i),(p=e.call(this)).initTime=new Date,p.itemsDone=!1,!(t_(p)instanceof i))throw new SyntaxError("Constructor must be called with the new operator");if(!qc(r)&&!pE(r)&&r instanceof Object){var f=o;o=r,r=f}o&&o.throttleRedraw&&console.warn('Timeline option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var m=t_(p);if(p.defaultOptions={autoResize:!0,longSelectPressTime:251,orientation:{axis:"bottom",item:"bottom"},moment:sO},p.options=wE.deepExtend({},p.defaultOptions),o&&wE.setupXSSProtection(o.xss),p._create(t),!o||o&&void 0===o.rtl){var v;p.dom.root.style.visibility="hidden";for(var g=p.dom.root;!v&&g;)v=window.getComputedStyle(g,null).direction,g=g.parentElement;p.options.rtl=v&&"rtl"==v.toLowerCase()}else p.options.rtl=o.rtl;o&&(o.rollingMode&&(p.options.rollingMode=o.rollingMode),o.onInitialDrawComplete&&(p.options.onInitialDrawComplete=o.onInitialDrawComplete),o.onTimeout&&(p.options.onTimeout=o.onTimeout),o.loadingScreenTemplate&&(p.options.loadingScreenTemplate=o.loadingScreenTemplate));var y=document.createElement("div");if(p.options.loadingScreenTemplate){var b,_=Tp(b=p.options.loadingScreenTemplate).call(b,t_(p)),w=_(p.dom.loadingScreen);w instanceof Object&&!(w instanceof Element)?_(y):w instanceof Element?(y.innerHTML="",y.appendChild(w)):null!=w&&(y.innerHTML=wE.xss(w))}function k(t,e){m.hasListeners(t)&&m.emit(t,m.getEventProperties(e))}return p.dom.loadingScreen.appendChild(y),p.components=[],p.body={dom:p.dom,domProps:p.props,emitter:{on:Tp(s=p.on).call(s,t_(p)),off:Tp(a=p.off).call(a,t_(p)),emit:Tp(l=p.emit).call(l,t_(p))},hiddenDates:[],util:{getScale:function(){return m.timeAxis.step.scale},getStep:function(){return m.timeAxis.step.step},toScreen:Tp(h=m._toScreen).call(h,m),toGlobalScreen:Tp(u=m._toGlobalScreen).call(u,m),toTime:Tp(d=m._toTime).call(d,m),toGlobalTime:Tp(c=m._toGlobalTime).call(c,m)}},p.range=new oP(p.body,p.options),p.components.push(p.range),p.body.range=p.range,p.timeAxis=new mP(p.body,p.options),p.timeAxis2=null,p.components.push(p.timeAxis),p.currentTime=new jP(p.body,p.options),p.components.push(p.currentTime),p.itemSet=new tI(p.body,p.options),p.components.push(p.itemSet),p.itemsData=null,p.groupsData=null,p.dom.root.onclick=function(t){k("click",t)},p.dom.root.ondblclick=function(t){k("doubleClick",t)},p.dom.root.oncontextmenu=function(t){k("contextmenu",t)},p.dom.root.onmouseover=function(t){k("mouseOver",t)},window.PointerEvent?(p.dom.root.onpointerdown=function(t){k("mouseDown",t)},p.dom.root.onpointermove=function(t){k("mouseMove",t)},p.dom.root.onpointerup=function(t){k("mouseUp",t)}):(p.dom.root.onmousemove=function(t){k("mouseMove",t)},p.dom.root.onmousedown=function(t){k("mouseDown",t)},p.dom.root.onmouseup=function(t){k("mouseUp",t)}),p.initialFitDone=!1,p.on("changed",(function(){if(null!=m.itemsData){if(!m.initialFitDone&&!m.options.rollingMode)if(m.initialFitDone=!0,null!=m.options.start||null!=m.options.end){if(null==m.options.start||null==m.options.end)var t=m.getItemRange();var e=null!=m.options.start?m.options.start:t.min,i=null!=m.options.end?m.options.end:t.max;m.setWindow(e,i,{animation:!1})}else m.fit({animation:!1});m.initialDrawDone||!m.initialRangeChangeDone&&(m.options.start||m.options.end)&&!m.options.rollingMode||(m.initialDrawDone=!0,m.itemSet.initialDrawDone=!0,m.dom.root.style.visibility="visible",m.dom.loadingScreen.parentNode.removeChild(m.dom.loadingScreen),m.options.onInitialDrawComplete&&Rv((function(){return m.options.onInitialDrawComplete()}),0))}})),p.on("destroyTimeline",(function(){m.destroy()})),o&&p.setOptions(o),p.body.emitter.on("fit",(function(t){p._onFit(t),p.redraw()})),r&&p.setGroups(r),n&&p.setItems(n),p._redraw(),p}return Yd(i,[{key:"_createConfigurator",value:function(){return new vI(this,this.dom.container,pI)}},{key:"redraw",value:function(){this.itemSet&&this.itemSet.markDirty({refreshItems:!0}),this._redraw()}},{key:"setOptions",value:function(t){if(!0===rI.validate(t,cI)&&console.log("%cErrors have been found in the supplied options object.",nI),RP.prototype.setOptions.call(this,t),"type"in t&&t.type!==this.options.type){this.options.type=t.type;var e=this.itemsData;if(e){var i=this.getSelection();this.setItems(null),this.setItems(e.rawDS),this.setSelection(i)}}}},{key:"setItems",value:function(t){var e;this.itemsDone=!1,e=t?pE(t)?gE(t):gE(new nO(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=e,this.itemSet&&this.itemSet.setItems(null!=e?e.rawDS:null)}},{key:"setGroups",value:function(t){var e;t?(qc(t)&&(t=new nO(t)),e=new rO(t,{filter:function(t){return!1!==t.visible}})):e=null,null!=this.groupsData&&"function"==typeof this.groupsData.setData&&this.groupsData.setData(null),this.groupsData=e,this.itemSet.setGroups(e)}},{key:"setData",value:function(t){t&&t.groups&&this.setGroups(t.groups),t&&t.items&&this.setItems(t.items)}},{key:"setSelection",value:function(t,e){this.itemSet&&this.itemSet.setSelection(t),e&&e.focus&&this.focus(t,e)}},{key:"getSelection",value:function(){return this.itemSet&&this.itemSet.getSelection()||[]}},{key:"focus",value:function(t,e){if(this.itemsData&&null!=t){var i=qc(t)?t:[t],n=this.itemsData.get(i),r=null,o=null;if(Hp(n).call(n,(function(t){var e=t.start.valueOf(),i="end"in t?t.end.valueOf():t.start.valueOf();(null===r||e<r)&&(r=e),(null===o||i>o)&&(o=i)})),null!==r&&null!==o){var s=this,a=this.itemSet.items[i[0]],l=-1*this._getScrollTop(),h=null,u=function(){var t=wI(s,a);t.shouldScroll&&t.itemTop!=h.itemTop&&(s._setScrollTop(-t.scrollOffset),s._redraw())},d=!e||void 0===e.zoom||e.zoom,c=(r+o)/2,p=d?1.1*(o-r):Math.max(this.range.end-this.range.start,1.1*(o-r)),f=!e||void 0===e.animation||e.animation;f||(h={shouldScroll:!1,scrollOffset:-1,itemTop:-1}),this.range.setRange(c-p/2,c+p/2,{animation:f},(function(){u(),Rv(u,100)}),(function(t,e,i){var n=wI(s,a);if(!1!==n&&(h||(h=n),h.itemTop!=n.itemTop||h.shouldScroll)){h.itemTop!=n.itemTop&&n.shouldScroll&&(h=n,l=-1*s._getScrollTop());var r=l,o=h.scrollOffset,u=i?o:r+(o-r)*t;s._setScrollTop(-u),e||s._redraw()}}))}}}},{key:"fit",value:function(t,e){var i,n=!t||void 0===t.animation||t.animation;1===this.itemsData.length&&void 0===this.itemsData.get()[0].end?(i=this.getDataRange(),this.moveTo(i.min.valueOf(),{animation:n},e)):(i=this.getItemRange(),this.range.setRange(i.min,i.max,{animation:n},e))}},{key:"getItemRange",value:function(){var t=this,e=this.getDataRange(),i=null!==e.min?e.min.valueOf():null,n=null!==e.max?e.max.valueOf():null,r=null,o=null;if(null!=i&&null!=n){var s=n-i;s<=0&&(s=10);var a=s/this.props.center.width,l={},h=0;if(Hp(wE).call(wE,this.itemSet.items,(function(t,e){if(t.groupShowing){l[e]=t.redraw(!0),h=l[e].length}})),h>0)for(var u=function(t){Hp(wE).call(wE,l,(function(e){e[t]()}))},d=0;d<h;d++)u(d);if(Hp(wE).call(wE,this.itemSet.items,(function(e){var s,l,h=bI(e),u=_I(e);t.options.rtl?(s=h-(e.getWidthRight()+10)*a,l=u+(e.getWidthLeft()+10)*a):(s=h-(e.getWidthLeft()+10)*a,l=u+(e.getWidthRight()+10)*a),s<i&&(i=s,r=e),l>n&&(n=l,o=e)})),r&&o){var c=r.getWidthLeft()+10,p=o.getWidthRight()+10,f=this.props.center.width-c-p;f>0&&(this.options.rtl?(i=bI(r)-p*s/f,n=_I(o)+c*s/f):(i=bI(r)-c*s/f,n=_I(o)+p*s/f))}}return{min:null!=i?new Date(i):null,max:null!=n?new Date(n):null}}},{key:"getDataRange",value:function(){var t,e=null,i=null;this.itemsData&&Hp(t=this.itemsData).call(t,(function(t){var n=wE.convert(t.start,"Date").valueOf(),r=wE.convert(null!=t.end?t.end:t.start,"Date").valueOf();(null===e||n<e)&&(e=n),(null===i||r>i)&&(i=r)}));return{min:null!=e?new Date(e):null,max:null!=i?new Date(i):null}}},{key:"getEventProperties",value:function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=this.dom.centerContainer.getBoundingClientRect(),r=this.options.rtl?n.right-e:e-n.left,o=i-n.top,s=this.itemSet.itemFromTarget(t),a=this.itemSet.groupFromTarget(t),l=NP.customTimeFromTarget(t),h=this.itemSet.options.snap||null,u=this.body.util.getScale(),d=this.body.util.getStep(),c=this._toTime(r),p=h?h(c,u,d):c,f=wE.getTarget(t),m=null;return null!=s?m="item":null!=l?m="custom-time":wE.hasParent(f,this.timeAxis.dom.foreground)||this.timeAxis2&&wE.hasParent(f,this.timeAxis2.dom.foreground)?m="axis":wE.hasParent(f,this.itemSet.dom.labelSet)?m="group-label":wE.hasParent(f,this.currentTime.bar)?m="current-time":wE.hasParent(f,this.dom.center)&&(m="background"),{event:t,item:s?s.id:null,isCluster:!!s&&!!s.isCluster,items:s?s.items||[]:null,group:a?a.groupId:null,customTime:l?l.options.id:null,what:m,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:r,y:o,time:c,snappedTime:p}}},{key:"toggleRollingMode",value:function(){this.range.rolling?this.range.stopRolling():(null==this.options.rollingMode&&this.setOptions(this.options),this.range.startRolling())}},{key:"_redraw",value:function(){RP.prototype._redraw.call(this)}},{key:"_onFit",value:function(t){var e=t.start,i=t.end,n=t.animation;i?this.range.setRange(e,i,{animation:n}):this.moveTo(e.valueOf(),{animation:n})}}]),i}(RP);function bI(t){return wE.convert(t.data.start,"Date").valueOf()}function _I(t){var e=null!=t.data.end?t.data.end:t.data.start;return wE.convert(e,"Date").valueOf()}function wI(t,e){if(!e.parent)return!1;var i=t.options.rtl?t.props.rightContainer.height:t.props.leftContainer.height,n=t.props.center.height,r=e.parent,o=r.top,s=!0,a=t.timeAxis.options.orientation.axis,l=function(){return"bottom"==a?r.height-e.top-e.height:e.top},h=-1*t._getScrollTop(),u=o+l(),d=e.height;return u<h?o+i<=o+l()+d&&(o+=l()-t.itemSet.options.margin.item.vertical):u+d>h+i?o+=l()+d-i+t.itemSet.options.margin.item.vertical:s=!1,{shouldScroll:s,scrollOffset:o=Math.min(o,n-i),itemTop:u}}var kI=function(){function t(e,i,n,r,o,s){var a=arguments.length>6&&void 0!==arguments[6]&&arguments[6],l=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(Ma(this,t),this.majorSteps=[1,2,5,10],this.minorSteps=[.25,.5,1,2],this.customLines=null,this.containerHeight=o,this.majorCharHeight=s,this._start=e,this._end=i,this.scale=1,this.minorStepIdx=-1,this.magnitudefactor=1,this.determineScale(),this.zeroAlign=a,this.autoScaleStart=n,this.autoScaleEnd=r,this.formattingFunction=l,n||r){var h=this,u=function(t){var e=t-t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx]);return t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx])>h.magnitudefactor*h.minorSteps[h.minorStepIdx]*.5?e+h.magnitudefactor*h.minorSteps[h.minorStepIdx]:e};n&&(this._start-=2*this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._start=u(this._start)),r&&(this._end+=this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._end=u(this._end)),this.determineScale()}}return Yd(t,[{key:"setCharHeight",value:function(t){this.majorCharHeight=t}},{key:"setHeight",value:function(t){this.containerHeight=t}},{key:"determineScale",value:function(){var t=this._end-this._start;this.scale=this.containerHeight/t;var e=this.majorCharHeight/this.scale,i=t>0?Math.round(Math.log(t)/Math.LN10):0;this.minorStepIdx=-1,this.magnitudefactor=Math.pow(10,i);var n=0;i<0&&(n=i);for(var r=!1,o=n;Math.abs(o)<=Math.abs(i);o++){this.magnitudefactor=Math.pow(10,o);for(var s=0;s<this.minorSteps.length;s++){if(this.magnitudefactor*this.minorSteps[s]>=e){r=!0,this.minorStepIdx=s;break}}if(!0===r)break}}},{key:"is_major",value:function(t){return t%(this.magnitudefactor*this.majorSteps[this.minorStepIdx])==0}},{key:"getStep",value:function(){return this.magnitudefactor*this.minorSteps[this.minorStepIdx]}},{key:"getFirstMajor",value:function(){var t=this.magnitudefactor*this.majorSteps[this.minorStepIdx];return this.convertValue(this._start+(t-this._start%t)%t)}},{key:"formatValue",value:function(t){var e=t.toPrecision(5);return"function"==typeof this.formattingFunction&&(e=this.formattingFunction(t)),"number"==typeof e?"".concat(e):"string"==typeof e?e:t.toPrecision(5)}},{key:"getLines",value:function(){for(var t=[],e=this.getStep(),i=(e-this._start%e)%e,n=this._start+i;this._end-n>1e-5;n+=e)n!=this._start&&t.push({major:this.is_major(n),y:this.convertValue(n),val:this.formatValue(n)});return t}},{key:"followScale",value:function(t){var e=this.minorStepIdx,i=this._start,n=this._end,r=this,o=function(){r.magnitudefactor*=2},s=function(){r.magnitudefactor/=2};t.minorStepIdx<=1&&this.minorStepIdx<=1||t.minorStepIdx>1&&this.minorStepIdx>1||(t.minorStepIdx<this.minorStepIdx?(this.minorStepIdx=1,2==e||o(),o()):(this.minorStepIdx=2,1==e||s(),s()));for(var a=t.convertValue(0),l=t.getStep()*t.scale,h=!1,u=0;!h&&u++<5;){this.scale=l/(this.minorSteps[this.minorStepIdx]*this.magnitudefactor);var d=this.containerHeight/this.scale;this._start=i,this._end=this._start+d;var c=this._end*this.scale,p=this.magnitudefactor*this.majorSteps[this.minorStepIdx],f=this.getFirstMajor()-t.getFirstMajor();if(this.zeroAlign){var m=a-c;this._end+=m/this.scale,this._start=this._end-d}else this.autoScaleStart?(this._start-=f/this.scale,this._end=this._start+d):(this._start+=p-f/this.scale,this._end=this._start+d);if(!this.autoScaleEnd&&this._end>n+1e-5)s(),h=!1;else{if(!this.autoScaleStart&&this._start<i-1e-5){if(!(this.zeroAlign&&i>=0)){s(),h=!1;continue}console.warn("Can't adhere to given 'min' range, due to zeroalign")}this.autoScaleStart&&this.autoScaleEnd&&d<n-i?(o(),h=!1):h=!0}}}},{key:"convertValue",value:function(t){return this.containerHeight-(t-this._start)*this.scale}},{key:"screenToValue",value:function(t){return(this.containerHeight-t)/this.scale+this._start}}]),t}();function xI(t,e){var i=void 0!==Ic&&Ta(t)||t["@@iterator"];if(!i){if(qc(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return DI(t,e);var n=Hc(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return sa(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return DI(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,r=function(){};return{s:r,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:r}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var o,s=!0,a=!1;return{s:function(){i=i.call(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,o=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw o}}}}function DI(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function SI(t){var e=function(){if("undefined"==typeof Reflect||!vM)return!1;if(vM.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(vM(Boolean,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=d_(t);if(e){var r=d_(this).constructor;i=vM(n,arguments,r)}else i=n.apply(this,arguments);return l_(this,i)}}pP(".vis-panel.vis-background.vis-horizontal .vis-grid.vis-horizontal{border-bottom:1px solid;height:0;position:absolute;width:100%}.vis-panel.vis-background.vis-horizontal .vis-grid.vis-minor{border-color:#e5e5e5}.vis-panel.vis-background.vis-horizontal .vis-grid.vis-major{border-color:#bfbfbf}.vis-data-axis .vis-y-axis.vis-major{color:#4d4d4d;position:absolute;white-space:nowrap;width:100%}.vis-data-axis .vis-y-axis.vis-major.vis-measure{border:0;margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-minor{color:#bebebe;position:absolute;white-space:nowrap;width:100%}.vis-data-axis .vis-y-axis.vis-minor.vis-measure{border:0;margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-title{bottom:20px;color:#4d4d4d;position:absolute;text-align:center;white-space:nowrap}.vis-data-axis .vis-y-axis.vis-title.vis-measure{margin:0;padding:0;visibility:hidden;width:auto}.vis-data-axis .vis-y-axis.vis-title.vis-left{bottom:0;-webkit-transform:rotate(-90deg);-moz-transform:rotate(-90deg);-ms-transform:rotate(-90deg);-o-transform:rotate(-90deg);transform:rotate(-90deg);-webkit-transform-origin:left top;-moz-transform-origin:left top;-ms-transform-origin:left top;-o-transform-origin:left top;transform-origin:left bottom}.vis-data-axis .vis-y-axis.vis-title.vis-right{bottom:0;-webkit-transform:rotate(90deg);-moz-transform:rotate(90deg);-ms-transform:rotate(90deg);-o-transform:rotate(90deg);transform:rotate(90deg);-webkit-transform-origin:right bottom;-moz-transform-origin:right bottom;-ms-transform-origin:right bottom;-o-transform-origin:right bottom;transform-origin:right bottom}.vis-legend{background-color:rgba(247,252,255,.65);border:1px solid #b3b3b3;box-shadow:2px 2px 10px hsla(0,0%,60%,.55);padding:5px}.vis-legend-text{display:inline-block;white-space:nowrap}");var CI=function(t){a_(i,t);var e=SI(i);function i(t,n,r,o){var s;Ma(this,i),(s=e.call(this)).id=UM(),s.body=t,s.defaultOptions={orientation:"left",showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,majorLinesOffset:7,minorLinesOffset:4,labelOffsetX:10,labelOffsetY:2,iconWidth:20,width:"40px",visible:!0,alignZeros:!0,left:{range:{min:void 0,max:void 0},format:function(t){return"".concat(AE(t.toPrecision(3)))},title:{text:void 0,style:void 0}},right:{range:{min:void 0,max:void 0},format:function(t){return"".concat(AE(t.toPrecision(3)))},title:{text:void 0,style:void 0}}},s.linegraphOptions=o,s.linegraphSVG=r,s.props={},s.DOMelements={lines:{},labels:{},title:{}},s.dom={},s.scale=void 0,s.range={start:0,end:0},s.options=wE.extend({},s.defaultOptions),s.conversionFactor=1,s.setOptions(n),s.width=Number("".concat(s.options.width).replace("px","")),s.minWidth=s.width,s.height=s.linegraphSVG.getBoundingClientRect().height,s.hidden=!1,s.stepPixels=25,s.zeroCrossing=-1,s.amountOfSteps=-1,s.lineOffset=0,s.master=!0,s.masterAxis=null,s.svgElements={},s.iconsRemoved=!1,s.groups={},s.amountOfGroups=0,s._create(),null==s.scale&&s._redrawLabels(),s.framework={svg:s.svg,svgElements:s.svgElements,options:s.options,groups:s.groups};var a=t_(s);return s.body.emitter.on("verticalDrag",(function(){a.dom.lineContainer.style.top="".concat(a.body.domProps.scrollTop,"px")})),s}return Yd(i,[{key:"addGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1}},{key:"updateGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.amountOfGroups+=1),this.groups[t]=e}},{key:"removeGroup",value:function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)}},{key:"setOptions",value:function(t){if(t){var e=!1;this.options.orientation!=t.orientation&&void 0!==t.orientation&&(e=!0);wE.selectiveDeepExtend(["orientation","showMinorLabels","showMajorLabels","icons","majorLinesOffset","minorLinesOffset","labelOffsetX","labelOffsetY","iconWidth","width","visible","left","right","alignZeros"],this.options,t),this.minWidth=Number("".concat(this.options.width).replace("px","")),!0===e&&this.dom.frame&&(this.hide(),this.show())}}},{key:"_create",value:function(){this.dom.frame=document.createElement("div"),this.dom.frame.style.width=this.options.width,this.dom.frame.style.height=this.height,this.dom.lineContainer=document.createElement("div"),this.dom.lineContainer.style.width="100%",this.dom.lineContainer.style.height=this.height,this.dom.lineContainer.style.position="relative",this.dom.lineContainer.style.visibility="visible",this.dom.lineContainer.style.display="block",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.height="100%",this.svg.style.width="100%",this.svg.style.display="block",this.dom.frame.appendChild(this.svg)}},{key:"_redrawGroupIcons",value:function(){var t;Ub(this.svgElements);var e=this.options.iconWidth,i=11.5;t="left"===this.options.orientation?4:this.width-e-4;var n=rp(this.groups);_T(n).call(n,(function(t,e){return t<e?-1:1}));var r,o=xI(n);try{for(o.s();!(r=o.n()).done;){var s=r.value;!0!==this.groups[s].visible||void 0!==this.linegraphOptions.visibility[s]&&!0!==this.linegraphOptions.visibility[s]||(this.groups[s].getLegend(e,15,this.framework,t,i),i+=19)}}catch(t){o.e(t)}finally{o.f()}Vb(this.svgElements),this.iconsRemoved=!1}},{key:"_cleanupIcons",value:function(){!1===this.iconsRemoved&&(Ub(this.svgElements),Vb(this.svgElements),this.iconsRemoved=!0)}},{key:"show",value:function(){this.hidden=!1,this.dom.frame.parentNode||("left"===this.options.orientation?this.body.dom.left.appendChild(this.dom.frame):this.body.dom.right.appendChild(this.dom.frame)),this.dom.lineContainer.parentNode||this.body.dom.backgroundHorizontal.appendChild(this.dom.lineContainer),this.dom.lineContainer.style.display="block"}},{key:"hide",value:function(){this.hidden=!0,this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.lineContainer.style.display="none"}},{key:"setRange",value:function(t,e){this.range.start=t,this.range.end=e}},{key:"redraw",value:function(){var t=!1,e=0;for(var i in this.dom.lineContainer.style.top="".concat(this.body.domProps.scrollTop,"px"),this.groups)this.groups.hasOwnProperty(i)&&(!0!==this.groups[i].visible||void 0!==this.linegraphOptions.visibility[i]&&!0!==this.linegraphOptions.visibility[i]||e++);if(0===this.amountOfGroups||0===e)this.hide();else{this.show(),this.height=Number(this.linegraphSVG.style.height.replace("px","")),this.dom.lineContainer.style.height="".concat(this.height,"px"),this.width=!0===this.options.visible?Number("".concat(this.options.width).replace("px","")):0;var n=this.props,r=this.dom.frame;r.className="vis-data-axis",this._calculateCharSize();var o=this.options.orientation,s=this.options.showMinorLabels,a=this.options.showMajorLabels,l=this.body.dom.backgroundHorizontal.offsetWidth;n.minorLabelHeight=s?n.minorCharHeight:0,n.majorLabelHeight=a?n.majorCharHeight:0,n.minorLineWidth=l-this.lineOffset-this.width+2*this.options.minorLinesOffset,n.minorLineHeight=1,n.majorLineWidth=l-this.lineOffset-this.width+2*this.options.majorLinesOffset,n.majorLineHeight=1,"left"===o?(r.style.top="0",r.style.left="0",r.style.bottom="",r.style.width="".concat(this.width,"px"),r.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.left.width,this.props.height=this.body.domProps.left.height):(r.style.top="",r.style.bottom="0",r.style.left="0",r.style.width="".concat(this.width,"px"),r.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.right.width,this.props.height=this.body.domProps.right.height),t=this._redrawLabels(),t=this._isResized()||t,!0===this.options.icons?this._redrawGroupIcons():this._cleanupIcons(),this._redrawTitle(o)}return t}},{key:"_redrawLabels",value:function(){var t=this,e=!1;Ub(this.DOMelements.lines),Ub(this.DOMelements.labels);var i=this.options.orientation,n=null!=this.options[i].range?this.options[i].range:{},r=!0;null!=n.max&&(this.range.end=n.max,r=!1);var o=!0;null!=n.min&&(this.range.start=n.min,o=!1),this.scale=new kI(this.range.start,this.range.end,o,r,this.dom.frame.offsetHeight,this.props.majorCharHeight,this.options.alignZeros,this.options[i].format),!1===this.master&&null!=this.masterAxis?(this.scale.followScale(this.masterAxis.scale),this.dom.lineContainer.style.display="none"):this.dom.lineContainer.style.display="block",this.maxLabelSize=0;var s=this.scale.getLines();Hp(s).call(s,(function(e){var n=e.y,r=e.major;t.options.showMinorLabels&&!1===r&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-minor",t.props.minorCharHeight),r&&n>=0&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-major",t.props.majorCharHeight),!0===t.master&&(r?t._redrawLine(n,i,"vis-grid vis-horizontal vis-major",t.options.majorLinesOffset,t.props.majorLineWidth):t._redrawLine(n,i,"vis-grid vis-horizontal vis-minor",t.options.minorLinesOffset,t.props.minorLineWidth))}));var a=0;void 0!==this.options[i].title&&void 0!==this.options[i].title.text&&(a=this.props.titleCharHeight);var l=!0===this.options.icons?Math.max(this.options.iconWidth,a)+this.options.labelOffsetX+15:a+this.options.labelOffsetX+15;return this.maxLabelSize>this.width-l&&!0===this.options.visible?(this.width=this.maxLabelSize+l,this.options.width="".concat(this.width,"px"),Vb(this.DOMelements.lines),Vb(this.DOMelements.labels),this.redraw(),e=!0):this.maxLabelSize<this.width-l&&!0===this.options.visible&&this.width>this.minWidth?(this.width=Math.max(this.minWidth,this.maxLabelSize+l),this.options.width="".concat(this.width,"px"),Vb(this.DOMelements.lines),Vb(this.DOMelements.labels),this.redraw(),e=!0):(Vb(this.DOMelements.lines),Vb(this.DOMelements.labels),e=!1),e}},{key:"convertValue",value:function(t){return this.scale.convertValue(t)}},{key:"screenToValue",value:function(t){return this.scale.screenToValue(t)}},{key:"_redrawLabel",value:function(t,e,i,n,r){var o=$b("div",this.DOMelements.labels,this.dom.frame);o.className=n,o.innerHTML=wE.xss(e),"left"===i?(o.style.left="-".concat(this.options.labelOffsetX,"px"),o.style.textAlign="right"):(o.style.right="-".concat(this.options.labelOffsetX,"px"),o.style.textAlign="left"),o.style.top="".concat(t-.5*r+this.options.labelOffsetY,"px"),e+="";var s=Math.max(this.props.majorCharWidth,this.props.minorCharWidth);this.maxLabelSize<e.length*s&&(this.maxLabelSize=e.length*s)}},{key:"_redrawLine",value:function(t,e,i,n,r){if(!0===this.master){var o=$b("div",this.DOMelements.lines,this.dom.lineContainer);o.className=i,o.innerHTML="","left"===e?o.style.left="".concat(this.width-n,"px"):o.style.right="".concat(this.width-n,"px"),o.style.width="".concat(r,"px"),o.style.top="".concat(t,"px")}}},{key:"_redrawTitle",value:function(t){if(Ub(this.DOMelements.title),void 0!==this.options[t].title&&void 0!==this.options[t].title.text){var e=$b("div",this.DOMelements.title,this.dom.frame);e.className="vis-y-axis vis-title vis-".concat(t),e.innerHTML=wE.xss(this.options[t].title.text),void 0!==this.options[t].title.style&&wE.addCssText(e,this.options[t].title.style),"left"===t?e.style.left="".concat(this.props.titleCharHeight,"px"):e.style.right="".concat(this.props.titleCharHeight,"px"),e.style.width="".concat(this.height,"px")}Vb(this.DOMelements.title)}},{key:"_calculateCharSize",value:function(){if(!("minorCharHeight"in this.props)){var t=document.createTextNode("0"),e=document.createElement("div");e.className="vis-y-axis vis-minor vis-measure",e.appendChild(t),this.dom.frame.appendChild(e),this.props.minorCharHeight=e.clientHeight,this.props.minorCharWidth=e.clientWidth,this.dom.frame.removeChild(e)}if(!("majorCharHeight"in this.props)){var i=document.createTextNode("0"),n=document.createElement("div");n.className="vis-y-axis vis-major vis-measure",n.appendChild(i),this.dom.frame.appendChild(n),this.props.majorCharHeight=n.clientHeight,this.props.majorCharWidth=n.clientWidth,this.dom.frame.removeChild(n)}if(!("titleCharHeight"in this.props)){var r=document.createTextNode("0"),o=document.createElement("div");o.className="vis-y-axis vis-title vis-measure",o.appendChild(r),this.dom.frame.appendChild(o),this.props.titleCharHeight=o.clientHeight,this.props.titleCharWidth=o.clientWidth,this.dom.frame.removeChild(o)}}}]),i}(IE);function TI(t,e){}function MI(t,e){return{style:(e=void 0===e?{}:e).style||t.options.drawPoints.style,styles:e.styles||t.options.drawPoints.styles,size:e.size||t.options.drawPoints.size,className:e.className||t.className}}function OI(t,e){}function EI(t,e){}function PI(t,e,i,n){this.id=e;this.options=wE.selectiveBridgeObject(["sampling","style","sort","yAxisOrientation","barChart","drawPoints","shaded","interpolation","zIndex","excludeFromStacking","excludeFromLegend"],i),this.usingDefaultStyle=void 0===t.className,this.groupsUsingDefaultStyles=n,this.zeroPosition=0,this.update(t),1==this.usingDefaultStyle&&(this.groupsUsingDefaultStyles[0]+=1),this.itemsData=[],this.visible=void 0===t.visible||t.visible}function AI(t,e,i,n){this.body=t,this.defaultOptions={enabled:!1,icons:!0,iconSize:20,iconSpacing:6,left:{visible:!0,position:"top-left"},right:{visible:!0,position:"top-right"}},this.side=i,this.options=wE.extend({},this.defaultOptions),this.linegraphOptions=n,this.svgElements={},this.dom={},this.groups={},this.amountOfGroups=0,this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups},this.setOptions(e)}TI.draw=function(t,e,i,n){n=n||0;for(var r=function(t,e){var i=void 0;t.options&&t.options.drawPoints&&t.options.drawPoints.onRender&&"function"==typeof t.options.drawPoints.onRender&&(i=t.options.drawPoints.onRender);e.group.options&&e.group.options.drawPoints&&e.group.options.drawPoints.onRender&&"function"==typeof e.group.options.drawPoints.onRender&&(i=e.group.options.drawPoints.onRender);return i}(i,e),o=0;o<t.length;o++)if(r){var s=r(t[o],e);!0!==s&&"object"!==Nd(s)||Zb(t[o].screen_x+n,t[o].screen_y,MI(e,s),i.svgElements,i.svg,t[o].label)}else Zb(t[o].screen_x+n,t[o].screen_y,MI(e),i.svgElements,i.svg,t[o].label)},TI.drawIcon=function(t,e,i,n,r,o){var s=.5*r,a=qb("rect",o.svgElements,o.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline"),Zb(e+.5*n,i,MI(t),o.svgElements,o.svg)},OI.drawIcon=function(t,e,i,n,r,o){var s=.5*r,a=qb("rect",o.svgElements,o.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline");var l=Math.round(.3*n),h=t.options.barChart.width/l,u=Math.round(.4*r),d=Math.round(.75*r),c=Math.round((n-2*l)/3);if(Kb(e+.5*l+c,i+s-u-1,l,u,t.className+" vis-bar",o.svgElements,o.svg,t.style),Kb(e+1.5*l+c+2,i+s-d-1,l,d,t.className+" vis-bar",o.svgElements,o.svg,t.style),1==t.options.drawPoints.enabled){var p={style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size/h,className:t.className};Zb(e+.5*l+c,i+s-u-1,p,o.svgElements,o.svg),Zb(e+1.5*l+c+2,i+s-d-1,p,o.svgElements,o.svg)}},OI.draw=function(t,e,i){var n,r,o,s,a,l,h=[],u={},d=0;for(a=0;a<t.length;a++)if("bar"===(s=i.groups[t[a]]).options.style&&!0===s.visible&&(void 0===i.options.groups.visibility[t[a]]||!0===i.options.groups.visibility[t[a]]))for(l=0;l<e[t[a]].length;l++)h.push({screen_x:e[t[a]][l].screen_x,screen_end:e[t[a]][l].screen_end,screen_y:e[t[a]][l].screen_y,x:e[t[a]][l].x,end:e[t[a]][l].end,y:e[t[a]][l].y,groupId:t[a],label:e[t[a]][l].label}),d+=1;if(0!==d)for(_T(h).call(h,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x})),OI._getDataIntersections(u,h),a=0;a<h.length;a++){var c=null!=(s=i.groups[h[a].groupId]).options.barChart.minWidth?s.options.barChart.minWidth:.1*s.options.barChart.width,p=0;if(void 0===u[r=h[a].screen_x])a+1<h.length&&(n=Math.abs(h[a+1].screen_x-r)),o=OI._getSafeDrawData(n,s,c);else{var f=a+(u[r].amount-u[r].resolved);f<h.length&&(n=Math.abs(h[f].screen_x-r)),o=OI._getSafeDrawData(n,s,c),u[r].resolved+=1,!0===s.options.stack&&!0!==s.options.excludeFromStacking?h[a].screen_y<s.zeroPosition?(p=u[r].accumulatedNegative,u[r].accumulatedNegative+=s.zeroPosition-h[a].screen_y):(p=u[r].accumulatedPositive,u[r].accumulatedPositive+=s.zeroPosition-h[a].screen_y):!0===s.options.barChart.sideBySide&&(o.width=o.width/u[r].amount,o.offset+=u[r].resolved*o.width-.5*o.width*(u[r].amount+1))}var m=o.width,v=h[a].screen_x;if(null!=h[a].screen_end?v+=.5*(m=h[a].screen_end-h[a].screen_x):v+=o.offset,Kb(v,h[a].screen_y-p,m,s.zeroPosition-h[a].screen_y,s.className+" vis-bar",i.svgElements,i.svg,s.style),!0===s.options.drawPoints.enabled){var g={screen_x:h[a].screen_x,screen_y:h[a].screen_y-p,x:h[a].x,y:h[a].y,groupId:h[a].groupId,label:h[a].label};TI.draw([g],s,i,o.offset)}}},OI._getDataIntersections=function(t,e){for(var i,n=0;n<e.length;n++)n+1<e.length&&(i=Math.abs(e[n+1].screen_x-e[n].screen_x)),n>0&&(i=Math.min(i,Math.abs(e[n-1].screen_x-e[n].screen_x))),0===i&&(void 0===t[e[n].screen_x]&&(t[e[n].screen_x]={amount:0,resolved:0,accumulatedPositive:0,accumulatedNegative:0}),t[e[n].screen_x].amount+=1)},OI._getSafeDrawData=function(t,e,i){var n,r;return t<e.options.barChart.width&&t>0?(n=t<i?i:t,r=0,"left"===e.options.barChart.align?r-=.5*t:"right"===e.options.barChart.align&&(r+=.5*t)):(n=e.options.barChart.width,r=0,"left"===e.options.barChart.align?r-=.5*e.options.barChart.width:"right"===e.options.barChart.align&&(r+=.5*e.options.barChart.width)),{width:n,offset:r}},OI.getStackedYRange=function(t,e,i,n,r){if(t.length>0){_T(t).call(t,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x}));var o={};OI._getDataIntersections(o,t),e[n]=OI._getStackedYRange(o,t),e[n].yAxisOrientation=r,i.push(n)}},OI._getStackedYRange=function(t,e){for(var i,n=e[0].screen_y,r=e[0].screen_y,o=0;o<e.length;o++)void 0===t[i=e[o].screen_x]?(n=n>e[o].screen_y?e[o].screen_y:n,r=r<e[o].screen_y?e[o].screen_y:r):e[o].screen_y<0?t[i].accumulatedNegative+=e[o].screen_y:t[i].accumulatedPositive+=e[o].screen_y;for(var s in t)t.hasOwnProperty(s)&&(n=(n=n>t[s].accumulatedNegative?t[s].accumulatedNegative:n)>t[s].accumulatedPositive?t[s].accumulatedPositive:n,r=(r=r<t[s].accumulatedNegative?t[s].accumulatedNegative:r)<t[s].accumulatedPositive?t[s].accumulatedPositive:r);return{min:n,max:r}},EI.calcPath=function(t,e){if(null!=t&&t.length>0){return 1==e.options.interpolation.enabled?EI._catmullRom(t,e):EI._linear(t)}},EI.drawIcon=function(t,e,i,n,r,o){var s,a,l=.5*r,h=qb("rect",o.svgElements,o.svg);(h.setAttributeNS(null,"x",e),h.setAttributeNS(null,"y",i-l),h.setAttributeNS(null,"width",n),h.setAttributeNS(null,"height",2*l),h.setAttributeNS(null,"class","vis-outline"),(s=qb("path",o.svgElements,o.svg)).setAttributeNS(null,"class",t.className),void 0!==t.style&&s.setAttributeNS(null,"style",t.style),s.setAttributeNS(null,"d","M"+e+","+i+" L"+(e+n)+","+i),1==t.options.shaded.enabled&&(a=qb("path",o.svgElements,o.svg),"top"==t.options.shaded.orientation?a.setAttributeNS(null,"d","M"+e+", "+(i-l)+"L"+e+","+i+" L"+(e+n)+","+i+" L"+(e+n)+","+(i-l)):a.setAttributeNS(null,"d","M"+e+","+i+" L"+e+","+(i+l)+" L"+(e+n)+","+(i+l)+"L"+(e+n)+","+i),a.setAttributeNS(null,"class",t.className+" vis-icon-fill"),void 0!==t.options.shaded.style&&""!==t.options.shaded.style&&a.setAttributeNS(null,"style",t.options.shaded.style)),1==t.options.drawPoints.enabled)&&Zb(e+.5*n,i,{style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size,className:t.className},o.svgElements,o.svg)},EI.drawShading=function(t,e,i,n){if(1==e.options.shaded.enabled){var r,o=Number(n.svg.style.height.replace("px","")),s=qb("path",n.svgElements,n.svg),a="L";1==e.options.interpolation.enabled&&(a="C");var l=0;l="top"==e.options.shaded.orientation?0:"bottom"==e.options.shaded.orientation?o:Math.min(Math.max(0,e.zeroPosition),o),r="group"==e.options.shaded.orientation&&null!=i&&null!=i?"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" L"+i[i.length-1][0]+","+i[i.length-1][1]+" "+this.serializePath(i,a,!0)+i[0][0]+","+i[0][1]+" Z":"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" V"+l+" H"+t[0][0]+" Z",s.setAttributeNS(null,"class",e.className+" vis-fill"),void 0!==e.options.shaded.style&&s.setAttributeNS(null,"style",e.options.shaded.style),s.setAttributeNS(null,"d",r)}},EI.draw=function(t,e,i){if(null!=t&&null!=t){var n=qb("path",i.svgElements,i.svg);n.setAttributeNS(null,"class",e.className),void 0!==e.style&&n.setAttributeNS(null,"style",e.style);var r="L";1==e.options.interpolation.enabled&&(r="C"),n.setAttributeNS(null,"d","M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,r,!1))}},EI.serializePath=function(t,e,i){if(t.length<2)return"";var n,r=e;if(i)for(n=t.length-2;n>0;n--)r+=t[n][0]+","+t[n][1]+" ";else for(n=1;n<t.length;n++)r+=t[n][0]+","+t[n][1]+" ";return r},EI._catmullRomUniform=function(t){var e,i,n,r,o,s,a=[];a.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var l=1/6,h=t.length,u=0;u<h-1;u++)e=0==u?t[0]:t[u-1],i=t[u],n=t[u+1],r=u+2<h?t[u+2]:n,o={screen_x:(-e.screen_x+6*i.screen_x+n.screen_x)*l,screen_y:(-e.screen_y+6*i.screen_y+n.screen_y)*l},s={screen_x:(i.screen_x+6*n.screen_x-r.screen_x)*l,screen_y:(i.screen_y+6*n.screen_y-r.screen_y)*l},a.push([o.screen_x,o.screen_y]),a.push([s.screen_x,s.screen_y]),a.push([n.screen_x,n.screen_y]);return a},EI._catmullRom=function(t,e){var i=e.options.interpolation.alpha;if(0==i||void 0===i)return this._catmullRomUniform(t);var n,r,o,s,a,l,h,u,d,c,p,f,m,v,g,y,b,_,w,k=[];k.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var x=t.length,D=0;D<x-1;D++)n=0==D?t[0]:t[D-1],r=t[D],o=t[D+1],s=D+2<x?t[D+2]:o,h=Math.sqrt(Math.pow(n.screen_x-r.screen_x,2)+Math.pow(n.screen_y-r.screen_y,2)),u=Math.sqrt(Math.pow(r.screen_x-o.screen_x,2)+Math.pow(r.screen_y-o.screen_y,2)),d=Math.sqrt(Math.pow(o.screen_x-s.screen_x,2)+Math.pow(o.screen_y-s.screen_y,2)),v=Math.pow(d,i),y=Math.pow(d,2*i),g=Math.pow(u,i),b=Math.pow(u,2*i),w=Math.pow(h,i),c=2*(_=Math.pow(h,2*i))+3*w*g+b,p=2*y+3*v*g+b,(f=3*w*(w+g))>0&&(f=1/f),(m=3*v*(v+g))>0&&(m=1/m),a={screen_x:(-b*n.screen_x+c*r.screen_x+_*o.screen_x)*f,screen_y:(-b*n.screen_y+c*r.screen_y+_*o.screen_y)*f},l={screen_x:(y*r.screen_x+p*o.screen_x-b*s.screen_x)*m,screen_y:(y*r.screen_y+p*o.screen_y-b*s.screen_y)*m},0==a.screen_x&&0==a.screen_y&&(a=r),0==l.screen_x&&0==l.screen_y&&(l=o),k.push([a.screen_x,a.screen_y]),k.push([l.screen_x,l.screen_y]),k.push([o.screen_x,o.screen_y]);return k},EI._linear=function(t){for(var e=[],i=0;i<t.length;i++)e.push([t[i].screen_x,t[i].screen_y]);return e},PI.prototype.setItems=function(t){null!=t?(this.itemsData=t,1==_T(this.options)&&wE.insertSort(this.itemsData,(function(t,e){return t.x>e.x?1:-1}))):this.itemsData=[]},PI.prototype.getItems=function(){return this.itemsData},PI.prototype.setZeroPosition=function(t){this.zeroPosition=t},PI.prototype.setOptions=function(t){if(void 0!==t){wE.selectiveDeepExtend(["sampling","style","sort","yAxisOrientation","barChart","zIndex","excludeFromStacking","excludeFromLegend"],this.options,t),"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),wE.mergeOptions(this.options,t,"interpolation"),wE.mergeOptions(this.options,t,"drawPoints"),wE.mergeOptions(this.options,t,"shaded"),t.interpolation&&"object"==Nd(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5))}},PI.prototype.update=function(t){this.group=t,this.content=t.content||"graph",this.className=t.className||this.className||"vis-graph-group"+this.groupsUsingDefaultStyles[0]%10,this.visible=void 0===t.visible||t.visible,this.style=t.style,this.setOptions(t.options)},PI.prototype.getLegend=function(t,e,i,n,r){null!=i&&null!=i||(i={svg:document.createElementNS("http://www.w3.org/2000/svg","svg"),svgElements:{},options:this.options,groups:[this]});switch(null!=n&&null!=n||(n=0),null!=r&&null!=r||(r=.5*e),this.options.style){case"line":EI.drawIcon(this,n,r,t,e,i);break;case"points":case"point":TI.drawIcon(this,n,r,t,e,i);break;case"bar":OI.drawIcon(this,n,r,t,e,i)}return{icon:i.svg,label:this.content,orientation:this.options.yAxisOrientation}},PI.prototype.getYRange=function(t){for(var e=t[0].y,i=t[0].y,n=0;n<t.length;n++)e=e>t[n].y?t[n].y:e,i=i<t[n].y?t[n].y:i;return{min:e,max:i,yAxisOrientation:this.options.yAxisOrientation}},AI.prototype=new IE,AI.prototype.clear=function(){this.groups={},this.amountOfGroups=0},AI.prototype.addGroup=function(t,e){1!=e.options.excludeFromLegend&&(this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1)},AI.prototype.updateGroup=function(t,e){this.groups[t]=e},AI.prototype.removeGroup=function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)},AI.prototype._create=function(){this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-legend",this.dom.frame.style.position="absolute",this.dom.frame.style.top="10px",this.dom.frame.style.display="block",this.dom.textArea=document.createElement("div"),this.dom.textArea.className="vis-legend-text",this.dom.textArea.style.position="relative",this.dom.textArea.style.top="0px",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.width=this.options.iconSize+5+"px",this.svg.style.height="100%",this.dom.frame.appendChild(this.svg),this.dom.frame.appendChild(this.dom.textArea)},AI.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},AI.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},AI.prototype.setOptions=function(t){wE.selectiveDeepExtend(["enabled","orientation","icons","left","right"],this.options,t)},AI.prototype.redraw=function(){var t=0,e=rp(this.groups);_T(e).call(e,(function(t,e){return t<e?-1:1}));for(var i=0;i<e.length;i++){var n=e[i];1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||t++}if(0==this.options[this.side].visible||0==this.amountOfGroups||0==this.options.enabled||0==t)this.hide();else{if(this.show(),"top-left"==this.options[this.side].position||"bottom-left"==this.options[this.side].position?(this.dom.frame.style.left="4px",this.dom.frame.style.textAlign="left",this.dom.textArea.style.textAlign="left",this.dom.textArea.style.left=this.options.iconSize+15+"px",this.dom.textArea.style.right="",this.svg.style.left="0px",this.svg.style.right=""):(this.dom.frame.style.right="4px",this.dom.frame.style.textAlign="right",this.dom.textArea.style.textAlign="right",this.dom.textArea.style.right=this.options.iconSize+15+"px",this.dom.textArea.style.left="",this.svg.style.right="0px",this.svg.style.left=""),"top-left"==this.options[this.side].position||"top-right"==this.options[this.side].position)this.dom.frame.style.top=4-Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.bottom="";else{var r=this.body.domProps.center.height-this.body.domProps.centerContainer.height;this.dom.frame.style.bottom=4+r+Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.top=""}0==this.options.icons?(this.dom.frame.style.width=this.dom.textArea.offsetWidth+10+"px",this.dom.textArea.style.right="",this.dom.textArea.style.left="",this.svg.style.width="0px"):(this.dom.frame.style.width=this.options.iconSize+15+this.dom.textArea.offsetWidth+10+"px",this.drawLegendIcons());var o="";for(i=0;i<e.length;i++)n=e[i],1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||(o+=this.groups[n].content+"<br />");this.dom.textArea.innerHTML=wE.xss(o),this.dom.textArea.style.lineHeight=.75*this.options.iconSize+this.options.iconSpacing+"px"}},AI.prototype.drawLegendIcons=function(){if(this.dom.frame.parentNode){var t=rp(this.groups);_T(t).call(t,(function(t,e){return t<e?-1:1})),Xb(this.svgElements);var e=window.getComputedStyle(this.dom.frame).paddingTop,i=Number(e.replace("px","")),n=i,r=this.options.iconSize,o=.75*this.options.iconSize,s=i+.5*o+3;this.svg.style.width=r+5+i+"px";for(var a=0;a<t.length;a++){var l=t[a];1!=this.groups[l].visible||void 0!==this.linegraphOptions.visibility[l]&&1!=this.linegraphOptions.visibility[l]||(this.groups[l].getLegend(r,o,this.framework,n,s),s+=o+this.options.iconSpacing)}}};var II="__ungrouped__";function LI(t,e){this.id=UM(),this.body=t,this.defaultOptions={yAxisOrientation:"left",defaultGroup:"default",sort:!0,sampling:!0,stack:!1,graphHeight:"400px",shaded:{enabled:!1,orientation:"bottom"},style:"line",barChart:{width:50,sideBySide:!1,align:"center"},interpolation:{enabled:!0,parametrization:"centripetal",alpha:.5},drawPoints:{enabled:!0,size:6,style:"square"},dataAxis:{},legend:{},groups:{visibility:{}}},this.options=wE.extend({},this.defaultOptions),this.dom={},this.props={},this.hammer=null,this.groups={},this.abortedGraphUpdate=!1,this.updateSVGheight=!1,this.updateSVGheightOnResize=!1,this.forceGraphUpdate=!0;var i=this;this.itemsData=null,this.groupsData=null,this.itemListeners={add:function(t,e,n){i._onAdd(e.items)},update:function(t,e,n){i._onUpdate(e.items)},remove:function(t,e,n){i._onRemove(e.items)}},this.groupListeners={add:function(t,e,n){i._onAddGroups(e.items)},update:function(t,e,n){i._onUpdateGroups(e.items)},remove:function(t,e,n){i._onRemoveGroups(e.items)}},this.items={},this.selection=[],this.lastStart=this.body.range.start,this.touchParams={},this.svgElements={},this.setOptions(e),this.groupsUsingDefaultStyles=[0],this.body.emitter.on("rangechanged",(function(){i.svg.style.left=wE.option.asSize(-i.props.width),i.forceGraphUpdate=!0,i.redraw.call(i)})),this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups}}LI.prototype=new IE,LI.prototype._create=function(){var t=document.createElement("div");t.className="vis-line-graph",this.dom.frame=t,this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="relative",this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",this.svg.style.display="block",t.appendChild(this.svg),this.options.dataAxis.orientation="left",this.yAxisLeft=new CI(this.body,this.options.dataAxis,this.svg,this.options.groups),this.options.dataAxis.orientation="right",this.yAxisRight=new CI(this.body,this.options.dataAxis,this.svg,this.options.groups),delete this.options.dataAxis.orientation,this.legendLeft=new AI(this.body,this.options.legend,"left",this.options.groups),this.legendRight=new AI(this.body,this.options.legend,"right",this.options.groups),this.show()},LI.prototype.setOptions=function(t){if(t){void 0===t.graphHeight&&void 0!==t.height?(this.updateSVGheight=!0,this.updateSVGheightOnResize=!0):void 0!==this.body.domProps.centerContainer.height&&void 0!==t.graphHeight&&Zm((t.graphHeight+"").replace("px",""))<this.body.domProps.centerContainer.height&&(this.updateSVGheight=!0),wE.selectiveDeepExtend(["sampling","defaultGroup","stack","height","graphHeight","yAxisOrientation","style","barChart","dataAxis","sort","groups"],this.options,t),wE.mergeOptions(this.options,t,"interpolation"),wE.mergeOptions(this.options,t,"drawPoints"),wE.mergeOptions(this.options,t,"shaded"),wE.mergeOptions(this.options,t,"legend"),t.interpolation&&"object"==Nd(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5)),this.yAxisLeft&&void 0!==t.dataAxis&&(this.yAxisLeft.setOptions(this.options.dataAxis),this.yAxisRight.setOptions(this.options.dataAxis)),this.legendLeft&&void 0!==t.legend&&(this.legendLeft.setOptions(this.options.legend),this.legendRight.setOptions(this.options.legend)),this.groups.hasOwnProperty(II)&&this.groups[II].setOptions(t)}this.dom.frame&&(this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0}))},LI.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},LI.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},LI.prototype.setItems=function(t){var e,i=this,n=this.itemsData;if(t){if(!pE(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.itemsData=gE(t)}else this.itemsData=null;if(n&&(Hp(wE).call(wE,this.itemListeners,(function(t,e){n.off(e,t)})),n.dispose(),e=n.getIds(),this._onRemove(e)),this.itemsData){var r=this.id;Hp(wE).call(wE,this.itemListeners,(function(t,e){i.itemsData.on(e,t,r)})),e=this.itemsData.getIds(),this._onAdd(e)}},LI.prototype.setGroups=function(t){var e,i=this;if(this.groupsData){Hp(wE).call(wE,this.groupListeners,(function(t,e){i.groupsData.off(e,t)})),e=this.groupsData.getIds(),this.groupsData=null;for(var n=0;n<e.length;n++)this._removeGroup(e[n])}if(t){if(!pE(t))throw new TypeError("Data must implement the interface of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var r=this.id;Hp(wE).call(wE,this.groupListeners,(function(t,e){i.groupsData.on(e,t,r)})),e=this.groupsData.getIds(),this._onAddGroups(e)}},LI.prototype._onUpdate=function(t){this._updateAllGroupData(t)},LI.prototype._onAdd=function(t){this._onUpdate(t)},LI.prototype._onRemove=function(t){this._onUpdate(t)},LI.prototype._onUpdateGroups=function(t){this._updateAllGroupData(null,t)},LI.prototype._onAddGroups=function(t){this._onUpdateGroups(t)},LI.prototype._onRemoveGroups=function(t){for(var e=0;e<t.length;e++)this._removeGroup(t[e]);this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})},LI.prototype._removeGroup=function(t){this.groups.hasOwnProperty(t)&&("right"==this.groups[t].options.yAxisOrientation?(this.yAxisRight.removeGroup(t),this.legendRight.removeGroup(t),this.legendRight.redraw()):(this.yAxisLeft.removeGroup(t),this.legendLeft.removeGroup(t),this.legendLeft.redraw()),delete this.groups[t])},LI.prototype._updateGroup=function(t,e){this.groups.hasOwnProperty(e)?(this.groups[e].update(t),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.updateGroup(e,this.groups[e]),this.legendRight.updateGroup(e,this.groups[e]),this.yAxisLeft.removeGroup(e),this.legendLeft.removeGroup(e)):(this.yAxisLeft.updateGroup(e,this.groups[e]),this.legendLeft.updateGroup(e,this.groups[e]),this.yAxisRight.removeGroup(e),this.legendRight.removeGroup(e))):(this.groups[e]=new PI(t,e,this.options,this.groupsUsingDefaultStyles),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.addGroup(e,this.groups[e]),this.legendRight.addGroup(e,this.groups[e])):(this.yAxisLeft.addGroup(e,this.groups[e]),this.legendLeft.addGroup(e,this.groups[e]))),this.legendLeft.redraw(),this.legendRight.redraw()},LI.prototype._updateAllGroupData=function(t,e){if(null!=this.itemsData){var i={},n=this.itemsData.get(),r=this.itemsData.idProp,o={};t&&ep(t).call(t,(function(t){o[t]=t}));for(var s={},a=0;a<n.length;a++){var l=n[a],h=l.group;null==h&&(h=II),s.hasOwnProperty(h)?s[h]++:s[h]=1}var u={};if(!e&&t)for(h in this.groups)if(this.groups.hasOwnProperty(h)){var d=(m=this.groups[h]).getItems();i[h]=mm(d).call(d,(function(t){return u[t[r]]=t[r],t[r]!==o[t[r]]}));var c=s[h];s[h]-=i[h].length,i[h].length<c&&(i[h][c-1]={})}for(a=0;a<n.length;a++)if(null==(h=(l=n[a]).group)&&(h=II),e||!t||l[r]===o[l[r]]||!u.hasOwnProperty(l[r])){i.hasOwnProperty(h)||(i[h]=new Array(s[h]));var p=wE.bridgeObject(l);p.x=wE.convert(l.x,"Date"),p.end=wE.convert(l.end,"Date"),p.orginalY=l.y,p.y=Number(l.y),p[r]=l[r];var f=i[h].length-s[h]--;i[h][f]=p}for(h in this.groups)this.groups.hasOwnProperty(h)&&(i.hasOwnProperty(h)||(i[h]=new Array(0)));for(h in i)if(i.hasOwnProperty(h))if(0==i[h].length)this.groups.hasOwnProperty(h)&&this._removeGroup(h);else{var m=void 0;null!=this.groupsData&&(m=this.groupsData.get(h)),null==m&&(m={id:h,content:this.options.defaultGroup+h}),this._updateGroup(m,h),this.groups[h].setItems(i[h])}this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})}},LI.prototype.redraw=function(){var t=!1;this.props.width=this.dom.frame.offsetWidth,this.props.height=this.body.domProps.centerContainer.height-this.body.domProps.border.top-this.body.domProps.border.bottom,t=this._isResized()||t;var e,i=this.body.range.end-this.body.range.start,n=i!=this.lastVisibleInterval;(this.lastVisibleInterval=i,1==t)&&(this.svg.style.width=wE.option.asSize(3*this.props.width),this.svg.style.left=wE.option.asSize(-this.props.width),-1==av(e=this.options.height+"").call(e,"%")&&1!=this.updateSVGheightOnResize||(this.updateSVGheight=!0));if(1==this.updateSVGheight?(this.options.graphHeight!=this.props.height+"px"&&(this.options.graphHeight=this.props.height+"px",this.svg.style.height=this.props.height+"px"),this.updateSVGheight=!1):this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",1==t||1==n||1==this.abortedGraphUpdate||1==this.forceGraphUpdate)t=this._updateGraph()||t,this.forceGraphUpdate=!1,this.lastStart=this.body.range.start,this.svg.style.left=-this.props.width+"px";else if(0!=this.lastStart){var r=this.body.range.start-this.lastStart,o=this.body.range.end-this.body.range.start;if(0!=this.props.width){var s=r*(this.props.width/o);this.svg.style.left=-this.props.width-s+"px"}}return this.legendLeft.redraw(),this.legendRight.redraw(),t},LI.prototype._getSortedGroupIds=function(){var t=[];for(var e in this.groups)if(this.groups.hasOwnProperty(e)){var i=this.groups[e];1!=i.visible||void 0!==this.options.groups.visibility[e]&&1!=this.options.groups.visibility[e]||t.push({id:e,zIndex:i.options.zIndex})}wE.insertSort(t,(function(t,e){var i=t.zIndex,n=e.zIndex;return void 0===i&&(i=0),void 0===n&&(n=0),i==n?0:i<n?-1:1}));for(var n=new Array(t.length),r=0;r<t.length;r++)n[r]=t[r].id;return n},LI.prototype._updateGraph=function(){if(Ub(this.svgElements),0!=this.props.width&&null!=this.itemsData){var t,e,i={},n=this.body.util.toGlobalTime(-this.body.domProps.root.width),r=this.body.util.toGlobalTime(2*this.body.domProps.root.width),o=this._getSortedGroupIds();if(o.length>0){var s={};for(this._getRelevantData(o,s,n,r),this._applySampling(o,s),e=0;e<o.length;e++)this._convertXcoordinates(s[o[e]]);if(this._getYRanges(o,s,i),1==this._updateYAxis(o,i))return Vb(this.svgElements),this.abortedGraphUpdate=!0,!0;this.abortedGraphUpdate=!1;var a=void 0;for(e=0;e<o.length;e++)t=this.groups[o[e]],!0===this.options.stack&&"line"===this.options.style&&(null!=t.options.excludeFromStacking&&t.options.excludeFromStacking||(null!=a&&(this._stack(s[t.id],s[a.id]),1==t.options.shaded.enabled&&"group"!==t.options.shaded.orientation&&("top"==t.options.shaded.orientation&&"group"!==a.options.shaded.orientation?(a.options.shaded.orientation="group",a.options.shaded.groupId=t.id):(t.options.shaded.orientation="group",t.options.shaded.groupId=a.id))),a=t)),this._convertYcoordinates(s[o[e]],t);var l={};for(e=0;e<o.length;e++)if("line"===(t=this.groups[o[e]]).options.style&&1==t.options.shaded.enabled){var h=s[o[e]];if(null==h||0==h.length)continue;if(l.hasOwnProperty(o[e])||(l[o[e]]=EI.calcPath(h,t)),"group"===t.options.shaded.orientation){var u=t.options.shaded.groupId;if(-1===av(o).call(o,u)){console.log(t.id+": Unknown shading group target given:"+u);continue}l.hasOwnProperty(u)||(l[u]=EI.calcPath(s[u],this.groups[u])),EI.drawShading(l[o[e]],t,l[u],this.framework)}else EI.drawShading(l[o[e]],t,void 0,this.framework)}for(OI.draw(o,s,this.framework),e=0;e<o.length;e++)if(t=this.groups[o[e]],s[o[e]].length>0)switch(t.options.style){case"line":l.hasOwnProperty(o[e])||(l[o[e]]=EI.calcPath(s[o[e]],t)),EI.draw(l[o[e]],t,this.framework);case"point":case"points":"point"!=t.options.style&&"points"!=t.options.style&&1!=t.options.drawPoints.enabled||TI.draw(s[o[e]],t,this.framework)}}}return Vb(this.svgElements),!1},LI.prototype._stack=function(t,e){var i,n,r,o,s;i=0;for(var a=0;a<t.length;a++){o=void 0,s=void 0;for(var l=i;l<e.length;l++){if(e[l].x===t[a].x){o=e[l],s=e[l],i=l;break}if(e[l].x>t[a].x){s=e[l],o=0==l?s:e[l-1],i=l;break}}void 0===s&&(o=e[e.length-1],s=e[e.length-1]),n=s.x-o.x,r=s.y-o.y,t[a].y=0==n?t[a].orginalY+s.y:t[a].orginalY+r/n*(t[a].x-o.x)+o.y}},LI.prototype._getRelevantData=function(t,e,i,n){var r,o,s,a;if(t.length>0)for(o=0;o<t.length;o++){var l=(r=this.groups[t[o]]).getItems();if(1==_T(r.options)){var h=function(t,e){return t.getTime()==e.getTime()?0:t<e?-1:1},u=Math.max(0,wE.binarySearchValue(l,i,"x","before",h)),d=Math.min(l.length,wE.binarySearchValue(l,n,"x","after",h)+1);d<=0&&(d=l.length);var c=new Array(d-u);for(s=u;s<d;s++)a=r.itemsData[s],c[s-u]=a;e[t[o]]=c}else e[t[o]]=r.itemsData}},LI.prototype._applySampling=function(t,e){if(t.length>0)for(var i=0;i<t.length;i++)if(1==this.groups[t[i]].options.sampling){var n=e[t[i]];if(n.length>0){var r,o=n.length,s=o/(this.body.util.toGlobalScreen(n[n.length-1].x)-this.body.util.toGlobalScreen(n[0].x));r=Math.min(Math.ceil(.2*o),Math.max(1,Math.round(s)));for(var a=new Array(o),l=0;l<o;l+=r){a[Math.round(l/r)]=n[l]}e[t[i]]=_f(a).call(a,0,Math.round(o/r))}}},LI.prototype._getYRanges=function(t,e,i){var n,r,o,s,a=[],l=[];if(t.length>0){for(o=0;o<t.length;o++)n=e[t[o]],s=this.groups[t[o]].options,n.length>0&&(r=this.groups[t[o]],!0===s.stack&&"bar"===s.style?"left"===s.yAxisOrientation?a=Yc(a).call(a,n):l=Yc(l).call(l,n):i[t[o]]=r.getYRange(n,t[o]));OI.getStackedYRange(a,i,t,"__barStackLeft","left"),OI.getStackedYRange(l,i,t,"__barStackRight","right")}},LI.prototype._updateYAxis=function(t,e){var i,n,r=!1,o=!1,s=!1,a=1e9,l=1e9,h=-1e9,u=-1e9;if(t.length>0){for(var d=0;d<t.length;d++){var c=this.groups[t[d]];c&&"right"!=c.options.yAxisOrientation?(o=!0,a=1e9,h=-1e9):c&&c.options.yAxisOrientation&&(s=!0,l=1e9,u=-1e9)}for(d=0;d<t.length;d++)e.hasOwnProperty(t[d])&&!0!==e[t[d]].ignore&&(i=e[t[d]].min,n=e[t[d]].max,"right"!=e[t[d]].yAxisOrientation?(o=!0,a=a>i?i:a,h=h<n?n:h):(s=!0,l=l>i?i:l,u=u<n?n:u));1==o&&this.yAxisLeft.setRange(a,h),1==s&&this.yAxisRight.setRange(l,u)}r=this._toggleAxisVisiblity(o,this.yAxisLeft)||r,r=this._toggleAxisVisiblity(s,this.yAxisRight)||r,1==s&&1==o?(this.yAxisLeft.drawIcons=!0,this.yAxisRight.drawIcons=!0):(this.yAxisLeft.drawIcons=!1,this.yAxisRight.drawIcons=!1),this.yAxisRight.master=!o,this.yAxisRight.masterAxis=this.yAxisLeft,0==this.yAxisRight.master?(this.yAxisLeft.lineOffset=1==s?this.yAxisRight.width:0,r=this.yAxisLeft.redraw()||r,r=this.yAxisRight.redraw()||r):r=this.yAxisRight.redraw()||r;var p=["__barStackLeft","__barStackRight","__lineStackLeft","__lineStackRight"];for(d=0;d<p.length;d++)-1!=av(t).call(t,p[d])&&_f(t).call(t,av(t).call(t,p[d]),1);return r},LI.prototype._toggleAxisVisiblity=function(t,e){var i=!1;return 0==t?e.dom.frame.parentNode&&0==e.hidden&&(e.hide(),i=!0):e.dom.frame.parentNode||1!=e.hidden||(e.show(),i=!0),i},LI.prototype._convertXcoordinates=function(t){for(var e=this.body.util.toScreen,i=0;i<t.length;i++)t[i].screen_x=e(t[i].x)+this.props.width,t[i].screen_y=t[i].y,null!=t[i].end?t[i].screen_end=e(t[i].end)+this.props.width:t[i].screen_end=void 0},LI.prototype._convertYcoordinates=function(t,e){var i=this.yAxisLeft,n=Number(this.svg.style.height.replace("px",""));"right"==e.options.yAxisOrientation&&(i=this.yAxisRight);for(var r=0;r<t.length;r++)t[r].screen_y=Math.round(i.convertValue(t[r].y));e.setZeroPosition(Math.min(n,i.convertValue(0)))};var NI="string",RI="boolean",FI="number",jI="date",YI="object",HI="moment",zI={configure:{enabled:{boolean:RI},filter:{boolean:RI,function:"function"},container:{dom:"dom"},__type__:{object:YI,boolean:RI,function:"function"}},alignCurrentTime:{string:NI,undefined:"undefined"},yAxisOrientation:{string:["left","right"]},defaultGroup:{string:NI},sort:{boolean:RI},sampling:{boolean:RI},stack:{boolean:RI},graphHeight:{string:NI,number:FI},shaded:{enabled:{boolean:RI},orientation:{string:["bottom","top","zero","group"]},groupId:{object:YI},__type__:{boolean:RI,object:YI}},style:{string:["line","bar","points"]},barChart:{width:{number:FI},minWidth:{number:FI},sideBySide:{boolean:RI},align:{string:["left","center","right"]},__type__:{object:YI}},interpolation:{enabled:{boolean:RI},parametrization:{string:["centripetal","chordal","uniform"]},alpha:{number:FI},__type__:{object:YI,boolean:RI}},drawPoints:{enabled:{boolean:RI},onRender:{function:"function"},size:{number:FI},style:{string:["square","circle"]},__type__:{object:YI,boolean:RI,function:"function"}},dataAxis:{showMinorLabels:{boolean:RI},showMajorLabels:{boolean:RI},showWeekScale:{boolean:RI},icons:{boolean:RI},width:{string:NI,number:FI},visible:{boolean:RI},alignZeros:{boolean:RI},left:{range:{min:{number:FI,undefined:"undefined"},max:{number:FI,undefined:"undefined"},__type__:{object:YI}},format:{function:"function"},title:{text:{string:NI,number:FI,undefined:"undefined"},style:{string:NI,undefined:"undefined"},__type__:{object:YI}},__type__:{object:YI}},right:{range:{min:{number:FI,undefined:"undefined"},max:{number:FI,undefined:"undefined"},__type__:{object:YI}},format:{function:"function"},title:{text:{string:NI,number:FI,undefined:"undefined"},style:{string:NI,undefined:"undefined"},__type__:{object:YI}},__type__:{object:YI}},__type__:{object:YI}},legend:{enabled:{boolean:RI},icons:{boolean:RI},left:{visible:{boolean:RI},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:YI}},right:{visible:{boolean:RI},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:YI}},__type__:{object:YI,boolean:RI}},groups:{visibility:{any:"any"},__type__:{object:YI}},autoResize:{boolean:RI},throttleRedraw:{number:FI},clickToUse:{boolean:RI},end:{number:FI,date:jI,string:NI,moment:HI},format:{minorLabels:{millisecond:{string:NI,undefined:"undefined"},second:{string:NI,undefined:"undefined"},minute:{string:NI,undefined:"undefined"},hour:{string:NI,undefined:"undefined"},weekday:{string:NI,undefined:"undefined"},day:{string:NI,undefined:"undefined"},week:{string:NI,undefined:"undefined"},month:{string:NI,undefined:"undefined"},quarter:{string:NI,undefined:"undefined"},year:{string:NI,undefined:"undefined"},__type__:{object:YI}},majorLabels:{millisecond:{string:NI,undefined:"undefined"},second:{string:NI,undefined:"undefined"},minute:{string:NI,undefined:"undefined"},hour:{string:NI,undefined:"undefined"},weekday:{string:NI,undefined:"undefined"},day:{string:NI,undefined:"undefined"},week:{string:NI,undefined:"undefined"},month:{string:NI,undefined:"undefined"},quarter:{string:NI,undefined:"undefined"},year:{string:NI,undefined:"undefined"},__type__:{object:YI}},__type__:{object:YI}},moment:{function:"function"},height:{string:NI,number:FI},hiddenDates:{start:{date:jI,number:FI,string:NI,moment:HI},end:{date:jI,number:FI,string:NI,moment:HI},repeat:{string:NI},__type__:{object:YI,array:"array"}},locale:{string:NI},locales:{__any__:{any:"any"},__type__:{object:YI}},max:{date:jI,number:FI,string:NI,moment:HI},maxHeight:{number:FI,string:NI},maxMinorChars:{number:FI},min:{date:jI,number:FI,string:NI,moment:HI},minHeight:{number:FI,string:NI},moveable:{boolean:RI},multiselect:{boolean:RI},orientation:{string:NI},showCurrentTime:{boolean:RI},showMajorLabels:{boolean:RI},showMinorLabels:{boolean:RI},showWeekScale:{boolean:RI},snap:{function:"function",null:"null"},start:{date:jI,number:FI,string:NI,moment:HI},timeAxis:{scale:{string:NI,undefined:"undefined"},step:{number:FI,undefined:"undefined"},__type__:{object:YI}},width:{string:NI,number:FI},zoomable:{boolean:RI},zoomKey:{string:["ctrlKey","altKey","metaKey",""]},zoomMax:{number:FI},zoomMin:{number:FI},zIndex:{number:FI},__type__:{object:YI}},BI={global:{alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],sort:!0,sampling:!0,stack:!1,shaded:{enabled:!1,orientation:["zero","top","bottom","group"]},style:["line","bar","points"],barChart:{width:[50,5,100,5],minWidth:[50,5,100,5],sideBySide:!1,align:["left","center","right"]},interpolation:{enabled:!0,parametrization:["centripetal","chordal","uniform"]},drawPoints:{enabled:!0,size:[6,2,30,1],style:["square","circle"]},dataAxis:{showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,width:[40,0,200,1],visible:!0,alignZeros:!0,left:{title:{text:"",style:""}},right:{title:{text:"",style:""}}},legend:{enabled:!1,icons:!0,left:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]},right:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]}},autoResize:!0,clickToUse:!1,end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",quarter:"[Q]Q",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",quarter:"YYYY",year:""}},height:"",locale:"",max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!0,orientation:["both","bottom","top"],showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,showWeekScale:!1,start:"",width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],zIndex:0}};function GI(t,e,i,n){var r,o,s,a,l,h,u;if(!qc(i)&&!pE(i)&&i instanceof Object){var d=n;n=i,i=d}n&&n.throttleRedraw&&console.warn('Graph2d option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var c=this;this.defaultOptions={start:null,end:null,autoResize:!0,orientation:{axis:"bottom",item:"bottom"},moment:sO,width:null,height:null,maxHeight:null,minHeight:null},this.options=wE.deepExtend({},this.defaultOptions),this._create(t),this.components=[],this.body={dom:this.dom,domProps:this.props,emitter:{on:Tp(r=this.on).call(r,this),off:Tp(o=this.off).call(o,this),emit:Tp(s=this.emit).call(s,this)},hiddenDates:[],util:{getScale:function(){return c.timeAxis.step.scale},getStep:function(){return c.timeAxis.step.step},toScreen:Tp(a=c._toScreen).call(a,c),toGlobalScreen:Tp(l=c._toGlobalScreen).call(l,c),toTime:Tp(h=c._toTime).call(h,c),toGlobalTime:Tp(u=c._toGlobalTime).call(u,c)}},this.range=new oP(this.body),this.components.push(this.range),this.body.range=this.range,this.timeAxis=new mP(this.body),this.components.push(this.timeAxis),this.currentTime=new jP(this.body),this.components.push(this.currentTime),this.linegraph=new LI(this.body),this.components.push(this.linegraph),this.itemsData=null,this.groupsData=null,this.on("tap",(function(t){c.emit("click",c.getEventProperties(t))})),this.on("doubletap",(function(t){c.emit("doubleClick",c.getEventProperties(t))})),this.dom.root.oncontextmenu=function(t){c.emit("contextmenu",c.getEventProperties(t))},this.initialFitDone=!1,this.on("changed",(function(){if(null!=c.itemsData){if(!c.initialFitDone&&!c.options.rollingMode)if(c.initialFitDone=!0,null!=c.options.start||null!=c.options.end){if(null==c.options.start||null==c.options.end)var t=c.getItemRange();var e=null!=c.options.start?c.options.start:t.min,i=null!=c.options.end?c.options.end:t.max;c.setWindow(e,i,{animation:!1})}else c.fit({animation:!1});c.initialDrawDone||!c.initialRangeChangeDone&&(c.options.start||c.options.end)&&!c.options.rollingMode||(c.initialDrawDone=!0,c.dom.root.style.visibility="visible",c.dom.loadingScreen.parentNode.removeChild(c.dom.loadingScreen),c.options.onInitialDrawComplete&&Rv((function(){return c.options.onInitialDrawComplete()}),0))}})),n&&this.setOptions(n),i&&this.setGroups(i),e&&this.setItems(e),this._redraw()}GI.prototype=new RP,GI.prototype.setOptions=function(t){!0===rI.validate(t,zI)&&console.log("%cErrors have been found in the supplied options object.",nI),RP.prototype.setOptions.call(this,t)},GI.prototype.setItems=function(t){var e,i=null==this.itemsData;if(e=t?pE(t)?gE(t):gE(new nO(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=e,this.linegraph&&this.linegraph.setItems(null!=e?e.rawDS:null),i)if(null!=this.options.start||null!=this.options.end){var n=null!=this.options.start?this.options.start:null,r=null!=this.options.end?this.options.end:null;this.setWindow(n,r,{animation:!1})}else this.fit({animation:!1})},GI.prototype.setGroups=function(t){var e;e=t?pE(t)?t:new nO(t):null,this.groupsData=e,this.linegraph.setGroups(e)},GI.prototype.getLegend=function(t,e,i){return void 0===e&&(e=15),void 0===i&&(i=15),void 0!==this.linegraph.groups[t]?this.linegraph.groups[t].getLegend(e,i):"cannot find group:'"+t+"'"},GI.prototype.isGroupVisible=function(t){return void 0!==this.linegraph.groups[t]&&(this.linegraph.groups[t].visible&&(void 0===this.linegraph.options.groups.visibility[t]||1==this.linegraph.options.groups.visibility[t]))},GI.prototype.getDataRange=function(){var t=null,e=null;for(var i in this.linegraph.groups)if(this.linegraph.groups.hasOwnProperty(i)&&1==this.linegraph.groups[i].visible)for(var n=0;n<this.linegraph.groups[i].itemsData.length;n++){var r=this.linegraph.groups[i].itemsData[n],o=wE.convert(r.x,"Date").valueOf();t=null==t||t>o?o:t,e=null==e||e<o?o:e}return{min:null!=t?new Date(t):null,max:null!=e?new Date(e):null}},GI.prototype.getEventProperties=function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=e-wE.getAbsoluteLeft(this.dom.centerContainer),r=i-wE.getAbsoluteTop(this.dom.centerContainer),o=this._toTime(n),s=NP.customTimeFromTarget(t),a=wE.getTarget(t),l=null;wE.hasParent(a,this.timeAxis.dom.foreground)||this.timeAxis2&&wE.hasParent(a,this.timeAxis2.dom.foreground)?l="axis":wE.hasParent(a,this.linegraph.yAxisLeft.dom.frame)||wE.hasParent(a,this.linegraph.yAxisRight.dom.frame)?l="data-axis":wE.hasParent(a,this.linegraph.legendLeft.dom.frame)||wE.hasParent(a,this.linegraph.legendRight.dom.frame)?l="legend":null!=s?l="custom-time":wE.hasParent(a,this.currentTime.bar)?l="current-time":wE.hasParent(a,this.dom.center)&&(l="background");var h=[],u=this.linegraph.yAxisLeft,d=this.linegraph.yAxisRight;return!u.hidden&&this.itemsData.length>0&&h.push(u.screenToValue(r)),!d.hidden&&this.itemsData.length>0&&h.push(d.screenToValue(r)),{event:t,customTime:s?s.options.id:null,what:l,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:n,y:r,time:o,value:h}},GI.prototype._createConfigurator=function(){return new vI(this,this.dom.container,BI)};var WI=Jb();sO.locale(WI);var UI={Core:RP,DateUtil:nP,Range:oP,stack:gA,TimeStep:cP,components:{items:{Item:DA,BackgroundItem:AA,BoxItem:CA,ClusterItem:WA,PointItem:MA,RangeItem:EA},BackgroundGroup:wA,Component:IE,CurrentTime:jP,CustomTime:NP,DataAxis:CI,DataScale:kI,GraphGroup:PI,Group:bA,ItemSet:tI,Legend:AI,LineGraph:LI,TimeAxis:mP}};t.DOMutil=Qb,t.DataSet=nO,t.DataView=rO,t.Graph2d=GI,t.Hammer=uP,t.Queue=tO,t.Timeline=yI,t.keycharm=gP,t.moment=sO,t.timeline=UI,t.util=Wb}));
//# sourceMappingURL=vis-timeline-graph2d.min.js.map
